// QAccessible.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QAccessible : QtSupport, IDisposable {

		public enum Event {
			SoundPlayed = 1,
			Alert = 2,
			ForegroundChanged = 3,
			MenuStart = 4,
			MenuEnd = 5,
			PopupMenuStart = 6,
			PopupMenuEnd = 7,
			ContextHelpStart = 12,
			ContextHelpEnd = 13,
			DragDropStart = 14,
			DragDropEnd = 15,
			DialogStart = 16,
			DialogEnd = 17,
			ScrollingStart = 18,
			ScrollingEnd = 19,
			MenuCommand = 24,
			ObjectCreated = 32768,
			ObjectDestroyed = 32769,
			ObjectShow = 32770,
			ObjectHide = 32771,
			ObjectReorder = 32772,
			Focus = 32773,
			Selection = 32774,
			SelectionAdd = 32775,
			SelectionRemove = 32776,
			SelectionWithin = 32777,
			StateChanged = 32778,
			LocationChanged = 32779,
			NameChanged = 32780,
			DescriptionChanged = 32781,
			ValueChanged = 32782,
			ParentChanged = 32783,
			HelpChanged = 32928,
			DefaultActionChanged = 32944,
			AcceleratorChanged = 32960
		}

		public enum State {
			Normal = 0,
			Unavailable = 1,
			Selected = 2,
			Focused = 4,
			Pressed = 8,
			Checked = 16,
			Mixed = 32,
			ReadOnly = 64,
			HotTracked = 128,
			Default = 256,
			Expanded = 512,
			Collapsed = 1024,
			Busy = 2048,
			Floating = 4096,
			Marqueed = 8192,
			Animated = 16384,
			Invisible = 32768,
			Offscreen = 65536,
			Sizeable = 131072,
			Moveable = 262144,
			SelfVoicing = 524288,
			Focusable = 1048576,
			Selectable = 2097152,
			Linked = 4194304,
			Traversed = 8388608,
			MultiSelectable = 16777216,
			ExtSelectable = 33554432,
			AlertLow = 67108864,
			AlertMedium = 134217728,
			AlertHigh = 268435456,
			Protected = 536870912,
			Valid = 1073741823
		}

		public enum Role {
			NoRole = 0,
			TitleBar = 1,
			MenuBar = 2,
			ScrollBar = 3,
			Grip = 4,
			Sound = 5,
			Cursor = 6,
			Caret = 7,
			AlertMessage = 8,
			Window = 9,
			Client = 10,
			PopupMenu = 11,
			MenuItem = 12,
			ToolTip = 13,
			Application = 14,
			Document = 15,
			Pane = 16,
			Chart = 17,
			Dialog = 18,
			Border = 19,
			Grouping = 20,
			Separator = 21,
			ToolBar = 22,
			StatusBar = 23,
			Table = 24,
			ColumnHeader = 25,
			RowHeader = 26,
			Column = 27,
			Row = 28,
			Cell = 29,
			Link = 30,
			HelpBalloon = 31,
			Character = 32,
			List = 33,
			ListItem = 34,
			Outline = 35,
			OutlineItem = 36,
			PageTab = 37,
			PropertyPage = 38,
			Indicator = 39,
			Graphic = 40,
			StaticText = 41,
			EditableText = 42,
			PushButton = 43,
			CheckBox = 44,
			RadioButton = 45,
			ComboBox = 46,
			DropLest = 47,
			ProgressBar = 48,
			Dial = 49,
			HotkeyField = 50,
			Slider = 51,
			SpinBox = 52,
			Diagram = 53,
			Animation = 54,
			Equation = 55,
			ButtonDropDown = 56,
			ButtonMenu = 57,
			ButtonDropGrid = 58,
			Whitespace = 59,
			PageTabList = 60,
			Clock = 61
		}

		public enum NavDirection {
			NavUp = 1,
			NavDown = 2,
			NavLeft = 3,
			NavRight = 4,
			NavNext = 5,
			NavPrevious = 6,
			NavFirstChild = 7,
			NavLastChild = 8,
			NavFocusChild = 9
		}

		public enum Text {
			Name = 0,
			Description = 1,
			Value = 2,
			Help = 3,
			Accelerator = 4,
			DefaultAction = 5
		}

		internal QAccessible () : this (QNull.Instance) {}

		public QAccessible (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QAccessible (QNull dummy) : base (QNull.Instance) {}

		~QAccessible ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QAccessible function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QAccessible_queryAccessibleInterface (IntPtr arg1, IntPtr arg2);
		public static long QueryAccessibleInterface (QObject arg1, QAccessibleInterface arg2)
		{
			return qt_QAccessible_queryAccessibleInterface (arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAccessible_updateAccessibility (IntPtr arg1, int who, QAccessible.Event reason);
		public static void UpdateAccessibility (QObject arg1, int who, QAccessible.Event reason)
		{
			qt_QAccessible_updateAccessibility (arg1.RawObject, who, reason);
		}
	}
}