// QAccessibleInterface.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QAccessibleInterface : QAccessible, IDisposable {

		internal QAccessibleInterface () : this (QNull.Instance) {}

		public QAccessibleInterface (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QAccessibleInterface (QNull dummy) : base (QNull.Instance) {}

		~QAccessibleInterface ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QAccessibleInterface function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAccessibleInterface_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QAccessibleInterface_childCount (IntPtr raw);
		public int ChildCount ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_childCount (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QAccessibleInterface_queryChild (IntPtr raw, int control, IntPtr arg1);
		public long QueryChild (int control, QAccessibleInterface arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_queryChild (rawObject, control, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QAccessibleInterface_queryParent (IntPtr raw, IntPtr arg1);
		public long QueryParent (QAccessibleInterface arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_queryParent (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QAccessibleInterface_controlAt (IntPtr raw, int x, int y);
		public int ControlAt (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_controlAt (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QAccessibleInterface_rect (IntPtr raw, int control);
		public QRect Rect (int control)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QAccessibleInterface_rect (rawObject, control), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QAccessibleInterface_navigate (IntPtr raw, QAccessible.NavDirection direction, int startControl);
		public int Navigate (QAccessible.NavDirection direction, int startControl)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_navigate (rawObject, direction, startControl);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QAccessibleInterface_text (IntPtr raw, QAccessible.Text t, int control);
		public string Text (QAccessible.Text t, int control)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QAccessibleInterface_text (rawObject, t, control));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAccessibleInterface_setText (IntPtr raw, QAccessible.Text t, int control, IntPtr text);
		public void SetText (QAccessible.Text t, int control, string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QAccessibleInterface_setText (rawObject, t, control, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QAccessible.Role qt_QAccessibleInterface_role (IntPtr raw, int control);
		public QAccessible.Role Role (int control)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_role (rawObject, control);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QAccessible.State qt_QAccessibleInterface_state (IntPtr raw, int control);
		public QAccessible.State State (int control)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_state (rawObject, control);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAccessibleInterface_doDefaultAction (IntPtr raw, int control);
		public bool DoDefaultAction (int control)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_doDefaultAction (rawObject, control);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAccessibleInterface_setFocus (IntPtr raw, int control);
		public bool SetFocus (int control)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_setFocus (rawObject, control);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAccessibleInterface_setSelected (IntPtr raw, int control, bool on, bool extend);
		public bool SetSelected (int control, bool on, bool extend)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_setSelected (rawObject, control, on, extend);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAccessibleInterface_clearSelection (IntPtr raw);
		public void ClearSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QAccessibleInterface_clearSelection (rawObject);
		}

		// Begin interface methods.


		// Begin interface methods.

	}
}