// QAccessibleObject.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QAccessibleObject : QObject, IQAccessible, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QAccessibleObject (IntPtr Q_object);
		public QAccessibleObject (QObject Q_object) : this (QNull.Instance)
		{
			rawObject = qt_new_QAccessibleObject (Q_object.RawObject);
			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		internal QAccessibleObject () : this (QNull.Instance) {}

		public QAccessibleObject (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QAccessibleObject (QNull dummy) : base (QNull.Instance) {}

		~QAccessibleObject ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QAccessibleObject (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QAccessibleObject (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QAccessibleObject_queryInterface (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public long QueryInterface (QUuid arg1, IntPtr arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleObject_queryInterface (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAccessibleObject_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleObject_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QAccessibleObject_object (IntPtr raw);
		protected QObject Q_object ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QAccessibleObject_object (rawObject), typeof (QObject)) as QObject;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QAccessibleObject_QAccessibleInterface (IntPtr raw);
		public IntPtr QAccessibleInterface ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleObject_QAccessibleInterface (rawObject);
		}

		// Begin interface methods.


		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QAccessibleInterface_childCount (IntPtr raw);
		public int ChildCount ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_childCount (QAccessibleInterface ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QAccessibleInterface_queryChild (IntPtr raw, int control, IntPtr arg1);
		public long QueryChild (int control, QAccessibleInterface arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_queryChild (QAccessibleInterface (), control, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QAccessibleInterface_queryParent (IntPtr raw, IntPtr arg1);
		public long QueryParent (QAccessibleInterface arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_queryParent (QAccessibleInterface (), arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QAccessibleInterface_controlAt (IntPtr raw, int x, int y);
		public int ControlAt (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_controlAt (QAccessibleInterface (), x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QAccessibleInterface_rect (IntPtr raw, int control);
		public QRect Rect (int control)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QAccessibleInterface_rect (QAccessibleInterface (), control), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QAccessibleInterface_navigate (IntPtr raw, QAccessible.NavDirection direction, int startControl);
		public int Navigate (QAccessible.NavDirection direction, int startControl)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_navigate (QAccessibleInterface (), direction, startControl);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QAccessibleInterface_text (IntPtr raw, QAccessible.Text t, int control);
		public string Text (QAccessible.Text t, int control)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QAccessibleInterface_text (QAccessibleInterface (), t, control));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAccessibleInterface_setText (IntPtr raw, QAccessible.Text t, int control, IntPtr text);
		public void SetText (QAccessible.Text t, int control, string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QAccessibleInterface_setText (QAccessibleInterface (), t, control, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QAccessible.Role qt_QAccessibleInterface_role (IntPtr raw, int control);
		public QAccessible.Role Role (int control)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_role (QAccessibleInterface (), control);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QAccessible.State qt_QAccessibleInterface_state (IntPtr raw, int control);
		public QAccessible.State State (int control)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_state (QAccessibleInterface (), control);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAccessibleInterface_doDefaultAction (IntPtr raw, int control);
		public bool DoDefaultAction (int control)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_doDefaultAction (QAccessibleInterface (), control);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAccessibleInterface_setFocus (IntPtr raw, int control);
		public bool SetFocus (int control)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_setFocus (QAccessibleInterface (), control);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAccessibleInterface_setSelected (IntPtr raw, int control, bool on, bool extend);
		public bool SetSelected (int control, bool on, bool extend)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAccessibleInterface_setSelected (QAccessibleInterface (), control, on, extend);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAccessibleInterface_clearSelection (IntPtr raw);
		public void ClearSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QAccessibleInterface_clearSelection (QAccessibleInterface ());
		}

		// Begin interface methods.

	}
}