// QActionGroup.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QActionGroup : QAction, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QActionGroup (IntPtr parent, string name, bool exclusive);
		public QActionGroup (QObject parent, string name, bool exclusive) : this (QNull.Instance)
		{
			rawObject = qt_new_QActionGroup (parent != null ? parent.RawObject : IntPtr.Zero, name, exclusive);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QActionGroup (QObject parent) : this (parent, "") {}

		public QActionGroup (QObject parent, string name) : this (parent, name, true) {}

		internal QActionGroup () : this (QNull.Instance) {}

		public QActionGroup (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QActionGroup (QNull dummy) : base (QNull.Instance) {}

		~QActionGroup ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QActionGroup (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QActionGroup (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_setExclusive (IntPtr raw, bool arg1);
		public void SetExclusive (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_setExclusive (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QActionGroup_isExclusive (IntPtr raw);
		public bool IsExclusive ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QActionGroup_isExclusive (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_add (IntPtr raw, IntPtr a);
		public void Add (QAction a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_add (rawObject, a.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_addSeparator (IntPtr raw);
		public void AddSeparator ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_addSeparator (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QActionGroup_addTo (IntPtr raw, IntPtr arg1);
		public bool AddTo (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QActionGroup_addTo (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QActionGroup_removeFrom (IntPtr raw, IntPtr arg1);
		public bool RemoveFrom (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QActionGroup_removeFrom (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_setEnabled (IntPtr raw, bool arg1);
		public void SetEnabled (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_setEnabled (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_setUsesDropDown (IntPtr raw, bool enable);
		public void SetUsesDropDown (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_setUsesDropDown (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QActionGroup_usesDropDown (IntPtr raw);
		public bool UsesDropDown ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QActionGroup_usesDropDown (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_setIconSet (IntPtr raw, IntPtr arg1);
		public void SetIconSet (QIconSet arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_setIconSet (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_setText (IntPtr raw, IntPtr arg1);
		public void SetText (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_setText (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_setMenuText (IntPtr raw, IntPtr arg1);
		public void SetMenuText (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_setMenuText (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_setToolTip (IntPtr raw, IntPtr arg1);
		public void SetToolTip (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_setToolTip (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_setWhatsThis (IntPtr raw, IntPtr arg1);
		public void SetWhatsThis (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_setWhatsThis (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_insert (IntPtr raw, IntPtr a);
		public void Insert (QAction a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_insert (rawObject, a.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_addedTo (IntPtr raw, IntPtr actionWidget, IntPtr container, IntPtr a);
		protected void AddedTo (QWidget actionWidget, QWidget container, QAction a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_addedTo (rawObject, actionWidget.RawObject, container.RawObject, a.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_addedTo1 (IntPtr raw, int index, IntPtr menu, IntPtr a);
		protected void AddedTo (int index, QPopupMenu menu, QAction a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_addedTo1 (rawObject, index, menu.RawObject, a.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_addedTo2 (IntPtr raw, IntPtr actionWidget, IntPtr container);
		protected void AddedTo (QWidget actionWidget, QWidget container)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_addedTo2 (rawObject, actionWidget.RawObject, container.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QActionGroup_addedTo3 (IntPtr raw, int index, IntPtr menu);
		protected void AddedTo (int index, QPopupMenu menu)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QActionGroup_addedTo3 (rawObject, index, menu.RawObject);
		}

		// Begin interface methods.

	}
}