// QAsciiCache.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QAsciiCache : QGCache, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QAsciiCache1 (int maxCost, int size, bool caseSensitive, bool copyKeys);
		public QAsciiCache (int maxCost, int size, bool caseSensitive, bool copyKeys) : this (QNull.Instance)
		{
			rawObject = qt_new_QAsciiCache1 (maxCost, size, caseSensitive, copyKeys);
			RegisterObject (this);
		}

		public QAsciiCache () : this ((int) 100) {}

		public QAsciiCache (int maxCost) : this (maxCost, (int) 17) {}

		public QAsciiCache (int maxCost, int size) : this (maxCost, size, true) {}

		public QAsciiCache (int maxCost, int size, bool caseSensitive) : this (maxCost, size, caseSensitive, true) {}

		public QAsciiCache (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QAsciiCache (QNull dummy) : base (QNull.Instance) {}

		~QAsciiCache ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QAsciiCache (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QAsciiCache (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QAsciiCache_maxCost (IntPtr raw);
		public int MaxCost ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiCache_maxCost (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QAsciiCache_totalCost (IntPtr raw);
		public int TotalCost ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiCache_totalCost (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAsciiCache_setMaxCost (IntPtr raw, int m);
		public void SetMaxCost (int m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QAsciiCache_setMaxCost (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QAsciiCache_count (IntPtr raw);
		public uint Count ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiCache_count (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QAsciiCache_size (IntPtr raw);
		public uint Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiCache_size (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAsciiCache_isEmpty (IntPtr raw);
		public bool IsEmpty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiCache_isEmpty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAsciiCache_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QAsciiCache_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAsciiCache_insert (IntPtr raw, string k, IntPtr d, int c, int p);
		public bool Insert (string k, IntPtr d, int c, int p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiCache_insert (rawObject, k, d, c, p);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAsciiCache_remove (IntPtr raw, string k);
		public bool Remove (string k)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiCache_remove (rawObject, k);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QAsciiCache_take (IntPtr raw, string k);
		public IntPtr Take (string k)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiCache_take (rawObject, k);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QAsciiCache_find (IntPtr raw, string k, bool Q_ref);
		public IntPtr Find (string k, bool Q_ref)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiCache_find (rawObject, k, Q_ref);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAsciiCache_statistics (IntPtr raw);
		public void Statistics ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QAsciiCache_statistics (rawObject);
		}

		public bool Insert (string k, IntPtr d)
		{
			return Insert(k, d, (int) 1);
		}

		public bool Insert (string k, IntPtr d, int c)
		{
			return Insert(k, d, c, (int) 0);
		}

		public IntPtr Find (string k)
		{
			return Find(k, true);
		}

		// Begin interface methods.

	}
}