// QAsciiDict.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QAsciiDict : QPtrCollection, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QAsciiDict (int size, bool caseSensitive, bool copyKeys);
		public QAsciiDict (int size, bool caseSensitive, bool copyKeys) : this (QNull.Instance)
		{
			rawObject = qt_new_QAsciiDict (size, caseSensitive, copyKeys);
			RegisterObject (this);
		}

		public QAsciiDict () : this ((int) 17) {}

		public QAsciiDict (int size) : this (size, true) {}

		public QAsciiDict (int size, bool caseSensitive) : this (size, caseSensitive, true) {}

		public QAsciiDict (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QAsciiDict (QNull dummy) : base (QNull.Instance) {}

		~QAsciiDict ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QAsciiDict (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QAsciiDict (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QAsciiDict_count (IntPtr raw);
		public uint Count ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiDict_count (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QAsciiDict_size (IntPtr raw);
		public uint Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiDict_size (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAsciiDict_isEmpty (IntPtr raw);
		public bool IsEmpty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiDict_isEmpty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAsciiDict_insert (IntPtr raw, string k, IntPtr d);
		public void Insert (string k, IntPtr d)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QAsciiDict_insert (rawObject, k, d);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAsciiDict_replace (IntPtr raw, string k, IntPtr d);
		public void Replace (string k, IntPtr d)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QAsciiDict_replace (rawObject, k, d);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QAsciiDict_remove (IntPtr raw, string k);
		public bool Remove (string k)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiDict_remove (rawObject, k);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QAsciiDict_take (IntPtr raw, string k);
		public IntPtr Take (string k)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiDict_take (rawObject, k);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QAsciiDict_find (IntPtr raw, string k);
		public IntPtr Find (string k)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QAsciiDict_find (rawObject, k);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAsciiDict_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QAsciiDict_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAsciiDict_resize (IntPtr raw, uint n);
		public void Resize (uint n)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QAsciiDict_resize (rawObject, n);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QAsciiDict_statistics (IntPtr raw);
		public void Statistics ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QAsciiDict_statistics (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QAsciiDict_read (IntPtr raw, IntPtr arg1, int arg2);
		protected QDataStream Read (QDataStream arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QAsciiDict_read (rawObject, arg1.RawObject, arg2), typeof (QDataStream)) as QDataStream;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QAsciiDict_write (IntPtr raw, IntPtr arg1, int arg2);
		protected QDataStream Write (QDataStream arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QAsciiDict_write (rawObject, arg1.RawObject, arg2), typeof (QDataStream)) as QDataStream;
		}

		// Begin interface methods.

	}
}