// QBitArray.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QBitArray : QByteArray, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QBitArray ();
		public QBitArray () : this (QNull.Instance)
		{
			rawObject = qt_new_QBitArray ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QBitArray1 (uint size);
		public QBitArray (uint size) : this (QNull.Instance)
		{
			rawObject = qt_new_QBitArray1 (size);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QBitArray2 (byte[] a);
		public QBitArray (byte[] a) : this (QNull.Instance)
		{
			rawObject = qt_new_QBitArray2 (a);
			RegisterObject (this);
		}

		public QBitArray (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QBitArray (QNull dummy) : base (QNull.Instance) {}

		~QBitArray ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QBitArray function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QBitArray_size (IntPtr raw);
		public uint Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBitArray_size (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QBitArray_resize (IntPtr raw, uint size);
		public bool Resize (uint size)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBitArray_resize (rawObject, size);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QBitArray_fill (IntPtr raw, bool v, int size);
		public bool Fill (bool v, int size)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBitArray_fill (rawObject, v, size);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBitArray_detach (IntPtr raw);
		public void Detach ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBitArray_detach (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern byte[] qt_QBitArray_copy (IntPtr raw);
		public byte[] Copy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBitArray_copy (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QBitArray_testBit (IntPtr raw, uint index);
		public bool TestBit (uint index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBitArray_testBit (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBitArray_setBit (IntPtr raw, uint index);
		public void SetBit (uint index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBitArray_setBit (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBitArray_setBit1 (IntPtr raw, uint index, bool value);
		public void SetBit (uint index, bool value)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBitArray_setBit1 (rawObject, index, value);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBitArray_clearBit (IntPtr raw, uint index);
		public void ClearBit (uint index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBitArray_clearBit (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QBitArray_toggleBit (IntPtr raw, uint index);
		public bool ToggleBit (uint index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBitArray_toggleBit (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QBitArray_at (IntPtr raw, uint index);
		public bool At (uint index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBitArray_at (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QBitArray_newData (IntPtr raw);
		protected IntPtr NewData ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBitArray_newData (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBitArray_deleteData (IntPtr raw, IntPtr d);
		protected void DeleteData (IntPtr d)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBitArray_deleteData (rawObject, d);
		}

		public bool Fill (bool v)
		{
			return Fill(v, (int) -1);
		}

		// Begin interface methods.

	}
}