// QBoxLayout.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QBoxLayout : QLayout, IDisposable {

		public enum Direction {
			LeftToRight = 0,
			RightToLeft = 1,
			TopToBottom = 2,
			BottomToTop = 3,
			Down = TopToBottom,
			Up = BottomToTop
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QBoxLayout (IntPtr parent, Direction arg1, int border, int spacing, string name);
		public QBoxLayout (QWidget parent, Direction arg1, int border, int spacing, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QBoxLayout (parent != null ? parent.RawObject : IntPtr.Zero, arg1, border, spacing, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QBoxLayout1 (IntPtr parentLayout, Direction arg1, int spacing, string name);
		public QBoxLayout (QLayout parentLayout, Direction arg1, int spacing, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QBoxLayout1 (parentLayout.RawObject, arg1, spacing, name);
			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QBoxLayout2 (Direction arg1, int spacing, string name);
		public QBoxLayout (Direction arg1, int spacing, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QBoxLayout2 (arg1, spacing, name);
			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QBoxLayout (QWidget parent, Direction arg1) : this (parent, arg1, (int) 0) {}

		public QBoxLayout (QWidget parent, Direction arg1, int border) : this (parent, arg1, border, (int) -1) {}

		public QBoxLayout (QWidget parent, Direction arg1, int border, int spacing) : this (parent, arg1, border, spacing, "") {}

		public QBoxLayout (QLayout parentLayout, Direction arg1) : this (parentLayout, arg1, (int) -1) {}

		public QBoxLayout (QLayout parentLayout, Direction arg1, int spacing) : this (parentLayout, arg1, spacing, "") {}

		public QBoxLayout (Direction arg1) : this (arg1, (int) -1) {}

		public QBoxLayout (Direction arg1, int spacing) : this (arg1, spacing, "") {}

		internal QBoxLayout () : this (QNull.Instance) {}

		public QBoxLayout (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QBoxLayout (QNull dummy) : base (QNull.Instance) {}

		~QBoxLayout ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QBoxLayout (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QBoxLayout (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_addItem (IntPtr raw, IntPtr arg1);
		public void AddItem (QLayoutItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_addItem (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Direction qt_QBoxLayout_direction (IntPtr raw);
		public Direction TheDirection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBoxLayout_direction (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_setDirection (IntPtr raw, Direction arg1);
		public void SetDirection (Direction arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_setDirection (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_addSpacing (IntPtr raw, int size);
		public void AddSpacing (int size)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_addSpacing (rawObject, size);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_addStretch (IntPtr raw, int stretch);
		public void AddStretch (int stretch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_addStretch (rawObject, stretch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_addWidget (IntPtr raw, IntPtr arg1, int stretch, int alignment);
		public void AddWidget (QWidget arg1, int stretch, int alignment)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_addWidget (rawObject, arg1.RawObject, stretch, alignment);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_addLayout (IntPtr raw, IntPtr layout, int stretch);
		public void AddLayout (QLayout layout, int stretch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_addLayout (rawObject, layout.RawObject, stretch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_addStrut (IntPtr raw, int arg1);
		public void AddStrut (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_addStrut (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_insertSpacing (IntPtr raw, int index, int size);
		public void InsertSpacing (int index, int size)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_insertSpacing (rawObject, index, size);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_insertStretch (IntPtr raw, int index, int stretch);
		public void InsertStretch (int index, int stretch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_insertStretch (rawObject, index, stretch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_insertWidget (IntPtr raw, int index, IntPtr widget, int stretch, int alignment);
		public void InsertWidget (int index, QWidget widget, int stretch, int alignment)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_insertWidget (rawObject, index, widget.RawObject, stretch, alignment);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_insertLayout (IntPtr raw, int index, IntPtr layout, int stretch);
		public void InsertLayout (int index, QLayout layout, int stretch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_insertLayout (rawObject, index, layout.RawObject, stretch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QBoxLayout_setStretchFactor (IntPtr raw, IntPtr arg1, int stretch);
		public bool SetStretchFactor (QWidget arg1, int stretch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBoxLayout_setStretchFactor (rawObject, arg1.RawObject, stretch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QBoxLayout_setStretchFactor1 (IntPtr raw, IntPtr l, int stretch);
		public bool SetStretchFactor (QLayout l, int stretch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBoxLayout_setStretchFactor1 (rawObject, l.RawObject, stretch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QBoxLayout_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QBoxLayout_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QBoxLayout_minimumSize (IntPtr raw);
		public QSize MinimumSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QBoxLayout_minimumSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QBoxLayout_maximumSize (IntPtr raw);
		public QSize MaximumSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QBoxLayout_maximumSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QBoxLayout_hasHeightForWidth (IntPtr raw);
		public bool HasHeightForWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBoxLayout_hasHeightForWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QBoxLayout_heightForWidth (IntPtr raw, int arg1);
		public int HeightForWidth (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBoxLayout_heightForWidth (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSizePolicy.ExpandData qt_QBoxLayout_expanding (IntPtr raw);
		public QSizePolicy.ExpandData Expanding ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBoxLayout_expanding (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_invalidate (IntPtr raw);
		public void Invalidate ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_invalidate (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QBoxLayout_iterator (IntPtr raw);
		public QLayoutIterator Iterator ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QBoxLayout_iterator (rawObject), typeof (QLayoutIterator)) as QLayoutIterator;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_setGeometry (IntPtr raw, IntPtr arg1);
		public void SetGeometry (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_setGeometry (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QBoxLayout_findWidget (IntPtr raw, IntPtr w);
		public int FindWidget (QWidget w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QBoxLayout_findWidget (rawObject, w.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QBoxLayout_insertItem (IntPtr raw, int index, IntPtr arg1);
		protected void InsertItem (int index, QLayoutItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QBoxLayout_insertItem (rawObject, index, arg1.RawObject);
		}

		public void AddStretch ()
		{
			AddStretch((int) 0);
		}

		public void AddWidget (QWidget arg1)
		{
			AddWidget(arg1, (int) 0);
		}

		public void AddWidget (QWidget arg1, int stretch)
		{
			AddWidget(arg1, stretch, (int) 0);
		}

		public void AddLayout (QLayout layout)
		{
			AddLayout(layout, (int) 0);
		}

		public void InsertStretch (int index)
		{
			InsertStretch(index, (int) 0);
		}

		public void InsertWidget (int index, QWidget widget)
		{
			InsertWidget(index, widget, (int) 0);
		}

		public void InsertWidget (int index, QWidget widget, int stretch)
		{
			InsertWidget(index, widget, stretch, (int) 0);
		}

		public void InsertLayout (int index, QLayout layout)
		{
			InsertLayout(index, layout, (int) 0);
		}

		// Begin interface methods.

	}
}