// QButton.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QButton : QWidget, IDisposable {

		public enum ToggleType {
			SingleShot = 0,
			Toggle = 1,
			Tristate = 2
		}

		public enum ToggleState {
			Off = 0,
			NoChange = 1,
			On = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QButton (IntPtr parent, string name, Qt.WidgetFlags f);
		public QButton (QWidget parent, string name, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QButton (parent != null ? parent.RawObject : IntPtr.Zero, name, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QButton () : this (new QWidget ()) {}

		public QButton (QWidget parent) : this (parent, "") {}

		public QButton (QWidget parent, string name) : this (parent, name, Qt.WidgetFlags.WWinOwnDC) {}

		public QButton (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QButton (QNull dummy) : base (QNull.Instance) {}

		~QButton ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QButton (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QButton (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QButton_text (IntPtr raw);
		public string Text ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QButton_text (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_setText (IntPtr raw, IntPtr arg1);
		public void SetText (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_setText (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QButton_pixmap (IntPtr raw);
		public QPixmap Pixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QButton_pixmap (rawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_setPixmap (IntPtr raw, IntPtr arg1);
		public void SetPixmap (QPixmap arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_setPixmap (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QButton_accel (IntPtr raw);
		public QKeySequence Accel ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QButton_accel (rawObject), typeof (QKeySequence)) as QKeySequence;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_setAccel (IntPtr raw, IntPtr arg1);
		public void SetAccel (QKeySequence arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_setAccel (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QButton_isToggleButton (IntPtr raw);
		public bool IsToggleButton ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QButton_isToggleButton (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ToggleType qt_QButton_toggleType (IntPtr raw);
		public ToggleType TheToggleType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QButton_toggleType (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_setDown (IntPtr raw, bool arg1);
		public void SetDown (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_setDown (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QButton_isDown (IntPtr raw);
		public bool IsDown ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QButton_isDown (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QButton_isOn (IntPtr raw);
		public bool IsOn ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QButton_isOn (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QButton.ToggleState qt_QButton_state (IntPtr raw);
		public QButton.ToggleState State ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QButton_state (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QButton_autoResize (IntPtr raw);
		public bool AutoResize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QButton_autoResize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_setAutoResize (IntPtr raw, bool arg1);
		public void SetAutoResize (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_setAutoResize (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QButton_autoRepeat (IntPtr raw);
		public bool AutoRepeat ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QButton_autoRepeat (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_setAutoRepeat (IntPtr raw, bool arg1);
		public void SetAutoRepeat (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_setAutoRepeat (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QButton_isExclusiveToggle (IntPtr raw);
		public bool IsExclusiveToggle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QButton_isExclusiveToggle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QButton_group (IntPtr raw);
		public QButtonGroup Group ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QButton_group (rawObject), typeof (QButtonGroup)) as QButtonGroup;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_animateClick (IntPtr raw);
		public void AnimateClick ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_animateClick (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_toggle (IntPtr raw);
		public void Toggle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_toggle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_setToggleButton (IntPtr raw, bool arg1);
		protected void SetToggleButton (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_setToggleButton (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_setToggleType (IntPtr raw, ToggleType arg1);
		protected void SetToggleType (ToggleType arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_setToggleType (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_setOn (IntPtr raw, bool arg1);
		protected void SetOn (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_setOn (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_setState (IntPtr raw, QButton.ToggleState arg1);
		protected void SetState (QButton.ToggleState arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_setState (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QButton_hitButton (IntPtr raw, IntPtr pos);
		protected bool HitButton (QPoint pos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QButton_hitButton (rawObject, pos.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_drawButton (IntPtr raw, IntPtr arg1);
		protected void DrawButton (QPainter arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_drawButton (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_drawButtonLabel (IntPtr raw, IntPtr arg1);
		protected void DrawButtonLabel (QPainter arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_drawButtonLabel (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QButton_enabledChange (IntPtr raw, bool arg1);
		protected void EnabledChange (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QButton_enabledChange (rawObject, arg1);
		}

		// Begin interface methods.

	}
}