// QCString.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QCString : QByteArray, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCString ();
		public QCString () : this (QNull.Instance)
		{
			rawObject = qt_new_QCString ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCString1 (int size);
		public QCString (int size) : this (QNull.Instance)
		{
			rawObject = qt_new_QCString1 (size);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCString2 (IntPtr s);
		public QCString (QCString s) : this (QNull.Instance)
		{
			rawObject = qt_new_QCString2 (s.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCString3 (string str);
		public QCString (string str) : this (QNull.Instance)
		{
			rawObject = qt_new_QCString3 (str);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCString4 (string str, uint maxlen);
		public QCString (string str, uint maxlen) : this (QNull.Instance)
		{
			rawObject = qt_new_QCString4 (str, maxlen);
			RegisterObject (this);
		}

		public QCString (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QCString (QNull dummy) : base (QNull.Instance) {}

		~QCString ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QCString (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QCString (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCString_isNull (IntPtr raw);
		public bool IsNull ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_isNull (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCString_isEmpty (IntPtr raw);
		public bool IsEmpty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_isEmpty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QCString_length (IntPtr raw);
		public uint Length ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_length (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCString_resize (IntPtr raw, uint newlen);
		public bool Resize (uint newlen)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_resize (rawObject, newlen);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCString_truncate (IntPtr raw, uint pos);
		public bool Truncate (uint pos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_truncate (rawObject, pos);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCString_fill (IntPtr raw, char c, int len);
		public bool Fill (char c, int len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_fill (rawObject, c, len);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_copy (IntPtr raw);
		public QCString Copy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_copy (rawObject), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCString_find (IntPtr raw, char c, int index, bool cs);
		public int Find (char c, int index, bool cs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_find (rawObject, c, index, cs);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCString_find1 (IntPtr raw, string str, int index, bool cs);
		public int Find (string str, int index, bool cs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_find1 (rawObject, str, index, cs);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCString_find2 (IntPtr raw, IntPtr arg1, int index);
		public int Find (QRegExp arg1, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_find2 (rawObject, arg1.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCString_findRev (IntPtr raw, char c, int index, bool cs);
		public int FindRev (char c, int index, bool cs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_findRev (rawObject, c, index, cs);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCString_findRev1 (IntPtr raw, string str, int index, bool cs);
		public int FindRev (string str, int index, bool cs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_findRev1 (rawObject, str, index, cs);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCString_findRev2 (IntPtr raw, IntPtr arg1, int index);
		public int FindRev (QRegExp arg1, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_findRev2 (rawObject, arg1.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCString_contains (IntPtr raw, char c, bool cs);
		public int Contains (char c, bool cs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_contains (rawObject, c, cs);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCString_contains1 (IntPtr raw, string str, bool cs);
		public int Contains (string str, bool cs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_contains1 (rawObject, str, cs);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCString_contains2 (IntPtr raw, IntPtr arg1);
		public int Contains (QRegExp arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_contains2 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_left (IntPtr raw, uint len);
		public QCString Left (uint len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_left (rawObject, len), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_right (IntPtr raw, uint len);
		public QCString Right (uint len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_right (rawObject, len), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_mid (IntPtr raw, uint index, uint len);
		public QCString Mid (uint index, uint len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_mid (rawObject, index, len), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_leftJustify (IntPtr raw, uint width, char fill, bool trunc);
		public QCString LeftJustify (uint width, char fill, bool trunc)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_leftJustify (rawObject, width, fill, trunc), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_rightJustify (IntPtr raw, uint width, char fill, bool trunc);
		public QCString RightJustify (uint width, char fill, bool trunc)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_rightJustify (rawObject, width, fill, trunc), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_lower (IntPtr raw);
		public QCString Lower ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_lower (rawObject), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_upper (IntPtr raw);
		public QCString Upper ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_upper (rawObject), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_stripWhiteSpace (IntPtr raw);
		public QCString StripWhiteSpace ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_stripWhiteSpace (rawObject), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_simplifyWhiteSpace (IntPtr raw);
		public QCString SimplifyWhiteSpace ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_simplifyWhiteSpace (rawObject), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_insert (IntPtr raw, uint index, string arg1);
		public QCString Insert (uint index, string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_insert (rawObject, index, arg1), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_insert1 (IntPtr raw, uint index, char arg1);
		public QCString Insert (uint index, char arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_insert1 (rawObject, index, arg1), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_append (IntPtr raw, string arg1);
		public QCString Append (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_append (rawObject, arg1), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_prepend (IntPtr raw, string arg1);
		public QCString Prepend (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_prepend (rawObject, arg1), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_remove (IntPtr raw, uint index, uint len);
		public QCString Remove (uint index, uint len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_remove (rawObject, index, len), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_replace (IntPtr raw, uint index, uint len, string arg1);
		public QCString Replace (uint index, uint len, string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_replace (rawObject, index, len, arg1), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_replace1 (IntPtr raw, IntPtr arg1, string arg2);
		public QCString Replace (QRegExp arg1, string arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_replace1 (rawObject, arg1.RawObject, arg2), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern short qt_QCString_toShort (IntPtr raw, bool ok);
		public short ToShort (bool ok)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_toShort (rawObject, ok);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ushort qt_QCString_toUShort (IntPtr raw, bool ok);
		public ushort ToUShort (bool ok)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_toUShort (rawObject, ok);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCString_toInt (IntPtr raw, bool ok);
		public int ToInt (bool ok)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_toInt (rawObject, ok);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QCString_toUInt (IntPtr raw, bool ok);
		public uint ToUInt (bool ok)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_toUInt (rawObject, ok);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QCString_toLong (IntPtr raw, bool ok);
		public long ToLong (bool ok)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_toLong (rawObject, ok);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ulong qt_QCString_toULong (IntPtr raw, bool ok);
		public ulong ToULong (bool ok)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_toULong (rawObject, ok);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern float qt_QCString_toFloat (IntPtr raw, bool ok);
		public float ToFloat (bool ok)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_toFloat (rawObject, ok);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QCString_toDouble (IntPtr raw, bool ok);
		public double ToDouble (bool ok)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_toDouble (rawObject, ok);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_setStr (IntPtr raw, string s);
		public QCString SetStr (string s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_setStr (rawObject, s), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_setNum (IntPtr raw, short arg1);
		public QCString SetNum (short arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_setNum (rawObject, arg1), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_setNum1 (IntPtr raw, ushort arg1);
		public QCString SetNum (ushort arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_setNum1 (rawObject, arg1), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_setNum2 (IntPtr raw, int arg1);
		public QCString SetNum (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_setNum2 (rawObject, arg1), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_setNum3 (IntPtr raw, uint arg1);
		public QCString SetNum (uint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_setNum3 (rawObject, arg1), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_setNum4 (IntPtr raw, long arg1);
		public QCString SetNum (long arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_setNum4 (rawObject, arg1), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_setNum5 (IntPtr raw, ulong arg1);
		public QCString SetNum (ulong arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_setNum5 (rawObject, arg1), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_setNum6 (IntPtr raw, float arg1, char f, int prec);
		public QCString SetNum (float arg1, char f, int prec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_setNum6 (rawObject, arg1, f, prec), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCString_setNum7 (IntPtr raw, double arg1, char f, int prec);
		public QCString SetNum (double arg1, char f, int prec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCString_setNum7 (rawObject, arg1, f, prec), typeof (QCString)) as QCString;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCString_setExpand (IntPtr raw, uint index, char c);
		public bool SetExpand (uint index, char c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCString_setExpand (rawObject, index, c);
		}

		public bool Fill (char c)
		{
			return Fill(c, (int) -1);
		}

		public int Find (char c)
		{
			return Find(c, (int) 0);
		}

		public int Find (char c, int index)
		{
			return Find(c, index, true);
		}

		public int Find (string str)
		{
			return Find(str, (int) 0);
		}

		public int Find (string str, int index)
		{
			return Find(str, index, true);
		}

		public int Find (QRegExp arg1)
		{
			return Find(arg1, (int) 0);
		}

		public int FindRev (char c)
		{
			return FindRev(c, (int) -1);
		}

		public int FindRev (char c, int index)
		{
			return FindRev(c, index, true);
		}

		public int FindRev (string str)
		{
			return FindRev(str, (int) -1);
		}

		public int FindRev (string str, int index)
		{
			return FindRev(str, index, true);
		}

		public int FindRev (QRegExp arg1)
		{
			return FindRev(arg1, (int) -1);
		}

		public int Contains (char c)
		{
			return Contains(c, true);
		}

		public int Contains (string str)
		{
			return Contains(str, true);
		}

		public QCString Mid (uint index)
		{
			return Mid(index, (uint) 1);
		}

		public QCString LeftJustify (uint width)
		{
			return LeftJustify(width, (char) ' ');
		}

		public QCString LeftJustify (uint width, char fill)
		{
			return LeftJustify(width, fill, false);
		}

		public QCString RightJustify (uint width)
		{
			return RightJustify(width, (char) ' ');
		}

		public QCString RightJustify (uint width, char fill)
		{
			return RightJustify(width, fill, false);
		}

		public short ToShort ()
		{
			return ToShort(false);
		}

		public ushort ToUShort ()
		{
			return ToUShort(false);
		}

		public int ToInt ()
		{
			return ToInt(false);
		}

		public uint ToUInt ()
		{
			return ToUInt(false);
		}

		public long ToLong ()
		{
			return ToLong(false);
		}

		public ulong ToULong ()
		{
			return ToULong(false);
		}

		public float ToFloat ()
		{
			return ToFloat(false);
		}

		public double ToDouble ()
		{
			return ToDouble(false);
		}

		public QCString SetNum (float arg1)
		{
			return SetNum(arg1, (char) 'g');
		}

		public QCString SetNum (float arg1, char f)
		{
			return SetNum(arg1, f, (int) 6);
		}

		public QCString SetNum (double arg1)
		{
			return SetNum(arg1, (char) 'g');
		}

		public QCString SetNum (double arg1, char f)
		{
			return SetNum(arg1, f, (int) 6);
		}

		// Begin interface methods.

	}
}