// QCache.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QCache : QPtrCollection, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCache1 (int maxCost, int size, bool caseSensitive);
		public QCache (int maxCost, int size, bool caseSensitive) : this (QNull.Instance)
		{
			rawObject = qt_new_QCache1 (maxCost, size, caseSensitive);
			RegisterObject (this);
		}

		public QCache () : this ((int) 100) {}

		public QCache (int maxCost) : this (maxCost, (int) 17) {}

		public QCache (int maxCost, int size) : this (maxCost, size, true) {}

		public QCache (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QCache (QNull dummy) : base (QNull.Instance) {}

		~QCache ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QCache (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QCache (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCache_maxCost (IntPtr raw);
		public int MaxCost ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCache_maxCost (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCache_totalCost (IntPtr raw);
		public int TotalCost ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCache_totalCost (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCache_setMaxCost (IntPtr raw, int m);
		public void SetMaxCost (int m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCache_setMaxCost (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QCache_count (IntPtr raw);
		public uint Count ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCache_count (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QCache_size (IntPtr raw);
		public uint Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCache_size (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCache_isEmpty (IntPtr raw);
		public bool IsEmpty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCache_isEmpty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCache_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCache_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCache_insert (IntPtr raw, IntPtr k, IntPtr d, int c, int p);
		public bool Insert (string k, IntPtr d, int c, int p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCache_insert (rawObject, new QString (k).RawObject, d, c, p);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCache_remove (IntPtr raw, IntPtr k);
		public bool Remove (string k)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCache_remove (rawObject, new QString (k).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCache_take (IntPtr raw, IntPtr k);
		public IntPtr Take (string k)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCache_take (rawObject, new QString (k).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCache_find (IntPtr raw, IntPtr k, bool Q_ref);
		public IntPtr Find (string k, bool Q_ref)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCache_find (rawObject, new QString (k).RawObject, Q_ref);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCache_statistics (IntPtr raw);
		public void Statistics ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCache_statistics (rawObject);
		}

		public bool Insert (string k, IntPtr d)
		{
			return Insert(k, d, (int) 1);
		}

		public bool Insert (string k, IntPtr d, int c)
		{
			return Insert(k, d, c, (int) 0);
		}

		public IntPtr Find (string k)
		{
			return Find(k, true);
		}

		// Begin interface methods.

	}
}