// QCanvas.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QCanvas : QObject, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCanvas (IntPtr parent, string name);
		public QCanvas (QObject parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QCanvas (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCanvas1 (int w, int h);
		public QCanvas (int w, int h) : this (QNull.Instance)
		{
			rawObject = qt_new_QCanvas1 (w, h);
			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCanvas2 (IntPtr p, int h, int v, int tilewidth, int tileheight);
		public QCanvas (QPixmap p, int h, int v, int tilewidth, int tileheight) : this (QNull.Instance)
		{
			rawObject = qt_new_QCanvas2 (p.RawObject, h, v, tilewidth, tileheight);
			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QCanvas () : this (new QObject ()) {}

		public QCanvas (QObject parent) : this (parent, "") {}

		public QCanvas (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QCanvas (QNull dummy) : base (QNull.Instance) {}

		~QCanvas ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QCanvas (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QCanvas (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_setTiles (IntPtr raw, IntPtr tiles, int h, int v, int tilewidth, int tileheight);
		public void SetTiles (QPixmap tiles, int h, int v, int tilewidth, int tileheight)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_setTiles (rawObject, tiles.RawObject, h, v, tilewidth, tileheight);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_setBackgroundPixmap (IntPtr raw, IntPtr p);
		public void SetBackgroundPixmap (QPixmap p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_setBackgroundPixmap (rawObject, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvas_backgroundPixmap (IntPtr raw);
		public QPixmap BackgroundPixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvas_backgroundPixmap (rawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_setBackgroundColor (IntPtr raw, IntPtr c);
		public void SetBackgroundColor (QColor c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_setBackgroundColor (rawObject, c.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvas_backgroundColor (IntPtr raw);
		public QColor BackgroundColor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvas_backgroundColor (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_setTile (IntPtr raw, int x, int y, int tilenum);
		public void SetTile (int x, int y, int tilenum)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_setTile (rawObject, x, y, tilenum);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvas_tile (IntPtr raw, int x, int y);
		public int Tile (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_tile (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvas_tilesHorizontally (IntPtr raw);
		public int TilesHorizontally ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_tilesHorizontally (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvas_tilesVertically (IntPtr raw);
		public int TilesVertically ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_tilesVertically (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvas_tileWidth (IntPtr raw);
		public int TileWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_tileWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvas_tileHeight (IntPtr raw);
		public int TileHeight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_tileHeight (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_resize (IntPtr raw, int width, int height);
		public void Resize (int width, int height)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_resize (rawObject, width, height);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvas_width (IntPtr raw);
		public int Width ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_width (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvas_height (IntPtr raw);
		public int Height ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_height (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvas_size (IntPtr raw);
		public QSize Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvas_size (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvas_rect (IntPtr raw);
		public QRect Rect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvas_rect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvas_onCanvas (IntPtr raw, int x, int y);
		public bool OnCanvas (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_onCanvas (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvas_onCanvas1 (IntPtr raw, IntPtr p);
		public bool OnCanvas (QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_onCanvas1 (rawObject, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvas_validChunk (IntPtr raw, int x, int y);
		public bool ValidChunk (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_validChunk (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvas_validChunk1 (IntPtr raw, IntPtr p);
		public bool ValidChunk (QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_validChunk1 (rawObject, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvas_chunkSize (IntPtr raw);
		public int ChunkSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_chunkSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_retune (IntPtr raw, int chunksize, int maxclusters);
		public void Retune (int chunksize, int maxclusters)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_retune (rawObject, chunksize, maxclusters);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvas_sameChunk (IntPtr raw, int x1, int y1, int x2, int y2);
		public bool SameChunk (int x1, int y1, int x2, int y2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvas_sameChunk (rawObject, x1, y1, x2, y2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_setChangedChunk (IntPtr raw, int i, int j);
		public void SetChangedChunk (int i, int j)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_setChangedChunk (rawObject, i, j);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_setChangedChunkContaining (IntPtr raw, int x, int y);
		public void SetChangedChunkContaining (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_setChangedChunkContaining (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_setAllChanged (IntPtr raw);
		public void SetAllChanged ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_setAllChanged (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_setChanged (IntPtr raw, IntPtr area);
		public void SetChanged (QRect area)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_setChanged (rawObject, area.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_setUnchanged (IntPtr raw, IntPtr area);
		public void SetUnchanged (QRect area)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_setUnchanged (rawObject, area.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_addItemToChunk (IntPtr raw, IntPtr arg1, int i, int j);
		public void AddItemToChunk (QCanvasItem arg1, int i, int j)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_addItemToChunk (rawObject, arg1.RawObject, i, j);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_removeItemFromChunk (IntPtr raw, IntPtr arg1, int i, int j);
		public void RemoveItemFromChunk (QCanvasItem arg1, int i, int j)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_removeItemFromChunk (rawObject, arg1.RawObject, i, j);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_addItemToChunkContaining (IntPtr raw, IntPtr arg1, int x, int y);
		public void AddItemToChunkContaining (QCanvasItem arg1, int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_addItemToChunkContaining (rawObject, arg1.RawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_removeItemFromChunkContaining (IntPtr raw, IntPtr arg1, int x, int y);
		public void RemoveItemFromChunkContaining (QCanvasItem arg1, int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_removeItemFromChunkContaining (rawObject, arg1.RawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvas_allItems (IntPtr raw);
		public QCanvasItemList AllItems ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvas_allItems (rawObject), typeof (QCanvasItemList)) as QCanvasItemList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvas_collisions (IntPtr raw, IntPtr arg1);
		public QCanvasItemList Collisions (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvas_collisions (rawObject, arg1.RawObject), typeof (QCanvasItemList)) as QCanvasItemList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvas_collisions1 (IntPtr raw, IntPtr arg1);
		public QCanvasItemList Collisions (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvas_collisions1 (rawObject, arg1.RawObject), typeof (QCanvasItemList)) as QCanvasItemList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvas_collisions2 (IntPtr raw, IntPtr pa, IntPtr item, bool exact);
		public QCanvasItemList Collisions (QPointArray pa, QCanvasItem item, bool exact)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvas_collisions2 (rawObject, pa.RawObject, item.RawObject, exact), typeof (QCanvasItemList)) as QCanvasItemList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_drawArea (IntPtr raw, IntPtr arg1, IntPtr p, bool double_buffer);
		public void DrawArea (QRect arg1, QPainter p, bool double_buffer)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_drawArea (rawObject, arg1.RawObject, p.RawObject, double_buffer);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_addView (IntPtr raw, IntPtr arg1);
		public void AddView (QCanvasView arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_addView (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_removeView (IntPtr raw, IntPtr arg1);
		public void RemoveView (QCanvasView arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_removeView (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_drawCanvasArea (IntPtr raw, IntPtr arg1, IntPtr p, bool double_buffer);
		public void DrawCanvasArea (QRect arg1, QPainter p, bool double_buffer)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_drawCanvasArea (rawObject, arg1.RawObject, p.RawObject, double_buffer);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_drawViewArea (IntPtr raw, IntPtr view, IntPtr p, IntPtr r, bool dbuf);
		public void DrawViewArea (QCanvasView view, QPainter p, QRect r, bool dbuf)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_drawViewArea (rawObject, view.RawObject, p.RawObject, r.RawObject, dbuf);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_addItem (IntPtr raw, IntPtr arg1);
		public void AddItem (QCanvasItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_addItem (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_addAnimation (IntPtr raw, IntPtr arg1);
		public void AddAnimation (QCanvasItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_addAnimation (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_removeItem (IntPtr raw, IntPtr arg1);
		public void RemoveItem (QCanvasItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_removeItem (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_removeAnimation (IntPtr raw, IntPtr arg1);
		public void RemoveAnimation (QCanvasItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_removeAnimation (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_setAdvancePeriod (IntPtr raw, int ms);
		public void SetAdvancePeriod (int ms)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_setAdvancePeriod (rawObject, ms);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_setUpdatePeriod (IntPtr raw, int ms);
		public void SetUpdatePeriod (int ms)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_setUpdatePeriod (rawObject, ms);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_setDoubleBuffering (IntPtr raw, bool y);
		public void SetDoubleBuffering (bool y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_setDoubleBuffering (rawObject, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_advance (IntPtr raw);
		public void Advance ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_advance (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_update (IntPtr raw);
		public void Update ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_update (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_drawBackground (IntPtr raw, IntPtr arg1, IntPtr area);
		protected void DrawBackground (QPainter arg1, QRect area)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_drawBackground (rawObject, arg1.RawObject, area.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvas_drawForeground (IntPtr raw, IntPtr arg1, IntPtr area);
		protected void DrawForeground (QPainter arg1, QRect area)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvas_drawForeground (rawObject, arg1.RawObject, area.RawObject);
		}

		public void Retune (int chunksize)
		{
			Retune(chunksize, (int) 100);
		}

		public void DrawArea (QRect arg1, QPainter p)
		{
			DrawArea(arg1, p, false);
		}

		public void DrawCanvasArea (QRect arg1)
		{
			DrawCanvasArea(arg1, new QPainter ());
		}

		public void DrawCanvasArea (QRect arg1, QPainter p)
		{
			DrawCanvasArea(arg1, p, true);
		}

		// Begin interface methods.

	}
}