// QCanvasItem.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QCanvasItem : QtSupport, IDisposable {

		public enum RttiValues {
			Rtti_Item = 0,
			Rtti_Sprite = 1,
			Rtti_PolygonalItem = 2,
			Rtti_Text = 3,
			Rtti_Polygon = 4,
			Rtti_Rectangle = 5,
			Rtti_Ellipse = 6,
			Rtti_Line = 7,
			Rtti_Spline = 8
		}

		internal QCanvasItem () : this (QNull.Instance) {}

		public QCanvasItem (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QCanvasItem (QNull dummy) : base (QNull.Instance) {}

		~QCanvasItem ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QCanvasItem (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QCanvasItem (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QCanvasItem_x (IntPtr raw);
		public double X ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_x (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QCanvasItem_y (IntPtr raw);
		public double Y ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_y (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QCanvasItem_z (IntPtr raw);
		public double Z ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_z (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_moveBy (IntPtr raw, double dx, double dy);
		public void MoveBy (double dx, double dy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_moveBy (rawObject, dx, dy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_move (IntPtr raw, double x, double y);
		public void Move (double x, double y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_move (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_setX (IntPtr raw, double a);
		public void SetX (double a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_setX (rawObject, a);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_setY (IntPtr raw, double a);
		public void SetY (double a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_setY (rawObject, a);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_setZ (IntPtr raw, double a);
		public void SetZ (double a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_setZ (rawObject, a);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvasItem_animated (IntPtr raw);
		public bool Animated ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_animated (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_setAnimated (IntPtr raw, bool y);
		public void SetAnimated (bool y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_setAnimated (rawObject, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_setVelocity (IntPtr raw, double vx, double vy);
		public void SetVelocity (double vx, double vy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_setVelocity (rawObject, vx, vy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_setXVelocity (IntPtr raw, double vx);
		public void SetXVelocity (double vx)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_setXVelocity (rawObject, vx);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_setYVelocity (IntPtr raw, double vy);
		public void SetYVelocity (double vy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_setYVelocity (rawObject, vy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QCanvasItem_xVelocity (IntPtr raw);
		public double XVelocity ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_xVelocity (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QCanvasItem_yVelocity (IntPtr raw);
		public double YVelocity ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_yVelocity (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_advance (IntPtr raw, int stage);
		public void Advance (int stage)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_advance (rawObject, stage);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvasItem_collidesWith (IntPtr raw, IntPtr arg1);
		public bool CollidesWith (QCanvasItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_collidesWith (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvasItem_collisions (IntPtr raw, bool exact);
		public QCanvasItemList Collisions (bool exact)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvasItem_collisions (rawObject, exact), typeof (QCanvasItemList)) as QCanvasItemList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_setCanvas (IntPtr raw, IntPtr arg1);
		public void SetCanvas (QCanvas arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_setCanvas (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_draw (IntPtr raw, IntPtr arg1);
		public void Draw (QPainter arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_draw (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_show (IntPtr raw);
		public void Show ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_show (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_hide (IntPtr raw);
		public void Hide ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_hide (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_setVisible (IntPtr raw, bool yes);
		public void SetVisible (bool yes)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_setVisible (rawObject, yes);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvasItem_isVisible (IntPtr raw);
		public bool IsVisible ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_isVisible (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_setSelected (IntPtr raw, bool yes);
		public void SetSelected (bool yes)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_setSelected (rawObject, yes);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvasItem_isSelected (IntPtr raw);
		public bool IsSelected ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_isSelected (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_setEnabled (IntPtr raw, bool yes);
		public void SetEnabled (bool yes)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_setEnabled (rawObject, yes);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvasItem_isEnabled (IntPtr raw);
		public bool IsEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_isEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasItem_setActive (IntPtr raw, bool yes);
		public void SetActive (bool yes)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasItem_setActive (rawObject, yes);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvasItem_isActive (IntPtr raw);
		public bool IsActive ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_isActive (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvasItem_visible (IntPtr raw);
		public bool Visible ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_visible (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvasItem_selected (IntPtr raw);
		public bool Selected ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_selected (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvasItem_enabled (IntPtr raw);
		public bool Enabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_enabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvasItem_active (IntPtr raw);
		public bool Active ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_active (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasItem_rtti (IntPtr raw);
		public int Rtti ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasItem_rtti (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvasItem_boundingRect (IntPtr raw);
		public QRect BoundingRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvasItem_boundingRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvasItem_boundingRectAdvanced (IntPtr raw);
		public QRect BoundingRectAdvanced ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvasItem_boundingRectAdvanced (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvasItem_canvas (IntPtr raw);
		public QCanvas Canvas ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvasItem_canvas (rawObject), typeof (QCanvas)) as QCanvas;
		}

		// Begin interface methods.

	}
}