// QCanvasSprite.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QCanvasSprite : QCanvasItem, IDisposable {

		public enum FrameAnimationType {
			Cycle = 0,
			Oscillate = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCanvasSprite (IntPtr array, IntPtr canvas);
		public QCanvasSprite (QCanvasPixmapArray array, QCanvas canvas) : this (QNull.Instance)
		{
			rawObject = qt_new_QCanvasSprite (array.RawObject, canvas.RawObject);
			RegisterObject (this);
		}

		internal QCanvasSprite () : this (QNull.Instance) {}

		public QCanvasSprite (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QCanvasSprite (QNull dummy) : base (QNull.Instance) {}

		~QCanvasSprite ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QCanvasSprite (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QCanvasSprite (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasSprite_setSequence (IntPtr raw, IntPtr seq);
		public void SetSequence (QCanvasPixmapArray seq)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasSprite_setSequence (rawObject, seq.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasSprite_move (IntPtr raw, double x, double y);
		public void Move (double x, double y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasSprite_move (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasSprite_move1 (IntPtr raw, double x, double y, int frame);
		public void Move (double x, double y, int frame)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasSprite_move1 (rawObject, x, y, frame);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasSprite_setFrame (IntPtr raw, int arg1);
		public void SetFrame (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasSprite_setFrame (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasSprite_setFrameAnimation (IntPtr raw, QCanvasSprite.FrameAnimationType arg1, int step, int state);
		public void SetFrameAnimation (QCanvasSprite.FrameAnimationType arg1, int step, int state)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasSprite_setFrameAnimation (rawObject, arg1, step, state);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_frame (IntPtr raw);
		public int Frame ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_frame (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_frameCount (IntPtr raw);
		public int FrameCount ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_frameCount (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_rtti (IntPtr raw);
		public int Rtti ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_rtti (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCanvasSprite_collidesWith (IntPtr raw, IntPtr arg1);
		public bool CollidesWith (QCanvasItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_collidesWith (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvasSprite_boundingRect (IntPtr raw);
		public QRect BoundingRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvasSprite_boundingRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_width (IntPtr raw);
		public int Width ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_width (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_height (IntPtr raw);
		public int Height ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_height (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_leftEdge (IntPtr raw);
		public int LeftEdge ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_leftEdge (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_topEdge (IntPtr raw);
		public int TopEdge ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_topEdge (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_rightEdge (IntPtr raw);
		public int RightEdge ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_rightEdge (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_bottomEdge (IntPtr raw);
		public int BottomEdge ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_bottomEdge (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_leftEdge1 (IntPtr raw, int nx);
		public int LeftEdge (int nx)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_leftEdge1 (rawObject, nx);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_topEdge1 (IntPtr raw, int ny);
		public int TopEdge (int ny)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_topEdge1 (rawObject, ny);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_rightEdge1 (IntPtr raw, int nx);
		public int RightEdge (int nx)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_rightEdge1 (rawObject, nx);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCanvasSprite_bottomEdge1 (IntPtr raw, int ny);
		public int BottomEdge (int ny)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCanvasSprite_bottomEdge1 (rawObject, ny);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvasSprite_image (IntPtr raw);
		public QCanvasPixmap Image ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvasSprite_image (rawObject), typeof (QCanvasPixmap)) as QCanvasPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvasSprite_imageAdvanced (IntPtr raw);
		public QCanvasPixmap ImageAdvanced ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvasSprite_imageAdvanced (rawObject), typeof (QCanvasPixmap)) as QCanvasPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCanvasSprite_image1 (IntPtr raw, int f);
		public QCanvasPixmap Image (int f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCanvasSprite_image1 (rawObject, f), typeof (QCanvasPixmap)) as QCanvasPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasSprite_advance (IntPtr raw, int stage);
		public void Advance (int stage)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasSprite_advance (rawObject, stage);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCanvasSprite_draw (IntPtr raw, IntPtr painter);
		public void Draw (QPainter painter)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCanvasSprite_draw (rawObject, painter.RawObject);
		}

		public void SetFrameAnimation ()
		{
			SetFrameAnimation(QCanvasSprite.FrameAnimationType.Cycle);
		}

		public void SetFrameAnimation (QCanvasSprite.FrameAnimationType arg1)
		{
			SetFrameAnimation(arg1, (int) 1);
		}

		public void SetFrameAnimation (QCanvasSprite.FrameAnimationType arg1, int step)
		{
			SetFrameAnimation(arg1, step, (int) 0);
		}

		// Begin interface methods.

	}
}