// QCharRef.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QCharRef : QtSupport, IDisposable {

		internal QCharRef () : this (QNull.Instance) {}

		public QCharRef (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QCharRef (QNull dummy) : base (QNull.Instance) {}

		~QCharRef ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QCharRef function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ushort qt_QCharRef_unicode (IntPtr raw);
		public ushort Unicode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_unicode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern char qt_QCharRef_latin1 (IntPtr raw);
		public char Latin1 ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_latin1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCharRef_isNull (IntPtr raw);
		public bool IsNull ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_isNull (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCharRef_isPrint (IntPtr raw);
		public bool IsPrint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_isPrint (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCharRef_isPunct (IntPtr raw);
		public bool IsPunct ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_isPunct (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCharRef_isSpace (IntPtr raw);
		public bool IsSpace ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_isSpace (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCharRef_isMark (IntPtr raw);
		public bool IsMark ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_isMark (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCharRef_isLetter (IntPtr raw);
		public bool IsLetter ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_isLetter (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCharRef_isNumber (IntPtr raw);
		public bool IsNumber ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_isNumber (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCharRef_isLetterOrNumber (IntPtr raw);
		public bool IsLetterOrNumber ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_isLetterOrNumber (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCharRef_isDigit (IntPtr raw);
		public bool IsDigit ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_isDigit (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCharRef_digitValue (IntPtr raw);
		public int DigitValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_digitValue (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCharRef_lower (IntPtr raw);
		public QChar Lower ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCharRef_lower (rawObject), typeof (QChar)) as QChar;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCharRef_upper (IntPtr raw);
		public QChar Upper ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCharRef_upper (rawObject), typeof (QChar)) as QChar;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QChar.Category qt_QCharRef_category (IntPtr raw);
		public QChar.Category Category ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_category (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QChar.Direction qt_QCharRef_direction (IntPtr raw);
		public QChar.Direction Direction ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_direction (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QChar.Joining qt_QCharRef_joining (IntPtr raw);
		public QChar.Joining Joining ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_joining (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCharRef_mirrored (IntPtr raw);
		public bool Mirrored ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_mirrored (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCharRef_mirroredChar (IntPtr raw);
		public QChar MirroredChar ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCharRef_mirroredChar (rawObject), typeof (QChar)) as QChar;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCharRef_decomposition (IntPtr raw);
		public string Decomposition ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QCharRef_decomposition (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QChar.Decomposition qt_QCharRef_decompositionTag (IntPtr raw);
		public QChar.Decomposition DecompositionTag ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_decompositionTag (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QCharRef_combiningClass (IntPtr raw);
		public string CombiningClass ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_combiningClass (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QCharRef_cell (IntPtr raw);
		public string Cell ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_cell (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QCharRef_row (IntPtr raw);
		public string Row ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCharRef_row (rawObject);
		}
	}
}