// QCheckBox.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QCheckBox : QButton, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCheckBox (IntPtr parent, string name);
		public QCheckBox (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QCheckBox (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCheckBox1 (IntPtr text, IntPtr parent, string name);
		public QCheckBox (string text, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QCheckBox1 (new QString (text).RawObject, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QCheckBox (QWidget parent) : this (parent, "") {}

		public QCheckBox (string text, QWidget parent) : this (text, parent, "") {}

		internal QCheckBox () : this (QNull.Instance) {}

		public QCheckBox (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QCheckBox (QNull dummy) : base (QNull.Instance) {}

		~QCheckBox ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QCheckBox function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCheckBox_isChecked (IntPtr raw);
		public bool IsChecked ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCheckBox_isChecked (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCheckBox_setChecked (IntPtr raw, bool check);
		public void SetChecked (bool check)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCheckBox_setChecked (rawObject, check);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCheckBox_setNoChange (IntPtr raw);
		public void SetNoChange ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCheckBox_setNoChange (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCheckBox_setTristate (IntPtr raw, bool y);
		public void SetTristate (bool y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCheckBox_setTristate (rawObject, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QCheckBox_isTristate (IntPtr raw);
		public bool IsTristate ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCheckBox_isTristate (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCheckBox_drawButton (IntPtr raw, IntPtr arg1);
		protected void DrawButton (QPainter arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCheckBox_drawButton (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCheckBox_drawButtonLabel (IntPtr raw, IntPtr arg1);
		protected void DrawButtonLabel (QPainter arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCheckBox_drawButtonLabel (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCheckBox_updateMask (IntPtr raw);
		protected void UpdateMask ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCheckBox_updateMask (rawObject);
		}

		public void SetTristate ()
		{
			SetTristate(true);
		}

		// Begin interface methods.

	}
}