// QClipboard.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QClipboard : QObject, IDisposable {

		internal QClipboard () : this (QNull.Instance) {}

		public QClipboard (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QClipboard (QNull dummy) : base (QNull.Instance) {}

		~QClipboard ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QClipboard function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QClipboard_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QClipboard_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QClipboard_supportsSelection (IntPtr raw);
		public bool SupportsSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QClipboard_supportsSelection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QClipboard_ownsSelection (IntPtr raw);
		public bool OwnsSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QClipboard_ownsSelection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QClipboard_ownsClipboard (IntPtr raw);
		public bool OwnsClipboard ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QClipboard_ownsClipboard (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QClipboard_setSelectionMode (IntPtr raw, bool enable);
		public void SetSelectionMode (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QClipboard_setSelectionMode (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QClipboard_selectionModeEnabled (IntPtr raw);
		public bool SelectionModeEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QClipboard_selectionModeEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QClipboard_data (IntPtr raw);
		public QMimeSource Data ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QClipboard_data (rawObject), typeof (QMimeSource)) as QMimeSource;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QClipboard_setData (IntPtr raw, IntPtr arg1);
		public void SetData (QMimeSource arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QClipboard_setData (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QClipboard_text (IntPtr raw);
		public string Text ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QClipboard_text (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QClipboard_text1 (IntPtr raw, IntPtr subtype);
		public string Text (QCString subtype)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QClipboard_text1 (rawObject, subtype.RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QClipboard_setText (IntPtr raw, IntPtr arg1);
		public void SetText (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QClipboard_setText (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QClipboard_image (IntPtr raw);
		public QImage Image ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QClipboard_image (rawObject), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QClipboard_pixmap (IntPtr raw);
		public QPixmap Pixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QClipboard_pixmap (rawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QClipboard_setImage (IntPtr raw, IntPtr arg1);
		public void SetImage (QImage arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QClipboard_setImage (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QClipboard_setPixmap (IntPtr raw, IntPtr arg1);
		public void SetPixmap (QPixmap arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QClipboard_setPixmap (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QClipboard_connectNotify (IntPtr raw, string arg1);
		protected void ConnectNotify (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QClipboard_connectNotify (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QClipboard_event (IntPtr raw, IntPtr arg1);
		protected bool Q_event (QEvent arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QClipboard_event (rawObject, arg1.RawObject);
		}

		// Begin interface methods.

	}
}