// QColor.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QColor : QtSupport, IDisposable {

		public enum Spec {
			Rgb = 0,
			Hsv = 1
		}

		public enum blank {
			Dirt = 1145655892,
			Invalid = 1224736768
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QColor ();
		public QColor () : this (QNull.Instance)
		{
			rawObject = qt_new_QColor ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QColor1 (int r, int g, int b);
		public QColor (int r, int g, int b) : this (QNull.Instance)
		{
			rawObject = qt_new_QColor1 (r, g, b);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QColor2 (int x, int y, int z, QColor.Spec arg1);
		public QColor (int x, int y, int z, QColor.Spec arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QColor2 (x, y, z, arg1);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QColor3 (int rgb, uint pixel);
		public QColor (int rgb, uint pixel) : this (QNull.Instance)
		{
			rawObject = qt_new_QColor3 (rgb, pixel);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QColor4 (IntPtr name);
		public QColor (string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QColor4 (new QString (name).RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QColor6 (IntPtr arg1);
		public QColor (QColor arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QColor6 (arg1.RawObject);
			RegisterObject (this);
		}

		public QColor (int rgb) : this (rgb, (uint) 1) {}

		public QColor (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QColor (QNull dummy) : base (QNull.Instance) {}

		~QColor ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QColor function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QColor_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QColor_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QColor_isDirty (IntPtr raw);
		public bool IsDirty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QColor_isDirty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColor_name (IntPtr raw);
		public string Name ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QColor_name (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColor_setNamedColor (IntPtr raw, IntPtr name);
		public void SetNamedColor (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QColor_setNamedColor (rawObject, new QString (name).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColor_rgb (IntPtr raw, int[] r, int[] g, int[] b);
		public void Rgb (int[] r, int[] g, int[] b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QColor_rgb (rawObject, r, g, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QColor_rgb1 (IntPtr raw);
		public int Rgb ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QColor_rgb1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColor_setRgb (IntPtr raw, int r, int g, int b);
		public void SetRgb (int r, int g, int b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QColor_setRgb (rawObject, r, g, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColor_setRgb1 (IntPtr raw, int rgb);
		public void SetRgb (int rgb)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QColor_setRgb1 (rawObject, rgb);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QColor_red (IntPtr raw);
		public int Red ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QColor_red (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QColor_green (IntPtr raw);
		public int Green ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QColor_green (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QColor_blue (IntPtr raw);
		public int Blue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QColor_blue (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColor_hsv (IntPtr raw, int[] h, int[] s, int[] v);
		public void Hsv (int[] h, int[] s, int[] v)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QColor_hsv (rawObject, h, s, v);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColor_getHsv (IntPtr raw, int h, int s, int v);
		public void GetHsv (int h, int s, int v)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QColor_getHsv (rawObject, h, s, v);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColor_setHsv (IntPtr raw, int h, int s, int v);
		public void SetHsv (int h, int s, int v)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QColor_setHsv (rawObject, h, s, v);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColor_light (IntPtr raw, int f);
		public QColor Light (int f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColor_light (rawObject, f), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColor_dark (IntPtr raw, int f);
		public QColor Dark (int f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColor_dark (rawObject, f), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QColor_alloc (IntPtr raw);
		public uint Alloc ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QColor_alloc (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QColor_pixel (IntPtr raw);
		public uint Pixel ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QColor_pixel (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QColor_maxColors ();
		public static int MaxColors ()
		{
			return qt_QColor_maxColors ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QColor_numBitPlanes ();
		public static int NumBitPlanes ()
		{
			return qt_QColor_numBitPlanes ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QColor_enterAllocContext ();
		public static int EnterAllocContext ()
		{
			return qt_QColor_enterAllocContext ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColor_leaveAllocContext ();
		public static void LeaveAllocContext ()
		{
			qt_QColor_leaveAllocContext ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QColor_currentAllocContext ();
		public static int CurrentAllocContext ()
		{
			return qt_QColor_currentAllocContext ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColor_destroyAllocContext (int arg1);
		public static void DestroyAllocContext (int arg1)
		{
			qt_QColor_destroyAllocContext (arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QColor_palette (int[] numEntries);
		public static int Palette (int[] numEntries)
		{
			return qt_QColor_palette (numEntries);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QColor_setPaletteEntries (int entries, int numEntries, int Q_base);
		public static int SetPaletteEntries (int entries, int numEntries, int Q_base)
		{
			return qt_QColor_setPaletteEntries (entries, numEntries, Q_base);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QColor_hPal ();
		public static uint HPal ()
		{
			return qt_QColor_hPal ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QColor_realizePal (IntPtr arg1);
		public static uint RealizePal (QWidget arg1)
		{
			return qt_QColor_realizePal (arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColor_initialize ();
		public static void Initialize ()
		{
			qt_QColor_initialize ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColor_cleanup ();
		public static void Cleanup ()
		{
			qt_QColor_cleanup ();
		}

		public QColor Light ()
		{
			return Light((int) 150);
		}

		public QColor Dark ()
		{
			return Dark((int) 200);
		}

		public static int Palette ()
		{
			return Palette(new int[]{0});
		}

		public static int SetPaletteEntries (int entries, int numEntries)
		{
			return SetPaletteEntries(entries, numEntries, (int) -1);
		}
	}
}