// QColorGroup.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QColorGroup : QtSupport, IDisposable {

		public enum ColorRole {
			Foreground = 0,
			Button = 1,
			Light = 2,
			Midlight = 3,
			Dark = 4,
			Mid = 5,
			Text = 6,
			BrightText = 7,
			ButtonText = 8,
			Base = 9,
			Background = 10,
			Shadow = 11,
			Highlight = 12,
			HighlightedText = 13,
			Link = 14,
			LinkVisited = 15,
			NColorRoles = 16
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QColorGroup ();
		public QColorGroup () : this (QNull.Instance)
		{
			rawObject = qt_new_QColorGroup ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QColorGroup1 (IntPtr foreground, IntPtr button, IntPtr light, IntPtr dark, IntPtr mid, IntPtr text, IntPtr Q_base);
		public QColorGroup (QColor foreground, QColor button, QColor light, QColor dark, QColor mid, QColor text, QColor Q_base) : this (QNull.Instance)
		{
			rawObject = qt_new_QColorGroup1 (foreground.RawObject, button.RawObject, light.RawObject, dark.RawObject, mid.RawObject, text.RawObject, Q_base.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QColorGroup2 (IntPtr foreground, IntPtr button, IntPtr light, IntPtr dark, IntPtr mid, IntPtr text, IntPtr bright_text, IntPtr Q_base, IntPtr background);
		public QColorGroup (QBrush foreground, QBrush button, QBrush light, QBrush dark, QBrush mid, QBrush text, QBrush bright_text, QBrush Q_base, QBrush background) : this (QNull.Instance)
		{
			rawObject = qt_new_QColorGroup2 (foreground.RawObject, button.RawObject, light.RawObject, dark.RawObject, mid.RawObject, text.RawObject, bright_text.RawObject, Q_base.RawObject, background.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QColorGroup3 (IntPtr arg1);
		public QColorGroup (QColorGroup arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QColorGroup3 (arg1.RawObject);
			RegisterObject (this);
		}

		public QColorGroup (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QColorGroup (QNull dummy) : base (QNull.Instance) {}

		~QColorGroup ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QColorGroup (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QColorGroup (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_color (IntPtr raw, QColorGroup.ColorRole arg1);
		public QColor Color (QColorGroup.ColorRole arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_color (rawObject, arg1), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_brush (IntPtr raw, QColorGroup.ColorRole arg1);
		public QBrush Brush (QColorGroup.ColorRole arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_brush (rawObject, arg1), typeof (QBrush)) as QBrush;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColorGroup_setColor (IntPtr raw, QColorGroup.ColorRole arg1, IntPtr arg2);
		public void SetColor (QColorGroup.ColorRole arg1, QColor arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QColorGroup_setColor (rawObject, arg1, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QColorGroup_setBrush (IntPtr raw, QColorGroup.ColorRole arg1, IntPtr arg2);
		public void SetBrush (QColorGroup.ColorRole arg1, QBrush arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QColorGroup_setBrush (rawObject, arg1, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_foreground (IntPtr raw);
		public QColor Foreground ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_foreground (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_button (IntPtr raw);
		public QColor Button ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_button (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_light (IntPtr raw);
		public QColor Light ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_light (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_dark (IntPtr raw);
		public QColor Dark ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_dark (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_mid (IntPtr raw);
		public QColor Mid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_mid (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_text (IntPtr raw);
		public QColor Text ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_text (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_base (IntPtr raw);
		public QColor Q_base ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_base (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_background (IntPtr raw);
		public QColor Background ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_background (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_midlight (IntPtr raw);
		public QColor Midlight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_midlight (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_brightText (IntPtr raw);
		public QColor BrightText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_brightText (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_buttonText (IntPtr raw);
		public QColor ButtonText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_buttonText (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_shadow (IntPtr raw);
		public QColor Shadow ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_shadow (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_highlight (IntPtr raw);
		public QColor Highlight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_highlight (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_highlightedText (IntPtr raw);
		public QColor HighlightedText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_highlightedText (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_link (IntPtr raw);
		public QColor Link ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_link (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QColorGroup_linkVisited (IntPtr raw);
		public QColor LinkVisited ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QColorGroup_linkVisited (rawObject), typeof (QColor)) as QColor;
		}
	}
}