// QComboTableItem.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QComboTableItem : QTableItem, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QComboTableItem (IntPtr table, IntPtr list, bool editable);
		public QComboTableItem (QTable table, QStringList list, bool editable) : this (QNull.Instance)
		{
			rawObject = qt_new_QComboTableItem (table.RawObject, list.RawObject, editable);
			RegisterObject (this);
		}

		public QComboTableItem (QTable table, QStringList list) : this (table, list, false) {}

		internal QComboTableItem () : this (QNull.Instance) {}

		public QComboTableItem (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QComboTableItem (QNull dummy) : base (QNull.Instance) {}

		~QComboTableItem ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QComboTableItem function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QComboTableItem_createEditor (IntPtr raw);
		public QWidget CreateEditor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QComboTableItem_createEditor (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QComboTableItem_setContentFromEditor (IntPtr raw, IntPtr w);
		public void SetContentFromEditor (QWidget w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QComboTableItem_setContentFromEditor (rawObject, w.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QComboTableItem_paint (IntPtr raw, IntPtr p, IntPtr cg, IntPtr cr, bool selected);
		public void Paint (QPainter p, QColorGroup cg, QRect cr, bool selected)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QComboTableItem_paint (rawObject, p.RawObject, cg.RawObject, cr.RawObject, selected);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QComboTableItem_setCurrentItem (IntPtr raw, int i);
		public void SetCurrentItem (int i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QComboTableItem_setCurrentItem (rawObject, i);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QComboTableItem_setCurrentItem1 (IntPtr raw, IntPtr i);
		public void SetCurrentItem (string i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QComboTableItem_setCurrentItem1 (rawObject, new QString (i).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QComboTableItem_currentItem (IntPtr raw);
		public int CurrentItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QComboTableItem_currentItem (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QComboTableItem_currentText (IntPtr raw);
		public string CurrentText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QComboTableItem_currentText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QComboTableItem_count (IntPtr raw);
		public int Count ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QComboTableItem_count (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QComboTableItem_text (IntPtr raw, int i);
		public string Text (int i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QComboTableItem_text (rawObject, i));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QComboTableItem_setEditable (IntPtr raw, bool b);
		public void SetEditable (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QComboTableItem_setEditable (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QComboTableItem_isEditable (IntPtr raw);
		public bool IsEditable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QComboTableItem_isEditable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QComboTableItem_setStringList (IntPtr raw, IntPtr l);
		public void SetStringList (QStringList l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QComboTableItem_setStringList (rawObject, l.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QComboTableItem_rtti (IntPtr raw);
		public int Rtti ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QComboTableItem_rtti (rawObject);
		}

		// Begin interface methods.

	}
}