// QContextMenuEvent.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QContextMenuEvent : QEvent, IDisposable {

		public enum Reason {
			Mouse = 0,
			Keyboard = 1,
			Other = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QContextMenuEvent (Reason reason, IntPtr pos, IntPtr globalPos, int state);
		public QContextMenuEvent (Reason reason, QPoint pos, QPoint globalPos, int state) : this (QNull.Instance)
		{
			rawObject = qt_new_QContextMenuEvent (reason, pos.RawObject, globalPos.RawObject, state);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QContextMenuEvent1 (Reason reason, IntPtr pos, int state);
		public QContextMenuEvent (Reason reason, QPoint pos, int state) : this (QNull.Instance)
		{
			rawObject = qt_new_QContextMenuEvent1 (reason, pos.RawObject, state);
			RegisterObject (this);
		}

		internal QContextMenuEvent () : this (QNull.Instance) {}

		public QContextMenuEvent (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QContextMenuEvent (QNull dummy) : base (QNull.Instance) {}

		~QContextMenuEvent ()
		{
			Dispose (false);
		}
		internal override void Delete ()
		{
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QContextMenuEvent_x (IntPtr raw);
		public int X ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QContextMenuEvent_x (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QContextMenuEvent_y (IntPtr raw);
		public int Y ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QContextMenuEvent_y (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QContextMenuEvent_globalX (IntPtr raw);
		public int GlobalX ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QContextMenuEvent_globalX (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QContextMenuEvent_globalY (IntPtr raw);
		public int GlobalY ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QContextMenuEvent_globalY (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QContextMenuEvent_pos (IntPtr raw);
		public QPoint Pos ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QContextMenuEvent_pos (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QContextMenuEvent_globalPos (IntPtr raw);
		public QPoint GlobalPos ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QContextMenuEvent_globalPos (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.ButtonState qt_QContextMenuEvent_state (IntPtr raw);
		public Qt.ButtonState State ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QContextMenuEvent_state (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QContextMenuEvent_isAccepted (IntPtr raw);
		public bool IsAccepted ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QContextMenuEvent_isAccepted (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QContextMenuEvent_isConsumed (IntPtr raw);
		public bool IsConsumed ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QContextMenuEvent_isConsumed (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QContextMenuEvent_consume (IntPtr raw);
		public void Consume ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QContextMenuEvent_consume (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QContextMenuEvent_accept (IntPtr raw);
		public void Accept ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QContextMenuEvent_accept (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QContextMenuEvent_ignore (IntPtr raw);
		public void Ignore ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QContextMenuEvent_ignore (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Reason qt_QContextMenuEvent_reason (IntPtr raw);
		public Reason TheReason ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QContextMenuEvent_reason (rawObject);
		}

		// Begin interface methods.

	}
}