// QCursor.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QCursor : QtSupport, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCursor ();
		public QCursor () : this (QNull.Instance)
		{
			rawObject = qt_new_QCursor ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCursor1 (int shape);
		public QCursor (int shape) : this (QNull.Instance)
		{
			rawObject = qt_new_QCursor1 (shape);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCursor2 (IntPtr bitmap, IntPtr mask, int hotX, int hotY);
		public QCursor (QBitmap bitmap, QBitmap mask, int hotX, int hotY) : this (QNull.Instance)
		{
			rawObject = qt_new_QCursor2 (bitmap.RawObject, mask.RawObject, hotX, hotY);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCursor3 (IntPtr pixmap, int hotX, int hotY);
		public QCursor (QPixmap pixmap, int hotX, int hotY) : this (QNull.Instance)
		{
			rawObject = qt_new_QCursor3 (pixmap.RawObject, hotX, hotY);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCursor4 (IntPtr arg1);
		public QCursor (QCursor arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QCursor4 (arg1.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QCursor5 (uint arg1);
		public QCursor (uint arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QCursor5 (arg1);
			RegisterObject (this);
		}

		public QCursor (QBitmap bitmap, QBitmap mask) : this (bitmap, mask, (int) -1) {}

		public QCursor (QBitmap bitmap, QBitmap mask, int hotX) : this (bitmap, mask, hotX, (int) -1) {}

		public QCursor (QPixmap pixmap) : this (pixmap, (int) -1) {}

		public QCursor (QPixmap pixmap, int hotX) : this (pixmap, hotX, (int) -1) {}

		public QCursor (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QCursor (QNull dummy) : base (QNull.Instance) {}

		~QCursor ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QCursor (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QCursor (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCursor_shape (IntPtr raw);
		public int Shape ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCursor_shape (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCursor_setShape (IntPtr raw, int arg1);
		public void SetShape (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QCursor_setShape (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCursor_bitmap (IntPtr raw);
		public QBitmap Bitmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCursor_bitmap (rawObject), typeof (QBitmap)) as QBitmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCursor_mask (IntPtr raw);
		public QBitmap Mask ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCursor_mask (rawObject), typeof (QBitmap)) as QBitmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCursor_hotSpot (IntPtr raw);
		public QPoint HotSpot ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QCursor_hotSpot (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QCursor_handle (IntPtr raw);
		public uint Handle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QCursor_handle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QCursor_pos ();
		public static QPoint Pos ()
		{
			return LookupObject (qt_QCursor_pos (), typeof (QPoint)) as QPoint;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCursor_setPos (int x, int y);
		public static void SetPos (int x, int y)
		{
			qt_QCursor_setPos (x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCursor_setPos1 (IntPtr arg1);
		public static void SetPos (QPoint arg1)
		{
			qt_QCursor_setPos1 (arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCursor_initialize ();
		public static void Initialize ()
		{
			qt_QCursor_initialize ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QCursor_cleanup ();
		public static void Cleanup ()
		{
			qt_QCursor_cleanup ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QCursor_x11Screen ();
		public static int X11Screen ()
		{
			return qt_QCursor_x11Screen ();
		}

		// Begin interface methods.


		// Begin interface methods.

	}
}