// QDataBrowser.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDataBrowser : QWidget, IDisposable {

		public enum Boundary {
			Unknown = 0,
			None = 1,
			BeforeBeginning = 2,
			Beginning = 3,
			End = 4,
			AfterEnd = 5
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDataBrowser (IntPtr parent, string name, Qt.WidgetFlags fl);
		public QDataBrowser (QWidget parent, string name, Qt.WidgetFlags fl) : this (QNull.Instance)
		{
			rawObject = qt_new_QDataBrowser (parent != null ? parent.RawObject : IntPtr.Zero, name, fl);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QDataBrowser () : this (new QWidget ()) {}

		public QDataBrowser (QWidget parent) : this (parent, "") {}

		public QDataBrowser (QWidget parent, string name) : this (parent, name, Qt.WidgetFlags.WWinOwnDC) {}

		public QDataBrowser (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDataBrowser (QNull dummy) : base (QNull.Instance) {}

		~QDataBrowser ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QDataBrowser (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QDataBrowser (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QDataBrowser.Boundary qt_QDataBrowser_boundary (IntPtr raw);
		public QDataBrowser.Boundary TheBoundary ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_boundary (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setBoundaryChecking (IntPtr raw, bool active);
		public void SetBoundaryChecking (bool active)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setBoundaryChecking (rawObject, active);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_boundaryChecking (IntPtr raw);
		public bool BoundaryChecking ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_boundaryChecking (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setSort (IntPtr raw, IntPtr sort);
		public void SetSort (QSqlIndex sort)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setSort (rawObject, sort.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setSort1 (IntPtr raw, IntPtr sort);
		public void SetSort (QStringList sort)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setSort1 (rawObject, sort.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataBrowser_sort (IntPtr raw);
		public QStringList Sort ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataBrowser_sort (rawObject), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setFilter (IntPtr raw, IntPtr filter);
		public void SetFilter (string filter)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setFilter (rawObject, new QString (filter).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataBrowser_filter (IntPtr raw);
		public string Filter ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDataBrowser_filter (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setSqlCursor (IntPtr raw, IntPtr cursor, bool autoDelete);
		public void SetSqlCursor (QSqlCursor cursor, bool autoDelete)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setSqlCursor (rawObject, cursor.RawObject, autoDelete);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataBrowser_sqlCursor (IntPtr raw);
		public QSqlCursor SqlCursor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataBrowser_sqlCursor (rawObject), typeof (QSqlCursor)) as QSqlCursor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setForm (IntPtr raw, IntPtr form);
		public void SetForm (QSqlForm form)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setForm (rawObject, form.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataBrowser_form (IntPtr raw);
		public QSqlForm Form ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataBrowser_form (rawObject), typeof (QSqlForm)) as QSqlForm;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setConfirmEdits (IntPtr raw, bool confirm);
		public void SetConfirmEdits (bool confirm)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setConfirmEdits (rawObject, confirm);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setConfirmInsert (IntPtr raw, bool confirm);
		public void SetConfirmInsert (bool confirm)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setConfirmInsert (rawObject, confirm);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setConfirmUpdate (IntPtr raw, bool confirm);
		public void SetConfirmUpdate (bool confirm)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setConfirmUpdate (rawObject, confirm);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setConfirmDelete (IntPtr raw, bool confirm);
		public void SetConfirmDelete (bool confirm)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setConfirmDelete (rawObject, confirm);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setConfirmCancels (IntPtr raw, bool confirm);
		public void SetConfirmCancels (bool confirm)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setConfirmCancels (rawObject, confirm);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_confirmEdits (IntPtr raw);
		public bool ConfirmEdits ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_confirmEdits (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_confirmInsert (IntPtr raw);
		public bool ConfirmInsert ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_confirmInsert (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_confirmUpdate (IntPtr raw);
		public bool ConfirmUpdate ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_confirmUpdate (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_confirmDelete (IntPtr raw);
		public bool ConfirmDelete ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_confirmDelete (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_confirmCancels (IntPtr raw);
		public bool ConfirmCancels ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_confirmCancels (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setReadOnly (IntPtr raw, bool active);
		public void SetReadOnly (bool active)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setReadOnly (rawObject, active);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_isReadOnly (IntPtr raw);
		public bool IsReadOnly ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_isReadOnly (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_setAutoEdit (IntPtr raw, bool autoEdit);
		public void SetAutoEdit (bool autoEdit)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_setAutoEdit (rawObject, autoEdit);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_autoEdit (IntPtr raw);
		public bool AutoEdit ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_autoEdit (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_seek (IntPtr raw, int i, bool relative);
		public bool Seek (int i, bool relative)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_seek (rawObject, i, relative);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_refresh (IntPtr raw);
		public void Refresh ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_refresh (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_insert (IntPtr raw);
		public void Insert ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_insert (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_update (IntPtr raw);
		public void Update ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_update (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_del (IntPtr raw);
		public void Del ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_del (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_first (IntPtr raw);
		public void First ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_first (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_last (IntPtr raw);
		public void Last ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_last (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_next (IntPtr raw);
		public void Next ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_next (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_prev (IntPtr raw);
		public void Prev ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_prev (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_readFields (IntPtr raw);
		public void ReadFields ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_readFields (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_writeFields (IntPtr raw);
		public void WriteFields ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_writeFields (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_clearValues (IntPtr raw);
		public void ClearValues ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_clearValues (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_updateBoundary (IntPtr raw);
		public void UpdateBoundary ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_updateBoundary (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_insertCurrent (IntPtr raw);
		protected bool InsertCurrent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_insertCurrent (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_updateCurrent (IntPtr raw);
		protected bool UpdateCurrent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_updateCurrent (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_deleteCurrent (IntPtr raw);
		protected bool DeleteCurrent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_deleteCurrent (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataBrowser_currentEdited (IntPtr raw);
		protected bool CurrentEdited ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_currentEdited (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSql.Confirm qt_QDataBrowser_confirmEdit (IntPtr raw, QSql.Op m);
		protected QSql.Confirm ConfirmEdit (QSql.Op m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_confirmEdit (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSql.Confirm qt_QDataBrowser_confirmCancel (IntPtr raw, QSql.Op m);
		protected QSql.Confirm ConfirmCancel (QSql.Op m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataBrowser_confirmCancel (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataBrowser_handleError (IntPtr raw, IntPtr error);
		protected void HandleError (QSqlError error)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataBrowser_handleError (rawObject, error.RawObject);
		}

		public void SetSqlCursor (QSqlCursor cursor)
		{
			SetSqlCursor(cursor, false);
		}

		public bool Seek (int i)
		{
			return Seek(i, false);
		}

		// Begin interface methods.

	}
}