// QDataSource.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDataSource : QAsyncIO, IDisposable {

		internal QDataSource () : this (QNull.Instance) {}

		public QDataSource (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDataSource (QNull dummy) : base (QNull.Instance) {}

		~QDataSource ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QDataSource function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDataSource_readyToSend (IntPtr raw);
		public int ReadyToSend ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataSource_readyToSend (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataSource_sendTo (IntPtr raw, IntPtr arg1, int count);
		public void SendTo (QDataSink arg1, int count)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataSource_sendTo (rawObject, arg1.RawObject, count);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataSource_maybeReady (IntPtr raw);
		public void MaybeReady ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataSource_maybeReady (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataSource_rewindable (IntPtr raw);
		public bool Rewindable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataSource_rewindable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataSource_enableRewind (IntPtr raw, bool arg1);
		public void EnableRewind (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataSource_enableRewind (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataSource_rewind (IntPtr raw);
		public void Rewind ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataSource_rewind (rawObject);
		}

		// Begin interface methods.

	}
}