// QDataStream.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDataStream : QtSupport, IDisposable {

		public enum ByteOrder {
			BigEndian = 0,
			LittleEndian = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDataStream ();
		public QDataStream () : this (QNull.Instance)
		{
			rawObject = qt_new_QDataStream ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDataStream1 (IntPtr arg1);
		public QDataStream (QIODevice arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QDataStream1 (arg1.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDataStream2 (byte[] arg1, int mode);
		public QDataStream (byte[] arg1, int mode) : this (QNull.Instance)
		{
			rawObject = qt_new_QDataStream2 (arg1, mode);
			RegisterObject (this);
		}

		public QDataStream (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDataStream (QNull dummy) : base (QNull.Instance) {}

		~QDataStream ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QDataStream (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QDataStream (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataStream_device (IntPtr raw);
		public QIODevice Device ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataStream_device (rawObject), typeof (QIODevice)) as QIODevice;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataStream_setDevice (IntPtr raw, IntPtr arg1);
		public void SetDevice (QIODevice arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataStream_setDevice (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataStream_unsetDevice (IntPtr raw);
		public void UnsetDevice ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataStream_unsetDevice (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataStream_atEnd (IntPtr raw);
		public bool AtEnd ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataStream_atEnd (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataStream_eof (IntPtr raw);
		public bool Eof ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataStream_eof (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDataStream_byteOrder (IntPtr raw);
		public int TheByteOrder ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataStream_byteOrder (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataStream_setByteOrder (IntPtr raw, int arg1);
		public void SetByteOrder (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataStream_setByteOrder (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataStream_isPrintableData (IntPtr raw);
		public bool IsPrintableData ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataStream_isPrintableData (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataStream_setPrintableData (IntPtr raw, bool arg1);
		public void SetPrintableData (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataStream_setPrintableData (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDataStream_version (IntPtr raw);
		public int Version ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataStream_version (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataStream_setVersion (IntPtr raw, int arg1);
		public void SetVersion (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataStream_setVersion (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataStream_readBytes (IntPtr raw, char arg1, uint len);
		public QDataStream ReadBytes (char arg1, uint len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataStream_readBytes (rawObject, arg1, len), typeof (QDataStream)) as QDataStream;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataStream_readRawBytes (IntPtr raw, string arg1, uint len);
		public QDataStream ReadRawBytes (string arg1, uint len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataStream_readRawBytes (rawObject, arg1, len), typeof (QDataStream)) as QDataStream;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataStream_writeBytes (IntPtr raw, string arg1, uint len);
		public QDataStream WriteBytes (string arg1, uint len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataStream_writeBytes (rawObject, arg1, len), typeof (QDataStream)) as QDataStream;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataStream_writeRawBytes (IntPtr raw, string arg1, uint len);
		public QDataStream WriteRawBytes (string arg1, uint len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataStream_writeRawBytes (rawObject, arg1, len), typeof (QDataStream)) as QDataStream;
		}
	}
}