// QDataTable.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDataTable : QTable, IDisposable {

		public enum Refresh {
			RefreshData = 1,
			RefreshColumns = 2,
			RefreshAll = 3
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDataTable (IntPtr parent, string name);
		public QDataTable (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QDataTable (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDataTable1 (IntPtr cursor, bool autoPopulate, IntPtr parent, string name);
		public QDataTable (QSqlCursor cursor, bool autoPopulate, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QDataTable1 (cursor.RawObject, autoPopulate, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QDataTable () : this (new QWidget ()) {}

		public QDataTable (QWidget parent) : this (parent, "") {}

		public QDataTable (QSqlCursor cursor) : this (cursor, false) {}

		public QDataTable (QSqlCursor cursor, bool autoPopulate) : this (cursor, autoPopulate, new QWidget ()) {}

		public QDataTable (QSqlCursor cursor, bool autoPopulate, QWidget parent) : this (cursor, autoPopulate, parent, "") {}

		public QDataTable (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDataTable (QNull dummy) : base (QNull.Instance) {}

		~QDataTable ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QDataTable (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QDataTable (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_addColumn (IntPtr raw, IntPtr fieldName, IntPtr label, int width, IntPtr iconset);
		public void AddColumn (string fieldName, string label, int width, QIconSet iconset)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_addColumn (rawObject, new QString (fieldName).RawObject, new QString (label).RawObject, width, iconset.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_removeColumn (IntPtr raw, uint col);
		public void RemoveColumn (uint col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_removeColumn (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setColumn (IntPtr raw, uint col, IntPtr fieldName, IntPtr label, int width, IntPtr iconset);
		public void SetColumn (uint col, string fieldName, string label, int width, QIconSet iconset)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setColumn (rawObject, col, new QString (fieldName).RawObject, new QString (label).RawObject, width, iconset.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataTable_nullText (IntPtr raw);
		public string NullText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDataTable_nullText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataTable_trueText (IntPtr raw);
		public string TrueText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDataTable_trueText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataTable_falseText (IntPtr raw);
		public string FalseText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDataTable_falseText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.DateFormat qt_QDataTable_dateFormat (IntPtr raw);
		public Qt.DateFormat DateFormat ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_dateFormat (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_confirmEdits (IntPtr raw);
		public bool ConfirmEdits ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_confirmEdits (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_confirmInsert (IntPtr raw);
		public bool ConfirmInsert ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_confirmInsert (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_confirmUpdate (IntPtr raw);
		public bool ConfirmUpdate ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_confirmUpdate (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_confirmDelete (IntPtr raw);
		public bool ConfirmDelete ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_confirmDelete (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_confirmCancels (IntPtr raw);
		public bool ConfirmCancels ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_confirmCancels (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_autoDelete (IntPtr raw);
		public bool AutoDelete ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_autoDelete (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_autoEdit (IntPtr raw);
		public bool AutoEdit ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_autoEdit (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataTable_filter (IntPtr raw);
		public string Filter ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDataTable_filter (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataTable_sort (IntPtr raw);
		public QStringList Sort ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataTable_sort (rawObject), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setSqlCursor (IntPtr raw, IntPtr cursor, bool autoPopulate, bool autoDelete);
		public void SetSqlCursor (QSqlCursor cursor, bool autoPopulate, bool autoDelete)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setSqlCursor (rawObject, cursor.RawObject, autoPopulate, autoDelete);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataTable_sqlCursor (IntPtr raw);
		public QSqlCursor SqlCursor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataTable_sqlCursor (rawObject), typeof (QSqlCursor)) as QSqlCursor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setNullText (IntPtr raw, IntPtr nullText);
		public void SetNullText (string nullText)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setNullText (rawObject, new QString (nullText).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setTrueText (IntPtr raw, IntPtr trueText);
		public void SetTrueText (string trueText)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setTrueText (rawObject, new QString (trueText).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setFalseText (IntPtr raw, IntPtr falseText);
		public void SetFalseText (string falseText)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setFalseText (rawObject, new QString (falseText).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setDateFormat (IntPtr raw, Qt.DateFormat f);
		public void SetDateFormat (Qt.DateFormat f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setDateFormat (rawObject, f);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setConfirmEdits (IntPtr raw, bool confirm);
		public void SetConfirmEdits (bool confirm)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setConfirmEdits (rawObject, confirm);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setConfirmInsert (IntPtr raw, bool confirm);
		public void SetConfirmInsert (bool confirm)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setConfirmInsert (rawObject, confirm);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setConfirmUpdate (IntPtr raw, bool confirm);
		public void SetConfirmUpdate (bool confirm)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setConfirmUpdate (rawObject, confirm);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setConfirmDelete (IntPtr raw, bool confirm);
		public void SetConfirmDelete (bool confirm)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setConfirmDelete (rawObject, confirm);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setConfirmCancels (IntPtr raw, bool confirm);
		public void SetConfirmCancels (bool confirm)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setConfirmCancels (rawObject, confirm);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setAutoDelete (IntPtr raw, bool enable);
		public void SetAutoDelete (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setAutoDelete (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setAutoEdit (IntPtr raw, bool autoEdit);
		public void SetAutoEdit (bool autoEdit)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setAutoEdit (rawObject, autoEdit);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setFilter (IntPtr raw, IntPtr filter);
		public void SetFilter (string filter)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setFilter (rawObject, new QString (filter).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setSort (IntPtr raw, IntPtr sort);
		public void SetSort (QStringList sort)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setSort (rawObject, sort.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setSort1 (IntPtr raw, IntPtr sort);
		public void SetSort (QSqlIndex sort)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setSort1 (rawObject, sort.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_refresh (IntPtr raw, QDataTable.Refresh mode);
		public void TheRefresh (QDataTable.Refresh mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_refresh (rawObject, mode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_sortColumn (IntPtr raw, int col, bool ascending, bool wholeRows);
		public void SortColumn (int col, bool ascending, bool wholeRows)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_sortColumn (rawObject, col, ascending, wholeRows);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataTable_text (IntPtr raw, int row, int col);
		public string Text (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDataTable_text (rawObject, row, col));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataTable_value (IntPtr raw, int row, int col);
		public QVariant Value (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataTable_value (rawObject, row, col), typeof (QVariant)) as QVariant;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataTable_currentRecord (IntPtr raw);
		public QSqlRecord CurrentRecord ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataTable_currentRecord (rawObject), typeof (QSqlRecord)) as QSqlRecord;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_installEditorFactory (IntPtr raw, IntPtr f);
		public void InstallEditorFactory (QSqlEditorFactory f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_installEditorFactory (rawObject, f.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_installPropertyMap (IntPtr raw, IntPtr m);
		public void InstallPropertyMap (QSqlPropertyMap m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_installPropertyMap (rawObject, m.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDataTable_numCols (IntPtr raw);
		public int NumCols ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_numCols (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDataTable_numRows (IntPtr raw);
		public int NumRows ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_numRows (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setNumCols (IntPtr raw, int c);
		public void SetNumCols (int c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setNumCols (rawObject, c);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setNumRows (IntPtr raw, int r);
		public void SetNumRows (int r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setNumRows (rawObject, r);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_findBuffer (IntPtr raw, IntPtr idx, int atHint);
		public bool FindBuffer (QSqlIndex idx, int atHint)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_findBuffer (rawObject, idx.RawObject, atHint);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_find (IntPtr raw, IntPtr str, bool caseSensitive, bool backwards);
		public void Find (string str, bool caseSensitive, bool backwards)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_find (rawObject, new QString (str).RawObject, caseSensitive, backwards);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_sortAscending (IntPtr raw, int col);
		public void SortAscending (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_sortAscending (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_sortDescending (IntPtr raw, int col);
		public void SortDescending (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_sortDescending (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_refresh1 (IntPtr raw);
		public void TheRefresh ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_refresh1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setColumnWidth (IntPtr raw, int col, int w);
		public void SetColumnWidth (int col, int w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setColumnWidth (rawObject, col, w);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_insertCurrent (IntPtr raw);
		protected bool InsertCurrent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_insertCurrent (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_updateCurrent (IntPtr raw);
		protected bool UpdateCurrent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_updateCurrent (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_deleteCurrent (IntPtr raw);
		protected bool DeleteCurrent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_deleteCurrent (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSql.Confirm qt_QDataTable_confirmEdit (IntPtr raw, QSql.Op m);
		protected QSql.Confirm ConfirmEdit (QSql.Op m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_confirmEdit (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSql.Confirm qt_QDataTable_confirmCancel (IntPtr raw, QSql.Op m);
		protected QSql.Confirm ConfirmCancel (QSql.Op m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_confirmCancel (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_handleError (IntPtr raw, IntPtr e);
		protected void HandleError (QSqlError e)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_handleError (rawObject, e.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_beginInsert (IntPtr raw);
		protected bool BeginInsert ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_beginInsert (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataTable_beginUpdate (IntPtr raw, int row, int col, bool replace);
		protected QWidget BeginUpdate (int row, int col, bool replace)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataTable_beginUpdate (rawObject, row, col, replace), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDataTable_eventFilter (IntPtr raw, IntPtr o, IntPtr e);
		protected bool EventFilter (QObject o, QEvent e)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_eventFilter (rawObject, o.RawObject, e.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_endEdit (IntPtr raw, int row, int col, bool accept, bool replace);
		protected void EndEdit (int row, int col, bool accept, bool replace)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_endEdit (rawObject, row, col, accept, replace);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataTable_createEditor (IntPtr raw, int row, int col, bool initFromCell);
		protected QWidget CreateEditor (int row, int col, bool initFromCell)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataTable_createEditor (rawObject, row, col, initFromCell), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_activateNextCell (IntPtr raw);
		protected void ActivateNextCell ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_activateNextCell (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDataTable_indexOf (IntPtr raw, uint i);
		protected int IndexOf (uint i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_indexOf (rawObject, i);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_reset (IntPtr raw);
		protected void Reset ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_reset (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setSize (IntPtr raw, IntPtr sql);
		protected void SetSize (QSqlCursor sql)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setSize (rawObject, sql.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_repaintCell (IntPtr raw, int row, int col);
		protected void RepaintCell (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_repaintCell (rawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_paintCell (IntPtr raw, IntPtr p, int row, int col, IntPtr cr, bool selected, IntPtr cg);
		protected void PaintCell (QPainter p, int row, int col, QRect cr, bool selected, QColorGroup cg)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_paintCell (rawObject, p.RawObject, row, col, cr.RawObject, selected, cg.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_paintField (IntPtr raw, IntPtr p, IntPtr field, IntPtr cr, bool selected);
		protected void PaintField (QPainter p, QSqlField field, QRect cr, bool selected)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_paintField (rawObject, p.RawObject, field.RawObject, cr.RawObject, selected);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDataTable_fieldAlignment (IntPtr raw, IntPtr field);
		protected int FieldAlignment (QSqlField field)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDataTable_fieldAlignment (rawObject, field.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_columnClicked (IntPtr raw, int col);
		protected void ColumnClicked (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_columnClicked (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_resizeData (IntPtr raw, int len);
		protected void ResizeData (int len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_resizeData (rawObject, len);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDataTable_item (IntPtr raw, int row, int col);
		protected QTableItem Item (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDataTable_item (rawObject, row, col), typeof (QTableItem)) as QTableItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setItem (IntPtr raw, int row, int col, IntPtr item);
		protected void SetItem (int row, int col, QTableItem item)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setItem (rawObject, row, col, item.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_clearCell (IntPtr raw, int row, int col);
		protected void ClearCell (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_clearCell (rawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_setPixmap (IntPtr raw, int row, int col, IntPtr pix);
		protected void SetPixmap (int row, int col, QPixmap pix)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_setPixmap (rawObject, row, col, pix.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDataTable_takeItem (IntPtr raw, IntPtr i);
		protected void TakeItem (QTableItem i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDataTable_takeItem (rawObject, i.RawObject);
		}

		public void AddColumn (string fieldName)
		{
			AddColumn(fieldName, (string) "");
		}

		public void AddColumn (string fieldName, string label)
		{
			AddColumn(fieldName, label, (int) -1);
		}

		public void AddColumn (string fieldName, string label, int width)
		{
			AddColumn(fieldName, label, width, new QIconSet ());
		}

		public void SetColumn (uint col, string fieldName)
		{
			SetColumn(col, fieldName, (string) "");
		}

		public void SetColumn (uint col, string fieldName, string label)
		{
			SetColumn(col, fieldName, label, (int) -1);
		}

		public void SetColumn (uint col, string fieldName, string label, int width)
		{
			SetColumn(col, fieldName, label, width, new QIconSet ());
		}

		public void SetSqlCursor ()
		{
			SetSqlCursor(new QSqlCursor ());
		}

		public void SetSqlCursor (QSqlCursor cursor)
		{
			SetSqlCursor(cursor, false);
		}

		public void SetSqlCursor (QSqlCursor cursor, bool autoPopulate)
		{
			SetSqlCursor(cursor, autoPopulate, false);
		}

		public void SortColumn (int col)
		{
			SortColumn(col, true);
		}

		public void SortColumn (int col, bool ascending)
		{
			SortColumn(col, ascending, false);
		}

		public bool FindBuffer (QSqlIndex idx)
		{
			return FindBuffer(idx, (int) 0);
		}

		// Begin interface methods.

	}
}