// QDate.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDate : QtSupport, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDate ();
		public QDate () : this (QNull.Instance)
		{
			rawObject = qt_new_QDate ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDate1 (int y, int m, int d);
		public QDate (int y, int m, int d) : this (QNull.Instance)
		{
			rawObject = qt_new_QDate1 (y, m, d);
			RegisterObject (this);
		}

		public QDate (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDate (QNull dummy) : base (QNull.Instance) {}

		~QDate ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QDate function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDate_isNull (IntPtr raw);
		public bool IsNull ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDate_isNull (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDate_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDate_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDate_year (IntPtr raw);
		public int Year ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDate_year (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDate_month (IntPtr raw);
		public int Month ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDate_month (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDate_day (IntPtr raw);
		public int Day ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDate_day (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDate_dayOfWeek (IntPtr raw);
		public int DayOfWeek ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDate_dayOfWeek (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDate_dayOfYear (IntPtr raw);
		public int DayOfYear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDate_dayOfYear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDate_daysInMonth (IntPtr raw);
		public int DaysInMonth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDate_daysInMonth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDate_daysInYear (IntPtr raw);
		public int DaysInYear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDate_daysInYear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_toString (IntPtr raw, Qt.DateFormat f);
		public string ToString (Qt.DateFormat f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDate_toString (rawObject, f));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_toString1 (IntPtr raw, IntPtr format);
		public string ToString (string format)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDate_toString1 (rawObject, new QString (format).RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDate_setYMD (IntPtr raw, int y, int m, int d);
		public bool SetYMD (int y, int m, int d)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDate_setYMD (rawObject, y, m, d);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_addDays (IntPtr raw, int days);
		public QDate AddDays (int days)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDate_addDays (rawObject, days), typeof (QDate)) as QDate;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_addMonths (IntPtr raw, int months);
		public QDate AddMonths (int months)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDate_addMonths (rawObject, months), typeof (QDate)) as QDate;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_addYears (IntPtr raw, int years);
		public QDate AddYears (int years)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDate_addYears (rawObject, years), typeof (QDate)) as QDate;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDate_daysTo (IntPtr raw, IntPtr arg1);
		public int DaysTo (QDate arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDate_daysTo (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_monthName (int month);
		public static string MonthName (int month)
		{
			QString qstr = new QString (qt_QDate_monthName (month));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_dayName (int weekday);
		public static string DayName (int weekday)
		{
			QString qstr = new QString (qt_QDate_dayName (weekday));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_shortMonthName (int month);
		public static string ShortMonthName (int month)
		{
			QString qstr = new QString (qt_QDate_shortMonthName (month));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_shortDayName (int weekday);
		public static string ShortDayName (int weekday)
		{
			QString qstr = new QString (qt_QDate_shortDayName (weekday));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_longMonthName (int month);
		public static string LongMonthName (int month)
		{
			QString qstr = new QString (qt_QDate_longMonthName (month));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_longDayName (int weekday);
		public static string LongDayName (int weekday)
		{
			QString qstr = new QString (qt_QDate_longDayName (weekday));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_currentDate ();
		public static QDate CurrentDate ()
		{
			return LookupObject (qt_QDate_currentDate (), typeof (QDate)) as QDate;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDate_fromString (IntPtr s, Qt.DateFormat f);
		public static QDate FromString (string s, Qt.DateFormat f)
		{
			return LookupObject (qt_QDate_fromString (new QString (s).RawObject, f), typeof (QDate)) as QDate;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDate_isValid1 (int y, int m, int d);
		public static bool IsValid (int y, int m, int d)
		{
			return qt_QDate_isValid1 (y, m, d);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDate_leapYear (int year);
		public static bool LeapYear (int year)
		{
			return qt_QDate_leapYear (year);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QDate_gregorianToJulian (int y, int m, int d);
		public static uint GregorianToJulian (int y, int m, int d)
		{
			return qt_QDate_gregorianToJulian (y, m, d);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDate_julianToGregorian (uint jd, int y, int m, int d);
		public static void JulianToGregorian (uint jd, int y, int m, int d)
		{
			qt_QDate_julianToGregorian (jd, y, m, d);
		}

		public string ToString ()
		{
			return ToString(Qt.DateFormat.TextDate);
		}

		public static QDate FromString (string s)
		{
			return FromString(s, Qt.DateFormat.TextDate);
		}
	}
}