// QDateEdit.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDateEdit : QDateTimeEditBase, IDisposable {

		public enum Order {
			DMY = 0,
			MDY = 1,
			YMD = 2,
			YDM = 3
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDateEdit (IntPtr parent, string name);
		public QDateEdit (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QDateEdit (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDateEdit1 (IntPtr date, IntPtr parent, string name);
		public QDateEdit (QDate date, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QDateEdit1 (date.RawObject, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QDateEdit () : this (new QWidget ()) {}

		public QDateEdit (QWidget parent) : this (parent, "") {}

		public QDateEdit (QDate date) : this (date, new QWidget ()) {}

		public QDateEdit (QDate date, QWidget parent) : this (date, parent, "") {}

		public QDateEdit (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDateEdit (QNull dummy) : base (QNull.Instance) {}

		~QDateEdit ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QDateEdit (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QDateEdit (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateEdit_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDateEdit_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateEdit_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDateEdit_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_setDate (IntPtr raw, IntPtr date);
		public void SetDate (QDate date)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_setDate (rawObject, date.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateEdit_date (IntPtr raw);
		public QDate Date ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDateEdit_date (rawObject), typeof (QDate)) as QDate;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_setOrder (IntPtr raw, QDateEdit.Order order);
		public void SetOrder (QDateEdit.Order order)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_setOrder (rawObject, order);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QDateEdit.Order qt_QDateEdit_order (IntPtr raw);
		public QDateEdit.Order TheOrder ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDateEdit_order (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_setAutoAdvance (IntPtr raw, bool advance);
		public void SetAutoAdvance (bool advance)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_setAutoAdvance (rawObject, advance);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDateEdit_autoAdvance (IntPtr raw);
		public bool AutoAdvance ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDateEdit_autoAdvance (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_setMinValue (IntPtr raw, IntPtr d);
		public void SetMinValue (QDate d)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_setMinValue (rawObject, d.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateEdit_minValue (IntPtr raw);
		public QDate MinValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDateEdit_minValue (rawObject), typeof (QDate)) as QDate;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_setMaxValue (IntPtr raw, IntPtr d);
		public void SetMaxValue (QDate d)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_setMaxValue (rawObject, d.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateEdit_maxValue (IntPtr raw);
		public QDate MaxValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDateEdit_maxValue (rawObject), typeof (QDate)) as QDate;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_setRange (IntPtr raw, IntPtr min, IntPtr max);
		public void SetRange (QDate min, QDate max)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_setRange (rawObject, min.RawObject, max.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateEdit_separator (IntPtr raw);
		public string Separator ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDateEdit_separator (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_setSeparator (IntPtr raw, IntPtr s);
		public void SetSeparator (string s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_setSeparator (rawObject, new QString (s).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDateEdit_event (IntPtr raw, IntPtr e);
		protected bool Q_event (QEvent e)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDateEdit_event (rawObject, e.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_stepUp (IntPtr raw);
		protected void StepUp ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_stepUp (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_stepDown (IntPtr raw);
		protected void StepDown ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_stepDown (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateEdit_sectionFormattedText (IntPtr raw, int sec);
		protected string SectionFormattedText (int sec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDateEdit_sectionFormattedText (rawObject, sec));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_addNumber (IntPtr raw, int sec, int num);
		protected void AddNumber (int sec, int num)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_addNumber (rawObject, sec, num);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_removeLastNumber (IntPtr raw, int sec);
		protected void RemoveLastNumber (int sec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_removeLastNumber (rawObject, sec);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDateEdit_setFocusSection (IntPtr raw, int s);
		protected bool SetFocusSection (int s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDateEdit_setFocusSection (rawObject, s);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_setYear (IntPtr raw, int year);
		protected void SetYear (int year)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_setYear (rawObject, year);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_setMonth (IntPtr raw, int month);
		protected void SetMonth (int month)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_setMonth (rawObject, month);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_setDay (IntPtr raw, int day);
		protected void SetDay (int day)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_setDay (rawObject, day);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_fix (IntPtr raw);
		protected void Fix ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_fix (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDateEdit_outOfRange (IntPtr raw, int y, int m, int d);
		protected bool OutOfRange (int y, int m, int d)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDateEdit_outOfRange (rawObject, y, m, d);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateEdit_updateButtons (IntPtr raw);
		protected void UpdateButtons ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateEdit_updateButtons (rawObject);
		}

		// Begin interface methods.

	}
}