// QDateTime.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDateTime : QtSupport, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDateTime ();
		public QDateTime () : this (QNull.Instance)
		{
			rawObject = qt_new_QDateTime ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDateTime1 (IntPtr arg1);
		public QDateTime (QDate arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QDateTime1 (arg1.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDateTime2 (IntPtr arg1, IntPtr arg2);
		public QDateTime (QDate arg1, QTime arg2) : this (QNull.Instance)
		{
			rawObject = qt_new_QDateTime2 (arg1.RawObject, arg2.RawObject);
			RegisterObject (this);
		}

		public QDateTime (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDateTime (QNull dummy) : base (QNull.Instance) {}

		~QDateTime ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QDateTime function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDateTime_isNull (IntPtr raw);
		public bool IsNull ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDateTime_isNull (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDateTime_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDateTime_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateTime_date (IntPtr raw);
		public QDate Date ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDateTime_date (rawObject), typeof (QDate)) as QDate;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateTime_time (IntPtr raw);
		public QTime Time ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDateTime_time (rawObject), typeof (QTime)) as QTime;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateTime_setDate (IntPtr raw, IntPtr date);
		public void SetDate (QDate date)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateTime_setDate (rawObject, date.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateTime_setTime (IntPtr raw, IntPtr time);
		public void SetTime (QTime time)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateTime_setTime (rawObject, time.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateTime_setTime_t (IntPtr raw, uint secsSince1Jan1970UTC);
		public void SetTime_t (uint secsSince1Jan1970UTC)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateTime_setTime_t (rawObject, secsSince1Jan1970UTC);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateTime_toString (IntPtr raw, Qt.DateFormat f);
		public string ToString (Qt.DateFormat f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDateTime_toString (rawObject, f));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateTime_toString1 (IntPtr raw, IntPtr format);
		public string ToString (string format)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDateTime_toString1 (rawObject, new QString (format).RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateTime_addDays (IntPtr raw, int days);
		public QDateTime AddDays (int days)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDateTime_addDays (rawObject, days), typeof (QDateTime)) as QDateTime;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateTime_addMonths (IntPtr raw, int months);
		public QDateTime AddMonths (int months)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDateTime_addMonths (rawObject, months), typeof (QDateTime)) as QDateTime;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateTime_addYears (IntPtr raw, int years);
		public QDateTime AddYears (int years)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDateTime_addYears (rawObject, years), typeof (QDateTime)) as QDateTime;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateTime_addSecs (IntPtr raw, int secs);
		public QDateTime AddSecs (int secs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDateTime_addSecs (rawObject, secs), typeof (QDateTime)) as QDateTime;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDateTime_daysTo (IntPtr raw, IntPtr arg1);
		public int DaysTo (QDateTime arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDateTime_daysTo (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDateTime_secsTo (IntPtr raw, IntPtr arg1);
		public int SecsTo (QDateTime arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDateTime_secsTo (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateTime_currentDateTime ();
		public static QDateTime CurrentDateTime ()
		{
			return LookupObject (qt_QDateTime_currentDateTime (), typeof (QDateTime)) as QDateTime;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateTime_fromString (IntPtr s, Qt.DateFormat f);
		public static QDateTime FromString (string s, Qt.DateFormat f)
		{
			return LookupObject (qt_QDateTime_fromString (new QString (s).RawObject, f), typeof (QDateTime)) as QDateTime;

		}

		public string ToString ()
		{
			return ToString(Qt.DateFormat.TextDate);
		}

		public static QDateTime FromString (string s)
		{
			return FromString(s, Qt.DateFormat.TextDate);
		}
	}
}