// QDateTimeEditBase.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDateTimeEditBase : QWidget, IDisposable {

		internal QDateTimeEditBase () : this (QNull.Instance) {}

		public QDateTimeEditBase (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDateTimeEditBase (QNull dummy) : base (QNull.Instance) {}

		~QDateTimeEditBase ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QDateTimeEditBase function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDateTimeEditBase_setFocusSection (IntPtr raw, int sec);
		public bool SetFocusSection (int sec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDateTimeEditBase_setFocusSection (rawObject, sec);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDateTimeEditBase_sectionFormattedText (IntPtr raw, int sec);
		public string SectionFormattedText (int sec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDateTimeEditBase_sectionFormattedText (rawObject, sec));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateTimeEditBase_addNumber (IntPtr raw, int sec, int num);
		public void AddNumber (int sec, int num)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateTimeEditBase_addNumber (rawObject, sec, num);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateTimeEditBase_removeLastNumber (IntPtr raw, int sec);
		public void RemoveLastNumber (int sec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateTimeEditBase_removeLastNumber (rawObject, sec);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateTimeEditBase_stepUp (IntPtr raw);
		public void StepUp ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateTimeEditBase_stepUp (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDateTimeEditBase_stepDown (IntPtr raw);
		public void StepDown ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDateTimeEditBase_stepDown (rawObject);
		}

		// Begin interface methods.

	}
}