// QDialog.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDialog : QWidget, IDisposable {

		public enum DialogCode {
			Rejected = 0,
			Accepted = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDialog (IntPtr parent, string name, bool modal, Qt.WidgetFlags f);
		public QDialog (QWidget parent, string name, bool modal, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QDialog (parent != null ? parent.RawObject : IntPtr.Zero, name, modal, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QDialog () : this (new QWidget ()) {}

		public QDialog (QWidget parent) : this (parent, "") {}

		public QDialog (QWidget parent, string name) : this (parent, name, false) {}

		public QDialog (QWidget parent, string name, bool modal) : this (parent, name, modal, Qt.WidgetFlags.WWinOwnDC) {}

		public QDialog (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDialog (QNull dummy) : base (QNull.Instance) {}

		~QDialog ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QDialog (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QDialog (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDialog_result (IntPtr raw);
		public int Result ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDialog_result (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_show (IntPtr raw);
		public void Show ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_show (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_hide (IntPtr raw);
		public void Hide ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_hide (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_move (IntPtr raw, int x, int y);
		public void Move (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_move (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_move1 (IntPtr raw, IntPtr p);
		public void Move (QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_move1 (rawObject, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_resize (IntPtr raw, int w, int h);
		public void Resize (int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_resize (rawObject, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_resize1 (IntPtr raw, IntPtr arg1);
		public void Resize (QSize arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_resize1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_setGeometry (IntPtr raw, int x, int y, int w, int h);
		public void SetGeometry (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_setGeometry (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_setGeometry1 (IntPtr raw, IntPtr arg1);
		public void SetGeometry (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_setGeometry1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_setOrientation (IntPtr raw, Orientation orientation);
		public void SetOrientation (Orientation orientation)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_setOrientation (rawObject, orientation);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Orientation qt_QDialog_orientation (IntPtr raw);
		public Orientation Orientation ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDialog_orientation (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_setExtension (IntPtr raw, IntPtr extension);
		public void SetExtension (QWidget extension)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_setExtension (rawObject, extension.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDialog_extension (IntPtr raw);
		public QWidget Extension ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDialog_extension (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDialog_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDialog_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDialog_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDialog_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_setSizeGripEnabled (IntPtr raw, bool arg1);
		public void SetSizeGripEnabled (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_setSizeGripEnabled (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDialog_isSizeGripEnabled (IntPtr raw);
		public bool IsSizeGripEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDialog_isSizeGripEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDialog_exec (IntPtr raw);
		public int Exec ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDialog_exec (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_setResult (IntPtr raw, int r);
		protected void SetResult (int r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_setResult (rawObject, r);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDialog_eventFilter (IntPtr raw, IntPtr arg1, IntPtr arg2);
		protected bool EventFilter (QObject arg1, QEvent arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDialog_eventFilter (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_adjustPosition (IntPtr raw, IntPtr arg1);
		protected void AdjustPosition (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_adjustPosition (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_done (IntPtr raw, int arg1);
		protected void Done (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_done (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_accept (IntPtr raw);
		protected void Accept ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_accept (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_reject (IntPtr raw);
		protected void Reject ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_reject (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDialog_showExtension (IntPtr raw, bool arg1);
		protected void ShowExtension (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDialog_showExtension (rawObject, arg1);
		}

		// Begin interface methods.

	}
}