// QDir.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDir : QtSupport, IDisposable {

		public enum FilterSpec {
			Dirs = 1,
			Files = 2,
			Drives = 4,
			NoSymLinks = 8,
			All = 7,
			TypeMask = 15,
			Readable = 16,
			Writable = 32,
			Executable = 64,
			RWEMask = 112,
			Modified = 128,
			Hidden = 256,
			System = 512,
			AccessMask = 1008,
			DefaultFilter = -1
		}

		public enum SortSpec {
			Name = 0,
			Time = 1,
			Size = 2,
			Unsorted = 3,
			SortByMask = 3,
			DirsFirst = 4,
			Reversed = 8,
			IgnoreCase = 16,
			DefaultSort = -1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDir ();
		public QDir () : this (QNull.Instance)
		{
			rawObject = qt_new_QDir ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDir1 (IntPtr path, IntPtr nameFilter, QDir.SortSpec SortSpec, QDir.FilterSpec FilterSpec);
		public QDir (string path, string nameFilter, QDir.SortSpec SortSpec, QDir.FilterSpec FilterSpec) : this (QNull.Instance)
		{
			rawObject = qt_new_QDir1 (new QString (path).RawObject, new QString (nameFilter).RawObject, SortSpec, FilterSpec);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDir2 (IntPtr arg1);
		public QDir (QDir arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QDir2 (arg1.RawObject);
			RegisterObject (this);
		}

		public QDir (string path) : this (path, (string) "") {}

		public QDir (string path, string nameFilter) : this (path, nameFilter, QDir.SortSpec.Name) {}

		public QDir (string path, string nameFilter, QDir.SortSpec SortSpec) : this (path, nameFilter, SortSpec, QDir.FilterSpec.All) {}

		public QDir (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDir (QNull dummy) : base (QNull.Instance) {}

		~QDir ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QDir (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QDir (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDir_setPath (IntPtr raw, IntPtr path);
		public void SetPath (string path)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDir_setPath (rawObject, new QString (path).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_path (IntPtr raw);
		public string Path ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDir_path (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_absPath (IntPtr raw);
		public string AbsPath ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDir_absPath (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_canonicalPath (IntPtr raw);
		public string CanonicalPath ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDir_canonicalPath (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_dirName (IntPtr raw);
		public string DirName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDir_dirName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_filePath (IntPtr raw, IntPtr fileName, bool acceptAbsPath);
		public string FilePath (string fileName, bool acceptAbsPath)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDir_filePath (rawObject, new QString (fileName).RawObject, acceptAbsPath));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_absFilePath (IntPtr raw, IntPtr fileName, bool acceptAbsPath);
		public string AbsFilePath (string fileName, bool acceptAbsPath)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDir_absFilePath (rawObject, new QString (fileName).RawObject, acceptAbsPath));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_cd (IntPtr raw, IntPtr dirName, bool acceptAbsPath);
		public bool Cd (string dirName, bool acceptAbsPath)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_cd (rawObject, new QString (dirName).RawObject, acceptAbsPath);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_cdUp (IntPtr raw);
		public bool CdUp ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_cdUp (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_nameFilter (IntPtr raw);
		public string NameFilter ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDir_nameFilter (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDir_setNameFilter (IntPtr raw, IntPtr nameFilter);
		public void SetNameFilter (string nameFilter)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDir_setNameFilter (rawObject, new QString (nameFilter).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QDir.FilterSpec qt_QDir_filter (IntPtr raw);
		public QDir.FilterSpec Filter ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_filter (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDir_setFilter (IntPtr raw, int filterSpec);
		public void SetFilter (int filterSpec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDir_setFilter (rawObject, filterSpec);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QDir.SortSpec qt_QDir_sorting (IntPtr raw);
		public QDir.SortSpec Sorting ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_sorting (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDir_setSorting (IntPtr raw, int sortSpec);
		public void SetSorting (int sortSpec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDir_setSorting (rawObject, sortSpec);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_matchAllDirs (IntPtr raw);
		public bool MatchAllDirs ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_matchAllDirs (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDir_setMatchAllDirs (IntPtr raw, bool arg1);
		public void SetMatchAllDirs (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDir_setMatchAllDirs (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QDir_count (IntPtr raw);
		public uint Count ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_count (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_encodedEntryList (IntPtr raw, QDir.FilterSpec filterSpec, QDir.SortSpec sortSpec);
		public QStrList EncodedEntryList (QDir.FilterSpec filterSpec, QDir.SortSpec sortSpec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDir_encodedEntryList (rawObject, filterSpec, sortSpec), typeof (QStrList)) as QStrList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_encodedEntryList1 (IntPtr raw, IntPtr nameFilter, QDir.FilterSpec filterSpec, QDir.SortSpec sortSpec);
		public QStrList EncodedEntryList (string nameFilter, QDir.FilterSpec filterSpec, QDir.SortSpec sortSpec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDir_encodedEntryList1 (rawObject, new QString (nameFilter).RawObject, filterSpec, sortSpec), typeof (QStrList)) as QStrList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_entryList (IntPtr raw, QDir.FilterSpec filterSpec, QDir.SortSpec sortSpec);
		public QStringList EntryList (QDir.FilterSpec filterSpec, QDir.SortSpec sortSpec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDir_entryList (rawObject, filterSpec, sortSpec), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_entryList1 (IntPtr raw, IntPtr nameFilter, QDir.FilterSpec filterSpec, QDir.SortSpec sortSpec);
		public QStringList EntryList (string nameFilter, QDir.FilterSpec filterSpec, QDir.SortSpec sortSpec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDir_entryList1 (rawObject, new QString (nameFilter).RawObject, filterSpec, sortSpec), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_entryInfoList (IntPtr raw, QDir.FilterSpec filterSpec, QDir.SortSpec sortSpec);
		public IntPtr EntryInfoList (QDir.FilterSpec filterSpec, QDir.SortSpec sortSpec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_entryInfoList (rawObject, filterSpec, sortSpec);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_entryInfoList1 (IntPtr raw, IntPtr nameFilter, QDir.FilterSpec filterSpec, QDir.SortSpec sortSpec);
		public IntPtr EntryInfoList (string nameFilter, QDir.FilterSpec filterSpec, QDir.SortSpec sortSpec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_entryInfoList1 (rawObject, new QString (nameFilter).RawObject, filterSpec, sortSpec);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_mkdir (IntPtr raw, IntPtr dirName, bool acceptAbsPath);
		public bool Mkdir (string dirName, bool acceptAbsPath)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_mkdir (rawObject, new QString (dirName).RawObject, acceptAbsPath);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_rmdir (IntPtr raw, IntPtr dirName, bool acceptAbsPath);
		public bool Rmdir (string dirName, bool acceptAbsPath)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_rmdir (rawObject, new QString (dirName).RawObject, acceptAbsPath);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_isReadable (IntPtr raw);
		public bool IsReadable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_isReadable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_exists (IntPtr raw);
		public bool Exists ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_exists (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_isRoot (IntPtr raw);
		public bool IsRoot ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_isRoot (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_isRelative (IntPtr raw);
		public bool IsRelative ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_isRelative (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDir_convertToAbs (IntPtr raw);
		public void ConvertToAbs ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDir_convertToAbs (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_remove (IntPtr raw, IntPtr fileName, bool acceptAbsPath);
		public bool Remove (string fileName, bool acceptAbsPath)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_remove (rawObject, new QString (fileName).RawObject, acceptAbsPath);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_rename (IntPtr raw, IntPtr name, IntPtr newName, bool acceptAbsPaths);
		public bool Rename (string name, string newName, bool acceptAbsPaths)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_rename (rawObject, new QString (name).RawObject, new QString (newName).RawObject, acceptAbsPaths);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_exists1 (IntPtr raw, IntPtr name, bool acceptAbsPath);
		public bool Exists (string name, bool acceptAbsPath)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDir_exists1 (rawObject, new QString (name).RawObject, acceptAbsPath);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_convertSeparators (IntPtr pathName);
		public static string ConvertSeparators (string pathName)
		{
			QString qstr = new QString (qt_QDir_convertSeparators (new QString (pathName).RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_drives ();
		public static IntPtr Drives ()
		{
			return qt_QDir_drives ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern char qt_QDir_separator ();
		public static char Separator ()
		{
			return qt_QDir_separator ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_setCurrent (IntPtr path);
		public static bool SetCurrent (string path)
		{
			return qt_QDir_setCurrent (new QString (path).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_current ();
		public static QDir Current ()
		{
			return LookupObject (qt_QDir_current (), typeof (QDir)) as QDir;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_home ();
		public static QDir Home ()
		{
			return LookupObject (qt_QDir_home (), typeof (QDir)) as QDir;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_root ();
		public static QDir Root ()
		{
			return LookupObject (qt_QDir_root (), typeof (QDir)) as QDir;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_currentDirPath ();
		public static string CurrentDirPath ()
		{
			QString qstr = new QString (qt_QDir_currentDirPath ());
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_homeDirPath ();
		public static string HomeDirPath ()
		{
			QString qstr = new QString (qt_QDir_homeDirPath ());
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_rootDirPath ();
		public static string RootDirPath ()
		{
			QString qstr = new QString (qt_QDir_rootDirPath ());
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_match (IntPtr filters, IntPtr fileName);
		public static bool Match (QStringList filters, string fileName)
		{
			return qt_QDir_match (filters.RawObject, new QString (fileName).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_match1 (IntPtr filter, IntPtr fileName);
		public static bool Match (string filter, string fileName)
		{
			return qt_QDir_match1 (new QString (filter).RawObject, new QString (fileName).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDir_cleanDirPath (IntPtr dirPath);
		public static string CleanDirPath (string dirPath)
		{
			QString qstr = new QString (qt_QDir_cleanDirPath (new QString (dirPath).RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDir_isRelativePath (IntPtr path);
		public static bool IsRelativePath (string path)
		{
			return qt_QDir_isRelativePath (new QString (path).RawObject);
		}

		public string FilePath (string fileName)
		{
			return FilePath(fileName, true);
		}

		public string AbsFilePath (string fileName)
		{
			return AbsFilePath(fileName, true);
		}

		public bool Cd (string dirName)
		{
			return Cd(dirName, true);
		}

		public QStrList EncodedEntryList ()
		{
			return EncodedEntryList(QDir.FilterSpec.DefaultFilter);
		}

		public QStrList EncodedEntryList (QDir.FilterSpec filterSpec)
		{
			return EncodedEntryList(filterSpec, QDir.SortSpec.DefaultSort);
		}

		public QStrList EncodedEntryList (string nameFilter)
		{
			return EncodedEntryList(nameFilter, QDir.FilterSpec.DefaultFilter);
		}

		public QStrList EncodedEntryList (string nameFilter, QDir.FilterSpec filterSpec)
		{
			return EncodedEntryList(nameFilter, filterSpec, QDir.SortSpec.DefaultSort);
		}

		public QStringList EntryList ()
		{
			return EntryList(QDir.FilterSpec.DefaultFilter);
		}

		public QStringList EntryList (QDir.FilterSpec filterSpec)
		{
			return EntryList(filterSpec, QDir.SortSpec.DefaultSort);
		}

		public QStringList EntryList (string nameFilter)
		{
			return EntryList(nameFilter, QDir.FilterSpec.DefaultFilter);
		}

		public QStringList EntryList (string nameFilter, QDir.FilterSpec filterSpec)
		{
			return EntryList(nameFilter, filterSpec, QDir.SortSpec.DefaultSort);
		}

		public IntPtr EntryInfoList ()
		{
			return EntryInfoList(QDir.FilterSpec.DefaultFilter);
		}

		public IntPtr EntryInfoList (QDir.FilterSpec filterSpec)
		{
			return EntryInfoList(filterSpec, QDir.SortSpec.DefaultSort);
		}

		public IntPtr EntryInfoList (string nameFilter)
		{
			return EntryInfoList(nameFilter, QDir.FilterSpec.DefaultFilter);
		}

		public IntPtr EntryInfoList (string nameFilter, QDir.FilterSpec filterSpec)
		{
			return EntryInfoList(nameFilter, filterSpec, QDir.SortSpec.DefaultSort);
		}

		public bool Mkdir (string dirName)
		{
			return Mkdir(dirName, true);
		}

		public bool Rmdir (string dirName)
		{
			return Rmdir(dirName, true);
		}

		public bool Remove (string fileName)
		{
			return Remove(fileName, true);
		}

		public bool Rename (string name, string newName)
		{
			return Rename(name, newName, true);
		}

		public bool Exists (string name)
		{
			return Exists(name, true);
		}
	}
}