// QDockArea.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDockArea : QWidget, IDisposable {

		public enum HandlePosition {
			Normal = 0,
			Reverse = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDockArea (Orientation o, QDockArea.HandlePosition h, IntPtr parent, string name);
		public QDockArea (Orientation o, QDockArea.HandlePosition h, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QDockArea (o, h, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QDockArea (Orientation o) : this (o, QDockArea.HandlePosition.Normal) {}

		public QDockArea (Orientation o, QDockArea.HandlePosition h) : this (o, h, new QWidget ()) {}

		public QDockArea (Orientation o, QDockArea.HandlePosition h, QWidget parent) : this (o, h, parent, "") {}

		internal QDockArea () : this (QNull.Instance) {}

		public QDockArea (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDockArea (QNull dummy) : base (QNull.Instance) {}

		~QDockArea ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QDockArea (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QDockArea (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockArea_moveDockWindow (IntPtr raw, IntPtr w, IntPtr globalPos, IntPtr rect, bool swap);
		public void MoveDockWindow (QDockWindow w, QPoint globalPos, QRect rect, bool swap)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockArea_moveDockWindow (rawObject, w.RawObject, globalPos.RawObject, rect.RawObject, swap);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockArea_removeDockWindow (IntPtr raw, IntPtr w, bool makeFloating, bool swap, bool fixNewLines);
		public void RemoveDockWindow (QDockWindow w, bool makeFloating, bool swap, bool fixNewLines)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockArea_removeDockWindow (rawObject, w.RawObject, makeFloating, swap, fixNewLines);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockArea_moveDockWindow1 (IntPtr raw, IntPtr w, int index);
		public void MoveDockWindow (QDockWindow w, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockArea_moveDockWindow1 (rawObject, w.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockArea_hasDockWindow (IntPtr raw, IntPtr w, int[] index);
		public bool HasDockWindow (QDockWindow w, int[] index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockArea_hasDockWindow (rawObject, w.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockArea_invalidNextOffset (IntPtr raw, IntPtr dw);
		public void InvalidNextOffset (QDockWindow dw)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockArea_invalidNextOffset (rawObject, dw.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Orientation qt_QDockArea_orientation (IntPtr raw);
		public Orientation Orientation ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockArea_orientation (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QDockArea.HandlePosition qt_QDockArea_handlePosition (IntPtr raw);
		public QDockArea.HandlePosition TheHandlePosition ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockArea_handlePosition (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockArea_eventFilter (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public bool EventFilter (QObject arg1, QEvent arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockArea_eventFilter (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockArea_isEmpty (IntPtr raw);
		public bool IsEmpty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockArea_isEmpty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDockArea_count (IntPtr raw);
		public int Count ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockArea_count (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockArea_isDockWindowAccepted (IntPtr raw, IntPtr dw);
		public bool IsDockWindowAccepted (QDockWindow dw)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockArea_isDockWindowAccepted (rawObject, dw.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockArea_setAcceptDockWindow (IntPtr raw, IntPtr dw, bool accept);
		public void SetAcceptDockWindow (QDockWindow dw, bool accept)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockArea_setAcceptDockWindow (rawObject, dw.RawObject, accept);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockArea_lineUp (IntPtr raw, bool keepNewLines);
		public void LineUp (bool keepNewLines)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockArea_lineUp (rawObject, keepNewLines);
		}

		public void RemoveDockWindow (QDockWindow w, bool makeFloating, bool swap)
		{
			RemoveDockWindow(w, makeFloating, swap, true);
		}

		public void MoveDockWindow (QDockWindow w)
		{
			MoveDockWindow(w, (int) -1);
		}

		public bool HasDockWindow (QDockWindow w)
		{
			return HasDockWindow(w, new int[]{0});
		}

		// Begin interface methods.

	}
}