// QDockWindow.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDockWindow : QFrame, IDisposable {

		public enum Place {
			InDock = 0,
			OutsideDock = 1
		}

		public enum CloseMode {
			Never = 0,
			Docked = 1,
			Undocked = 2,
			Always = Docked|Undocked
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDockWindow (QDockWindow.Place p, IntPtr parent, string name, Qt.WidgetFlags f);
		public QDockWindow (QDockWindow.Place p, QWidget parent, string name, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QDockWindow (p, parent != null ? parent.RawObject : IntPtr.Zero, name, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QDockWindow () : this (QDockWindow.Place.InDock) {}

		public QDockWindow (QDockWindow.Place p) : this (p, new QWidget ()) {}

		public QDockWindow (QDockWindow.Place p, QWidget parent) : this (p, parent, "") {}

		public QDockWindow (QDockWindow.Place p, QWidget parent, string name) : this (p, parent, name, Qt.WidgetFlags.WWinOwnDC) {}

		public QDockWindow (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDockWindow (QNull dummy) : base (QNull.Instance) {}

		~QDockWindow ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QDockWindow (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QDockWindow (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setWidget (IntPtr raw, IntPtr w);
		public void SetWidget (QWidget w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setWidget (rawObject, w.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDockWindow_widget (IntPtr raw);
		public QWidget Widget ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDockWindow_widget (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QDockWindow.Place qt_QDockWindow_place (IntPtr raw);
		public QDockWindow.Place ThePlace ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_place (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDockWindow_area (IntPtr raw);
		public QDockArea Area ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDockWindow_area (rawObject), typeof (QDockArea)) as QDockArea;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setCloseMode (IntPtr raw, int m);
		public void SetCloseMode (int m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setCloseMode (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockWindow_isCloseEnabled (IntPtr raw);
		public bool IsCloseEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_isCloseEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDockWindow_closeMode (IntPtr raw);
		public int TheCloseMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_closeMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setResizeEnabled (IntPtr raw, bool b);
		public void SetResizeEnabled (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setResizeEnabled (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setMovingEnabled (IntPtr raw, bool b);
		public void SetMovingEnabled (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setMovingEnabled (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockWindow_isResizeEnabled (IntPtr raw);
		public bool IsResizeEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_isResizeEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockWindow_isMovingEnabled (IntPtr raw);
		public bool IsMovingEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_isMovingEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setHorizontallyStretchable (IntPtr raw, bool b);
		public void SetHorizontallyStretchable (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setHorizontallyStretchable (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setVerticallyStretchable (IntPtr raw, bool b);
		public void SetVerticallyStretchable (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setVerticallyStretchable (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockWindow_isHorizontallyStretchable (IntPtr raw);
		public bool IsHorizontallyStretchable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_isHorizontallyStretchable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockWindow_isVerticallyStretchable (IntPtr raw);
		public bool IsVerticallyStretchable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_isVerticallyStretchable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setHorizontalStretchable (IntPtr raw, bool b);
		public void SetHorizontalStretchable (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setHorizontalStretchable (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setVerticalStretchable (IntPtr raw, bool b);
		public void SetVerticalStretchable (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setVerticalStretchable (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockWindow_isHorizontalStretchable (IntPtr raw);
		public bool IsHorizontalStretchable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_isHorizontalStretchable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockWindow_isVerticalStretchable (IntPtr raw);
		public bool IsVerticalStretchable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_isVerticalStretchable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockWindow_isStretchable (IntPtr raw);
		public bool IsStretchable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_isStretchable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setOffset (IntPtr raw, int o);
		public void SetOffset (int o)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setOffset (rawObject, o);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QDockWindow_offset (IntPtr raw);
		public int Offset ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_offset (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setFixedExtentWidth (IntPtr raw, int w);
		public void SetFixedExtentWidth (int w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setFixedExtentWidth (rawObject, w);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setFixedExtentHeight (IntPtr raw, int h);
		public void SetFixedExtentHeight (int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setFixedExtentHeight (rawObject, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDockWindow_fixedExtent (IntPtr raw);
		public QSize FixedExtent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDockWindow_fixedExtent (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setNewLine (IntPtr raw, bool b);
		public void SetNewLine (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setNewLine (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockWindow_newLine (IntPtr raw);
		public bool NewLine ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_newLine (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.Orientation qt_QDockWindow_orientation (IntPtr raw);
		public Qt.Orientation Orientation ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_orientation (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDockWindow_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDockWindow_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDockWindow_minimumSize (IntPtr raw);
		public QSize MinimumSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDockWindow_minimumSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDockWindow_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDockWindow_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDockWindow_boxLayout (IntPtr raw);
		public QBoxLayout BoxLayout ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDockWindow_boxLayout (rawObject), typeof (QBoxLayout)) as QBoxLayout;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setOpaqueMoving (IntPtr raw, bool b);
		public void SetOpaqueMoving (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setOpaqueMoving (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockWindow_opaqueMoving (IntPtr raw);
		public bool OpaqueMoving ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_opaqueMoving (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockWindow_eventFilter (IntPtr raw, IntPtr o, IntPtr e);
		public bool EventFilter (QObject o, QEvent e)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_eventFilter (rawObject, o.RawObject, e.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDockWindow_caption (IntPtr raw);
		public string Caption ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDockWindow_caption (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_undock (IntPtr raw, IntPtr w);
		public void Undock (QWidget w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_undock (rawObject, w.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_undock1 (IntPtr raw);
		public void Undock ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_undock1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_dock (IntPtr raw);
		public void Dock ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_dock (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setOrientation (IntPtr raw, Orientation o);
		public void SetOrientation (Orientation o)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setOrientation (rawObject, o);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_setCaption (IntPtr raw, IntPtr s);
		public void SetCaption (string s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_setCaption (rawObject, new QString (s).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDockWindow_drawFrame (IntPtr raw, IntPtr arg1);
		protected void DrawFrame (QPainter arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDockWindow_drawFrame (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDockWindow_event (IntPtr raw, IntPtr e);
		protected bool Q_event (QEvent e)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDockWindow_event (rawObject, e.RawObject);
		}

		// Begin interface methods.

	}
}