// QDomDocument.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDomDocument : QDomNode, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDomDocument ();
		public QDomDocument () : this (QNull.Instance)
		{
			rawObject = qt_new_QDomDocument ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDomDocument1 (IntPtr name);
		public QDomDocument (string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QDomDocument1 (new QString (name).RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDomDocument2 (IntPtr doctype);
		public QDomDocument (QDomDocumentType doctype) : this (QNull.Instance)
		{
			rawObject = qt_new_QDomDocument2 (doctype.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDomDocument3 (IntPtr x);
		public QDomDocument (QDomDocument x) : this (QNull.Instance)
		{
			rawObject = qt_new_QDomDocument3 (x.RawObject);
			RegisterObject (this);
		}

		public QDomDocument (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDomDocument (QNull dummy) : base (QNull.Instance) {}

		~QDomDocument ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QDomDocument (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QDomDocument (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_createElement (IntPtr raw, IntPtr tagName);
		public QDomElement CreateElement (string tagName)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_createElement (rawObject, new QString (tagName).RawObject), typeof (QDomElement)) as QDomElement;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_createDocumentFragment (IntPtr raw);
		public QDomDocumentFragment CreateDocumentFragment ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_createDocumentFragment (rawObject), typeof (QDomDocumentFragment)) as QDomDocumentFragment;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_createTextNode (IntPtr raw, IntPtr data);
		public QDomText CreateTextNode (string data)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_createTextNode (rawObject, new QString (data).RawObject), typeof (QDomText)) as QDomText;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_createComment (IntPtr raw, IntPtr data);
		public QDomComment CreateComment (string data)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_createComment (rawObject, new QString (data).RawObject), typeof (QDomComment)) as QDomComment;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_createCDATASection (IntPtr raw, IntPtr data);
		public QDomCDATASection CreateCDATASection (string data)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_createCDATASection (rawObject, new QString (data).RawObject), typeof (QDomCDATASection)) as QDomCDATASection;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_createProcessingInstruction (IntPtr raw, IntPtr target, IntPtr data);
		public QDomProcessingInstruction CreateProcessingInstruction (string target, string data)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_createProcessingInstruction (rawObject, new QString (target).RawObject, new QString (data).RawObject), typeof (QDomProcessingInstruction)) as QDomProcessingInstruction;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_createAttribute (IntPtr raw, IntPtr name);
		public QDomAttr CreateAttribute (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_createAttribute (rawObject, new QString (name).RawObject), typeof (QDomAttr)) as QDomAttr;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_createEntityReference (IntPtr raw, IntPtr name);
		public QDomEntityReference CreateEntityReference (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_createEntityReference (rawObject, new QString (name).RawObject), typeof (QDomEntityReference)) as QDomEntityReference;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_elementsByTagName (IntPtr raw, IntPtr tagname);
		public QDomNodeList ElementsByTagName (string tagname)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_elementsByTagName (rawObject, new QString (tagname).RawObject), typeof (QDomNodeList)) as QDomNodeList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_importNode (IntPtr raw, IntPtr importedNode, bool deep);
		public QDomNode ImportNode (QDomNode importedNode, bool deep)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_importNode (rawObject, importedNode.RawObject, deep), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_createElementNS (IntPtr raw, IntPtr nsURI, IntPtr qName);
		public QDomElement CreateElementNS (string nsURI, string qName)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_createElementNS (rawObject, new QString (nsURI).RawObject, new QString (qName).RawObject), typeof (QDomElement)) as QDomElement;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_createAttributeNS (IntPtr raw, IntPtr nsURI, IntPtr qName);
		public QDomAttr CreateAttributeNS (string nsURI, string qName)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_createAttributeNS (rawObject, new QString (nsURI).RawObject, new QString (qName).RawObject), typeof (QDomAttr)) as QDomAttr;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_elementsByTagNameNS (IntPtr raw, IntPtr nsURI, IntPtr localName);
		public QDomNodeList ElementsByTagNameNS (string nsURI, string localName)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_elementsByTagNameNS (rawObject, new QString (nsURI).RawObject, new QString (localName).RawObject), typeof (QDomNodeList)) as QDomNodeList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_elementById (IntPtr raw, IntPtr elementId);
		public QDomElement ElementById (string elementId)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_elementById (rawObject, new QString (elementId).RawObject), typeof (QDomElement)) as QDomElement;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_doctype (IntPtr raw);
		public QDomDocumentType Doctype ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_doctype (rawObject), typeof (QDomDocumentType)) as QDomDocumentType;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_implementation (IntPtr raw);
		public QDomImplementation Implementation ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_implementation (rawObject), typeof (QDomImplementation)) as QDomImplementation;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_documentElement (IntPtr raw);
		public QDomElement DocumentElement ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_documentElement (rawObject), typeof (QDomElement)) as QDomElement;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QDomNode.NodeType qt_QDomDocument_nodeType (IntPtr raw);
		public QDomNode.NodeType NodeType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomDocument_nodeType (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomDocument_isDocument (IntPtr raw);
		public bool IsDocument ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomDocument_isDocument (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_toString (IntPtr raw);
		public string ToString ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDomDocument_toString (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomDocument_toCString (IntPtr raw);
		public QCString ToCString ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomDocument_toCString (rawObject), typeof (QCString)) as QCString;
		}

		// Begin interface methods.

	}
}