// QDomNode.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDomNode : QtSupport, IDisposable {

		public enum NodeType {
			ElementNode = 1,
			AttributeNode = 2,
			TextNode = 3,
			CDATASectionNode = 4,
			EntityReferenceNode = 5,
			EntityNode = 6,
			ProcessingInstructionNode = 7,
			CommentNode = 8,
			DocumentNode = 9,
			DocumentTypeNode = 10,
			DocumentFragmentNode = 11,
			NotationNode = 12,
			BaseNode = 21,
			CharacterDataNode = 22
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDomNode ();
		public QDomNode () : this (QNull.Instance)
		{
			rawObject = qt_new_QDomNode ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDomNode1 (IntPtr arg1);
		public QDomNode (QDomNode arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QDomNode1 (arg1.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDomNode2 (int arg1);
		protected QDomNode (int arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QDomNode2 (arg1);
			RegisterObject (this);
		}

		public QDomNode (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDomNode (QNull dummy) : base (QNull.Instance) {}

		~QDomNode ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QDomNode (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QDomNode (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_insertBefore (IntPtr raw, IntPtr newChild, IntPtr refChild);
		public QDomNode InsertBefore (QDomNode newChild, QDomNode refChild)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_insertBefore (rawObject, newChild.RawObject, refChild.RawObject), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_insertAfter (IntPtr raw, IntPtr newChild, IntPtr refChild);
		public QDomNode InsertAfter (QDomNode newChild, QDomNode refChild)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_insertAfter (rawObject, newChild.RawObject, refChild.RawObject), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_replaceChild (IntPtr raw, IntPtr newChild, IntPtr oldChild);
		public QDomNode ReplaceChild (QDomNode newChild, QDomNode oldChild)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_replaceChild (rawObject, newChild.RawObject, oldChild.RawObject), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_removeChild (IntPtr raw, IntPtr oldChild);
		public QDomNode RemoveChild (QDomNode oldChild)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_removeChild (rawObject, oldChild.RawObject), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_appendChild (IntPtr raw, IntPtr newChild);
		public QDomNode AppendChild (QDomNode newChild)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_appendChild (rawObject, newChild.RawObject), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_hasChildNodes (IntPtr raw);
		public bool HasChildNodes ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_hasChildNodes (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_cloneNode (IntPtr raw, bool deep);
		public QDomNode CloneNode (bool deep)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_cloneNode (rawObject, deep), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDomNode_normalize (IntPtr raw);
		public void Normalize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDomNode_normalize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isSupported (IntPtr raw, IntPtr feature, IntPtr version);
		public bool IsSupported (string feature, string version)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isSupported (rawObject, new QString (feature).RawObject, new QString (version).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_nodeName (IntPtr raw);
		public string NodeName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDomNode_nodeName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QDomNode.NodeType qt_QDomNode_nodeType (IntPtr raw);
		public QDomNode.NodeType TheNodeType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_nodeType (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_parentNode (IntPtr raw);
		public QDomNode ParentNode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_parentNode (rawObject), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_childNodes (IntPtr raw);
		public QDomNodeList ChildNodes ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_childNodes (rawObject), typeof (QDomNodeList)) as QDomNodeList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_firstChild (IntPtr raw);
		public QDomNode FirstChild ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_firstChild (rawObject), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_lastChild (IntPtr raw);
		public QDomNode LastChild ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_lastChild (rawObject), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_previousSibling (IntPtr raw);
		public QDomNode PreviousSibling ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_previousSibling (rawObject), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_nextSibling (IntPtr raw);
		public QDomNode NextSibling ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_nextSibling (rawObject), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_attributes (IntPtr raw);
		public QDomNamedNodeMap Attributes ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_attributes (rawObject), typeof (QDomNamedNodeMap)) as QDomNamedNodeMap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_ownerDocument (IntPtr raw);
		public QDomDocument OwnerDocument ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_ownerDocument (rawObject), typeof (QDomDocument)) as QDomDocument;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_namespaceURI (IntPtr raw);
		public string NamespaceURI ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDomNode_namespaceURI (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_localName (IntPtr raw);
		public string LocalName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDomNode_localName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_hasAttributes (IntPtr raw);
		public bool HasAttributes ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_hasAttributes (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_nodeValue (IntPtr raw);
		public string NodeValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDomNode_nodeValue (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDomNode_setNodeValue (IntPtr raw, IntPtr arg1);
		public void SetNodeValue (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDomNode_setNodeValue (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_prefix (IntPtr raw);
		public string Prefix ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QDomNode_prefix (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDomNode_setPrefix (IntPtr raw, IntPtr pre);
		public void SetPrefix (string pre)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDomNode_setPrefix (rawObject, new QString (pre).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isAttr (IntPtr raw);
		public bool IsAttr ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isAttr (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isCDATASection (IntPtr raw);
		public bool IsCDATASection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isCDATASection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isDocumentFragment (IntPtr raw);
		public bool IsDocumentFragment ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isDocumentFragment (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isDocument (IntPtr raw);
		public bool IsDocument ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isDocument (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isDocumentType (IntPtr raw);
		public bool IsDocumentType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isDocumentType (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isElement (IntPtr raw);
		public bool IsElement ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isElement (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isEntityReference (IntPtr raw);
		public bool IsEntityReference ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isEntityReference (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isText (IntPtr raw);
		public bool IsText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isText (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isEntity (IntPtr raw);
		public bool IsEntity ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isEntity (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isNotation (IntPtr raw);
		public bool IsNotation ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isNotation (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isProcessingInstruction (IntPtr raw);
		public bool IsProcessingInstruction ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isProcessingInstruction (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isCharacterData (IntPtr raw);
		public bool IsCharacterData ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isCharacterData (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isComment (IntPtr raw);
		public bool IsComment ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isComment (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_namedItem (IntPtr raw, IntPtr name);
		public QDomNode NamedItem (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_namedItem (rawObject, new QString (name).RawObject), typeof (QDomNode)) as QDomNode;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDomNode_isNull (IntPtr raw);
		public bool IsNull ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDomNode_isNull (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDomNode_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDomNode_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toAttr (IntPtr raw);
		public QDomAttr ToAttr ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toAttr (rawObject), typeof (QDomAttr)) as QDomAttr;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toCDATASection (IntPtr raw);
		public QDomCDATASection ToCDATASection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toCDATASection (rawObject), typeof (QDomCDATASection)) as QDomCDATASection;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toDocumentFragment (IntPtr raw);
		public QDomDocumentFragment ToDocumentFragment ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toDocumentFragment (rawObject), typeof (QDomDocumentFragment)) as QDomDocumentFragment;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toDocument (IntPtr raw);
		public QDomDocument ToDocument ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toDocument (rawObject), typeof (QDomDocument)) as QDomDocument;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toDocumentType (IntPtr raw);
		public QDomDocumentType ToDocumentType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toDocumentType (rawObject), typeof (QDomDocumentType)) as QDomDocumentType;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toElement (IntPtr raw);
		public QDomElement ToElement ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toElement (rawObject), typeof (QDomElement)) as QDomElement;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toEntityReference (IntPtr raw);
		public QDomEntityReference ToEntityReference ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toEntityReference (rawObject), typeof (QDomEntityReference)) as QDomEntityReference;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toText (IntPtr raw);
		public QDomText ToText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toText (rawObject), typeof (QDomText)) as QDomText;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toEntity (IntPtr raw);
		public QDomEntity ToEntity ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toEntity (rawObject), typeof (QDomEntity)) as QDomEntity;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toNotation (IntPtr raw);
		public QDomNotation ToNotation ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toNotation (rawObject), typeof (QDomNotation)) as QDomNotation;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toProcessingInstruction (IntPtr raw);
		public QDomProcessingInstruction ToProcessingInstruction ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toProcessingInstruction (rawObject), typeof (QDomProcessingInstruction)) as QDomProcessingInstruction;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toCharacterData (IntPtr raw);
		public QDomCharacterData ToCharacterData ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toCharacterData (rawObject), typeof (QDomCharacterData)) as QDomCharacterData;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDomNode_toComment (IntPtr raw);
		public QDomComment ToComment ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDomNode_toComment (rawObject), typeof (QDomComment)) as QDomComment;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDomNode_save (IntPtr raw, IntPtr arg1, int arg2);
		public void Save (QTextStream arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDomNode_save (rawObject, arg1.RawObject, arg2);
		}

		public QDomNode CloneNode ()
		{
			return CloneNode(true);
		}
	}
}