// QDragObject.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDragObject : QObject, IQMimeSource, IDisposable {

		public enum DragMode {
			DragDefault = 0,
			DragCopy = 1,
			DragMove = 2,
			DragLink = 3,
			DragCopyOrMove = 4
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDragObject (IntPtr dragSource, string name);
		public QDragObject (QWidget dragSource, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QDragObject (dragSource.RawObject, name);
			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QDragObject () : this (new QWidget ()) {}

		public QDragObject (QWidget dragSource) : this (dragSource, "") {}

		public QDragObject (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDragObject (QNull dummy) : base (QNull.Instance) {}

		~QDragObject ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QDragObject (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QDragObject (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDragObject_drag (IntPtr raw);
		public bool Drag ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDragObject_drag (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDragObject_dragMove (IntPtr raw);
		public bool DragMove ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDragObject_dragMove (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDragObject_dragCopy (IntPtr raw);
		public void DragCopy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDragObject_dragCopy (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDragObject_dragLink (IntPtr raw);
		public void DragLink ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDragObject_dragLink (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDragObject_setPixmap (IntPtr raw, IntPtr arg1);
		public void SetPixmap (QPixmap arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDragObject_setPixmap (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDragObject_setPixmap1 (IntPtr raw, IntPtr arg1, IntPtr hotspot);
		public void SetPixmap (QPixmap arg1, QPoint hotspot)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDragObject_setPixmap1 (rawObject, arg1.RawObject, hotspot.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDragObject_pixmap (IntPtr raw);
		public QPixmap Pixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDragObject_pixmap (rawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDragObject_pixmapHotSpot (IntPtr raw);
		public QPoint PixmapHotSpot ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDragObject_pixmapHotSpot (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDragObject_source (IntPtr raw);
		public QWidget Source ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDragObject_source (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDragObject_target ();
		public static QWidget Target ()
		{
			return LookupObject (qt_QDragObject_target (), typeof (QWidget)) as QWidget;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDragObject_setTarget (IntPtr arg1);
		public static void SetTarget (QWidget arg1)
		{
			qt_QDragObject_setTarget (arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDragObject_drag1 (IntPtr raw, QDragObject.DragMode arg1);
		protected bool Drag (QDragObject.DragMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDragObject_drag1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDragObject_QMimeSource (IntPtr raw);
		public IntPtr QMimeSource ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDragObject_QMimeSource (rawObject);
		}

		// Begin interface methods.


		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QMimeSource_format (IntPtr raw, int n);
		public string Format (int n)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMimeSource_format (QMimeSource (), n);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMimeSource_provides (IntPtr raw, string arg1);
		public bool Provides (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMimeSource_provides (QMimeSource (), arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern byte[] qt_QMimeSource_encodedData (IntPtr raw, string arg1);
		public byte[] EncodedData (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMimeSource_encodedData (QMimeSource (), arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMimeSource_serialNumber (IntPtr raw);
		public int SerialNumber ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMimeSource_serialNumber (QMimeSource ());
		}

		public string Format ()
		{
			return Format((int) 0);
		}

		// Begin interface methods.

	}
}