// QDropEvent.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QDropEvent : QEvent, IQMimeSource, IDisposable {

		public enum Action {
			Copy = 0,
			Link = 1,
			Move = 2,
			Private = 3,
			UserAction = 100
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QDropEvent (IntPtr pos, Type typ);
		public QDropEvent (QPoint pos, Type typ) : this (QNull.Instance)
		{
			rawObject = qt_new_QDropEvent (pos.RawObject, typ);
			RegisterObject (this);
		}

		internal QDropEvent () : this (QNull.Instance) {}

		public QDropEvent (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QDropEvent (QNull dummy) : base (QNull.Instance) {}

		~QDropEvent ()
		{
			Dispose (false);
		}
		internal override void Delete ()
		{
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDropEvent_pos (IntPtr raw);
		public QPoint Pos ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDropEvent_pos (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDropEvent_isAccepted (IntPtr raw);
		public bool IsAccepted ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDropEvent_isAccepted (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDropEvent_accept (IntPtr raw, bool y);
		public void Accept (bool y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDropEvent_accept (rawObject, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDropEvent_ignore (IntPtr raw);
		public void Ignore ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDropEvent_ignore (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDropEvent_isActionAccepted (IntPtr raw);
		public bool IsActionAccepted ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDropEvent_isActionAccepted (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDropEvent_acceptAction (IntPtr raw, bool y);
		public void AcceptAction (bool y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDropEvent_acceptAction (rawObject, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDropEvent_setAction (IntPtr raw, QDropEvent.Action a);
		public void SetAction (QDropEvent.Action a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDropEvent_setAction (rawObject, a);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QDropEvent.Action qt_QDropEvent_action (IntPtr raw);
		public QDropEvent.Action TheAction ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDropEvent_action (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDropEvent_source (IntPtr raw);
		public QWidget Source ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QDropEvent_source (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QDropEvent_format (IntPtr raw, int n);
		public string Format (int n)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDropEvent_format (rawObject, n);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern byte[] qt_QDropEvent_encodedData (IntPtr raw, string arg1);
		public byte[] EncodedData (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDropEvent_encodedData (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QDropEvent_provides (IntPtr raw, string arg1);
		public bool Provides (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDropEvent_provides (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern byte[] qt_QDropEvent_data (IntPtr raw, string f);
		public byte[] Data (string f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDropEvent_data (rawObject, f);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QDropEvent_setPoint (IntPtr raw, IntPtr np);
		public void SetPoint (QPoint np)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QDropEvent_setPoint (rawObject, np.RawObject);
		}

		public void Accept ()
		{
			Accept(true);
		}

		public void AcceptAction ()
		{
			AcceptAction(true);
		}

		public string Format ()
		{
			return Format((int) 0);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QDropEvent_QMimeSource (IntPtr raw);
		public IntPtr QMimeSource ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QDropEvent_QMimeSource (rawObject);
		}

		// Begin interface methods.


		// Begin interface methods.


		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMimeSource_serialNumber (IntPtr raw);
		public int SerialNumber ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMimeSource_serialNumber (QMimeSource ());
		}
	}
}