// QEvent.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QEvent : QtSupport, IDisposable {

		public enum Type {
			None = 0,
			Timer = 1,
			MouseButtonPress = 2,
			MouseButtonRelease = 3,
			MouseButtonDblClick = 4,
			MouseMove = 5,
			KeyPress = 6,
			KeyRelease = 7,
			FocusIn = 8,
			FocusOut = 9,
			Enter = 10,
			Leave = 11,
			Paint = 12,
			Move = 13,
			Resize = 14,
			Create = 15,
			Destroy = 16,
			Show = 17,
			Hide = 18,
			Close = 19,
			Quit = 20,
			Reparent = 21,
			ShowMinimized = 22,
			ShowNormal = 23,
			WindowActivate = 24,
			WindowDeactivate = 25,
			ShowToParent = 26,
			HideToParent = 27,
			ShowMaximized = 28,
			ShowFullScreen = 29,
			Accel = 30,
			Wheel = 31,
			AccelAvailable = 32,
			CaptionChange = 33,
			IconChange = 34,
			ParentFontChange = 35,
			ApplicationFontChange = 36,
			ParentPaletteChange = 37,
			ApplicationPaletteChange = 38,
			PaletteChange = 39,
			Clipboard = 40,
			Speech = 42,
			SockAct = 50,
			AccelOverride = 51,
			DeferredDelete = 52,
			DragEnter = 60,
			DragMove = 61,
			DragLeave = 62,
			Drop = 63,
			DragResponse = 64,
			ChildInserted = 70,
			ChildRemoved = 71,
			LayoutHint = 72,
			ShowWindowRequest = 73,
			ActivateControl = 80,
			DeactivateControl = 81,
			ContextMenu = 82,
			IMStart = 83,
			IMCompose = 84,
			IMEnd = 85,
			Accessibility = 86,
			Tablet = 87,
			User = 1000,
			MaxUser = 65535
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QEvent (Type type);
		public QEvent (Type type) : this (QNull.Instance)
		{
			rawObject = qt_new_QEvent (type);
			RegisterObject (this);
		}

		internal QEvent () : this (QNull.Instance) {}

		public QEvent (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QEvent (QNull dummy) : base (QNull.Instance) {}

		~QEvent ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QEvent (IntPtr raw);
		internal override void Delete ()
		{
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Type qt_QEvent_type (IntPtr raw);
		public Type TheType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QEvent_type (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QEvent_spontaneous (IntPtr raw);
		public bool Spontaneous ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QEvent_spontaneous (rawObject);
		}

		// Begin interface methods.

	}
}