// QFileDialog.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QFileDialog : QDialog, IDisposable {

		public enum Mode {
			AnyFile = 0,
			ExistingFile = 1,
			Directory = 2,
			ExistingFiles = 3,
			DirectoryOnly = 4
		}

		public enum ViewMode {
			Detail = 0,
			List = 1
		}

		public enum PreviewMode {
			NoPreview = 0,
			Contents = 1,
			Info = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QFileDialog (IntPtr dirName, IntPtr filter, IntPtr parent, string name, bool modal);
		public QFileDialog (string dirName, string filter, QWidget parent, string name, bool modal) : this (QNull.Instance)
		{
			rawObject = qt_new_QFileDialog (new QString (dirName).RawObject, new QString (filter).RawObject, parent != null ? parent.RawObject : IntPtr.Zero, name, modal);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QFileDialog1 (IntPtr parent, string name, bool modal);
		public QFileDialog (QWidget parent, string name, bool modal) : this (QNull.Instance)
		{
			rawObject = qt_new_QFileDialog1 (parent != null ? parent.RawObject : IntPtr.Zero, name, modal);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QFileDialog (string dirName) : this (dirName, (string) "") {}

		public QFileDialog (string dirName, string filter) : this (dirName, filter, new QWidget ()) {}

		public QFileDialog (string dirName, string filter, QWidget parent) : this (dirName, filter, parent, "") {}

		public QFileDialog (string dirName, string filter, QWidget parent, string name) : this (dirName, filter, parent, name, false) {}

		public QFileDialog () : this (new QWidget ()) {}

		public QFileDialog (QWidget parent) : this (parent, "") {}

		public QFileDialog (QWidget parent, string name) : this (parent, name, false) {}

		public QFileDialog (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QFileDialog (QNull dummy) : base (QNull.Instance) {}

		~QFileDialog ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QFileDialog (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QFileDialog (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileDialog_selectedFile (IntPtr raw);
		public string SelectedFile ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFileDialog_selectedFile (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileDialog_selectedFilter (IntPtr raw);
		public string SelectedFilter ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFileDialog_selectedFilter (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setSelectedFilter (IntPtr raw, IntPtr arg1);
		public void SetSelectedFilter (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setSelectedFilter (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setSelectedFilter1 (IntPtr raw, int arg1);
		public void SetSelectedFilter (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setSelectedFilter1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setSelection (IntPtr raw, IntPtr arg1);
		public void SetSelection (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setSelection (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_selectAll (IntPtr raw, bool b);
		public void SelectAll (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_selectAll (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileDialog_selectedFiles (IntPtr raw);
		public QStringList SelectedFiles ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFileDialog_selectedFiles (rawObject), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileDialog_dirPath (IntPtr raw);
		public string DirPath ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFileDialog_dirPath (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setDir (IntPtr raw, IntPtr arg1);
		public void SetDir (QDir arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setDir (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileDialog_dir (IntPtr raw);
		public QDir Dir ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFileDialog_dir (rawObject), typeof (QDir)) as QDir;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setShowHiddenFiles (IntPtr raw, bool s);
		public void SetShowHiddenFiles (bool s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setShowHiddenFiles (rawObject, s);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileDialog_showHiddenFiles (IntPtr raw);
		public bool ShowHiddenFiles ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileDialog_showHiddenFiles (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_rereadDir (IntPtr raw);
		public void RereadDir ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_rereadDir (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_resortDir (IntPtr raw);
		public void ResortDir ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_resortDir (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setMode (IntPtr raw, Mode arg1);
		public void SetMode (Mode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Mode qt_QFileDialog_mode (IntPtr raw);
		public Mode TheMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileDialog_mode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setViewMode (IntPtr raw, QFileDialog.ViewMode m);
		public void SetViewMode (QFileDialog.ViewMode m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setViewMode (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QFileDialog.ViewMode qt_QFileDialog_viewMode (IntPtr raw);
		public QFileDialog.ViewMode TheViewMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileDialog_viewMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setPreviewMode (IntPtr raw, QFileDialog.PreviewMode m);
		public void SetPreviewMode (QFileDialog.PreviewMode m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setPreviewMode (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QFileDialog.PreviewMode qt_QFileDialog_previewMode (IntPtr raw);
		public QFileDialog.PreviewMode ThePreviewMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileDialog_previewMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileDialog_eventFilter (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public bool EventFilter (QObject arg1, QEvent arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileDialog_eventFilter (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileDialog_isInfoPreviewEnabled (IntPtr raw);
		public bool IsInfoPreviewEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileDialog_isInfoPreviewEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileDialog_isContentsPreviewEnabled (IntPtr raw);
		public bool IsContentsPreviewEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileDialog_isContentsPreviewEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setInfoPreviewEnabled (IntPtr raw, bool arg1);
		public void SetInfoPreviewEnabled (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setInfoPreviewEnabled (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setContentsPreviewEnabled (IntPtr raw, bool arg1);
		public void SetContentsPreviewEnabled (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setContentsPreviewEnabled (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setInfoPreview (IntPtr raw, IntPtr w, IntPtr preview);
		public void SetInfoPreview (QWidget w, QFilePreview preview)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setInfoPreview (rawObject, w.RawObject, preview.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setContentsPreview (IntPtr raw, IntPtr w, IntPtr preview);
		public void SetContentsPreview (QWidget w, QFilePreview preview)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setContentsPreview (rawObject, w.RawObject, preview.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileDialog_url (IntPtr raw);
		public QUrl Url ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFileDialog_url (rawObject), typeof (QUrl)) as QUrl;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_addFilter (IntPtr raw, IntPtr filter);
		public void AddFilter (string filter)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_addFilter (rawObject, new QString (filter).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_done (IntPtr raw, int arg1);
		public void Done (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_done (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setDir1 (IntPtr raw, IntPtr arg1);
		public void SetDir (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setDir1 (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setUrl (IntPtr raw, IntPtr url);
		public void SetUrl (QUrlOperator url)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setUrl (rawObject, url.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setFilter (IntPtr raw, IntPtr arg1);
		public void SetFilter (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setFilter (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setFilters (IntPtr raw, IntPtr arg1);
		public void SetFilters (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setFilters (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setFilters1 (IntPtr raw, string[] arg1);
		public void SetFilters (string[] arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setFilters1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setFilters2 (IntPtr raw, IntPtr arg1);
		public void SetFilters (QStringList arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_setFilters2 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileDialog_getOpenFileName (IntPtr initially, IntPtr filter, IntPtr parent, string name, IntPtr caption, IntPtr selectedFilter, bool resolveSymlinks);
		public static string GetOpenFileName (string initially, string filter, QWidget parent, string name, string caption, string selectedFilter, bool resolveSymlinks)
		{
			QString qstr = new QString (qt_QFileDialog_getOpenFileName (new QString (initially).RawObject, new QString (filter).RawObject, parent.RawObject, name, new QString (caption).RawObject, new QString (selectedFilter).RawObject, resolveSymlinks));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileDialog_getSaveFileName (IntPtr initially, IntPtr filter, IntPtr parent, string name, IntPtr caption, IntPtr selectedFilter, bool resolveSymlinks);
		public static string GetSaveFileName (string initially, string filter, QWidget parent, string name, string caption, string selectedFilter, bool resolveSymlinks)
		{
			QString qstr = new QString (qt_QFileDialog_getSaveFileName (new QString (initially).RawObject, new QString (filter).RawObject, parent.RawObject, name, new QString (caption).RawObject, new QString (selectedFilter).RawObject, resolveSymlinks));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileDialog_getExistingDirectory (IntPtr dir, IntPtr parent, string name, IntPtr caption, bool dirOnly, bool resolveSymlinks);
		public static string GetExistingDirectory (string dir, QWidget parent, string name, string caption, bool dirOnly, bool resolveSymlinks)
		{
			QString qstr = new QString (qt_QFileDialog_getExistingDirectory (new QString (dir).RawObject, parent.RawObject, name, new QString (caption).RawObject, dirOnly, resolveSymlinks));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileDialog_getOpenFileNames (IntPtr filter, IntPtr dir, IntPtr parent, string name, IntPtr caption, IntPtr selectedFilter, bool resolveSymlinks);
		public static QStringList GetOpenFileNames (string filter, string dir, QWidget parent, string name, string caption, string selectedFilter, bool resolveSymlinks)
		{
			return LookupObject (qt_QFileDialog_getOpenFileNames (new QString (filter).RawObject, new QString (dir).RawObject, parent.RawObject, name, new QString (caption).RawObject, new QString (selectedFilter).RawObject, resolveSymlinks), typeof (QStringList)) as QStringList;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_setIconProvider (IntPtr arg1);
		public static void SetIconProvider (QFileIconProvider arg1)
		{
			qt_QFileDialog_setIconProvider (arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileDialog_iconProvider ();
		public static QFileIconProvider IconProvider ()
		{
			return LookupObject (qt_QFileDialog_iconProvider (), typeof (QFileIconProvider)) as QFileIconProvider;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_addWidgets (IntPtr raw, IntPtr arg1, IntPtr arg2, IntPtr arg3);
		protected void AddWidgets (QLabel arg1, QWidget arg2, QPushButton arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_addWidgets (rawObject, arg1.RawObject, arg2.RawObject, arg3.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_addToolButton (IntPtr raw, IntPtr b, bool separator);
		protected void AddToolButton (QButton b, bool separator)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_addToolButton (rawObject, b.RawObject, separator);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_addLeftWidget (IntPtr raw, IntPtr w);
		protected void AddLeftWidget (QWidget w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_addLeftWidget (rawObject, w.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileDialog_addRightWidget (IntPtr raw, IntPtr w);
		protected void AddRightWidget (QWidget w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileDialog_addRightWidget (rawObject, w.RawObject);
		}

		public static string GetOpenFileName ()
		{
			return GetOpenFileName((string) "");
		}

		public static string GetOpenFileName (string initially)
		{
			return GetOpenFileName(initially, (string) "");
		}

		public static string GetOpenFileName (string initially, string filter)
		{
			return GetOpenFileName(initially, filter, new QWidget ());
		}

		public static string GetOpenFileName (string initially, string filter, QWidget parent)
		{
			return GetOpenFileName(initially, filter, parent, "");
		}

		public static string GetOpenFileName (string initially, string filter, QWidget parent, string name)
		{
			return GetOpenFileName(initially, filter, parent, name, (string) "");
		}

		public static string GetOpenFileName (string initially, string filter, QWidget parent, string name, string caption)
		{
			return GetOpenFileName(initially, filter, parent, name, caption, (string) "0");
		}

		public static string GetOpenFileName (string initially, string filter, QWidget parent, string name, string caption, string selectedFilter)
		{
			return GetOpenFileName(initially, filter, parent, name, caption, selectedFilter, true);
		}

		public static string GetSaveFileName ()
		{
			return GetSaveFileName((string) "");
		}

		public static string GetSaveFileName (string initially)
		{
			return GetSaveFileName(initially, (string) "");
		}

		public static string GetSaveFileName (string initially, string filter)
		{
			return GetSaveFileName(initially, filter, new QWidget ());
		}

		public static string GetSaveFileName (string initially, string filter, QWidget parent)
		{
			return GetSaveFileName(initially, filter, parent, "");
		}

		public static string GetSaveFileName (string initially, string filter, QWidget parent, string name)
		{
			return GetSaveFileName(initially, filter, parent, name, (string) "");
		}

		public static string GetSaveFileName (string initially, string filter, QWidget parent, string name, string caption)
		{
			return GetSaveFileName(initially, filter, parent, name, caption, (string) "0");
		}

		public static string GetSaveFileName (string initially, string filter, QWidget parent, string name, string caption, string selectedFilter)
		{
			return GetSaveFileName(initially, filter, parent, name, caption, selectedFilter, true);
		}

		public static string GetExistingDirectory ()
		{
			return GetExistingDirectory((string) "");
		}

		public static string GetExistingDirectory (string dir)
		{
			return GetExistingDirectory(dir, new QWidget ());
		}

		public static string GetExistingDirectory (string dir, QWidget parent)
		{
			return GetExistingDirectory(dir, parent, "");
		}

		public static string GetExistingDirectory (string dir, QWidget parent, string name)
		{
			return GetExistingDirectory(dir, parent, name, (string) "");
		}

		public static string GetExistingDirectory (string dir, QWidget parent, string name, string caption)
		{
			return GetExistingDirectory(dir, parent, name, caption, true);
		}

		public static string GetExistingDirectory (string dir, QWidget parent, string name, string caption, bool dirOnly)
		{
			return GetExistingDirectory(dir, parent, name, caption, dirOnly, true);
		}

		public static QStringList GetOpenFileNames ()
		{
			return GetOpenFileNames((string) "");
		}

		public static QStringList GetOpenFileNames (string filter)
		{
			return GetOpenFileNames(filter, (string) "");
		}

		public static QStringList GetOpenFileNames (string filter, string dir)
		{
			return GetOpenFileNames(filter, dir, new QWidget ());
		}

		public static QStringList GetOpenFileNames (string filter, string dir, QWidget parent)
		{
			return GetOpenFileNames(filter, dir, parent, "");
		}

		public static QStringList GetOpenFileNames (string filter, string dir, QWidget parent, string name)
		{
			return GetOpenFileNames(filter, dir, parent, name, (string) "");
		}

		public static QStringList GetOpenFileNames (string filter, string dir, QWidget parent, string name, string caption)
		{
			return GetOpenFileNames(filter, dir, parent, name, caption, (string) "0");
		}

		public static QStringList GetOpenFileNames (string filter, string dir, QWidget parent, string name, string caption, string selectedFilter)
		{
			return GetOpenFileNames(filter, dir, parent, name, caption, selectedFilter, true);
		}

		protected void AddToolButton (QButton b)
		{
			AddToolButton(b, false);
		}

		// Begin interface methods.

	}
}