// QFileInfo.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QFileInfo : QtSupport, IDisposable {

		public enum PermissionSpec {
			ReadUser = 0400,
			WriteUser = 0200,
			ExeUser = 0100,
			ReadGroup = 0040,
			WriteGroup = 0020,
			ExeGroup = 0010,
			ReadOther = 0004,
			WriteOther = 0002,
			ExeOther = 0001
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QFileInfo ();
		public QFileInfo () : this (QNull.Instance)
		{
			rawObject = qt_new_QFileInfo ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QFileInfo1 (IntPtr file);
		public QFileInfo (string file) : this (QNull.Instance)
		{
			rawObject = qt_new_QFileInfo1 (new QString (file).RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QFileInfo2 (IntPtr arg1);
		public QFileInfo (QFile arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QFileInfo2 (arg1.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QFileInfo3 (IntPtr arg1, IntPtr fileName);
		public QFileInfo (QDir arg1, string fileName) : this (QNull.Instance)
		{
			rawObject = qt_new_QFileInfo3 (arg1.RawObject, new QString (fileName).RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QFileInfo4 (IntPtr arg1);
		public QFileInfo (QFileInfo arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QFileInfo4 (arg1.RawObject);
			RegisterObject (this);
		}

		public QFileInfo (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QFileInfo (QNull dummy) : base (QNull.Instance) {}

		~QFileInfo ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QFileInfo (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QFileInfo (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileInfo_setFile (IntPtr raw, IntPtr file);
		public void SetFile (string file)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileInfo_setFile (rawObject, new QString (file).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileInfo_setFile1 (IntPtr raw, IntPtr arg1);
		public void SetFile (QFile arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileInfo_setFile1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileInfo_setFile2 (IntPtr raw, IntPtr arg1, IntPtr fileName);
		public void SetFile (QDir arg1, string fileName)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileInfo_setFile2 (rawObject, arg1.RawObject, new QString (fileName).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileInfo_exists (IntPtr raw);
		public bool Exists ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_exists (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileInfo_refresh (IntPtr raw);
		public void Refresh ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileInfo_refresh (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileInfo_caching (IntPtr raw);
		public bool Caching ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_caching (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFileInfo_setCaching (IntPtr raw, bool arg1);
		public void SetCaching (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFileInfo_setCaching (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_filePath (IntPtr raw);
		public string FilePath ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFileInfo_filePath (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_fileName (IntPtr raw);
		public string FileName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFileInfo_fileName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_absFilePath (IntPtr raw);
		public string AbsFilePath ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFileInfo_absFilePath (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_baseName (IntPtr raw, bool complete);
		public string BaseName (bool complete)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFileInfo_baseName (rawObject, complete));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_extension (IntPtr raw, bool complete);
		public string Extension (bool complete)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFileInfo_extension (rawObject, complete));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_dirPath (IntPtr raw, bool absPath);
		public string DirPath (bool absPath)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFileInfo_dirPath (rawObject, absPath));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_dir (IntPtr raw, bool absPath);
		public QDir Dir (bool absPath)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFileInfo_dir (rawObject, absPath), typeof (QDir)) as QDir;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileInfo_isReadable (IntPtr raw);
		public bool IsReadable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_isReadable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileInfo_isWritable (IntPtr raw);
		public bool IsWritable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_isWritable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileInfo_isExecutable (IntPtr raw);
		public bool IsExecutable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_isExecutable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileInfo_isRelative (IntPtr raw);
		public bool IsRelative ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_isRelative (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileInfo_convertToAbs (IntPtr raw);
		public bool ConvertToAbs ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_convertToAbs (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileInfo_isFile (IntPtr raw);
		public bool IsFile ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_isFile (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileInfo_isDir (IntPtr raw);
		public bool IsDir ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_isDir (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileInfo_isSymLink (IntPtr raw);
		public bool IsSymLink ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_isSymLink (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_readLink (IntPtr raw);
		public string ReadLink ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFileInfo_readLink (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_owner (IntPtr raw);
		public string Owner ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFileInfo_owner (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QFileInfo_ownerId (IntPtr raw);
		public uint OwnerId ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_ownerId (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_group (IntPtr raw);
		public string Group ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFileInfo_group (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QFileInfo_groupId (IntPtr raw);
		public uint GroupId ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_groupId (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFileInfo_permission (IntPtr raw, int permissionSpec);
		public bool Permission (int permissionSpec)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_permission (rawObject, permissionSpec);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QFileInfo_size (IntPtr raw);
		public uint Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFileInfo_size (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_created (IntPtr raw);
		public QDateTime Created ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFileInfo_created (rawObject), typeof (QDateTime)) as QDateTime;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_lastModified (IntPtr raw);
		public QDateTime LastModified ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFileInfo_lastModified (rawObject), typeof (QDateTime)) as QDateTime;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFileInfo_lastRead (IntPtr raw);
		public QDateTime LastRead ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFileInfo_lastRead (rawObject), typeof (QDateTime)) as QDateTime;
		}

		public string BaseName ()
		{
			return BaseName(false);
		}

		public string Extension ()
		{
			return Extension(true);
		}

		public string DirPath ()
		{
			return DirPath(false);
		}

		public QDir Dir ()
		{
			return Dir(false);
		}
	}
}