// QFocusEvent.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QFocusEvent : QEvent, IDisposable {

		public enum Reason {
			Mouse = 0,
			Tab = 1,
			Backtab = 2,
			ActiveWindow = 3,
			Popup = 4,
			Shortcut = 5,
			Other = 6
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QFocusEvent (Type type);
		public QFocusEvent (Type type) : this (QNull.Instance)
		{
			rawObject = qt_new_QFocusEvent (type);
			RegisterObject (this);
		}

		internal QFocusEvent () : this (QNull.Instance) {}

		public QFocusEvent (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QFocusEvent (QNull dummy) : base (QNull.Instance) {}

		~QFocusEvent ()
		{
			Dispose (false);
		}
		internal override void Delete ()
		{
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFocusEvent_gotFocus (IntPtr raw);
		public bool GotFocus ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFocusEvent_gotFocus (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFocusEvent_lostFocus (IntPtr raw);
		public bool LostFocus ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFocusEvent_lostFocus (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Reason qt_QFocusEvent_reason ();
		public static Reason TheReason ()
		{
			return qt_QFocusEvent_reason ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFocusEvent_setReason (Reason reason);
		public static void SetReason (Reason reason)
		{
			qt_QFocusEvent_setReason (reason);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFocusEvent_resetReason ();
		public static void ResetReason ()
		{
			qt_QFocusEvent_resetReason ();
		}

		// Begin interface methods.

	}
}