// QFont.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QFont : QtSupport, IDisposable {

		public enum StyleHint {
			Helvetica = 0,
			SansSerif = Helvetica,
			Times = 1,
			Serif = Times,
			Courier = 2,
			TypeWriter = Courier,
			OldEnglish = 3,
			Decorative = OldEnglish,
			System = 4,
			AnyStyle = 5
		}

		public enum StyleStrategy {
			PreferDefault = 1,
			PreferBitmap = 2,
			PreferDevice = 4,
			PreferOutline = 8,
			ForceOutline = 16,
			PreferMatch = 32,
			PreferQuality = 64,
			PreferAntialias = 128,
			NoAntialias = 256
		}

		public enum Weight {
			Light = 25,
			Normal = 50,
			DemiBold = 63,
			Bold = 75,
			Black = 87
		}

		public enum Script {
			Latin = 0,
			Greek = 1,
			Cyrillic = 2,
			Armenian = 3,
			Georgian = 4,
			Runic = 5,
			Ogham = 6,
			SpacingModifiers = 7,
			CombiningMarks = 8,
			Hebrew = 9,
			Arabic = 10,
			Syriac = 11,
			Thaana = 12,
			Devanagari = 13,
			Bengali = 14,
			Gurmukhi = 15,
			Gujarati = 16,
			Oriya = 17,
			Tamil = 18,
			Telugu = 19,
			Kannada = 20,
			Malayalam = 21,
			Sinhala = 22,
			Thai = 23,
			Lao = 24,
			Tibetan = 25,
			Myanmar = 26,
			Khmer = 27,
			Han = 28,
			Hiragana = 29,
			Katakana = 30,
			Hangul = 31,
			Bopomofo = 32,
			Yi = 33,
			Ethiopic = 34,
			Cherokee = 35,
			CanadianAboriginal = 36,
			Mongolian = 37,
			CurrencySymbols = 38,
			LetterlikeSymbols = 39,
			NumberForms = 40,
			MathematicalOperators = 41,
			TechnicalSymbols = 42,
			GeometricSymbols = 43,
			MiscellaneousSymbols = 44,
			EnclosedAndSquare = 45,
			Braille = 46,
			Unicode = 47,
			NScripts = 48,
			UnknownScript = NScripts,
			NoScript = 49,
			HanX11 = 50,
			LatinBasic = Latin,
			LatinExtendedA_2 = HanX11+1,
			LatinExtendedA_3 = 52,
			LatinExtendedA_4 = 53,
			LatinExtendedA_14 = 54,
			LatinExtendedA_15 = 55,
			LastPrivateScript = 56
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QFont ();
		public QFont () : this (QNull.Instance)
		{
			rawObject = qt_new_QFont ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QFont1 (IntPtr family, int pointSize, QFont.Weight weight, bool italic);
		public QFont (string family, int pointSize, QFont.Weight weight, bool italic) : this (QNull.Instance)
		{
			rawObject = qt_new_QFont1 (new QString (family).RawObject, pointSize, weight, italic);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QFont2 (IntPtr arg1);
		public QFont (QFont arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QFont2 (arg1.RawObject);
			RegisterObject (this);
		}

		public QFont (string family) : this (family, (int) 12) {}

		public QFont (string family, int pointSize) : this (family, pointSize, QFont.Weight.Normal) {}

		public QFont (string family, int pointSize, QFont.Weight weight) : this (family, pointSize, weight, false) {}

		public QFont (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QFont (QNull dummy) : base (QNull.Instance) {}

		~QFont ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QFont (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QFont (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFont_family (IntPtr raw);
		public string Family ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFont_family (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setFamily (IntPtr raw, IntPtr arg1);
		public void SetFamily (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setFamily (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QFont_pointSize (IntPtr raw);
		public int PointSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_pointSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern float qt_QFont_pointSizeFloat (IntPtr raw);
		public float PointSizeFloat ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_pointSizeFloat (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setPointSize (IntPtr raw, int arg1);
		public void SetPointSize (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setPointSize (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setPointSizeFloat (IntPtr raw, float arg1);
		public void SetPointSizeFloat (float arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setPointSizeFloat (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QFont_pixelSize (IntPtr raw);
		public int PixelSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_pixelSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setPixelSize (IntPtr raw, int arg1);
		public void SetPixelSize (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setPixelSize (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setPixelSizeFloat (IntPtr raw, float arg1);
		public void SetPixelSizeFloat (float arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setPixelSizeFloat (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QFont_weight (IntPtr raw);
		public int TheWeight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_weight (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setWeight (IntPtr raw, int arg1);
		public void SetWeight (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setWeight (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFont_bold (IntPtr raw);
		public bool Bold ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_bold (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setBold (IntPtr raw, bool arg1);
		public void SetBold (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setBold (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFont_italic (IntPtr raw);
		public bool Italic ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_italic (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setItalic (IntPtr raw, bool arg1);
		public void SetItalic (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setItalic (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFont_underline (IntPtr raw);
		public bool Underline ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_underline (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setUnderline (IntPtr raw, bool arg1);
		public void SetUnderline (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setUnderline (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFont_strikeOut (IntPtr raw);
		public bool StrikeOut ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_strikeOut (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setStrikeOut (IntPtr raw, bool arg1);
		public void SetStrikeOut (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setStrikeOut (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFont_fixedPitch (IntPtr raw);
		public bool FixedPitch ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_fixedPitch (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setFixedPitch (IntPtr raw, bool arg1);
		public void SetFixedPitch (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setFixedPitch (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern StyleHint qt_QFont_styleHint (IntPtr raw);
		public StyleHint TheStyleHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_styleHint (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QFont.StyleStrategy qt_QFont_styleStrategy (IntPtr raw);
		public QFont.StyleStrategy TheStyleStrategy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_styleStrategy (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setStyleHint (IntPtr raw, StyleHint arg1, QFont.StyleStrategy arg2);
		public void SetStyleHint (StyleHint arg1, QFont.StyleStrategy arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setStyleHint (rawObject, arg1, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setStyleStrategy (IntPtr raw, QFont.StyleStrategy s);
		public void SetStyleStrategy (QFont.StyleStrategy s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setStyleStrategy (rawObject, s);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFont_rawMode (IntPtr raw);
		public bool RawMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_rawMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setRawMode (IntPtr raw, bool arg1);
		public void SetRawMode (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setRawMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFont_exactMatch (IntPtr raw);
		public bool ExactMatch ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_exactMatch (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFont_isCopyOf (IntPtr raw, IntPtr arg1);
		public bool IsCopyOf (QFont arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_isCopyOf (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QFont_handle (IntPtr raw);
		public uint Handle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_handle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setRawName (IntPtr raw, IntPtr arg1);
		public void SetRawName (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_setRawName (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFont_rawName (IntPtr raw);
		public string RawName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFont_rawName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFont_key (IntPtr raw);
		public string Key ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFont_key (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFont_toString (IntPtr raw);
		public string ToString ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFont_toString (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFont_fromString (IntPtr raw, IntPtr arg1);
		public bool FromString (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_fromString (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_qwsRenderToDisk (IntPtr raw, bool all);
		public void QwsRenderToDisk (bool all)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFont_qwsRenderToDisk (rawObject, all);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFont_defaultFamily (IntPtr raw);
		public string DefaultFamily ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFont_defaultFamily (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFont_lastResortFamily (IntPtr raw);
		public string LastResortFamily ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFont_lastResortFamily (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFont_lastResortFont (IntPtr raw);
		public string LastResortFont ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFont_lastResortFont (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFont_substitute (IntPtr arg1);
		public static string Substitute (string arg1)
		{
			QString qstr = new QString (qt_QFont_substitute (new QString (arg1).RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFont_substitutes (IntPtr arg1);
		public static QStringList Substitutes (string arg1)
		{
			return LookupObject (qt_QFont_substitutes (new QString (arg1).RawObject), typeof (QStringList)) as QStringList;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFont_substitutions ();
		public static QStringList Substitutions ()
		{
			return LookupObject (qt_QFont_substitutions (), typeof (QStringList)) as QStringList;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_insertSubstitution (IntPtr arg1, IntPtr arg2);
		public static void InsertSubstitution (string arg1, string arg2)
		{
			qt_QFont_insertSubstitution (new QString (arg1).RawObject, new QString (arg2).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_insertSubstitutions (IntPtr arg1, IntPtr arg2);
		public static void InsertSubstitutions (string arg1, QStringList arg2)
		{
			qt_QFont_insertSubstitutions (new QString (arg1).RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_removeSubstitution (IntPtr arg1);
		public static void RemoveSubstitution (string arg1)
		{
			qt_QFont_removeSubstitution (new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_initialize ();
		public static void Initialize ()
		{
			qt_QFont_initialize ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_cleanup ();
		public static void Cleanup ()
		{
			qt_QFont_cleanup ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_cacheStatistics ();
		public static void CacheStatistics ()
		{
			qt_QFont_cacheStatistics ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFont_defaultFont ();
		public static QFont DefaultFont ()
		{
			return LookupObject (qt_QFont_defaultFont (), typeof (QFont)) as QFont;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFont_setDefaultFont (IntPtr arg1);
		public static void SetDefaultFont (QFont arg1)
		{
			qt_QFont_setDefaultFont (arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFont_dirty (IntPtr raw);
		protected bool Dirty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_dirty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QFont_deciPointSize (IntPtr raw);
		protected int DeciPointSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFont_deciPointSize (rawObject);
		}

		public void SetStyleHint (StyleHint arg1)
		{
			SetStyleHint(arg1, QFont.StyleStrategy.PreferDefault);
		}

		public void QwsRenderToDisk ()
		{
			QwsRenderToDisk(true);
		}
	}
}