// QFontDialog.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QFontDialog : QDialog, IDisposable {

		internal QFontDialog () : this (QNull.Instance) {}

		public QFontDialog (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QFontDialog (QNull dummy) : base (QNull.Instance) {}

		~QFontDialog ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QFontDialog function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFontDialog_getFont (bool ok, IntPtr def, IntPtr parent, string name);
		public static QFont GetFont (bool ok, QFont def, QWidget parent, string name)
		{
			return LookupObject (qt_QFontDialog_getFont (ok, def.RawObject, parent.RawObject, name), typeof (QFont)) as QFont;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFontDialog_getFont1 (bool ok, IntPtr parent, string name);
		public static QFont GetFont (bool ok, QWidget parent, string name)
		{
			return LookupObject (qt_QFontDialog_getFont1 (ok, parent.RawObject, name), typeof (QFont)) as QFont;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFontDialog_eventFilter (IntPtr raw, IntPtr arg1, IntPtr arg2);
		protected bool EventFilter (QObject arg1, QEvent arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFontDialog_eventFilter (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFontDialog_familyListBox (IntPtr raw);
		protected QListBox FamilyListBox ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFontDialog_familyListBox (rawObject), typeof (QListBox)) as QListBox;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFontDialog_updateFamilies (IntPtr raw);
		protected void UpdateFamilies ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFontDialog_updateFamilies (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFontDialog_styleListBox (IntPtr raw);
		protected QListBox StyleListBox ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFontDialog_styleListBox (rawObject), typeof (QListBox)) as QListBox;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFontDialog_updateStyles (IntPtr raw);
		protected void UpdateStyles ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFontDialog_updateStyles (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFontDialog_sizeListBox (IntPtr raw);
		protected QListBox SizeListBox ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFontDialog_sizeListBox (rawObject), typeof (QListBox)) as QListBox;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFontDialog_updateSizes (IntPtr raw);
		protected void UpdateSizes ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFontDialog_updateSizes (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFontDialog_scriptCombo (IntPtr raw);
		protected QComboBox ScriptCombo ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFontDialog_scriptCombo (rawObject), typeof (QComboBox)) as QComboBox;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFontDialog_updateScripts (IntPtr raw);
		protected void UpdateScripts ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFontDialog_updateScripts (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFontDialog_family (IntPtr raw);
		protected string Family ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFontDialog_family (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFontDialog_script (IntPtr raw);
		protected string Script ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QFontDialog_script (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFontDialog_sizeChanged (IntPtr raw, IntPtr arg1);
		protected void SizeChanged (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFontDialog_sizeChanged (rawObject, new QString (arg1).RawObject);
		}

		public static QFont GetFont (bool ok, QFont def)
		{
			return GetFont(ok, def, new QWidget ());
		}

		public static QFont GetFont (bool ok, QFont def, QWidget parent)
		{
			return GetFont(ok, def, parent, "");
		}

		public static QFont GetFont (bool ok)
		{
			return GetFont(ok, new QWidget ());
		}

		public static QFont GetFont (bool ok, QWidget parent)
		{
			return GetFont(ok, parent, "");
		}

		// Begin interface methods.

	}
}