// QFrame.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QFrame : QWidget, IDisposable {

		public enum Shape {
			NoFrame = 0,
			Box = 1,
			Panel = 2,
			WinPanel = 3,
			HLine = 4,
			VLine = 5,
			StyledPanel = 6,
			PopupPanel = 7,
			MenuBarPanel = 8,
			ToolBarPanel = 9,
			LineEditPanel = 10,
			TabWidgetPanel = 11,
			MShape = 15
		}

		public enum Shadow {
			Plain = 16,
			Raised = 32,
			Sunken = 48,
			MShadow = 240
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QFrame (IntPtr parent, string name, Qt.WidgetFlags f);
		public QFrame (QWidget parent, string name, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QFrame (parent != null ? parent.RawObject : IntPtr.Zero, name, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QFrame () : this (new QWidget ()) {}

		public QFrame (QWidget parent) : this (parent, "") {}

		public QFrame (QWidget parent, string name) : this (parent, name, Qt.WidgetFlags.WWinOwnDC) {}

		public QFrame (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QFrame (QNull dummy) : base (QNull.Instance) {}

		~QFrame ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QFrame function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QFrame_frameStyle (IntPtr raw);
		public int FrameStyle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFrame_frameStyle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFrame_setFrameStyle (IntPtr raw, int arg1);
		public void SetFrameStyle (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFrame_setFrameStyle (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QFrame_frameWidth (IntPtr raw);
		public int FrameWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFrame_frameWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFrame_contentsRect (IntPtr raw);
		public QRect ContentsRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFrame_contentsRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QFrame_lineShapesOk (IntPtr raw);
		public bool LineShapesOk ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFrame_lineShapesOk (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFrame_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFrame_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Shape qt_QFrame_frameShape (IntPtr raw);
		public Shape FrameShape ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFrame_frameShape (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFrame_setFrameShape (IntPtr raw, Shape arg1);
		public void SetFrameShape (Shape arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFrame_setFrameShape (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QFrame.Shadow qt_QFrame_frameShadow (IntPtr raw);
		public QFrame.Shadow FrameShadow ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFrame_frameShadow (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFrame_setFrameShadow (IntPtr raw, QFrame.Shadow arg1);
		public void SetFrameShadow (QFrame.Shadow arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFrame_setFrameShadow (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QFrame_lineWidth (IntPtr raw);
		public int LineWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFrame_lineWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFrame_setLineWidth (IntPtr raw, int arg1);
		public void SetLineWidth (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFrame_setLineWidth (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QFrame_margin (IntPtr raw);
		public int Margin ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFrame_margin (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFrame_setMargin (IntPtr raw, int arg1);
		public void SetMargin (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFrame_setMargin (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QFrame_midLineWidth (IntPtr raw);
		public int MidLineWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QFrame_midLineWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFrame_setMidLineWidth (IntPtr raw, int arg1);
		public void SetMidLineWidth (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFrame_setMidLineWidth (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QFrame_frameRect (IntPtr raw);
		public QRect FrameRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QFrame_frameRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFrame_setFrameRect (IntPtr raw, IntPtr arg1);
		public void SetFrameRect (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFrame_setFrameRect (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFrame_drawFrame (IntPtr raw, IntPtr arg1);
		protected void DrawFrame (QPainter arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFrame_drawFrame (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFrame_drawContents (IntPtr raw, IntPtr arg1);
		protected void DrawContents (QPainter arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFrame_drawContents (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QFrame_frameChanged (IntPtr raw);
		protected void FrameChanged ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QFrame_frameChanged (rawObject);
		}

		// Begin interface methods.

	}
}