// QGCache.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QGCache : QPtrCollection, IDisposable {

		protected enum KeyType {
			StringKey = 0,
			AsciiKey = 1,
			IntKey = 2,
			PtrKey = 3
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QGCache (int maxCost, uint size, KeyType kt, bool caseSensitive, bool copyKeys);
		protected QGCache (int maxCost, uint size, KeyType kt, bool caseSensitive, bool copyKeys) : this (QNull.Instance)
		{
			rawObject = qt_new_QGCache (maxCost, size, kt, caseSensitive, copyKeys);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QGCache1 (IntPtr arg1);
		protected QGCache (QGCache arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QGCache1 (arg1.RawObject);
			RegisterObject (this);
		}

		internal QGCache () : this (QNull.Instance) {}

		public QGCache (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QGCache (QNull dummy) : base (QNull.Instance) {}

		~QGCache ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QGCache (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QGCache (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QGCache_count (IntPtr raw);
		protected uint Count ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGCache_count (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QGCache_size (IntPtr raw);
		protected uint Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGCache_size (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QGCache_maxCost (IntPtr raw);
		protected int MaxCost ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGCache_maxCost (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QGCache_totalCost (IntPtr raw);
		protected int TotalCost ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGCache_totalCost (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGCache_setMaxCost (IntPtr raw, int maxCost);
		protected void SetMaxCost (int maxCost)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGCache_setMaxCost (rawObject, maxCost);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGCache_clear (IntPtr raw);
		protected void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGCache_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGCache_insert_string (IntPtr raw, IntPtr key, int arg1, int cost, int priority);
		protected bool Insert_string (string key, int arg1, int cost, int priority)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGCache_insert_string (rawObject, new QString (key).RawObject, arg1, cost, priority);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGCache_insert_other (IntPtr raw, string key, int arg1, int cost, int priority);
		protected bool Insert_other (string key, int arg1, int cost, int priority)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGCache_insert_other (rawObject, key, arg1, cost, priority);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGCache_remove_string (IntPtr raw, IntPtr key);
		protected bool Remove_string (string key)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGCache_remove_string (rawObject, new QString (key).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGCache_remove_other (IntPtr raw, string key);
		protected bool Remove_other (string key)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGCache_remove_other (rawObject, key);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QGCache_take_string (IntPtr raw, IntPtr key);
		protected int Take_string (string key)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGCache_take_string (rawObject, new QString (key).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QGCache_take_other (IntPtr raw, string key);
		protected int Take_other (string key)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGCache_take_other (rawObject, key);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QGCache_find_string (IntPtr raw, IntPtr key, bool Q_ref);
		protected int Find_string (string key, bool Q_ref)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGCache_find_string (rawObject, new QString (key).RawObject, Q_ref);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QGCache_find_other (IntPtr raw, string key, bool Q_ref);
		protected int Find_other (string key, bool Q_ref)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGCache_find_other (rawObject, key, Q_ref);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGCache_statistics (IntPtr raw);
		protected void Statistics ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGCache_statistics (rawObject);
		}

		protected int Find_string (string key)
		{
			return Find_string(key, true);
		}

		protected int Find_other (string key)
		{
			return Find_other(key, true);
		}

		// Begin interface methods.

	}
}