// QGLContext.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QGLContext : QGL, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QGLContext (IntPtr format, IntPtr device);
		public QGLContext (QGLFormat format, IQPaintDevice device) : this (QNull.Instance)
		{
			rawObject = qt_new_QGLContext (format.RawObject, device.QPaintDevice ());
			RegisterObject (this);
		}

		internal QGLContext () : this (QNull.Instance) {}

		public QGLContext (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QGLContext (QNull dummy) : base (QNull.Instance) {}

		~QGLContext ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QGLContext (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QGLContext (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGLContext_create (IntPtr raw, IntPtr shareContext);
		public bool Create (QGLContext shareContext)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_create (rawObject, shareContext.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGLContext_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGLContext_isSharing (IntPtr raw);
		public bool IsSharing ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_isSharing (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLContext_reset (IntPtr raw);
		public void Reset ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLContext_reset (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGLContext_format (IntPtr raw);
		public QGLFormat Format ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGLContext_format (rawObject), typeof (QGLFormat)) as QGLFormat;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGLContext_requestedFormat (IntPtr raw);
		public QGLFormat RequestedFormat ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGLContext_requestedFormat (rawObject), typeof (QGLFormat)) as QGLFormat;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLContext_setFormat (IntPtr raw, IntPtr format);
		public void SetFormat (QGLFormat format)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLContext_setFormat (rawObject, format.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLContext_makeCurrent (IntPtr raw);
		public void MakeCurrent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLContext_makeCurrent (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLContext_swapBuffers (IntPtr raw);
		public void SwapBuffers ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLContext_swapBuffers (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IQPaintDevice qt_QGLContext_device (IntPtr raw);
		public IQPaintDevice Device ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_device (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGLContext_overlayTransparentColor (IntPtr raw);
		public QColor OverlayTransparentColor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGLContext_overlayTransparentColor (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGLContext_currentContext ();
		public static QGLContext CurrentContext ()
		{
			return LookupObject (qt_QGLContext_currentContext (), typeof (QGLContext)) as QGLContext;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGLContext_chooseContext (IntPtr raw, IntPtr shareContext);
		protected bool ChooseContext (QGLContext shareContext)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_chooseContext (rawObject, shareContext.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLContext_doneCurrent (IntPtr raw);
		protected void DoneCurrent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLContext_doneCurrent (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QGLContext_choosePixelFormat (IntPtr raw, int[] pfd, uint pdc);
		protected int ChoosePixelFormat (int[] pfd, uint pdc)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_choosePixelFormat (rawObject, pfd, pdc);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QGLContext_tryVisual (IntPtr raw, IntPtr f, int bufDepth);
		protected int[] TryVisual (QGLFormat f, int bufDepth)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_tryVisual (rawObject, f.RawObject, bufDepth);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QGLContext_chooseVisual (IntPtr raw);
		protected int[] ChooseVisual ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_chooseVisual (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QGLContext_chooseMacVisual (IntPtr raw, IntPtr arg1);
		protected int[] ChooseMacVisual (IntPtr arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_chooseMacVisual (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGLContext_deviceIsPixmap (IntPtr raw);
		protected bool DeviceIsPixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_deviceIsPixmap (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGLContext_windowCreated (IntPtr raw);
		protected bool WindowCreated ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_windowCreated (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLContext_setWindowCreated (IntPtr raw, bool on);
		protected void SetWindowCreated (bool on)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLContext_setWindowCreated (rawObject, on);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGLContext_initialized (IntPtr raw);
		protected bool Initialized ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_initialized (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLContext_setInitialized (IntPtr raw, bool on);
		protected void SetInitialized (bool on)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLContext_setInitialized (rawObject, on);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QGLContext_colorIndex (IntPtr raw, IntPtr c);
		protected uint ColorIndex (QColor c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLContext_colorIndex (rawObject, c.RawObject);
		}

		public bool Create ()
		{
			return Create(new QGLContext ());
		}

		protected bool ChooseContext ()
		{
			return ChooseContext(new QGLContext ());
		}

		protected int[] TryVisual (QGLFormat f)
		{
			return TryVisual(f, (int) 1);
		}

		// Begin interface methods.

	}
}