// QGLWidget.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QGLWidget : QGL, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QGLWidget (IntPtr parent, string name, IntPtr shareWidget, Qt.WidgetFlags f);
		public QGLWidget (QWidget parent, string name, QGLWidget shareWidget, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QGLWidget (parent != null ? parent.RawObject : IntPtr.Zero, name, shareWidget.RawObject, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QGLWidget1 (IntPtr format, IntPtr parent, string name, IntPtr shareWidget, Qt.WidgetFlags f);
		public QGLWidget (QGLFormat format, QWidget parent, string name, QGLWidget shareWidget, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QGLWidget1 (format.RawObject, parent != null ? parent.RawObject : IntPtr.Zero, name, shareWidget.RawObject, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QGLWidget () : this (new QWidget ()) {}

		public QGLWidget (QWidget parent) : this (parent, "") {}

		public QGLWidget (QWidget parent, string name) : this (parent, name, new QGLWidget ()) {}

		public QGLWidget (QWidget parent, string name, QGLWidget shareWidget) : this (parent, name, shareWidget, Qt.WidgetFlags.WWinOwnDC) {}

		public QGLWidget (QGLFormat format) : this (format, new QWidget ()) {}

		public QGLWidget (QGLFormat format, QWidget parent) : this (format, parent, "") {}

		public QGLWidget (QGLFormat format, QWidget parent, string name) : this (format, parent, name, new QGLWidget ()) {}

		public QGLWidget (QGLFormat format, QWidget parent, string name, QGLWidget shareWidget) : this (format, parent, name, shareWidget, Qt.WidgetFlags.WWinOwnDC) {}

		public QGLWidget (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QGLWidget (QNull dummy) : base (QNull.Instance) {}

		~QGLWidget ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QGLWidget (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QGLWidget (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_qglColor (IntPtr raw, IntPtr c);
		public void QglColor (QColor c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_qglColor (rawObject, c.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_qglClearColor (IntPtr raw, IntPtr c);
		public void QglClearColor (QColor c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_qglClearColor (rawObject, c.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGLWidget_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLWidget_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGLWidget_isSharing (IntPtr raw);
		public bool IsSharing ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLWidget_isSharing (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_makeCurrent (IntPtr raw);
		public void MakeCurrent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_makeCurrent (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGLWidget_doubleBuffer (IntPtr raw);
		public bool DoubleBuffer ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLWidget_doubleBuffer (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_swapBuffers (IntPtr raw);
		public void SwapBuffers ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_swapBuffers (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGLWidget_format (IntPtr raw);
		public QGLFormat Format ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGLWidget_format (rawObject), typeof (QGLFormat)) as QGLFormat;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_setFormat (IntPtr raw, IntPtr format);
		public void SetFormat (QGLFormat format)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_setFormat (rawObject, format.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGLWidget_context (IntPtr raw);
		public QGLContext Context ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGLWidget_context (rawObject), typeof (QGLContext)) as QGLContext;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_setContext (IntPtr raw, IntPtr context, IntPtr shareContext, bool deleteOldContext);
		public void SetContext (QGLContext context, QGLContext shareContext, bool deleteOldContext)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_setContext (rawObject, context.RawObject, shareContext.RawObject, deleteOldContext);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGLWidget_renderPixmap (IntPtr raw, int w, int h, bool useContext);
		public QPixmap RenderPixmap (int w, int h, bool useContext)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGLWidget_renderPixmap (rawObject, w, h, useContext), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGLWidget_grabFrameBuffer (IntPtr raw, bool withAlpha);
		public QImage GrabFrameBuffer (bool withAlpha)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGLWidget_grabFrameBuffer (rawObject, withAlpha), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_makeOverlayCurrent (IntPtr raw);
		public void MakeOverlayCurrent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_makeOverlayCurrent (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGLWidget_overlayContext (IntPtr raw);
		public QGLContext OverlayContext ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGLWidget_overlayContext (rawObject), typeof (QGLContext)) as QGLContext;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_setMouseTracking (IntPtr raw, bool enable);
		public void SetMouseTracking (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_setMouseTracking (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_reparent (IntPtr raw, IntPtr parent, Qt.WidgetFlags f, IntPtr p, bool showIt);
		public void Reparent (QWidget parent, Qt.WidgetFlags f, QPoint p, bool showIt)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_reparent (rawObject, parent.RawObject, f, p.RawObject, showIt);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGLWidget_colormap (IntPtr raw);
		public QGLColormap Colormap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGLWidget_colormap (rawObject), typeof (QGLColormap)) as QGLColormap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_setColormap (IntPtr raw, IntPtr map);
		public void SetColormap (QGLColormap map)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_setColormap (rawObject, map.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_updateGL (IntPtr raw);
		public void UpdateGL ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_updateGL (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_updateOverlayGL (IntPtr raw);
		public void UpdateOverlayGL ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_updateOverlayGL (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGLWidget_convertToGLFormat (IntPtr img);
		public static QImage ConvertToGLFormat (QImage img)
		{
			return LookupObject (qt_QGLWidget_convertToGLFormat (img.RawObject), typeof (QImage)) as QImage;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_initializeGL (IntPtr raw);
		protected void InitializeGL ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_initializeGL (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_resizeGL (IntPtr raw, int w, int h);
		protected void ResizeGL (int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_resizeGL (rawObject, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_paintGL (IntPtr raw);
		protected void PaintGL ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_paintGL (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_initializeOverlayGL (IntPtr raw);
		protected void InitializeOverlayGL ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_initializeOverlayGL (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_resizeOverlayGL (IntPtr raw, int w, int h);
		protected void ResizeOverlayGL (int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_resizeOverlayGL (rawObject, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_paintOverlayGL (IntPtr raw);
		protected void PaintOverlayGL ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_paintOverlayGL (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_setAutoBufferSwap (IntPtr raw, bool on);
		protected void SetAutoBufferSwap (bool on)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_setAutoBufferSwap (rawObject, on);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGLWidget_autoBufferSwap (IntPtr raw);
		protected bool AutoBufferSwap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGLWidget_autoBufferSwap (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_glInit (IntPtr raw);
		protected void GlInit ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_glInit (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGLWidget_glDraw (IntPtr raw);
		protected void GlDraw ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGLWidget_glDraw (rawObject);
		}

		public void SetContext (QGLContext context)
		{
			SetContext(context, new QGLContext ());
		}

		public void SetContext (QGLContext context, QGLContext shareContext)
		{
			SetContext(context, shareContext, true);
		}

		public QPixmap RenderPixmap ()
		{
			return RenderPixmap((int) 0);
		}

		public QPixmap RenderPixmap (int w)
		{
			return RenderPixmap(w, (int) 0);
		}

		public QPixmap RenderPixmap (int w, int h)
		{
			return RenderPixmap(w, h, false);
		}

		public QImage GrabFrameBuffer ()
		{
			return GrabFrameBuffer(false);
		}

		public void Reparent (QWidget parent, Qt.WidgetFlags f, QPoint p)
		{
			Reparent(parent, f, p, false);
		}

		// Begin interface methods.


		// Begin interface methods.

	}
}