// QGridLayout.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QGridLayout : QLayout, IDisposable {

		public enum Corner {
			TopLeft = 0,
			TopRight = 1,
			BottomLeft = 2,
			BottomRight = 3
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QGridLayout (IntPtr parent, int nRows, int nCols, int border, int spacing, string name);
		public QGridLayout (QWidget parent, int nRows, int nCols, int border, int spacing, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QGridLayout (parent != null ? parent.RawObject : IntPtr.Zero, nRows, nCols, border, spacing, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QGridLayout1 (int nRows, int nCols, int spacing, string name);
		public QGridLayout (int nRows, int nCols, int spacing, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QGridLayout1 (nRows, nCols, spacing, name);
			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QGridLayout2 (IntPtr parentLayout, int nRows, int nCols, int spacing, string name);
		public QGridLayout (QLayout parentLayout, int nRows, int nCols, int spacing, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QGridLayout2 (parentLayout.RawObject, nRows, nCols, spacing, name);
			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QGridLayout (QWidget parent) : this (parent, (int) 1) {}

		public QGridLayout (QWidget parent, int nRows) : this (parent, nRows, (int) 1) {}

		public QGridLayout (QWidget parent, int nRows, int nCols) : this (parent, nRows, nCols, (int) 0) {}

		public QGridLayout (QWidget parent, int nRows, int nCols, int border) : this (parent, nRows, nCols, border, (int) -1) {}

		public QGridLayout (QWidget parent, int nRows, int nCols, int border, int spacing) : this (parent, nRows, nCols, border, spacing, "") {}

		public QGridLayout () : this ((int) 1) {}

		public QGridLayout (int nRows) : this (nRows, (int) 1) {}

		public QGridLayout (int nRows, int nCols) : this (nRows, nCols, (int) -1) {}

		public QGridLayout (int nRows, int nCols, int spacing) : this (nRows, nCols, spacing, "") {}

		public QGridLayout (QLayout parentLayout) : this (parentLayout, (int) 1) {}

		public QGridLayout (QLayout parentLayout, int nRows) : this (parentLayout, nRows, (int) 1) {}

		public QGridLayout (QLayout parentLayout, int nRows, int nCols) : this (parentLayout, nRows, nCols, (int) -1) {}

		public QGridLayout (QLayout parentLayout, int nRows, int nCols, int spacing) : this (parentLayout, nRows, nCols, spacing, "") {}

		public QGridLayout (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QGridLayout (QNull dummy) : base (QNull.Instance) {}

		~QGridLayout ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QGridLayout (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QGridLayout (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGridLayout_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGridLayout_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGridLayout_minimumSize (IntPtr raw);
		public QSize MinimumSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGridLayout_minimumSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGridLayout_maximumSize (IntPtr raw);
		public QSize MaximumSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGridLayout_maximumSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_setRowStretch (IntPtr raw, int row, int stretch);
		public void SetRowStretch (int row, int stretch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_setRowStretch (rawObject, row, stretch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_setColStretch (IntPtr raw, int col, int stretch);
		public void SetColStretch (int col, int stretch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_setColStretch (rawObject, col, stretch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QGridLayout_rowStretch (IntPtr raw, int row);
		public int RowStretch (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGridLayout_rowStretch (rawObject, row);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QGridLayout_colStretch (IntPtr raw, int col);
		public int ColStretch (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGridLayout_colStretch (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QGridLayout_numRows (IntPtr raw);
		public int NumRows ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGridLayout_numRows (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QGridLayout_numCols (IntPtr raw);
		public int NumCols ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGridLayout_numCols (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGridLayout_cellGeometry (IntPtr raw, int row, int col);
		public QRect CellGeometry (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGridLayout_cellGeometry (rawObject, row, col), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGridLayout_hasHeightForWidth (IntPtr raw);
		public bool HasHeightForWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGridLayout_hasHeightForWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QGridLayout_heightForWidth (IntPtr raw, int arg1);
		public int HeightForWidth (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGridLayout_heightForWidth (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSizePolicy.ExpandData qt_QGridLayout_expanding (IntPtr raw);
		public QSizePolicy.ExpandData Expanding ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGridLayout_expanding (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_invalidate (IntPtr raw);
		public void Invalidate ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_invalidate (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_addItem (IntPtr raw, IntPtr arg1);
		public void AddItem (QLayoutItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_addItem (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_addItem1 (IntPtr raw, IntPtr item, int row, int col);
		public void AddItem (QLayoutItem item, int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_addItem1 (rawObject, item.RawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_addMultiCell (IntPtr raw, IntPtr arg1, int fromRow, int toRow, int fromCol, int toCol, int align);
		public void AddMultiCell (QLayoutItem arg1, int fromRow, int toRow, int fromCol, int toCol, int align)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_addMultiCell (rawObject, arg1.RawObject, fromRow, toRow, fromCol, toCol, align);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_addWidget (IntPtr raw, IntPtr arg1, int row, int col, int align);
		public void AddWidget (QWidget arg1, int row, int col, int align)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_addWidget (rawObject, arg1.RawObject, row, col, align);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_addMultiCellWidget (IntPtr raw, IntPtr arg1, int fromRow, int toRow, int fromCol, int toCol, int align);
		public void AddMultiCellWidget (QWidget arg1, int fromRow, int toRow, int fromCol, int toCol, int align)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_addMultiCellWidget (rawObject, arg1.RawObject, fromRow, toRow, fromCol, toCol, align);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_addLayout (IntPtr raw, IntPtr layout, int row, int col);
		public void AddLayout (QLayout layout, int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_addLayout (rawObject, layout.RawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_addMultiCellLayout (IntPtr raw, IntPtr layout, int fromRow, int toRow, int fromCol, int toCol, int align);
		public void AddMultiCellLayout (QLayout layout, int fromRow, int toRow, int fromCol, int toCol, int align)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_addMultiCellLayout (rawObject, layout.RawObject, fromRow, toRow, fromCol, toCol, align);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_addRowSpacing (IntPtr raw, int row, int minsize);
		public void AddRowSpacing (int row, int minsize)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_addRowSpacing (rawObject, row, minsize);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_addColSpacing (IntPtr raw, int col, int minsize);
		public void AddColSpacing (int col, int minsize)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_addColSpacing (rawObject, col, minsize);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_expand (IntPtr raw, int rows, int cols);
		public void Expand (int rows, int cols)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_expand (rawObject, rows, cols);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_setOrigin (IntPtr raw, QGridLayout.Corner arg1);
		public void SetOrigin (QGridLayout.Corner arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_setOrigin (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QGridLayout.Corner qt_QGridLayout_origin (IntPtr raw);
		public QGridLayout.Corner Origin ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGridLayout_origin (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QGridLayout_iterator (IntPtr raw);
		public QLayoutIterator Iterator ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QGridLayout_iterator (rawObject), typeof (QLayoutIterator)) as QLayoutIterator;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_setGeometry (IntPtr raw, IntPtr arg1);
		public void SetGeometry (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_setGeometry (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QGridLayout_findWidget (IntPtr raw, IntPtr w, int[] r, int[] c);
		protected bool FindWidget (QWidget w, int[] r, int[] c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QGridLayout_findWidget (rawObject, w.RawObject, r, c);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QGridLayout_add (IntPtr raw, IntPtr arg1, int row, int col);
		protected void Add (QLayoutItem arg1, int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QGridLayout_add (rawObject, arg1.RawObject, row, col);
		}

		public void AddMultiCell (QLayoutItem arg1, int fromRow, int toRow, int fromCol, int toCol)
		{
			AddMultiCell(arg1, fromRow, toRow, fromCol, toCol, (int) 0);
		}

		public void AddWidget (QWidget arg1, int row, int col)
		{
			AddWidget(arg1, row, col, (int) 0);
		}

		public void AddMultiCellWidget (QWidget arg1, int fromRow, int toRow, int fromCol, int toCol)
		{
			AddMultiCellWidget(arg1, fromRow, toRow, fromCol, toCol, (int) 0);
		}

		public void AddMultiCellLayout (QLayout layout, int fromRow, int toRow, int fromCol, int toCol)
		{
			AddMultiCellLayout(layout, fromRow, toRow, fromCol, toCol, (int) 0);
		}

		// Begin interface methods.

	}
}