// QIconSet.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QIconSet : QtSupport, IDisposable {

		public enum Size {
			Automatic = 0,
			Small = 1,
			Large = 2
		}

		public enum Mode {
			Normal = 0,
			Disabled = 1,
			Active = 2
		}

		public enum State {
			On = 0,
			Off = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QIconSet ();
		public QIconSet () : this (QNull.Instance)
		{
			rawObject = qt_new_QIconSet ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QIconSet1 (IntPtr arg1, QIconSet.Size arg2);
		public QIconSet (QPixmap arg1, QIconSet.Size arg2) : this (QNull.Instance)
		{
			rawObject = qt_new_QIconSet1 (arg1.RawObject, arg2);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QIconSet2 (IntPtr smallPix, IntPtr largePix);
		public QIconSet (QPixmap smallPix, QPixmap largePix) : this (QNull.Instance)
		{
			rawObject = qt_new_QIconSet2 (smallPix.RawObject, largePix.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QIconSet3 (IntPtr arg1);
		public QIconSet (QIconSet arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QIconSet3 (arg1.RawObject);
			RegisterObject (this);
		}

		public QIconSet (QPixmap arg1) : this (arg1, QIconSet.Size.Automatic) {}

		public QIconSet (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QIconSet (QNull dummy) : base (QNull.Instance) {}

		~QIconSet ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QIconSet (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QIconSet (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconSet_reset (IntPtr raw, IntPtr arg1, QIconSet.Size arg2);
		public void Reset (QPixmap arg1, QIconSet.Size arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconSet_reset (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconSet_setPixmap (IntPtr raw, IntPtr arg1, QIconSet.Size arg2, Mode arg3, State arg4);
		public void SetPixmap (QPixmap arg1, QIconSet.Size arg2, Mode arg3, State arg4)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconSet_setPixmap (rawObject, arg1.RawObject, arg2, arg3, arg4);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconSet_setPixmap1 (IntPtr raw, IntPtr arg1, QIconSet.Size arg2, Mode arg3, State arg4);
		public void SetPixmap (string arg1, QIconSet.Size arg2, Mode arg3, State arg4)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconSet_setPixmap1 (rawObject, new QString (arg1).RawObject, arg2, arg3, arg4);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconSet_pixmap (IntPtr raw, QIconSet.Size arg1, Mode arg2, State arg3);
		public QPixmap Pixmap (QIconSet.Size arg1, Mode arg2, State arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconSet_pixmap (rawObject, arg1, arg2, arg3), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconSet_pixmap1 (IntPtr raw, QIconSet.Size s, bool enabled, State arg1);
		public QPixmap Pixmap (QIconSet.Size s, bool enabled, State arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconSet_pixmap1 (rawObject, s, enabled, arg1), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconSet_pixmap2 (IntPtr raw);
		public QPixmap Pixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconSet_pixmap2 (rawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIconSet_isGenerated (IntPtr raw, QIconSet.Size arg1, Mode arg2, State arg3);
		public bool IsGenerated (QIconSet.Size arg1, Mode arg2, State arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconSet_isGenerated (rawObject, arg1, arg2, arg3);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconSet_clearGenerated (IntPtr raw);
		public void ClearGenerated ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconSet_clearGenerated (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIconSet_isNull (IntPtr raw);
		public bool IsNull ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconSet_isNull (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconSet_detach (IntPtr raw);
		public void Detach ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconSet_detach (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconSet_setIconSize (QIconSet.Size arg1, IntPtr arg2);
		public static void SetIconSize (QIconSet.Size arg1, QSize arg2)
		{
			qt_QIconSet_setIconSize (arg1, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconSet_iconSize (QIconSet.Size arg1);
		public static QSize IconSize (QIconSet.Size arg1)
		{
			return LookupObject (qt_QIconSet_iconSize (arg1), typeof (QSize)) as QSize;

		}

		public void SetPixmap (QPixmap arg1, QIconSet.Size arg2)
		{
			SetPixmap(arg1, arg2, Mode.Normal);
		}

		public void SetPixmap (QPixmap arg1, QIconSet.Size arg2, Mode arg3)
		{
			SetPixmap(arg1, arg2, arg3, State.Off);
		}

		public void SetPixmap (string arg1, QIconSet.Size arg2)
		{
			SetPixmap(arg1, arg2, Mode.Normal);
		}

		public void SetPixmap (string arg1, QIconSet.Size arg2, Mode arg3)
		{
			SetPixmap(arg1, arg2, arg3, State.Off);
		}

		public QPixmap Pixmap (QIconSet.Size arg1, Mode arg2)
		{
			return Pixmap(arg1, arg2, State.Off);
		}

		public QPixmap Pixmap (QIconSet.Size s, bool enabled)
		{
			return Pixmap(s, enabled, State.Off);
		}

		public bool IsGenerated (QIconSet.Size arg1, Mode arg2)
		{
			return IsGenerated(arg1, arg2, State.Off);
		}
	}
}