// QIconView.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QIconView : QScrollView, IDisposable {

		public enum SelectionMode {
			Single = 0,
			Multi = 1,
			Extended = 2,
			NoSelection = 3
		}

		public enum Arrangement {
			LeftToRight = 0,
			TopToBottom = 1
		}

		public enum ResizeMode {
			Fixed = 0,
			Adjust = 1
		}

		public enum ItemTextPos {
			Bottom = 0,
			Right = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QIconView (IntPtr parent, string name, Qt.WidgetFlags f);
		public QIconView (QWidget parent, string name, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QIconView (parent != null ? parent.RawObject : IntPtr.Zero, name, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QIconView () : this (new QWidget ()) {}

		public QIconView (QWidget parent) : this (parent, "") {}

		public QIconView (QWidget parent, string name) : this (parent, name, Qt.WidgetFlags.WWinOwnDC) {}

		public QIconView (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QIconView (QNull dummy) : base (QNull.Instance) {}

		~QIconView ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QIconView (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QIconView (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_insertItem (IntPtr raw, IntPtr item, IntPtr after);
		public void InsertItem (QIconViewItem item, QIconViewItem after)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_insertItem (rawObject, item.RawObject, after.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_takeItem (IntPtr raw, IntPtr item);
		public void TakeItem (QIconViewItem item)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_takeItem (rawObject, item.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QIconView_index (IntPtr raw, IntPtr item);
		public int Index (QIconViewItem item)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_index (rawObject, item.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconView_firstItem (IntPtr raw);
		public QIconViewItem FirstItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconView_firstItem (rawObject), typeof (QIconViewItem)) as QIconViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconView_lastItem (IntPtr raw);
		public QIconViewItem LastItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconView_lastItem (rawObject), typeof (QIconViewItem)) as QIconViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconView_currentItem (IntPtr raw);
		public QIconViewItem CurrentItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconView_currentItem (rawObject), typeof (QIconViewItem)) as QIconViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setCurrentItem (IntPtr raw, IntPtr item);
		public void SetCurrentItem (QIconViewItem item)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setCurrentItem (rawObject, item.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setSelected (IntPtr raw, IntPtr item, bool s, bool cb);
		public void SetSelected (QIconViewItem item, bool s, bool cb)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setSelected (rawObject, item.RawObject, s, cb);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QIconView_count (IntPtr raw);
		public uint Count ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_count (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setSelectionMode (IntPtr raw, SelectionMode m);
		public void SetSelectionMode (SelectionMode m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setSelectionMode (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern SelectionMode qt_QIconView_selectionMode (IntPtr raw);
		public SelectionMode TheSelectionMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_selectionMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconView_findItem (IntPtr raw, IntPtr pos);
		public QIconViewItem FindItem (QPoint pos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconView_findItem (rawObject, pos.RawObject), typeof (QIconViewItem)) as QIconViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconView_findItem1 (IntPtr raw, IntPtr text, Qt.StringComparisonMode compare);
		public QIconViewItem FindItem (string text, Qt.StringComparisonMode compare)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconView_findItem1 (rawObject, new QString (text).RawObject, compare), typeof (QIconViewItem)) as QIconViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_selectAll (IntPtr raw, bool select);
		public void SelectAll (bool select)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_selectAll (rawObject, select);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_clearSelection (IntPtr raw);
		public void ClearSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_clearSelection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_invertSelection (IntPtr raw);
		public void InvertSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_invertSelection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_repaintItem (IntPtr raw, IntPtr item);
		public void RepaintItem (QIconViewItem item)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_repaintItem (rawObject, item.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_ensureItemVisible (IntPtr raw, IntPtr item);
		public void EnsureItemVisible (QIconViewItem item)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_ensureItemVisible (rawObject, item.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconView_findFirstVisibleItem (IntPtr raw, IntPtr r);
		public QIconViewItem FindFirstVisibleItem (QRect r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconView_findFirstVisibleItem (rawObject, r.RawObject), typeof (QIconViewItem)) as QIconViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconView_findLastVisibleItem (IntPtr raw, IntPtr r);
		public QIconViewItem FindLastVisibleItem (QRect r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconView_findLastVisibleItem (rawObject, r.RawObject), typeof (QIconViewItem)) as QIconViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setGridX (IntPtr raw, int rx);
		public void SetGridX (int rx)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setGridX (rawObject, rx);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setGridY (IntPtr raw, int ry);
		public void SetGridY (int ry)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setGridY (rawObject, ry);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QIconView_gridX (IntPtr raw);
		public int GridX ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_gridX (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QIconView_gridY (IntPtr raw);
		public int GridY ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_gridY (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setSpacing (IntPtr raw, int sp);
		public void SetSpacing (int sp)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setSpacing (rawObject, sp);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QIconView_spacing (IntPtr raw);
		public int Spacing ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_spacing (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setItemTextPos (IntPtr raw, QIconView.ItemTextPos pos);
		public void SetItemTextPos (QIconView.ItemTextPos pos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setItemTextPos (rawObject, pos);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QIconView.ItemTextPos qt_QIconView_itemTextPos (IntPtr raw);
		public QIconView.ItemTextPos TheItemTextPos ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_itemTextPos (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setItemTextBackground (IntPtr raw, IntPtr b);
		public void SetItemTextBackground (QBrush b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setItemTextBackground (rawObject, b.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconView_itemTextBackground (IntPtr raw);
		public QBrush ItemTextBackground ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconView_itemTextBackground (rawObject), typeof (QBrush)) as QBrush;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setArrangement (IntPtr raw, QIconView.Arrangement am);
		public void SetArrangement (QIconView.Arrangement am)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setArrangement (rawObject, am);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QIconView.Arrangement qt_QIconView_arrangement (IntPtr raw);
		public QIconView.Arrangement TheArrangement ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_arrangement (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setResizeMode (IntPtr raw, ResizeMode am);
		public void SetResizeMode (ResizeMode am)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setResizeMode (rawObject, am);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ResizeMode qt_QIconView_resizeMode (IntPtr raw);
		public ResizeMode TheResizeMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_resizeMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setMaxItemWidth (IntPtr raw, int w);
		public void SetMaxItemWidth (int w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setMaxItemWidth (rawObject, w);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QIconView_maxItemWidth (IntPtr raw);
		public int MaxItemWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_maxItemWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setMaxItemTextLength (IntPtr raw, int w);
		public void SetMaxItemTextLength (int w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setMaxItemTextLength (rawObject, w);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QIconView_maxItemTextLength (IntPtr raw);
		public int MaxItemTextLength ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_maxItemTextLength (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setAutoArrange (IntPtr raw, bool b);
		public void SetAutoArrange (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setAutoArrange (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIconView_autoArrange (IntPtr raw);
		public bool AutoArrange ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_autoArrange (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setShowToolTips (IntPtr raw, bool b);
		public void SetShowToolTips (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setShowToolTips (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIconView_showToolTips (IntPtr raw);
		public bool ShowToolTips ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_showToolTips (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setSorting (IntPtr raw, bool sort, bool ascending);
		public void SetSorting (bool sort, bool ascending)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setSorting (rawObject, sort, ascending);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIconView_sorting (IntPtr raw);
		public bool Sorting ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_sorting (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIconView_sortDirection (IntPtr raw);
		public bool SortDirection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_sortDirection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setItemsMovable (IntPtr raw, bool b);
		public void SetItemsMovable (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setItemsMovable (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIconView_itemsMovable (IntPtr raw);
		public bool ItemsMovable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_itemsMovable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setWordWrapIconText (IntPtr raw, bool b);
		public void SetWordWrapIconText (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setWordWrapIconText (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIconView_wordWrapIconText (IntPtr raw);
		public bool WordWrapIconText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_wordWrapIconText (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIconView_eventFilter (IntPtr raw, IntPtr o, IntPtr arg1);
		public bool EventFilter (QObject o, QEvent arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_eventFilter (rawObject, o.RawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconView_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconView_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconView_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconView_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_sort (IntPtr raw, bool ascending);
		public void Sort (bool ascending)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_sort (rawObject, ascending);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setFont (IntPtr raw, IntPtr arg1);
		public void SetFont (QFont arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setFont (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setPalette (IntPtr raw, IntPtr arg1);
		public void SetPalette (QPalette arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setPalette (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIconView_isRenaming (IntPtr raw);
		public bool IsRenaming ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIconView_isRenaming (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_arrangeItemsInGrid (IntPtr raw, IntPtr grid, bool update);
		public void ArrangeItemsInGrid (QSize grid, bool update)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_arrangeItemsInGrid (rawObject, grid.RawObject, update);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_arrangeItemsInGrid1 (IntPtr raw, bool update);
		public void ArrangeItemsInGrid (bool update)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_arrangeItemsInGrid1 (rawObject, update);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_setContentsPos (IntPtr raw, int x, int y);
		public void SetContentsPos (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_setContentsPos (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_updateContents (IntPtr raw);
		public void UpdateContents ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_updateContents (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_drawContents (IntPtr raw, IntPtr p, int cx, int cy, int cw, int ch);
		protected void DrawContents (QPainter p, int cx, int cy, int cw, int ch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_drawContents (rawObject, p.RawObject, cx, cy, cw, ch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_drawRubber (IntPtr raw, IntPtr p);
		protected void DrawRubber (QPainter p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_drawRubber (rawObject, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconView_dragObject (IntPtr raw);
		protected QDragObject DragObject ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconView_dragObject (rawObject), typeof (QDragObject)) as QDragObject;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_startDrag (IntPtr raw);
		protected void StartDrag ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_startDrag (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_insertInGrid (IntPtr raw, IntPtr item);
		protected void InsertInGrid (QIconViewItem item)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_insertInGrid (rawObject, item.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_drawBackground (IntPtr raw, IntPtr p, IntPtr r);
		protected void DrawBackground (QPainter p, QRect r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_drawBackground (rawObject, p.RawObject, r.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_emitSelectionChanged (IntPtr raw, IntPtr i);
		protected void EmitSelectionChanged (QIconViewItem i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_emitSelectionChanged (rawObject, i.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_emitRenamed (IntPtr raw, IntPtr item);
		protected void EmitRenamed (QIconViewItem item)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_emitRenamed (rawObject, item.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIconView_makeRowLayout (IntPtr raw, IntPtr begin, int y, bool changed);
		protected QIconViewItem MakeRowLayout (QIconViewItem begin, int y, bool changed)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIconView_makeRowLayout (rawObject, begin.RawObject, y, changed), typeof (QIconViewItem)) as QIconViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_windowActivationChange (IntPtr raw, bool arg1);
		protected void WindowActivationChange (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_windowActivationChange (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_doAutoScroll (IntPtr raw);
		protected void DoAutoScroll ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_doAutoScroll (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_adjustItems (IntPtr raw);
		protected void AdjustItems ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_adjustItems (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIconView_slotUpdate (IntPtr raw);
		protected void SlotUpdate ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIconView_slotUpdate (rawObject);
		}

		public void InsertItem (QIconViewItem item)
		{
			InsertItem(item, new QIconViewItem ());
		}

		public void SetSelected (QIconViewItem item, bool s)
		{
			SetSelected(item, s, false);
		}

		public QIconViewItem FindItem (string text)
		{
			return FindItem(text, Qt.StringComparisonMode.BeginsWith);
		}

		public void SetSorting (bool sort)
		{
			SetSorting(sort, true);
		}

		public void Sort ()
		{
			Sort(true);
		}

		public void ArrangeItemsInGrid (QSize grid)
		{
			ArrangeItemsInGrid(grid, true);
		}

		public void ArrangeItemsInGrid ()
		{
			ArrangeItemsInGrid(true);
		}

		protected void EmitSelectionChanged ()
		{
			EmitSelectionChanged(new QIconViewItem ());
		}

		// Begin interface methods.

	}
}