// QImage.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QImage : QtSupport, IDisposable {

		public enum Endian {
			IgnoreEndian = 0,
			BigEndian = 1,
			LittleEndian = 2
		}

		public enum ScaleMode {
			ScaleFree = 0,
			ScaleMin = 1,
			ScaleMax = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QImage ();
		public QImage () : this (QNull.Instance)
		{
			rawObject = qt_new_QImage ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QImage1 (int width, int height, int depth, int numColors, QImage.Endian bitOrder);
		public QImage (int width, int height, int depth, int numColors, QImage.Endian bitOrder) : this (QNull.Instance)
		{
			rawObject = qt_new_QImage1 (width, height, depth, numColors, bitOrder);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QImage2 (IntPtr arg1, int depth, int numColors, QImage.Endian bitOrder);
		public QImage (QSize arg1, int depth, int numColors, QImage.Endian bitOrder) : this (QNull.Instance)
		{
			rawObject = qt_new_QImage2 (arg1.RawObject, depth, numColors, bitOrder);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QImage3 (IntPtr fileName, string format);
		public QImage (string fileName, string format) : this (QNull.Instance)
		{
			rawObject = qt_new_QImage3 (new QString (fileName).RawObject, format);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QImage4 (string[] xpm);
		public QImage (string[] xpm) : this (QNull.Instance)
		{
			rawObject = qt_new_QImage4 (xpm);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QImage5 (byte[] data);
		public QImage (byte[] data) : this (QNull.Instance)
		{
			rawObject = qt_new_QImage5 (data);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QImage6 (string data, int w, int h, int depth, int colortable, int numColors, QImage.Endian bitOrder);
		public QImage (string data, int w, int h, int depth, int colortable, int numColors, QImage.Endian bitOrder) : this (QNull.Instance)
		{
			rawObject = qt_new_QImage6 (data, w, h, depth, colortable, numColors, bitOrder);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QImage7 (string data, int w, int h, int depth, int pbl, int colortable, int numColors, QImage.Endian bitOrder);
		public QImage (string data, int w, int h, int depth, int pbl, int colortable, int numColors, QImage.Endian bitOrder) : this (QNull.Instance)
		{
			rawObject = qt_new_QImage7 (data, w, h, depth, pbl, colortable, numColors, bitOrder);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QImage8 (IntPtr arg1);
		public QImage (QImage arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QImage8 (arg1.RawObject);
			RegisterObject (this);
		}

		public QImage (int width, int height, int depth) : this (width, height, depth, (int) 0) {}

		public QImage (int width, int height, int depth, int numColors) : this (width, height, depth, numColors, QImage.Endian.IgnoreEndian) {}

		public QImage (QSize arg1, int depth) : this (arg1, depth, (int) 0) {}

		public QImage (QSize arg1, int depth, int numColors) : this (arg1, depth, numColors, QImage.Endian.IgnoreEndian) {}

		public QImage (string fileName) : this (fileName, "") {}

		public QImage (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QImage (QNull dummy) : base (QNull.Instance) {}

		~QImage ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QImage (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QImage (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QImage_detach (IntPtr raw);
		public void Detach ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QImage_detach (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_copy (IntPtr raw);
		public QImage Copy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_copy (rawObject), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_copy1 (IntPtr raw, int x, int y, int w, int h, int conversion_flags);
		public QImage Copy (int x, int y, int w, int h, int conversion_flags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_copy1 (rawObject, x, y, w, h, conversion_flags), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_copy2 (IntPtr raw, IntPtr arg1);
		public QImage Copy (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_copy2 (rawObject, arg1.RawObject), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QImage_isNull (IntPtr raw);
		public bool IsNull ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_isNull (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QImage_width (IntPtr raw);
		public int Width ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_width (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QImage_height (IntPtr raw);
		public int Height ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_height (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_size (IntPtr raw);
		public QSize Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_size (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_rect (IntPtr raw);
		public QRect Rect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_rect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QImage_depth (IntPtr raw);
		public int Depth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_depth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QImage_numColors (IntPtr raw);
		public int NumColors ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_numColors (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QImage.Endian qt_QImage_bitOrder (IntPtr raw);
		public QImage.Endian BitOrder ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_bitOrder (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QImage_color (IntPtr raw, int i);
		public int Color (int i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_color (rawObject, i);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QImage_setColor (IntPtr raw, int i, int c);
		public void SetColor (int i, int c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QImage_setColor (rawObject, i, c);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QImage_setNumColors (IntPtr raw, int arg1);
		public void SetNumColors (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QImage_setNumColors (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QImage_hasAlphaBuffer (IntPtr raw);
		public bool HasAlphaBuffer ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_hasAlphaBuffer (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QImage_setAlphaBuffer (IntPtr raw, bool arg1);
		public void SetAlphaBuffer (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QImage_setAlphaBuffer (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QImage_allGray (IntPtr raw);
		public bool AllGray ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_allGray (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QImage_isGrayscale (IntPtr raw);
		public bool IsGrayscale ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_isGrayscale (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QImage_bits (IntPtr raw);
		public string Bits ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_bits (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QImage_scanLine (IntPtr raw, int arg1);
		public string ScanLine (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_scanLine (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string[] qt_QImage_jumpTable (IntPtr raw);
		public string[] JumpTable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_jumpTable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QImage_colorTable (IntPtr raw);
		public int ColorTable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_colorTable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QImage_numBytes (IntPtr raw);
		public int NumBytes ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_numBytes (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QImage_bytesPerLine (IntPtr raw);
		public int BytesPerLine ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_bytesPerLine (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_graphicsContext (IntPtr raw);
		public IntPtr GraphicsContext ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_graphicsContext (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QImage_create (IntPtr raw, int width, int height, int depth, int numColors, QImage.Endian bitOrder);
		public bool Create (int width, int height, int depth, int numColors, QImage.Endian bitOrder)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_create (rawObject, width, height, depth, numColors, bitOrder);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QImage_create1 (IntPtr raw, IntPtr arg1, int depth, int numColors, QImage.Endian bitOrder);
		public bool Create (QSize arg1, int depth, int numColors, QImage.Endian bitOrder)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_create1 (rawObject, arg1.RawObject, depth, numColors, bitOrder);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QImage_reset (IntPtr raw);
		public void Reset ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QImage_reset (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QImage_fill (IntPtr raw, uint pixel);
		public void Fill (uint pixel)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QImage_fill (rawObject, pixel);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QImage_invertPixels (IntPtr raw, bool invertAlpha);
		public void InvertPixels (bool invertAlpha)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QImage_invertPixels (rawObject, invertAlpha);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_convertDepth (IntPtr raw, int arg1);
		public QImage ConvertDepth (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_convertDepth (rawObject, arg1), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_convertDepthWithPalette (IntPtr raw, int arg1, int p, int pc, int cf);
		public QImage ConvertDepthWithPalette (int arg1, int p, int pc, int cf)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_convertDepthWithPalette (rawObject, arg1, p, pc, cf), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_convertDepth1 (IntPtr raw, int arg1, int conversion_flags);
		public QImage ConvertDepth (int arg1, int conversion_flags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_convertDepth1 (rawObject, arg1, conversion_flags), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_convertBitOrder (IntPtr raw, QImage.Endian arg1);
		public QImage ConvertBitOrder (QImage.Endian arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_convertBitOrder (rawObject, arg1), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_smoothScale (IntPtr raw, int w, int h, QImage.ScaleMode mode);
		public QImage SmoothScale (int w, int h, QImage.ScaleMode mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_smoothScale (rawObject, w, h, mode), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_smoothScale1 (IntPtr raw, IntPtr s, QImage.ScaleMode mode);
		public QImage SmoothScale (QSize s, QImage.ScaleMode mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_smoothScale1 (rawObject, s.RawObject, mode), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_scale (IntPtr raw, int w, int h, QImage.ScaleMode mode);
		public QImage Scale (int w, int h, QImage.ScaleMode mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_scale (rawObject, w, h, mode), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_scale1 (IntPtr raw, IntPtr s, QImage.ScaleMode mode);
		public QImage Scale (QSize s, QImage.ScaleMode mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_scale1 (rawObject, s.RawObject, mode), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_scaleWidth (IntPtr raw, int w);
		public QImage ScaleWidth (int w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_scaleWidth (rawObject, w), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_scaleHeight (IntPtr raw, int h);
		public QImage ScaleHeight (int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_scaleHeight (rawObject, h), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_xForm (IntPtr raw, IntPtr matrix);
		public QImage XForm (QWMatrix matrix)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_xForm (rawObject, matrix.RawObject), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_createAlphaMask (IntPtr raw, int conversion_flags);
		public QImage CreateAlphaMask (int conversion_flags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_createAlphaMask (rawObject, conversion_flags), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_createHeuristicMask (IntPtr raw, bool clipTight);
		public QImage CreateHeuristicMask (bool clipTight)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_createHeuristicMask (rawObject, clipTight), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_mirror (IntPtr raw);
		public QImage Mirror ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_mirror (rawObject), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_mirror1 (IntPtr raw, bool horizontally, bool vertically);
		public QImage Mirror (bool horizontally, bool vertically)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_mirror1 (rawObject, horizontally, vertically), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_swapRGB (IntPtr raw);
		public QImage SwapRGB ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_swapRGB (rawObject), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QImage_load (IntPtr raw, IntPtr fileName, string format);
		public bool Load (string fileName, string format)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_load (rawObject, new QString (fileName).RawObject, format);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QImage_loadFromData (IntPtr raw, string buf, uint len, string format);
		public bool LoadFromData (string buf, uint len, string format)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_loadFromData (rawObject, buf, len, format);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QImage_loadFromData1 (IntPtr raw, byte[] data, string format);
		public bool LoadFromData (byte[] data, string format)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_loadFromData1 (rawObject, data, format);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QImage_save (IntPtr raw, IntPtr fileName, string format, int quality);
		public bool Save (string fileName, string format, int quality)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_save (rawObject, new QString (fileName).RawObject, format, quality);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QImage_valid (IntPtr raw, int x, int y);
		public bool Valid (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_valid (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QImage_pixelIndex (IntPtr raw, int x, int y);
		public int PixelIndex (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_pixelIndex (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QImage_pixel (IntPtr raw, int x, int y);
		public int Pixel (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_pixel (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QImage_setPixel (IntPtr raw, int x, int y, uint index_or_rgb);
		public void SetPixel (int x, int y, uint index_or_rgb)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QImage_setPixel (rawObject, x, y, index_or_rgb);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QImage_dotsPerMeterX (IntPtr raw);
		public int DotsPerMeterX ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_dotsPerMeterX (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QImage_dotsPerMeterY (IntPtr raw);
		public int DotsPerMeterY ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QImage_dotsPerMeterY (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QImage_setDotsPerMeterX (IntPtr raw, int arg1);
		public void SetDotsPerMeterX (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QImage_setDotsPerMeterX (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QImage_setDotsPerMeterY (IntPtr raw, int arg1);
		public void SetDotsPerMeterY (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QImage_setDotsPerMeterY (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_offset (IntPtr raw);
		public QPoint Offset ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_offset (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QImage_setOffset (IntPtr raw, IntPtr arg1);
		public void SetOffset (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QImage_setOffset (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_textLanguages (IntPtr raw);
		public QStringList TextLanguages ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_textLanguages (rawObject), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_textKeys (IntPtr raw);
		public QStringList TextKeys ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QImage_textKeys (rawObject), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_text (IntPtr raw, string key, string lang);
		public string Text (string key, string lang)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QImage_text (rawObject, key, lang));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_text1 (IntPtr raw, IntPtr arg1);
		public string Text (QImageTextKeyLang arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QImage_text1 (rawObject, arg1.RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QImage_setText (IntPtr raw, string key, string lang, IntPtr arg1);
		public void SetText (string key, string lang, string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QImage_setText (rawObject, key, lang, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QImage.Endian qt_QImage_systemBitOrder ();
		public static QImage.Endian SystemBitOrder ()
		{
			return qt_QImage_systemBitOrder ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QImage.Endian qt_QImage_systemByteOrder ();
		public static QImage.Endian SystemByteOrder ()
		{
			return qt_QImage_systemByteOrder ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QImage_imageFormat (IntPtr fileName);
		public static string ImageFormat (string fileName)
		{
			return qt_QImage_imageFormat (new QString (fileName).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_inputFormats ();
		public static QStrList InputFormats ()
		{
			return LookupObject (qt_QImage_inputFormats (), typeof (QStrList)) as QStrList;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_outputFormats ();
		public static QStrList OutputFormats ()
		{
			return LookupObject (qt_QImage_outputFormats (), typeof (QStrList)) as QStrList;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_inputFormatList ();
		public static QStringList InputFormatList ()
		{
			return LookupObject (qt_QImage_inputFormatList (), typeof (QStringList)) as QStringList;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QImage_outputFormatList ();
		public static QStringList OutputFormatList ()
		{
			return LookupObject (qt_QImage_outputFormatList (), typeof (QStringList)) as QStringList;

		}

		public QImage Copy (int x, int y, int w, int h)
		{
			return Copy(x, y, w, h, (int) 0);
		}

		public bool Create (int width, int height, int depth)
		{
			return Create(width, height, depth, (int) 0);
		}

		public bool Create (int width, int height, int depth, int numColors)
		{
			return Create(width, height, depth, numColors, QImage.Endian.IgnoreEndian);
		}

		public bool Create (QSize arg1, int depth)
		{
			return Create(arg1, depth, (int) 0);
		}

		public bool Create (QSize arg1, int depth, int numColors)
		{
			return Create(arg1, depth, numColors, QImage.Endian.IgnoreEndian);
		}

		public void InvertPixels ()
		{
			InvertPixels(true);
		}

		public QImage ConvertDepthWithPalette (int arg1, int p, int pc)
		{
			return ConvertDepthWithPalette(arg1, p, pc, (int) 0);
		}

		public QImage SmoothScale (int w, int h)
		{
			return SmoothScale(w, h, QImage.ScaleMode.ScaleFree);
		}

		public QImage SmoothScale (QSize s)
		{
			return SmoothScale(s, QImage.ScaleMode.ScaleFree);
		}

		public QImage Scale (int w, int h)
		{
			return Scale(w, h, QImage.ScaleMode.ScaleFree);
		}

		public QImage Scale (QSize s)
		{
			return Scale(s, QImage.ScaleMode.ScaleFree);
		}

		public QImage CreateAlphaMask ()
		{
			return CreateAlphaMask((int) 0);
		}

		public QImage CreateHeuristicMask ()
		{
			return CreateHeuristicMask(true);
		}

		public bool Load (string fileName)
		{
			return Load(fileName, "");
		}

		public bool LoadFromData (string buf, uint len)
		{
			return LoadFromData(buf, len, "");
		}

		public bool LoadFromData (byte[] data)
		{
			return LoadFromData(data, "");
		}

		public bool Save (string fileName, string format)
		{
			return Save(fileName, format, (int) -1);
		}

		public string Text (string key)
		{
			return Text(key, "");
		}
	}
}