// QInputDialog.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QInputDialog : QDialog, IDisposable {

		internal QInputDialog () : this (QNull.Instance) {}

		public QInputDialog (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QInputDialog (QNull dummy) : base (QNull.Instance) {}

		~QInputDialog ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QInputDialog function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QInputDialog_getText (IntPtr caption, IntPtr label, QLineEdit.EchoMode echo, IntPtr text, bool ok, IntPtr parent, string name);
		public static string GetText (string caption, string label, QLineEdit.EchoMode echo, string text, bool ok, QWidget parent, string name)
		{
			QString qstr = new QString (qt_QInputDialog_getText (new QString (caption).RawObject, new QString (label).RawObject, echo, new QString (text).RawObject, ok, parent.RawObject, name));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QInputDialog_getInteger (IntPtr caption, IntPtr label, int num, int from, int to, int step, bool ok, IntPtr parent, string name);
		public static int GetInteger (string caption, string label, int num, int from, int to, int step, bool ok, QWidget parent, string name)
		{
			return qt_QInputDialog_getInteger (new QString (caption).RawObject, new QString (label).RawObject, num, from, to, step, ok, parent.RawObject, name);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QInputDialog_getDouble (IntPtr caption, IntPtr label, double num, double from, double to, int decimals, bool ok, IntPtr parent, string name);
		public static double GetDouble (string caption, string label, double num, double from, double to, int decimals, bool ok, QWidget parent, string name)
		{
			return qt_QInputDialog_getDouble (new QString (caption).RawObject, new QString (label).RawObject, num, from, to, decimals, ok, parent.RawObject, name);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QInputDialog_getItem (IntPtr caption, IntPtr label, IntPtr list, int current, bool editable, bool ok, IntPtr parent, string name);
		public static string GetItem (string caption, string label, QStringList list, int current, bool editable, bool ok, QWidget parent, string name)
		{
			QString qstr = new QString (qt_QInputDialog_getItem (new QString (caption).RawObject, new QString (label).RawObject, list.RawObject, current, editable, ok, parent.RawObject, name));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		public static string GetText (string caption, string label)
		{
			return GetText(caption, label, QLineEdit.EchoMode.Normal);
		}

		public static string GetText (string caption, string label, QLineEdit.EchoMode echo)
		{
			return GetText(caption, label, echo, (string) "");
		}

		public static string GetText (string caption, string label, QLineEdit.EchoMode echo, string text)
		{
			return GetText(caption, label, echo, text, false);
		}

		public static string GetText (string caption, string label, QLineEdit.EchoMode echo, string text, bool ok)
		{
			return GetText(caption, label, echo, text, ok, new QWidget ());
		}

		public static string GetText (string caption, string label, QLineEdit.EchoMode echo, string text, bool ok, QWidget parent)
		{
			return GetText(caption, label, echo, text, ok, parent, "");
		}

		public static int GetInteger (string caption, string label)
		{
			return GetInteger(caption, label, (int) 0);
		}

		public static int GetInteger (string caption, string label, int num)
		{
			return GetInteger(caption, label, num, (int) -2147483647);
		}

		public static int GetInteger (string caption, string label, int num, int from)
		{
			return GetInteger(caption, label, num, from, (int) 2147483647);
		}

		public static int GetInteger (string caption, string label, int num, int from, int to)
		{
			return GetInteger(caption, label, num, from, to, (int) 1);
		}

		public static int GetInteger (string caption, string label, int num, int from, int to, int step)
		{
			return GetInteger(caption, label, num, from, to, step, false);
		}

		public static int GetInteger (string caption, string label, int num, int from, int to, int step, bool ok)
		{
			return GetInteger(caption, label, num, from, to, step, ok, new QWidget ());
		}

		public static int GetInteger (string caption, string label, int num, int from, int to, int step, bool ok, QWidget parent)
		{
			return GetInteger(caption, label, num, from, to, step, ok, parent, "");
		}

		public static double GetDouble (string caption, string label)
		{
			return GetDouble(caption, label, (double) 0);
		}

		public static double GetDouble (string caption, string label, double num)
		{
			return GetDouble(caption, label, num, (double) -2147483647);
		}

		public static double GetDouble (string caption, string label, double num, double from)
		{
			return GetDouble(caption, label, num, from, (double) 2147483647);
		}

		public static double GetDouble (string caption, string label, double num, double from, double to)
		{
			return GetDouble(caption, label, num, from, to, (int) 1);
		}

		public static double GetDouble (string caption, string label, double num, double from, double to, int decimals)
		{
			return GetDouble(caption, label, num, from, to, decimals, false);
		}

		public static double GetDouble (string caption, string label, double num, double from, double to, int decimals, bool ok)
		{
			return GetDouble(caption, label, num, from, to, decimals, ok, new QWidget ());
		}

		public static double GetDouble (string caption, string label, double num, double from, double to, int decimals, bool ok, QWidget parent)
		{
			return GetDouble(caption, label, num, from, to, decimals, ok, parent, "");
		}

		public static string GetItem (string caption, string label, QStringList list)
		{
			return GetItem(caption, label, list, (int) 0);
		}

		public static string GetItem (string caption, string label, QStringList list, int current)
		{
			return GetItem(caption, label, list, current, true);
		}

		public static string GetItem (string caption, string label, QStringList list, int current, bool editable)
		{
			return GetItem(caption, label, list, current, editable, false);
		}

		public static string GetItem (string caption, string label, QStringList list, int current, bool editable, bool ok)
		{
			return GetItem(caption, label, list, current, editable, ok, new QWidget ());
		}

		public static string GetItem (string caption, string label, QStringList list, int current, bool editable, bool ok, QWidget parent)
		{
			return GetItem(caption, label, list, current, editable, ok, parent, "");
		}

		// Begin interface methods.

	}
}