// QIntCache.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QIntCache : QGCache, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QIntCache1 (int maxCost, int size);
		public QIntCache (int maxCost, int size) : this (QNull.Instance)
		{
			rawObject = qt_new_QIntCache1 (maxCost, size);
			RegisterObject (this);
		}

		public QIntCache () : this ((int) 100) {}

		public QIntCache (int maxCost) : this (maxCost, (int) 17) {}

		public QIntCache (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QIntCache (QNull dummy) : base (QNull.Instance) {}

		~QIntCache ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QIntCache (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QIntCache (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QIntCache_maxCost (IntPtr raw);
		public int MaxCost ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntCache_maxCost (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QIntCache_totalCost (IntPtr raw);
		public int TotalCost ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntCache_totalCost (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIntCache_setMaxCost (IntPtr raw, int m);
		public void SetMaxCost (int m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIntCache_setMaxCost (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QIntCache_count (IntPtr raw);
		public uint Count ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntCache_count (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QIntCache_size (IntPtr raw);
		public uint Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntCache_size (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIntCache_isEmpty (IntPtr raw);
		public bool IsEmpty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntCache_isEmpty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIntCache_insert (IntPtr raw, long k, IntPtr d, int c, int p);
		public bool Insert (long k, IntPtr d, int c, int p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntCache_insert (rawObject, k, d, c, p);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIntCache_remove (IntPtr raw, long k);
		public bool Remove (long k)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntCache_remove (rawObject, k);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIntCache_take (IntPtr raw, long k);
		public IntPtr Take (long k)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntCache_take (rawObject, k);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIntCache_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIntCache_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIntCache_find (IntPtr raw, long k, bool Q_ref);
		public IntPtr Find (long k, bool Q_ref)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntCache_find (rawObject, k, Q_ref);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIntCache_statistics (IntPtr raw);
		public void Statistics ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIntCache_statistics (rawObject);
		}

		public bool Insert (long k, IntPtr d)
		{
			return Insert(k, d, (int) 1);
		}

		public bool Insert (long k, IntPtr d, int c)
		{
			return Insert(k, d, c, (int) 0);
		}

		public IntPtr Find (long k)
		{
			return Find(k, true);
		}

		// Begin interface methods.

	}
}