// QIntDict.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QIntDict : QPtrCollection, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QIntDict (int size);
		public QIntDict (int size) : this (QNull.Instance)
		{
			rawObject = qt_new_QIntDict (size);
			RegisterObject (this);
		}

		public QIntDict () : this ((int) 17) {}

		public QIntDict (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QIntDict (QNull dummy) : base (QNull.Instance) {}

		~QIntDict ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QIntDict (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QIntDict (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QIntDict_count (IntPtr raw);
		public uint Count ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntDict_count (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QIntDict_size (IntPtr raw);
		public uint Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntDict_size (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIntDict_isEmpty (IntPtr raw);
		public bool IsEmpty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntDict_isEmpty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIntDict_insert (IntPtr raw, long k, IntPtr d);
		public void Insert (long k, IntPtr d)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIntDict_insert (rawObject, k, d);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIntDict_replace (IntPtr raw, long k, IntPtr d);
		public void Replace (long k, IntPtr d)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIntDict_replace (rawObject, k, d);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIntDict_remove (IntPtr raw, long k);
		public bool Remove (long k)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntDict_remove (rawObject, k);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIntDict_take (IntPtr raw, long k);
		public IntPtr Take (long k)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntDict_take (rawObject, k);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIntDict_find (IntPtr raw, long k);
		public IntPtr Find (long k)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIntDict_find (rawObject, k);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIntDict_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIntDict_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIntDict_resize (IntPtr raw, uint n);
		public void Resize (uint n)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIntDict_resize (rawObject, n);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIntDict_statistics (IntPtr raw);
		public void Statistics ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIntDict_statistics (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIntDict_read (IntPtr raw, IntPtr arg1, int arg2);
		protected QDataStream Read (QDataStream arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIntDict_read (rawObject, arg1.RawObject, arg2), typeof (QDataStream)) as QDataStream;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QIntDict_write (IntPtr raw, IntPtr arg1, int arg2);
		protected QDataStream Write (QDataStream arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QIntDict_write (rawObject, arg1.RawObject, arg2), typeof (QDataStream)) as QDataStream;
		}

		// Begin interface methods.

	}
}