// QJpUnicodeConv.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QJpUnicodeConv : QtSupport, IDisposable {

		public enum Rules {
			Default = 0,
			Unicode = 1,
			Unicode_JISX0201 = 1,
			Unicode_ASCII = 2,
			JISX0221_JISX0201 = 3,
			JISX0221_ASCII = 4,
			Sun_JDK117 = 5,
			Microsoft_CP932 = 6,
			NEC_VDC = 256,
			UDC = 512,
			IBM_VDC = 1024
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QJpUnicodeConv (int r);
		protected QJpUnicodeConv (int r) : this (QNull.Instance)
		{
			rawObject = qt_new_QJpUnicodeConv (r);
			RegisterObject (this);
		}

		internal QJpUnicodeConv () : this (QNull.Instance) {}

		public QJpUnicodeConv (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QJpUnicodeConv (QNull dummy) : base (QNull.Instance) {}

		~QJpUnicodeConv ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QJpUnicodeConv function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_asciiToUnicode (IntPtr raw, uint h, uint l);
		public uint AsciiToUnicode (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_asciiToUnicode (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_jisx0201ToUnicode (IntPtr raw, uint h, uint l);
		public uint Jisx0201ToUnicode (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_jisx0201ToUnicode (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_jisx0201LatinToUnicode (IntPtr raw, uint h, uint l);
		public uint Jisx0201LatinToUnicode (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_jisx0201LatinToUnicode (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_jisx0201KanaToUnicode (IntPtr raw, uint h, uint l);
		public uint Jisx0201KanaToUnicode (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_jisx0201KanaToUnicode (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_jisx0208ToUnicode (IntPtr raw, uint h, uint l);
		public uint Jisx0208ToUnicode (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_jisx0208ToUnicode (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_jisx0212ToUnicode (IntPtr raw, uint h, uint l);
		public uint Jisx0212ToUnicode (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_jisx0212ToUnicode (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_asciiToUnicode1 (IntPtr raw, uint ascii);
		public uint AsciiToUnicode (uint ascii)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_asciiToUnicode1 (rawObject, ascii);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_jisx0201ToUnicode1 (IntPtr raw, uint jis);
		public uint Jisx0201ToUnicode (uint jis)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_jisx0201ToUnicode1 (rawObject, jis);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_jisx0201LatinToUnicode1 (IntPtr raw, uint jis);
		public uint Jisx0201LatinToUnicode (uint jis)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_jisx0201LatinToUnicode1 (rawObject, jis);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_jisx0201KanaToUnicode1 (IntPtr raw, uint jis);
		public uint Jisx0201KanaToUnicode (uint jis)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_jisx0201KanaToUnicode1 (rawObject, jis);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_jisx0208ToUnicode1 (IntPtr raw, uint jis);
		public uint Jisx0208ToUnicode (uint jis)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_jisx0208ToUnicode1 (rawObject, jis);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_jisx0212ToUnicode1 (IntPtr raw, uint jis);
		public uint Jisx0212ToUnicode (uint jis)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_jisx0212ToUnicode1 (rawObject, jis);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToAscii (IntPtr raw, uint h, uint l);
		public uint UnicodeToAscii (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToAscii (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToJisx0201 (IntPtr raw, uint h, uint l);
		public uint UnicodeToJisx0201 (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToJisx0201 (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToJisx0201Latin (IntPtr raw, uint h, uint l);
		public uint UnicodeToJisx0201Latin (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToJisx0201Latin (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToJisx0201Kana (IntPtr raw, uint h, uint l);
		public uint UnicodeToJisx0201Kana (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToJisx0201Kana (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToJisx0208 (IntPtr raw, uint h, uint l);
		public uint UnicodeToJisx0208 (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToJisx0208 (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToJisx0212 (IntPtr raw, uint h, uint l);
		public uint UnicodeToJisx0212 (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToJisx0212 (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToAscii1 (IntPtr raw, uint unicode);
		public uint UnicodeToAscii (uint unicode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToAscii1 (rawObject, unicode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToJisx02011 (IntPtr raw, uint unicode);
		public uint UnicodeToJisx0201 (uint unicode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToJisx02011 (rawObject, unicode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToJisx0201Latin1 (IntPtr raw, uint unicode);
		public uint UnicodeToJisx0201Latin (uint unicode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToJisx0201Latin1 (rawObject, unicode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToJisx0201Kana1 (IntPtr raw, uint unicode);
		public uint UnicodeToJisx0201Kana (uint unicode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToJisx0201Kana1 (rawObject, unicode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToJisx02081 (IntPtr raw, uint unicode);
		public uint UnicodeToJisx0208 (uint unicode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToJisx02081 (rawObject, unicode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToJisx02121 (IntPtr raw, uint unicode);
		public uint UnicodeToJisx0212 (uint unicode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToJisx02121 (rawObject, unicode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_sjisToUnicode (IntPtr raw, uint h, uint l);
		public uint SjisToUnicode (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_sjisToUnicode (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToSjis (IntPtr raw, uint h, uint l);
		public uint UnicodeToSjis (uint h, uint l)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToSjis (rawObject, h, l);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_sjisToUnicode1 (IntPtr raw, uint sjis);
		public uint SjisToUnicode (uint sjis)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_sjisToUnicode1 (rawObject, sjis);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QJpUnicodeConv_unicodeToSjis1 (IntPtr raw, uint unicode);
		public uint UnicodeToSjis (uint unicode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QJpUnicodeConv_unicodeToSjis1 (rawObject, unicode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QJpUnicodeConv_newConverter (int rule);
		public static QJpUnicodeConv NewConverter (int rule)
		{
			return LookupObject (qt_QJpUnicodeConv_newConverter (rule), typeof (QJpUnicodeConv)) as QJpUnicodeConv;

		}
	}
}