// QLCDNumber.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QLCDNumber : QFrame, IDisposable {

		public enum Mode {
			Hex = 0,
			Dec = 1,
			Oct = 2,
			Bin = 3,
			HEX = Hex,
			DEC = Dec,
			OCT = Oct,
			BIN = Bin
		}

		public enum SegmentStyle {
			Outline = 0,
			Filled = 1,
			Flat = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QLCDNumber (IntPtr parent, string name);
		public QLCDNumber (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QLCDNumber (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QLCDNumber1 (uint numDigits, IntPtr parent, string name);
		public QLCDNumber (uint numDigits, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QLCDNumber1 (numDigits, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QLCDNumber () : this (new QWidget ()) {}

		public QLCDNumber (QWidget parent) : this (parent, "") {}

		public QLCDNumber (uint numDigits) : this (numDigits, new QWidget ()) {}

		public QLCDNumber (uint numDigits, QWidget parent) : this (numDigits, parent, "") {}

		public QLCDNumber (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QLCDNumber (QNull dummy) : base (QNull.Instance) {}

		~QLCDNumber ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QLCDNumber (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QLCDNumber (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLCDNumber_smallDecimalPoint (IntPtr raw);
		public bool SmallDecimalPoint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLCDNumber_smallDecimalPoint (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QLCDNumber_numDigits (IntPtr raw);
		public int NumDigits ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLCDNumber_numDigits (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLCDNumber_setNumDigits (IntPtr raw, int nDigits);
		public void SetNumDigits (int nDigits)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLCDNumber_setNumDigits (rawObject, nDigits);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLCDNumber_checkOverflow (IntPtr raw, double num);
		public bool CheckOverflow (double num)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLCDNumber_checkOverflow (rawObject, num);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLCDNumber_checkOverflow1 (IntPtr raw, int num);
		public bool CheckOverflow (int num)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLCDNumber_checkOverflow1 (rawObject, num);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Mode qt_QLCDNumber_mode (IntPtr raw);
		public Mode TheMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLCDNumber_mode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLCDNumber_setMode (IntPtr raw, Mode arg1);
		public void SetMode (Mode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLCDNumber_setMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QLCDNumber.SegmentStyle qt_QLCDNumber_segmentStyle (IntPtr raw);
		public QLCDNumber.SegmentStyle TheSegmentStyle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLCDNumber_segmentStyle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLCDNumber_setSegmentStyle (IntPtr raw, QLCDNumber.SegmentStyle arg1);
		public void SetSegmentStyle (QLCDNumber.SegmentStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLCDNumber_setSegmentStyle (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QLCDNumber_value (IntPtr raw);
		public double Value ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLCDNumber_value (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QLCDNumber_intValue (IntPtr raw);
		public int IntValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLCDNumber_intValue (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QLCDNumber_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QLCDNumber_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLCDNumber_display1 (IntPtr raw, int num);
		public void Display (int num)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLCDNumber_display1 (rawObject, num);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLCDNumber_display (IntPtr raw, IntPtr str);
		public void Display (string str)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLCDNumber_display (rawObject, new QString (str).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLCDNumber_display2 (IntPtr raw, double num);
		public void Display (double num)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLCDNumber_display2 (rawObject, num);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLCDNumber_setHexMode (IntPtr raw);
		public void SetHexMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLCDNumber_setHexMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLCDNumber_setDecMode (IntPtr raw);
		public void SetDecMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLCDNumber_setDecMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLCDNumber_setOctMode (IntPtr raw);
		public void SetOctMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLCDNumber_setOctMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLCDNumber_setBinMode (IntPtr raw);
		public void SetBinMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLCDNumber_setBinMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLCDNumber_setSmallDecimalPoint (IntPtr raw, bool arg1);
		public void SetSmallDecimalPoint (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLCDNumber_setSmallDecimalPoint (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLCDNumber_drawContents (IntPtr raw, IntPtr arg1);
		protected void DrawContents (QPainter arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLCDNumber_drawContents (rawObject, arg1.RawObject);
		}

		// Begin interface methods.

	}
}