// QLineEdit.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QLineEdit : QFrame, IDisposable {

		public enum EchoMode {
			Normal = 0,
			NoEcho = 1,
			Password = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QLineEdit (IntPtr parent, string name);
		public QLineEdit (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QLineEdit (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QLineEdit1 (IntPtr arg1, IntPtr parent, string name);
		public QLineEdit (string arg1, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QLineEdit1 (new QString (arg1).RawObject, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QLineEdit (QWidget parent) : this (parent, "") {}

		public QLineEdit (string arg1, QWidget parent) : this (arg1, parent, "") {}

		internal QLineEdit () : this (QNull.Instance) {}

		public QLineEdit (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QLineEdit (QNull dummy) : base (QNull.Instance) {}

		~QLineEdit ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QLineEdit (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QLineEdit (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QLineEdit_text (IntPtr raw);
		public string Text ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QLineEdit_text (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QLineEdit_displayText (IntPtr raw);
		public string DisplayText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QLineEdit_displayText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QLineEdit_maxLength (IntPtr raw);
		public int MaxLength ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_maxLength (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLineEdit_frame (IntPtr raw);
		public bool Frame ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_frame (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern EchoMode qt_QLineEdit_echoMode (IntPtr raw);
		public EchoMode TheEchoMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_echoMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLineEdit_isReadOnly (IntPtr raw);
		public bool IsReadOnly ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_isReadOnly (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QLineEdit_validator (IntPtr raw);
		public QValidator Validator ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QLineEdit_validator (rawObject), typeof (QValidator)) as QValidator;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QLineEdit_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QLineEdit_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QLineEdit_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QLineEdit_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QLineEdit_cursorPosition (IntPtr raw);
		public int CursorPosition ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_cursorPosition (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLineEdit_validateAndSet (IntPtr raw, IntPtr arg1, int arg2, int arg3, int arg4);
		public bool ValidateAndSet (string arg1, int arg2, int arg3, int arg4)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_validateAndSet (rawObject, new QString (arg1).RawObject, arg2, arg3, arg4);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QLineEdit_alignment (IntPtr raw);
		public int Alignment ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_alignment (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_cursorLeft (IntPtr raw, bool mark, int steps);
		public void CursorLeft (bool mark, int steps)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_cursorLeft (rawObject, mark, steps);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_cursorRight (IntPtr raw, bool mark, int steps);
		public void CursorRight (bool mark, int steps)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_cursorRight (rawObject, mark, steps);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_cursorForward (IntPtr raw, bool mark, int steps);
		public void CursorForward (bool mark, int steps)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_cursorForward (rawObject, mark, steps);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_cursorBackward (IntPtr raw, bool mark, int steps);
		public void CursorBackward (bool mark, int steps)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_cursorBackward (rawObject, mark, steps);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_cursorWordForward (IntPtr raw, bool mark);
		public void CursorWordForward (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_cursorWordForward (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_cursorWordBackward (IntPtr raw, bool mark);
		public void CursorWordBackward (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_cursorWordBackward (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_backspace (IntPtr raw);
		public void Backspace ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_backspace (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_del (IntPtr raw);
		public void Del ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_del (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_home (IntPtr raw, bool mark);
		public void Home (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_home (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_end (IntPtr raw, bool mark);
		public void End (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_end (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setEdited (IntPtr raw, bool arg1);
		public void SetEdited (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setEdited (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLineEdit_edited (IntPtr raw);
		public bool Edited ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_edited (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLineEdit_hasSelectedText (IntPtr raw);
		public bool HasSelectedText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_hasSelectedText (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QLineEdit_selectedText (IntPtr raw);
		public string SelectedText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QLineEdit_selectedText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLineEdit_getSelection (IntPtr raw, int[] start, int[] end);
		public bool GetSelection (int[] start, int[] end)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_getSelection (rawObject, start, end);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLineEdit_isUndoAvailable (IntPtr raw);
		public bool IsUndoAvailable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_isUndoAvailable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLineEdit_isRedoAvailable (IntPtr raw);
		public bool IsRedoAvailable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_isRedoAvailable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLineEdit_hasMarkedText (IntPtr raw);
		public bool HasMarkedText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_hasMarkedText (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QLineEdit_markedText (IntPtr raw);
		public string MarkedText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QLineEdit_markedText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setPasswordChar (IntPtr raw, IntPtr c);
		public void SetPasswordChar (QChar c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setPasswordChar (rawObject, c.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QLineEdit_passwordChar (IntPtr raw);
		public QChar PasswordChar ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QLineEdit_passwordChar (rawObject), typeof (QChar)) as QChar;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLineEdit_dragEnabled (IntPtr raw);
		public bool DragEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_dragEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QLineEdit_characterAt (IntPtr raw, int xpos, IntPtr chr);
		public int CharacterAt (int xpos, QChar chr)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_characterAt (rawObject, xpos, chr.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setText (IntPtr raw, IntPtr arg1);
		public void SetText (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setText (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_selectAll (IntPtr raw);
		public void SelectAll ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_selectAll (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_deselect (IntPtr raw);
		public void Deselect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_deselect (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_clearValidator (IntPtr raw);
		public void ClearValidator ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_clearValidator (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_insert (IntPtr raw, IntPtr arg1);
		public void Insert (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_insert (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_undo (IntPtr raw);
		public void Undo ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_undo (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_redo (IntPtr raw);
		public void Redo ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_redo (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setMaxLength (IntPtr raw, int arg1);
		public void SetMaxLength (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setMaxLength (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setFrame (IntPtr raw, bool arg1);
		public void SetFrame (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setFrame (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setEchoMode (IntPtr raw, EchoMode arg1);
		public void SetEchoMode (EchoMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setEchoMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setReadOnly (IntPtr raw, bool arg1);
		public void SetReadOnly (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setReadOnly (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setValidator (IntPtr raw, IntPtr arg1);
		public void SetValidator (QValidator arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setValidator (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setFont (IntPtr raw, IntPtr arg1);
		public void SetFont (QFont arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setFont (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setPalette (IntPtr raw, IntPtr arg1);
		public void SetPalette (QPalette arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setPalette (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setSelection (IntPtr raw, int arg1, int arg2);
		public void SetSelection (int arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setSelection (rawObject, arg1, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setCursorPosition (IntPtr raw, int arg1);
		public void SetCursorPosition (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setCursorPosition (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setAlignment (IntPtr raw, int flag);
		public void SetAlignment (int flag)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setAlignment (rawObject, flag);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_cut (IntPtr raw);
		public void Cut ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_cut (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_copy (IntPtr raw);
		public void Copy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_copy (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_paste (IntPtr raw);
		public void Paste ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_paste (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_setDragEnabled (IntPtr raw, bool b);
		public void SetDragEnabled (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_setDragEnabled (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QLineEdit_event (IntPtr raw, IntPtr arg1);
		protected bool Q_event (QEvent arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QLineEdit_event (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_drawContents (IntPtr raw, IntPtr painter);
		protected void DrawContents (QPainter painter)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_drawContents (rawObject, painter.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_repaintArea (IntPtr raw, int arg1, int arg2);
		protected void RepaintArea (int arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_repaintArea (rawObject, arg1, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QLineEdit_createPopupMenu (IntPtr raw);
		protected QPopupMenu CreatePopupMenu ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QLineEdit_createPopupMenu (rawObject), typeof (QPopupMenu)) as QPopupMenu;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QLineEdit_windowActivationChange (IntPtr raw, bool arg1);
		protected void WindowActivationChange (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QLineEdit_windowActivationChange (rawObject, arg1);
		}

		public void CursorLeft (bool mark)
		{
			CursorLeft(mark, (int) 1);
		}

		public void CursorRight (bool mark)
		{
			CursorRight(mark, (int) 1);
		}

		public void CursorForward (bool mark)
		{
			CursorForward(mark, (int) 1);
		}

		public void CursorBackward (bool mark)
		{
			CursorBackward(mark, (int) 1);
		}

		// Begin interface methods.

	}
}