// QListBox.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QListBox : QScrollView, IDisposable {

		public enum SelectionMode {
			Single = 0,
			Multi = 1,
			Extended = 2,
			NoSelection = 3
		}

		public enum LayoutMode {
			FixedNumber = 0,
			FitToWidth = 1,
			FitToHeight = FitToWidth,
			Variable = 3
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QListBox (IntPtr parent, string name, Qt.WidgetFlags f);
		public QListBox (QWidget parent, string name, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QListBox (parent != null ? parent.RawObject : IntPtr.Zero, name, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QListBox () : this (new QWidget ()) {}

		public QListBox (QWidget parent) : this (parent, "") {}

		public QListBox (QWidget parent, string name) : this (parent, name, Qt.WidgetFlags.WWinOwnDC) {}

		public QListBox (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QListBox (QNull dummy) : base (QNull.Instance) {}

		~QListBox ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QListBox (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QListBox (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setFont (IntPtr raw, IntPtr arg1);
		public void SetFont (QFont arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setFont (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QListBox_count (IntPtr raw);
		public uint Count ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_count (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_insertStringList (IntPtr raw, IntPtr arg1, int index);
		public void InsertStringList (QStringList arg1, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_insertStringList (rawObject, arg1.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_insertStrList (IntPtr raw, IntPtr arg1, int index);
		public void InsertStrList (QStrList arg1, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_insertStrList (rawObject, arg1.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_insertStrList2 (IntPtr raw, string[] arg1, int numStrings, int index);
		public void InsertStrList (string[] arg1, int numStrings, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_insertStrList2 (rawObject, arg1, numStrings, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_insertItem (IntPtr raw, IntPtr arg1, int index);
		public void InsertItem (QListBoxItem arg1, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_insertItem (rawObject, arg1.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_insertItem1 (IntPtr raw, IntPtr arg1, IntPtr after);
		public void InsertItem (QListBoxItem arg1, QListBoxItem after)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_insertItem1 (rawObject, arg1.RawObject, after.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_insertItem2 (IntPtr raw, IntPtr text, int index);
		public void InsertItem (string text, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_insertItem2 (rawObject, new QString (text).RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_insertItem3 (IntPtr raw, IntPtr pixmap, int index);
		public void InsertItem (QPixmap pixmap, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_insertItem3 (rawObject, pixmap.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_insertItem4 (IntPtr raw, IntPtr pixmap, IntPtr text, int index);
		public void InsertItem (QPixmap pixmap, string text, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_insertItem4 (rawObject, pixmap.RawObject, new QString (text).RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_removeItem (IntPtr raw, int index);
		public void RemoveItem (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_removeItem (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListBox_text (IntPtr raw, int index);
		public string Text (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QListBox_text (rawObject, index));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListBox_pixmap (IntPtr raw, int index);
		public QPixmap Pixmap (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListBox_pixmap (rawObject, index), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_changeItem (IntPtr raw, IntPtr arg1, int index);
		public void ChangeItem (QListBoxItem arg1, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_changeItem (rawObject, arg1.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_changeItem1 (IntPtr raw, IntPtr text, int index);
		public void ChangeItem (string text, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_changeItem1 (rawObject, new QString (text).RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_changeItem2 (IntPtr raw, IntPtr pixmap, int index);
		public void ChangeItem (QPixmap pixmap, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_changeItem2 (rawObject, pixmap.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_changeItem3 (IntPtr raw, IntPtr pixmap, IntPtr text, int index);
		public void ChangeItem (QPixmap pixmap, string text, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_changeItem3 (rawObject, pixmap.RawObject, new QString (text).RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_takeItem (IntPtr raw, IntPtr arg1);
		public void TakeItem (QListBoxItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_takeItem (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_numItemsVisible (IntPtr raw);
		public int NumItemsVisible ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_numItemsVisible (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_currentItem (IntPtr raw);
		public int CurrentItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_currentItem (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListBox_currentText (IntPtr raw);
		public string CurrentText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QListBox_currentText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setCurrentItem (IntPtr raw, int index);
		public void SetCurrentItem (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setCurrentItem (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setCurrentItem1 (IntPtr raw, IntPtr arg1);
		public void SetCurrentItem (QListBoxItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setCurrentItem1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_centerCurrentItem (IntPtr raw);
		public void CenterCurrentItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_centerCurrentItem (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_topItem (IntPtr raw);
		public int TopItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_topItem (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setTopItem (IntPtr raw, int index);
		public void SetTopItem (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setTopItem (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setBottomItem (IntPtr raw, int index);
		public void SetBottomItem (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setBottomItem (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QListBox_maxItemWidth (IntPtr raw);
		public long MaxItemWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_maxItemWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setSelectionMode (IntPtr raw, SelectionMode arg1);
		public void SetSelectionMode (SelectionMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setSelectionMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern SelectionMode qt_QListBox_selectionMode (IntPtr raw);
		public SelectionMode TheSelectionMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_selectionMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setMultiSelection (IntPtr raw, bool multi);
		public void SetMultiSelection (bool multi)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setMultiSelection (rawObject, multi);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_isMultiSelection (IntPtr raw);
		public bool IsMultiSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_isMultiSelection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setSelected (IntPtr raw, IntPtr arg1, bool arg2);
		public void SetSelected (QListBoxItem arg1, bool arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setSelected (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setSelected1 (IntPtr raw, int arg1, bool arg2);
		public void SetSelected (int arg1, bool arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setSelected1 (rawObject, arg1, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_isSelected (IntPtr raw, int arg1);
		public bool IsSelected (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_isSelected (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_isSelected1 (IntPtr raw, IntPtr arg1);
		public bool IsSelected (QListBoxItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_isSelected1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListBox_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListBox_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListBox_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListBox_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListBox_item (IntPtr raw, int index);
		public QListBoxItem Item (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListBox_item (rawObject, index), typeof (QListBoxItem)) as QListBoxItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_index (IntPtr raw, IntPtr arg1);
		public int Index (QListBoxItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_index (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListBox_findItem (IntPtr raw, IntPtr text, Qt.StringComparisonMode compare);
		public QListBoxItem FindItem (string text, Qt.StringComparisonMode compare)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListBox_findItem (rawObject, new QString (text).RawObject, compare), typeof (QListBoxItem)) as QListBoxItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_triggerUpdate (IntPtr raw, bool doLayout);
		public void TriggerUpdate (bool doLayout)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_triggerUpdate (rawObject, doLayout);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_itemVisible (IntPtr raw, int index);
		public bool ItemVisible (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_itemVisible (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_itemVisible1 (IntPtr raw, IntPtr arg1);
		public bool ItemVisible (QListBoxItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_itemVisible1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setColumnMode (IntPtr raw, QListBox.LayoutMode arg1);
		public void SetColumnMode (QListBox.LayoutMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setColumnMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setColumnMode1 (IntPtr raw, int arg1);
		public void SetColumnMode (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setColumnMode1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setRowMode (IntPtr raw, QListBox.LayoutMode arg1);
		public void SetRowMode (QListBox.LayoutMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setRowMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setRowMode1 (IntPtr raw, int arg1);
		public void SetRowMode (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setRowMode1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QListBox.LayoutMode qt_QListBox_columnMode (IntPtr raw);
		public QListBox.LayoutMode ColumnMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_columnMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QListBox.LayoutMode qt_QListBox_rowMode (IntPtr raw);
		public QListBox.LayoutMode RowMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_rowMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_numColumns (IntPtr raw);
		public int NumColumns ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_numColumns (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_numRows (IntPtr raw);
		public int NumRows ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_numRows (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_variableWidth (IntPtr raw);
		public bool VariableWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_variableWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setVariableWidth (IntPtr raw, bool arg1);
		public void SetVariableWidth (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setVariableWidth (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_variableHeight (IntPtr raw);
		public bool VariableHeight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_variableHeight (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setVariableHeight (IntPtr raw, bool arg1);
		public void SetVariableHeight (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setVariableHeight (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_dragSelect (IntPtr raw);
		public bool DragSelect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_dragSelect (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setDragSelect (IntPtr raw, bool arg1);
		public void SetDragSelect (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setDragSelect (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_autoScroll (IntPtr raw);
		public bool AutoScroll ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_autoScroll (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setAutoScroll (IntPtr raw, bool arg1);
		public void SetAutoScroll (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setAutoScroll (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_autoScrollBar (IntPtr raw);
		public bool AutoScrollBar ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_autoScrollBar (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setAutoScrollBar (IntPtr raw, bool enable);
		public void SetAutoScrollBar (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setAutoScrollBar (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_scrollBar (IntPtr raw);
		public bool ScrollBar ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_scrollBar (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setScrollBar (IntPtr raw, bool enable);
		public void SetScrollBar (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setScrollBar (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_autoBottomScrollBar (IntPtr raw);
		public bool AutoBottomScrollBar ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_autoBottomScrollBar (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setAutoBottomScrollBar (IntPtr raw, bool enable);
		public void SetAutoBottomScrollBar (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setAutoBottomScrollBar (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_bottomScrollBar (IntPtr raw);
		public bool BottomScrollBar ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_bottomScrollBar (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setBottomScrollBar (IntPtr raw, bool enable);
		public void SetBottomScrollBar (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setBottomScrollBar (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_smoothScrolling (IntPtr raw);
		public bool SmoothScrolling ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_smoothScrolling (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setSmoothScrolling (IntPtr raw, bool arg1);
		public void SetSmoothScrolling (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setSmoothScrolling (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_autoUpdate (IntPtr raw);
		public bool AutoUpdate ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_autoUpdate (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setAutoUpdate (IntPtr raw, bool arg1);
		public void SetAutoUpdate (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setAutoUpdate (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_setFixedVisibleLines (IntPtr raw, int lines);
		public void SetFixedVisibleLines (int lines)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_setFixedVisibleLines (rawObject, lines);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_inSort (IntPtr raw, IntPtr arg1);
		public int InSort (QListBoxItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_inSort (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_inSort1 (IntPtr raw, IntPtr text);
		public int InSort (string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_inSort1 (rawObject, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_cellHeight (IntPtr raw, int i);
		public int CellHeight (int i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_cellHeight (rawObject, i);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_cellHeight1 (IntPtr raw);
		public int CellHeight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_cellHeight1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_cellWidth (IntPtr raw);
		public int CellWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_cellWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_cellWidth1 (IntPtr raw, int i);
		public int CellWidth (int i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_cellWidth1 (rawObject, i);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_numCols (IntPtr raw);
		public int NumCols ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_numCols (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_itemHeight (IntPtr raw, int index);
		public int ItemHeight (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_itemHeight (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListBox_itemAt (IntPtr raw, IntPtr arg1);
		public QListBoxItem ItemAt (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListBox_itemAt (rawObject, arg1.RawObject), typeof (QListBoxItem)) as QListBoxItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListBox_itemRect (IntPtr raw, IntPtr item);
		public QRect ItemRect (QListBoxItem item)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListBox_itemRect (rawObject, item.RawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListBox_firstItem (IntPtr raw);
		public QListBoxItem FirstItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListBox_firstItem (rawObject), typeof (QListBoxItem)) as QListBoxItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_sort (IntPtr raw, bool ascending);
		public void Sort (bool ascending)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_sort (rawObject, ascending);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_ensureCurrentVisible (IntPtr raw);
		public void EnsureCurrentVisible ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_ensureCurrentVisible (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_clearSelection (IntPtr raw);
		public void ClearSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_clearSelection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_selectAll (IntPtr raw, bool select);
		public void SelectAll (bool select)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_selectAll (rawObject, select);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_invertSelection (IntPtr raw);
		public void InvertSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_invertSelection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_eventFilter (IntPtr raw, IntPtr o, IntPtr e);
		protected bool EventFilter (QObject o, QEvent e)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_eventFilter (rawObject, o.RawObject, e.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_updateItem (IntPtr raw, int index);
		protected void UpdateItem (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_updateItem (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_updateItem1 (IntPtr raw, IntPtr arg1);
		protected void UpdateItem (QListBoxItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_updateItem1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_updateCellWidth (IntPtr raw);
		protected void UpdateCellWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_updateCellWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_totalWidth (IntPtr raw);
		protected int TotalWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_totalWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_totalHeight (IntPtr raw);
		protected int TotalHeight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_totalHeight (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_paintCell (IntPtr raw, IntPtr arg1, int row, int col);
		protected void PaintCell (QPainter arg1, int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_paintCell (rawObject, arg1.RawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_toggleCurrentItem (IntPtr raw);
		protected void ToggleCurrentItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_toggleCurrentItem (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_isRubberSelecting (IntPtr raw);
		protected bool IsRubberSelecting ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_isRubberSelecting (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_doLayout (IntPtr raw);
		protected void DoLayout ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_doLayout (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_windowActivationChange (IntPtr raw, bool arg1);
		protected void WindowActivationChange (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_windowActivationChange (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListBox_itemYPos (IntPtr raw, int index, int[] yPos);
		protected bool ItemYPos (int index, int[] yPos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_itemYPos (rawObject, index, yPos);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListBox_findItem1 (IntPtr raw, int yPos);
		protected int FindItem (int yPos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListBox_findItem1 (rawObject, yPos);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListBox_clearInputString (IntPtr raw);
		protected void ClearInputString ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListBox_clearInputString (rawObject);
		}

		public void InsertStringList (QStringList arg1)
		{
			InsertStringList(arg1, (int) -1);
		}

		public void InsertStrList (QStrList arg1)
		{
			InsertStrList(arg1, (int) -1);
		}

		public void InsertStrList (string[] arg1)
		{
			InsertStrList(arg1, (int) -1);
		}

		public void InsertStrList (string[] arg1, int numStrings)
		{
			InsertStrList(arg1, numStrings, (int) -1);
		}

		public void InsertItem (QListBoxItem arg1)
		{
			InsertItem(arg1, (int) -1);
		}

		public void InsertItem (string text)
		{
			InsertItem(text, (int) -1);
		}

		public void InsertItem (QPixmap pixmap)
		{
			InsertItem(pixmap, (int) -1);
		}

		public void InsertItem (QPixmap pixmap, string text)
		{
			InsertItem(pixmap, text, (int) -1);
		}

		public QListBoxItem FindItem (string text)
		{
			return FindItem(text, Qt.StringComparisonMode.BeginsWith);
		}

		public int ItemHeight ()
		{
			return ItemHeight((int) 0);
		}

		public void Sort ()
		{
			Sort(true);
		}

		// Begin interface methods.

	}
}