// QListView.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QListView : QScrollView, IDisposable {

		public enum WidthMode {
			Manual = 0,
			Maximum = 1
		}

		public enum SelectionMode {
			Single = 0,
			Multi = 1,
			Extended = 2,
			NoSelection = 3
		}

		public enum ResizeMode {
			NoColumn = 0,
			AllColumns = 1,
			LastColumn = 2
		}

		public enum RenameAction {
			Accept = 0,
			Reject = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QListView (IntPtr parent, string name, Qt.WidgetFlags f);
		public QListView (QWidget parent, string name, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QListView (parent != null ? parent.RawObject : IntPtr.Zero, name, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QListView () : this (new QWidget ()) {}

		public QListView (QWidget parent) : this (parent, "") {}

		public QListView (QWidget parent, string name) : this (parent, name, Qt.WidgetFlags.WWinOwnDC) {}

		public QListView (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QListView (QNull dummy) : base (QNull.Instance) {}

		~QListView ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QListView (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QListView (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListView_treeStepSize (IntPtr raw);
		public int TreeStepSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_treeStepSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setTreeStepSize (IntPtr raw, int arg1);
		public void SetTreeStepSize (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setTreeStepSize (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_insertItem (IntPtr raw, IntPtr arg1);
		public void InsertItem (QListViewItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_insertItem (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_takeItem (IntPtr raw, IntPtr arg1);
		public void TakeItem (QListViewItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_takeItem (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_removeItem (IntPtr raw, IntPtr item);
		public void RemoveItem (QListViewItem item)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_removeItem (rawObject, item.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListView_header (IntPtr raw);
		public QHeader Header ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListView_header (rawObject), typeof (QHeader)) as QHeader;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListView_addColumn (IntPtr raw, IntPtr label, int size);
		public int AddColumn (string label, int size)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_addColumn (rawObject, new QString (label).RawObject, size);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListView_addColumn1 (IntPtr raw, IntPtr iconset, IntPtr label, int size);
		public int AddColumn (QIconSet iconset, string label, int size)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_addColumn1 (rawObject, iconset.RawObject, new QString (label).RawObject, size);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_removeColumn (IntPtr raw, int index);
		public void RemoveColumn (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_removeColumn (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setColumnText (IntPtr raw, int column, IntPtr label);
		public void SetColumnText (int column, string label)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setColumnText (rawObject, column, new QString (label).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setColumnText1 (IntPtr raw, int column, IntPtr iconset, IntPtr label);
		public void SetColumnText (int column, QIconSet iconset, string label)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setColumnText1 (rawObject, column, iconset.RawObject, new QString (label).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListView_columnText (IntPtr raw, int column);
		public string ColumnText (int column)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QListView_columnText (rawObject, column));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setColumnWidth (IntPtr raw, int column, int width);
		public void SetColumnWidth (int column, int width)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setColumnWidth (rawObject, column, width);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListView_columnWidth (IntPtr raw, int column);
		public int ColumnWidth (int column)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_columnWidth (rawObject, column);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setColumnWidthMode (IntPtr raw, int column, QListView.WidthMode arg1);
		public void SetColumnWidthMode (int column, QListView.WidthMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setColumnWidthMode (rawObject, column, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QListView.WidthMode qt_QListView_columnWidthMode (IntPtr raw, int column);
		public QListView.WidthMode ColumnWidthMode (int column)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_columnWidthMode (rawObject, column);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListView_columns (IntPtr raw);
		public int Columns ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_columns (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setColumnAlignment (IntPtr raw, int arg1, int arg2);
		public void SetColumnAlignment (int arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setColumnAlignment (rawObject, arg1, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListView_columnAlignment (IntPtr raw, int arg1);
		public int ColumnAlignment (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_columnAlignment (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_show (IntPtr raw);
		public void Show ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_show (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListView_itemAt (IntPtr raw, IntPtr screenPos);
		public QListViewItem ItemAt (QPoint screenPos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListView_itemAt (rawObject, screenPos.RawObject), typeof (QListViewItem)) as QListViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListView_itemRect (IntPtr raw, IntPtr arg1);
		public QRect ItemRect (QListViewItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListView_itemRect (rawObject, arg1.RawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListView_itemPos (IntPtr raw, IntPtr arg1);
		public int ItemPos (QListViewItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_itemPos (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_ensureItemVisible (IntPtr raw, IntPtr arg1);
		public void EnsureItemVisible (QListViewItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_ensureItemVisible (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_repaintItem (IntPtr raw, IntPtr arg1);
		public void RepaintItem (QListViewItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_repaintItem (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setMultiSelection (IntPtr raw, bool enable);
		public void SetMultiSelection (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setMultiSelection (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListView_isMultiSelection (IntPtr raw);
		public bool IsMultiSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_isMultiSelection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setSelectionMode (IntPtr raw, SelectionMode mode);
		public void SetSelectionMode (SelectionMode mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setSelectionMode (rawObject, mode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern SelectionMode qt_QListView_selectionMode (IntPtr raw);
		public SelectionMode TheSelectionMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_selectionMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_clearSelection (IntPtr raw);
		public void ClearSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_clearSelection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setSelected (IntPtr raw, IntPtr arg1, bool arg2);
		public void SetSelected (QListViewItem arg1, bool arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setSelected (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListView_isSelected (IntPtr raw, IntPtr arg1);
		public bool IsSelected (QListViewItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_isSelected (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListView_selectedItem (IntPtr raw);
		public QListViewItem SelectedItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListView_selectedItem (rawObject), typeof (QListViewItem)) as QListViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setOpen (IntPtr raw, IntPtr arg1, bool arg2);
		public void SetOpen (QListViewItem arg1, bool arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setOpen (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListView_isOpen (IntPtr raw, IntPtr arg1);
		public bool IsOpen (QListViewItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_isOpen (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setCurrentItem (IntPtr raw, IntPtr arg1);
		public void SetCurrentItem (QListViewItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setCurrentItem (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListView_currentItem (IntPtr raw);
		public QListViewItem CurrentItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListView_currentItem (rawObject), typeof (QListViewItem)) as QListViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListView_firstChild (IntPtr raw);
		public QListViewItem FirstChild ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListView_firstChild (rawObject), typeof (QListViewItem)) as QListViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListView_lastItem (IntPtr raw);
		public QListViewItem LastItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListView_lastItem (rawObject), typeof (QListViewItem)) as QListViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListView_childCount (IntPtr raw);
		public int ChildCount ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_childCount (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setAllColumnsShowFocus (IntPtr raw, bool arg1);
		public void SetAllColumnsShowFocus (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setAllColumnsShowFocus (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListView_allColumnsShowFocus (IntPtr raw);
		public bool AllColumnsShowFocus ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_allColumnsShowFocus (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setItemMargin (IntPtr raw, int arg1);
		public void SetItemMargin (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setItemMargin (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QListView_itemMargin (IntPtr raw);
		public int ItemMargin ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_itemMargin (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setRootIsDecorated (IntPtr raw, bool arg1);
		public void SetRootIsDecorated (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setRootIsDecorated (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListView_rootIsDecorated (IntPtr raw);
		public bool RootIsDecorated ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_rootIsDecorated (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setSorting (IntPtr raw, int column, bool increasing);
		public void SetSorting (int column, bool increasing)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setSorting (rawObject, column, increasing);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_sort (IntPtr raw);
		public void Sort ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_sort (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setFont (IntPtr raw, IntPtr arg1);
		public void SetFont (QFont arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setFont (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setPalette (IntPtr raw, IntPtr arg1);
		public void SetPalette (QPalette arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setPalette (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListView_eventFilter (IntPtr raw, IntPtr o, IntPtr arg1);
		public bool EventFilter (QObject o, QEvent arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_eventFilter (rawObject, o.RawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListView_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListView_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListView_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListView_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setShowSortIndicator (IntPtr raw, bool show);
		public void SetShowSortIndicator (bool show)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setShowSortIndicator (rawObject, show);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListView_showSortIndicator (IntPtr raw);
		public bool ShowSortIndicator ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_showSortIndicator (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setShowToolTips (IntPtr raw, bool b);
		public void SetShowToolTips (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setShowToolTips (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListView_showToolTips (IntPtr raw);
		public bool ShowToolTips ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_showToolTips (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setResizeMode (IntPtr raw, ResizeMode m);
		public void SetResizeMode (ResizeMode m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setResizeMode (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ResizeMode qt_QListView_resizeMode (IntPtr raw);
		public ResizeMode TheResizeMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_resizeMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListView_findItem (IntPtr raw, IntPtr text, int column, Qt.StringComparisonMode compare);
		public QListViewItem FindItem (string text, int column, Qt.StringComparisonMode compare)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListView_findItem (rawObject, new QString (text).RawObject, column, compare), typeof (QListViewItem)) as QListViewItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setDefaultRenameAction (IntPtr raw, QListView.RenameAction a);
		public void SetDefaultRenameAction (QListView.RenameAction a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setDefaultRenameAction (rawObject, a);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QListView.RenameAction qt_QListView_defaultRenameAction (IntPtr raw);
		public QListView.RenameAction DefaultRenameAction ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_defaultRenameAction (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QListView_isRenaming (IntPtr raw);
		public bool IsRenaming ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QListView_isRenaming (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_invertSelection (IntPtr raw);
		public void InvertSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_invertSelection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_selectAll (IntPtr raw, bool select);
		public void SelectAll (bool select)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_selectAll (rawObject, select);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_triggerUpdate (IntPtr raw);
		public void TriggerUpdate ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_triggerUpdate (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_setContentsPos (IntPtr raw, int x, int y);
		public void SetContentsPos (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_setContentsPos (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QListView_dragObject (IntPtr raw);
		protected QDragObject DragObject ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QListView_dragObject (rawObject), typeof (QDragObject)) as QDragObject;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_startDrag (IntPtr raw);
		protected void StartDrag ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_startDrag (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_drawContentsOffset (IntPtr raw, IntPtr arg1, int ox, int oy, int cx, int cy, int cw, int ch);
		protected void DrawContentsOffset (QPainter arg1, int ox, int oy, int cx, int cy, int cw, int ch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_drawContentsOffset (rawObject, arg1.RawObject, ox, oy, cx, cy, cw, ch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_paintEmptyArea (IntPtr raw, IntPtr arg1, IntPtr arg2);
		protected void PaintEmptyArea (QPainter arg1, QRect arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_paintEmptyArea (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_windowActivationChange (IntPtr raw, bool arg1);
		protected void WindowActivationChange (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_windowActivationChange (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_updateContents (IntPtr raw);
		protected void UpdateContents ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_updateContents (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QListView_doAutoScroll (IntPtr raw);
		protected void DoAutoScroll ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QListView_doAutoScroll (rawObject);
		}

		public int AddColumn (string label)
		{
			return AddColumn(label, (int) -1);
		}

		public int AddColumn (QIconSet iconset, string label)
		{
			return AddColumn(iconset, label, (int) -1);
		}

		public void SetSorting (int column)
		{
			SetSorting(column, true);
		}

		public QListViewItem FindItem (string text, int column)
		{
			return FindItem(text, column, Qt.StringComparisonMode.CaseSensitive);
		}

		// Begin interface methods.

	}
}