// QMainWindow.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QMainWindow : QWidget, IDisposable {

		public enum DockWindows {
			OnlyToolBars = 0,
			NoToolBars = 1,
			AllDockWindows = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QMainWindow (IntPtr parent, string name, Qt.WidgetFlags f);
		public QMainWindow (QWidget parent, string name, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QMainWindow (parent != null ? parent.RawObject : IntPtr.Zero, name, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QMainWindow () : this (new QWidget ()) {}

		public QMainWindow (QWidget parent) : this (parent, "") {}

		public QMainWindow (QWidget parent, string name) : this (parent, name, Qt.WidgetFlags.WType_TopLevel) {}

		public QMainWindow (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QMainWindow (QNull dummy) : base (QNull.Instance) {}

		~QMainWindow ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QMainWindow (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QMainWindow (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMainWindow_menuBar (IntPtr raw);
		public QMenuBar MenuBar ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMainWindow_menuBar (rawObject), typeof (QMenuBar)) as QMenuBar;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMainWindow_statusBar (IntPtr raw);
		public QStatusBar StatusBar ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMainWindow_statusBar (rawObject), typeof (QStatusBar)) as QStatusBar;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMainWindow_toolTipGroup (IntPtr raw);
		public QToolTipGroup ToolTipGroup ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMainWindow_toolTipGroup (rawObject), typeof (QToolTipGroup)) as QToolTipGroup;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_setCentralWidget (IntPtr raw, IntPtr arg1);
		public void SetCentralWidget (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_setCentralWidget (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMainWindow_centralWidget (IntPtr raw);
		public QWidget CentralWidget ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMainWindow_centralWidget (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_setDockEnabled (IntPtr raw, Qt.Dock dock, bool enable);
		public void SetDockEnabled (Qt.Dock dock, bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_setDockEnabled (rawObject, dock, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_isDockEnabled (IntPtr raw, Qt.Dock dock);
		public bool IsDockEnabled (Qt.Dock dock)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_isDockEnabled (rawObject, dock);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_isDockEnabled1 (IntPtr raw, IntPtr area);
		public bool IsDockEnabled (QDockArea area)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_isDockEnabled1 (rawObject, area.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_setDockEnabled1 (IntPtr raw, IntPtr tb, Qt.Dock dock, bool enable);
		public void SetDockEnabled (QDockWindow tb, Qt.Dock dock, bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_setDockEnabled1 (rawObject, tb.RawObject, dock, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_isDockEnabled2 (IntPtr raw, IntPtr tb, Qt.Dock dock);
		public bool IsDockEnabled (QDockWindow tb, Qt.Dock dock)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_isDockEnabled2 (rawObject, tb.RawObject, dock);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_isDockEnabled3 (IntPtr raw, IntPtr tb, IntPtr area);
		public bool IsDockEnabled (QDockWindow tb, QDockArea area)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_isDockEnabled3 (rawObject, tb.RawObject, area.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_addDockWindow (IntPtr raw, IntPtr arg1, Qt.Dock arg2, bool newLine);
		public void AddDockWindow (QDockWindow arg1, Qt.Dock arg2, bool newLine)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_addDockWindow (rawObject, arg1.RawObject, arg2, newLine);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_addDockWindow1 (IntPtr raw, IntPtr arg1, IntPtr label, Qt.Dock arg2, bool newLine);
		public void AddDockWindow (QDockWindow arg1, string label, Qt.Dock arg2, bool newLine)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_addDockWindow1 (rawObject, arg1.RawObject, new QString (label).RawObject, arg2, newLine);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_moveDockWindow (IntPtr raw, IntPtr arg1, Qt.Dock arg2);
		public void MoveDockWindow (QDockWindow arg1, Qt.Dock arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_moveDockWindow (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_moveDockWindow1 (IntPtr raw, IntPtr arg1, Qt.Dock arg2, bool nl, int index, int extraOffset);
		public void MoveDockWindow (QDockWindow arg1, Qt.Dock arg2, bool nl, int index, int extraOffset)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_moveDockWindow1 (rawObject, arg1.RawObject, arg2, nl, index, extraOffset);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_removeDockWindow (IntPtr raw, IntPtr arg1);
		public void RemoveDockWindow (QDockWindow arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_removeDockWindow (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_show (IntPtr raw);
		public void Show ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_show (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMainWindow_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMainWindow_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMainWindow_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMainWindow_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_rightJustification (IntPtr raw);
		public bool RightJustification ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_rightJustification (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_usesBigPixmaps (IntPtr raw);
		public bool UsesBigPixmaps ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_usesBigPixmaps (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_usesTextLabel (IntPtr raw);
		public bool UsesTextLabel ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_usesTextLabel (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_dockWindowsMovable (IntPtr raw);
		public bool DockWindowsMovable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_dockWindowsMovable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_opaqueMoving (IntPtr raw);
		public bool OpaqueMoving ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_opaqueMoving (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_eventFilter (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public bool EventFilter (QObject arg1, QEvent arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_eventFilter (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_getLocation (IntPtr raw, IntPtr tb, Qt.Dock dock, int index, bool nl, int extraOffset);
		public bool GetLocation (QDockWindow tb, Qt.Dock dock, int index, bool nl, int extraOffset)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_getLocation (rawObject, tb.RawObject, dock, index, nl, extraOffset);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_lineUpDockWindows (IntPtr raw, bool keepNewLines);
		public void LineUpDockWindows (bool keepNewLines)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_lineUpDockWindows (rawObject, keepNewLines);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_isDockMenuEnabled (IntPtr raw);
		public bool IsDockMenuEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_isDockMenuEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_hasDockWindow (IntPtr raw, IntPtr dw);
		public bool HasDockWindow (QDockWindow dw)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_hasDockWindow (rawObject, dw.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_addToolBar (IntPtr raw, IntPtr arg1, Qt.Dock arg2, bool newLine);
		public void AddToolBar (QDockWindow arg1, Qt.Dock arg2, bool newLine)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_addToolBar (rawObject, arg1.RawObject, arg2, newLine);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_addToolBar1 (IntPtr raw, IntPtr arg1, IntPtr label, Qt.Dock arg2, bool newLine);
		public void AddToolBar (QDockWindow arg1, string label, Qt.Dock arg2, bool newLine)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_addToolBar1 (rawObject, arg1.RawObject, new QString (label).RawObject, arg2, newLine);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_moveToolBar (IntPtr raw, IntPtr arg1, Qt.Dock arg2);
		public void MoveToolBar (QDockWindow arg1, Qt.Dock arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_moveToolBar (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_moveToolBar1 (IntPtr raw, IntPtr arg1, Qt.Dock arg2, bool nl, int index, int extraOffset);
		public void MoveToolBar (QDockWindow arg1, Qt.Dock arg2, bool nl, int index, int extraOffset)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_moveToolBar1 (rawObject, arg1.RawObject, arg2, nl, index, extraOffset);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_removeToolBar (IntPtr raw, IntPtr arg1);
		public void RemoveToolBar (QDockWindow arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_removeToolBar (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_toolBarsMovable (IntPtr raw);
		public bool ToolBarsMovable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_toolBarsMovable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_lineUpToolBars (IntPtr raw, bool keepNewLines);
		public void LineUpToolBars (bool keepNewLines)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_lineUpToolBars (rawObject, keepNewLines);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMainWindow_dockingArea (IntPtr raw, IntPtr p);
		public QDockArea DockingArea (QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMainWindow_dockingArea (rawObject, p.RawObject), typeof (QDockArea)) as QDockArea;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMainWindow_leftDock (IntPtr raw);
		public QDockArea LeftDock ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMainWindow_leftDock (rawObject), typeof (QDockArea)) as QDockArea;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMainWindow_rightDock (IntPtr raw);
		public QDockArea RightDock ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMainWindow_rightDock (rawObject), typeof (QDockArea)) as QDockArea;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMainWindow_topDock (IntPtr raw);
		public QDockArea TopDock ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMainWindow_topDock (rawObject), typeof (QDockArea)) as QDockArea;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMainWindow_bottomDock (IntPtr raw);
		public QDockArea BottomDock ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMainWindow_bottomDock (rawObject), typeof (QDockArea)) as QDockArea;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_isCustomizable (IntPtr raw);
		public bool IsCustomizable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_isCustomizable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_appropriate (IntPtr raw, IntPtr dw);
		public bool Appropriate (QDockWindow dw)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_appropriate (rawObject, dw.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMainWindow_createDockWindowMenu (IntPtr raw, QMainWindow.DockWindows dockWindows);
		public QPopupMenu CreateDockWindowMenu (QMainWindow.DockWindows dockWindows)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMainWindow_createDockWindowMenu (rawObject, dockWindows), typeof (QPopupMenu)) as QPopupMenu;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_setRightJustification (IntPtr raw, bool arg1);
		public void SetRightJustification (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_setRightJustification (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_setUsesBigPixmaps (IntPtr raw, bool arg1);
		public void SetUsesBigPixmaps (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_setUsesBigPixmaps (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_setUsesTextLabel (IntPtr raw, bool arg1);
		public void SetUsesTextLabel (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_setUsesTextLabel (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_setDockWindowsMovable (IntPtr raw, bool arg1);
		public void SetDockWindowsMovable (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_setDockWindowsMovable (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_setOpaqueMoving (IntPtr raw, bool arg1);
		public void SetOpaqueMoving (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_setOpaqueMoving (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_setDockMenuEnabled (IntPtr raw, bool arg1);
		public void SetDockMenuEnabled (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_setDockMenuEnabled (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_whatsThis (IntPtr raw);
		public void WhatsThis ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_whatsThis (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_setAppropriate (IntPtr raw, IntPtr dw, bool a);
		public void SetAppropriate (QDockWindow dw, bool a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_setAppropriate (rawObject, dw.RawObject, a);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_customize (IntPtr raw);
		public void Customize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_customize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_setToolBarsMovable (IntPtr raw, bool arg1);
		public void SetToolBarsMovable (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_setToolBarsMovable (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_event (IntPtr raw, IntPtr arg1);
		protected bool Q_event (QEvent arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_event (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_setUpLayout (IntPtr raw);
		protected void SetUpLayout ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_setUpLayout (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMainWindow_showDockMenu (IntPtr raw, IntPtr globalPos);
		protected bool ShowDockMenu (QPoint globalPos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMainWindow_showDockMenu (rawObject, globalPos.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMainWindow_menuAboutToShow (IntPtr raw);
		protected void MenuAboutToShow ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMainWindow_menuAboutToShow (rawObject);
		}

		public void AddDockWindow (QDockWindow arg1)
		{
			AddDockWindow(arg1, Qt.Dock.DockTop);
		}

		public void AddDockWindow (QDockWindow arg1, Qt.Dock arg2)
		{
			AddDockWindow(arg1, arg2, false);
		}

		public void AddDockWindow (QDockWindow arg1, string label)
		{
			AddDockWindow(arg1, label, Qt.Dock.DockTop);
		}

		public void AddDockWindow (QDockWindow arg1, string label, Qt.Dock arg2)
		{
			AddDockWindow(arg1, label, arg2, false);
		}

		public void MoveDockWindow (QDockWindow arg1)
		{
			MoveDockWindow(arg1, Qt.Dock.DockTop);
		}

		public void MoveDockWindow (QDockWindow arg1, Qt.Dock arg2, bool nl, int index)
		{
			MoveDockWindow(arg1, arg2, nl, index, (int) -1);
		}

		public void LineUpDockWindows ()
		{
			LineUpDockWindows(false);
		}

		public void AddToolBar (QDockWindow arg1)
		{
			AddToolBar(arg1, Qt.Dock.DockTop);
		}

		public void AddToolBar (QDockWindow arg1, Qt.Dock arg2)
		{
			AddToolBar(arg1, arg2, false);
		}

		public void AddToolBar (QDockWindow arg1, string label)
		{
			AddToolBar(arg1, label, Qt.Dock.DockTop);
		}

		public void AddToolBar (QDockWindow arg1, string label, Qt.Dock arg2)
		{
			AddToolBar(arg1, label, arg2, false);
		}

		public void MoveToolBar (QDockWindow arg1)
		{
			MoveToolBar(arg1, Qt.Dock.DockTop);
		}

		public void MoveToolBar (QDockWindow arg1, Qt.Dock arg2, bool nl, int index)
		{
			MoveToolBar(arg1, arg2, nl, index, (int) -1);
		}

		public void LineUpToolBars ()
		{
			LineUpToolBars(false);
		}

		public QPopupMenu CreateDockWindowMenu ()
		{
			return CreateDockWindowMenu(QMainWindow.DockWindows.AllDockWindows);
		}

		// Begin interface methods.

	}
}