// QMessageBox.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QMessageBox : QDialog, IDisposable {

		public enum Icon {
			NoIcon = 0,
			Information = 1,
			Warning = 2,
			Critical = 3
		}

		public enum blank {
			NoButton = 0,
			Ok = 1,
			Cancel = 2,
			Yes = 3,
			No = 4,
			Abort = 5,
			Retry = 6,
			Ignore = 7,
			ButtonMask = 7,
			Default = 256,
			Escape = 512,
			FlagMask = 768
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QMessageBox (IntPtr parent, string name);
		public QMessageBox (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QMessageBox (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QMessageBox1 (IntPtr caption, IntPtr text, QMessageBox.Icon icon, int button0, int button1, int button2, IntPtr parent, string name, bool modal, Qt.WidgetFlags f);
		public QMessageBox (string caption, string text, QMessageBox.Icon icon, int button0, int button1, int button2, QWidget parent, string name, bool modal, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QMessageBox1 (new QString (caption).RawObject, new QString (text).RawObject, icon, button0, button1, button2, parent != null ? parent.RawObject : IntPtr.Zero, name, modal, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QMessageBox () : this (new QWidget ()) {}

		public QMessageBox (QWidget parent) : this (parent, "") {}

		public QMessageBox (string caption, string text, QMessageBox.Icon icon, int button0, int button1, int button2) : this (caption, text, icon, button0, button1, button2, new QWidget ()) {}

		public QMessageBox (string caption, string text, QMessageBox.Icon icon, int button0, int button1, int button2, QWidget parent) : this (caption, text, icon, button0, button1, button2, parent, "") {}

		public QMessageBox (string caption, string text, QMessageBox.Icon icon, int button0, int button1, int button2, QWidget parent, string name) : this (caption, text, icon, button0, button1, button2, parent, name, true) {}

		public QMessageBox (string caption, string text, QMessageBox.Icon icon, int button0, int button1, int button2, QWidget parent, string name, bool modal) : this (caption, text, icon, button0, button1, button2, parent, name, modal, Qt.WidgetFlags.WStyle_DialogBorder) {}

		public QMessageBox (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QMessageBox (QNull dummy) : base (QNull.Instance) {}

		~QMessageBox ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QMessageBox (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QMessageBox (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMessageBox_text (IntPtr raw);
		public string Text ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QMessageBox_text (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMessageBox_setText (IntPtr raw, IntPtr arg1);
		public void SetText (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMessageBox_setText (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMessageBox_setIcon (IntPtr raw, QMessageBox.Icon arg1);
		public void SetIcon (QMessageBox.Icon arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMessageBox_setIcon (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMessageBox_setIcon1 (IntPtr raw, IntPtr arg1);
		public void SetIcon (QPixmap arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMessageBox_setIcon1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMessageBox_iconPixmap (IntPtr raw);
		public QPixmap IconPixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMessageBox_iconPixmap (rawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMessageBox_setIconPixmap (IntPtr raw, IntPtr arg1);
		public void SetIconPixmap (QPixmap arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMessageBox_setIconPixmap (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMessageBox_buttonText (IntPtr raw, int button);
		public string ButtonText (int button)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QMessageBox_buttonText (rawObject, button));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMessageBox_setButtonText (IntPtr raw, int button, IntPtr arg1);
		public void SetButtonText (int button, string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMessageBox_setButtonText (rawObject, button, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMessageBox_adjustSize (IntPtr raw);
		public void AdjustSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMessageBox_adjustSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.TextFormat qt_QMessageBox_textFormat (IntPtr raw);
		public Qt.TextFormat TextFormat ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMessageBox_textFormat (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMessageBox_setTextFormat (IntPtr raw, Qt.TextFormat arg1);
		public void SetTextFormat (Qt.TextFormat arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMessageBox_setTextFormat (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMessageBox_information (IntPtr parent, IntPtr caption, IntPtr text, int button0, int button1, int button2);
		public static int Information (QWidget parent, string caption, string text, int button0, int button1, int button2)
		{
			return qt_QMessageBox_information (parent.RawObject, new QString (caption).RawObject, new QString (text).RawObject, button0, button1, button2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMessageBox_information1 (IntPtr parent, IntPtr caption, IntPtr text, IntPtr button0Text, IntPtr button1Text, IntPtr button2Text, int defaultButtonNumber, int escapeButtonNumber);
		public static int Information (QWidget parent, string caption, string text, string button0Text, string button1Text, string button2Text, int defaultButtonNumber, int escapeButtonNumber)
		{
			return qt_QMessageBox_information1 (parent.RawObject, new QString (caption).RawObject, new QString (text).RawObject, new QString (button0Text).RawObject, new QString (button1Text).RawObject, new QString (button2Text).RawObject, defaultButtonNumber, escapeButtonNumber);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMessageBox_warning (IntPtr parent, IntPtr caption, IntPtr text, int button0, int button1, int button2);
		public static int Warning (QWidget parent, string caption, string text, int button0, int button1, int button2)
		{
			return qt_QMessageBox_warning (parent.RawObject, new QString (caption).RawObject, new QString (text).RawObject, button0, button1, button2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMessageBox_warning1 (IntPtr parent, IntPtr caption, IntPtr text, IntPtr button0Text, IntPtr button1Text, IntPtr button2Text, int defaultButtonNumber, int escapeButtonNumber);
		public static int Warning (QWidget parent, string caption, string text, string button0Text, string button1Text, string button2Text, int defaultButtonNumber, int escapeButtonNumber)
		{
			return qt_QMessageBox_warning1 (parent.RawObject, new QString (caption).RawObject, new QString (text).RawObject, new QString (button0Text).RawObject, new QString (button1Text).RawObject, new QString (button2Text).RawObject, defaultButtonNumber, escapeButtonNumber);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMessageBox_critical (IntPtr parent, IntPtr caption, IntPtr text, int button0, int button1, int button2);
		public static int Critical (QWidget parent, string caption, string text, int button0, int button1, int button2)
		{
			return qt_QMessageBox_critical (parent.RawObject, new QString (caption).RawObject, new QString (text).RawObject, button0, button1, button2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMessageBox_critical1 (IntPtr parent, IntPtr caption, IntPtr text, IntPtr button0Text, IntPtr button1Text, IntPtr button2Text, int defaultButtonNumber, int escapeButtonNumber);
		public static int Critical (QWidget parent, string caption, string text, string button0Text, string button1Text, string button2Text, int defaultButtonNumber, int escapeButtonNumber)
		{
			return qt_QMessageBox_critical1 (parent.RawObject, new QString (caption).RawObject, new QString (text).RawObject, new QString (button0Text).RawObject, new QString (button1Text).RawObject, new QString (button2Text).RawObject, defaultButtonNumber, escapeButtonNumber);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMessageBox_about (IntPtr parent, IntPtr caption, IntPtr text);
		public static void About (QWidget parent, string caption, string text)
		{
			qt_QMessageBox_about (parent.RawObject, new QString (caption).RawObject, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMessageBox_aboutQt (IntPtr parent, IntPtr caption);
		public static void AboutQt (QWidget parent, string caption)
		{
			qt_QMessageBox_aboutQt (parent.RawObject, new QString (caption).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMessageBox_message (IntPtr caption, IntPtr text, IntPtr buttonText, IntPtr parent, string arg1);
		public static int Message (string caption, string text, string buttonText, QWidget parent, string arg1)
		{
			return qt_QMessageBox_message (new QString (caption).RawObject, new QString (text).RawObject, new QString (buttonText).RawObject, parent.RawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMessageBox_query (IntPtr caption, IntPtr text, IntPtr yesButtonText, IntPtr noButtonText, IntPtr parent, string arg1);
		public static bool Query (string caption, string text, string yesButtonText, string noButtonText, QWidget parent, string arg1)
		{
			return qt_QMessageBox_query (new QString (caption).RawObject, new QString (text).RawObject, new QString (yesButtonText).RawObject, new QString (noButtonText).RawObject, parent.RawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMessageBox_standardIcon (QMessageBox.Icon icon, Qt.GUIStyle arg1);
		public static QPixmap StandardIcon (QMessageBox.Icon icon, Qt.GUIStyle arg1)
		{
			return LookupObject (qt_QMessageBox_standardIcon (icon, arg1), typeof (QPixmap)) as QPixmap;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMessageBox_standardIcon1 (QMessageBox.Icon icon);
		public static QPixmap StandardIcon (QMessageBox.Icon icon)
		{
			return LookupObject (qt_QMessageBox_standardIcon1 (icon), typeof (QPixmap)) as QPixmap;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMessageBox_styleChanged (IntPtr raw, IntPtr arg1);
		protected void StyleChanged (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMessageBox_styleChanged (rawObject, arg1.RawObject);
		}

		public static int Information (QWidget parent, string caption, string text, int button0)
		{
			return Information(parent, caption, text, button0, (int) 0);
		}

		public static int Information (QWidget parent, string caption, string text, int button0, int button1)
		{
			return Information(parent, caption, text, button0, button1, (int) 0);
		}

		public static int Information (QWidget parent, string caption, string text)
		{
			return Information(parent, caption, text, (string) "");
		}

		public static int Information (QWidget parent, string caption, string text, string button0Text)
		{
			return Information(parent, caption, text, button0Text, (string) "");
		}

		public static int Information (QWidget parent, string caption, string text, string button0Text, string button1Text)
		{
			return Information(parent, caption, text, button0Text, button1Text, (string) "");
		}

		public static int Information (QWidget parent, string caption, string text, string button0Text, string button1Text, string button2Text)
		{
			return Information(parent, caption, text, button0Text, button1Text, button2Text, (int) 0);
		}

		public static int Information (QWidget parent, string caption, string text, string button0Text, string button1Text, string button2Text, int defaultButtonNumber)
		{
			return Information(parent, caption, text, button0Text, button1Text, button2Text, defaultButtonNumber, (int) -1);
		}

		public static int Warning (QWidget parent, string caption, string text, int button0, int button1)
		{
			return Warning(parent, caption, text, button0, button1, (int) 0);
		}

		public static int Warning (QWidget parent, string caption, string text)
		{
			return Warning(parent, caption, text, (string) "");
		}

		public static int Warning (QWidget parent, string caption, string text, string button0Text)
		{
			return Warning(parent, caption, text, button0Text, (string) "");
		}

		public static int Warning (QWidget parent, string caption, string text, string button0Text, string button1Text)
		{
			return Warning(parent, caption, text, button0Text, button1Text, (string) "");
		}

		public static int Warning (QWidget parent, string caption, string text, string button0Text, string button1Text, string button2Text)
		{
			return Warning(parent, caption, text, button0Text, button1Text, button2Text, (int) 0);
		}

		public static int Warning (QWidget parent, string caption, string text, string button0Text, string button1Text, string button2Text, int defaultButtonNumber)
		{
			return Warning(parent, caption, text, button0Text, button1Text, button2Text, defaultButtonNumber, (int) -1);
		}

		public static int Critical (QWidget parent, string caption, string text, int button0, int button1)
		{
			return Critical(parent, caption, text, button0, button1, (int) 0);
		}

		public static int Critical (QWidget parent, string caption, string text)
		{
			return Critical(parent, caption, text, (string) "");
		}

		public static int Critical (QWidget parent, string caption, string text, string button0Text)
		{
			return Critical(parent, caption, text, button0Text, (string) "");
		}

		public static int Critical (QWidget parent, string caption, string text, string button0Text, string button1Text)
		{
			return Critical(parent, caption, text, button0Text, button1Text, (string) "");
		}

		public static int Critical (QWidget parent, string caption, string text, string button0Text, string button1Text, string button2Text)
		{
			return Critical(parent, caption, text, button0Text, button1Text, button2Text, (int) 0);
		}

		public static int Critical (QWidget parent, string caption, string text, string button0Text, string button1Text, string button2Text, int defaultButtonNumber)
		{
			return Critical(parent, caption, text, button0Text, button1Text, button2Text, defaultButtonNumber, (int) -1);
		}

		public static void AboutQt (QWidget parent)
		{
			AboutQt(parent, (string) "");
		}

		public static int Message (string caption, string text)
		{
			return Message(caption, text, (string) "");
		}

		public static int Message (string caption, string text, string buttonText)
		{
			return Message(caption, text, buttonText, new QWidget ());
		}

		public static int Message (string caption, string text, string buttonText, QWidget parent)
		{
			return Message(caption, text, buttonText, parent, "");
		}

		public static bool Query (string caption, string text)
		{
			return Query(caption, text, (string) "");
		}

		public static bool Query (string caption, string text, string yesButtonText)
		{
			return Query(caption, text, yesButtonText, (string) "");
		}

		public static bool Query (string caption, string text, string yesButtonText, string noButtonText)
		{
			return Query(caption, text, yesButtonText, noButtonText, new QWidget ());
		}

		public static bool Query (string caption, string text, string yesButtonText, string noButtonText, QWidget parent)
		{
			return Query(caption, text, yesButtonText, noButtonText, parent, "");
		}

		// Begin interface methods.

	}
}