// QMetaProperty.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QMetaProperty : QtSupport, IDisposable {

		public enum Flags {
			Invalid = 0,
			Readable = 1,
			Writable = 2,
			EnumOrSet = 4,
			StdSet = 256,
			Override = 512
		}

		internal QMetaProperty () : this (QNull.Instance) {}

		public QMetaProperty (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QMetaProperty (QNull dummy) : base (QNull.Instance) {}

		~QMetaProperty ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QMetaProperty function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QMetaProperty_type (IntPtr raw);
		public string Type ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_type (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QMetaProperty_name (IntPtr raw);
		public string Name ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_name (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMetaProperty_writable (IntPtr raw);
		public bool Writable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_writable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMetaProperty_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMetaProperty_isSetType (IntPtr raw);
		public bool IsSetType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_isSetType (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMetaProperty_isEnumType (IntPtr raw);
		public bool IsEnumType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_isEnumType (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMetaProperty_enumKeys (IntPtr raw);
		public QStrList EnumKeys ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMetaProperty_enumKeys (rawObject), typeof (QStrList)) as QStrList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMetaProperty_keyToValue (IntPtr raw, string key);
		public int KeyToValue (string key)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_keyToValue (rawObject, key);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QMetaProperty_valueToKey (IntPtr raw, int value);
		public string ValueToKey (int value)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_valueToKey (rawObject, value);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMetaProperty_keysToValue (IntPtr raw, IntPtr keys);
		public int KeysToValue (QStrList keys)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_keysToValue (rawObject, keys.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMetaProperty_valueToKeys (IntPtr raw, int value);
		public QStrList ValueToKeys (int value)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMetaProperty_valueToKeys (rawObject, value), typeof (QStrList)) as QStrList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMetaProperty_designable (IntPtr raw, IntPtr arg1);
		public bool Designable (QObject arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_designable (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMetaProperty_scriptable (IntPtr raw, IntPtr arg1);
		public bool Scriptable (QObject arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_scriptable (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMetaProperty_stored (IntPtr raw, IntPtr arg1);
		public bool Stored (QObject arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_stored (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMetaProperty_reset (IntPtr raw, IntPtr arg1);
		public bool Reset (QObject arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_reset (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMetaProperty_testFlags (IntPtr raw, uint f);
		public bool TestFlags (uint f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_testFlags (rawObject, f);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMetaProperty_stdSet (IntPtr raw);
		public bool StdSet ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_stdSet (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMetaProperty_id (IntPtr raw);
		public int Id ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMetaProperty_id (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMetaProperty_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMetaProperty_clear (rawObject);
		}
	}
}