// QMovie.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QMovie : QtSupport, IDisposable {

		public enum Status {
			SourceEmpty = -2,
			UnrecognizedFormat = -1,
			Paused = 1,
			EndOfFrame = 2,
			EndOfLoop = 3,
			EndOfMovie = 4,
			SpeedChanged = 5
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QMovie ();
		public QMovie () : this (QNull.Instance)
		{
			rawObject = qt_new_QMovie ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QMovie1 (int bufsize);
		public QMovie (int bufsize) : this (QNull.Instance)
		{
			rawObject = qt_new_QMovie1 (bufsize);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QMovie2 (IntPtr arg1, int bufsize);
		public QMovie (QDataSource arg1, int bufsize) : this (QNull.Instance)
		{
			rawObject = qt_new_QMovie2 (arg1.RawObject, bufsize);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QMovie3 (IntPtr fileName, int bufsize);
		public QMovie (string fileName, int bufsize) : this (QNull.Instance)
		{
			rawObject = qt_new_QMovie3 (new QString (fileName).RawObject, bufsize);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QMovie4 (byte[] data, int bufsize);
		public QMovie (byte[] data, int bufsize) : this (QNull.Instance)
		{
			rawObject = qt_new_QMovie4 (data, bufsize);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QMovie5 (IntPtr arg1);
		public QMovie (QMovie arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QMovie5 (arg1.RawObject);
			RegisterObject (this);
		}

		public QMovie (QDataSource arg1) : this (arg1, (int) 1024) {}

		public QMovie (string fileName) : this (fileName, (int) 1024) {}

		public QMovie (byte[] data) : this (data, (int) 1024) {}

		public QMovie (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QMovie (QNull dummy) : base (QNull.Instance) {}

		~QMovie ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QMovie (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QMovie (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMovie_pushSpace (IntPtr raw);
		public int PushSpace ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMovie_pushSpace (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_pushData (IntPtr raw, string data, int length);
		public void PushData (string data, int length)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_pushData (rawObject, data, length);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMovie_backgroundColor (IntPtr raw);
		public QColor BackgroundColor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMovie_backgroundColor (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_setBackgroundColor (IntPtr raw, IntPtr arg1);
		public void SetBackgroundColor (QColor arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_setBackgroundColor (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMovie_getValidRect (IntPtr raw);
		public QRect GetValidRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMovie_getValidRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMovie_framePixmap (IntPtr raw);
		public QPixmap FramePixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMovie_framePixmap (rawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMovie_frameImage (IntPtr raw);
		public QImage FrameImage ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMovie_frameImage (rawObject), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMovie_isNull (IntPtr raw);
		public bool IsNull ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMovie_isNull (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMovie_frameNumber (IntPtr raw);
		public int FrameNumber ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMovie_frameNumber (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMovie_steps (IntPtr raw);
		public int Steps ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMovie_steps (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMovie_paused (IntPtr raw);
		public bool Paused ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMovie_paused (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMovie_finished (IntPtr raw);
		public bool Finished ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMovie_finished (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMovie_running (IntPtr raw);
		public bool Running ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMovie_running (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_unpause (IntPtr raw);
		public void Unpause ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_unpause (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_pause (IntPtr raw);
		public void Pause ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_pause (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_step (IntPtr raw);
		public void Step ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_step (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_step1 (IntPtr raw, int arg1);
		public void Step (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_step1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_restart (IntPtr raw);
		public void Restart ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_restart (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMovie_speed (IntPtr raw);
		public int Speed ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMovie_speed (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_setSpeed (IntPtr raw, int arg1);
		public void SetSpeed (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_setSpeed (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_connectResize (IntPtr raw, IntPtr receiver, string member);
		public void ConnectResize (QObject receiver, string member)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_connectResize (rawObject, receiver.RawObject, member);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_disconnectResize (IntPtr raw, IntPtr receiver, string member);
		public void DisconnectResize (QObject receiver, string member)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_disconnectResize (rawObject, receiver.RawObject, member);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_connectUpdate (IntPtr raw, IntPtr receiver, string member);
		public void ConnectUpdate (QObject receiver, string member)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_connectUpdate (rawObject, receiver.RawObject, member);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_disconnectUpdate (IntPtr raw, IntPtr receiver, string member);
		public void DisconnectUpdate (QObject receiver, string member)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_disconnectUpdate (rawObject, receiver.RawObject, member);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_setDisplayWidget (IntPtr raw, IntPtr w);
		public void SetDisplayWidget (QWidget w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_setDisplayWidget (rawObject, w.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_connectStatus (IntPtr raw, IntPtr receiver, string member);
		public void ConnectStatus (QObject receiver, string member)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_connectStatus (rawObject, receiver.RawObject, member);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMovie_disconnectStatus (IntPtr raw, IntPtr receiver, string member);
		public void DisconnectStatus (QObject receiver, string member)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMovie_disconnectStatus (rawObject, receiver.RawObject, member);
		}

		public void DisconnectResize (QObject receiver)
		{
			DisconnectResize(receiver, "");
		}

		public void DisconnectUpdate (QObject receiver)
		{
			DisconnectUpdate(receiver, "");
		}

		public void DisconnectStatus (QObject receiver)
		{
			DisconnectStatus(receiver, "");
		}
	}
}