// QMultiLineEdit.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QMultiLineEdit : QTextEdit, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QMultiLineEdit (IntPtr parent, string name);
		public QMultiLineEdit (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QMultiLineEdit (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QMultiLineEdit () : this (new QWidget ()) {}

		public QMultiLineEdit (QWidget parent) : this (parent, "") {}

		public QMultiLineEdit (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QMultiLineEdit (QNull dummy) : base (QNull.Instance) {}

		~QMultiLineEdit ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QMultiLineEdit (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QMultiLineEdit (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMultiLineEdit_textLine (IntPtr raw, int line);
		public string TextLine (int line)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QMultiLineEdit_textLine (rawObject, line));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMultiLineEdit_numLines (IntPtr raw);
		public int NumLines ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMultiLineEdit_numLines (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_insertLine (IntPtr raw, IntPtr s, int line);
		public void InsertLine (string s, int line)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_insertLine (rawObject, new QString (s).RawObject, line);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_insertAt (IntPtr raw, IntPtr s, int line, int col, bool mark);
		public void InsertAt (string s, int line, int col, bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_insertAt (rawObject, new QString (s).RawObject, line, col, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_removeLine (IntPtr raw, int line);
		public void RemoveLine (int line)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_removeLine (rawObject, line);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_setCursorPosition (IntPtr raw, int line, int col, bool mark);
		public void SetCursorPosition (int line, int col, bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_setCursorPosition (rawObject, line, col, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMultiLineEdit_atBeginning (IntPtr raw);
		public bool AtBeginning ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMultiLineEdit_atBeginning (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMultiLineEdit_atEnd (IntPtr raw);
		public bool AtEnd ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMultiLineEdit_atEnd (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_setAlignment (IntPtr raw, int flags);
		public void SetAlignment (int flags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_setAlignment (rawObject, flags);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMultiLineEdit_alignment (IntPtr raw);
		public int Alignment ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMultiLineEdit_alignment (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_setEdited (IntPtr raw, bool arg1);
		public void SetEdited (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_setEdited (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMultiLineEdit_edited (IntPtr raw);
		public bool Edited ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMultiLineEdit_edited (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMultiLineEdit_hasMarkedText (IntPtr raw);
		public bool HasMarkedText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMultiLineEdit_hasMarkedText (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMultiLineEdit_markedText (IntPtr raw);
		public string MarkedText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QMultiLineEdit_markedText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_cursorWordForward (IntPtr raw, bool mark);
		public void CursorWordForward (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_cursorWordForward (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_cursorWordBackward (IntPtr raw, bool mark);
		public void CursorWordBackward (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_cursorWordBackward (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMultiLineEdit_autoUpdate (IntPtr raw);
		public bool AutoUpdate ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMultiLineEdit_autoUpdate (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_setAutoUpdate (IntPtr raw, bool arg1);
		public void SetAutoUpdate (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_setAutoUpdate (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMultiLineEdit_totalWidth (IntPtr raw);
		public int TotalWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMultiLineEdit_totalWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMultiLineEdit_totalHeight (IntPtr raw);
		public int TotalHeight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMultiLineEdit_totalHeight (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMultiLineEdit_maxLines (IntPtr raw);
		public int MaxLines ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMultiLineEdit_maxLines (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_setMaxLines (IntPtr raw, int arg1);
		public void SetMaxLines (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_setMaxLines (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_deselect (IntPtr raw);
		public void Deselect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_deselect (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QMultiLineEdit_cursorPoint (IntPtr raw);
		protected QPoint CursorPoint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QMultiLineEdit_cursorPoint (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_insertAndMark (IntPtr raw, IntPtr arg1, bool mark);
		protected void InsertAndMark (string arg1, bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_insertAndMark (rawObject, new QString (arg1).RawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_newLine (IntPtr raw);
		protected void NewLine ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_newLine (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_killLine (IntPtr raw);
		protected void KillLine ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_killLine (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_pageUp (IntPtr raw, bool mark);
		protected void PageUp (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_pageUp (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_pageDown (IntPtr raw, bool mark);
		protected void PageDown (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_pageDown (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_cursorLeft (IntPtr raw, bool mark, bool wrap);
		protected void CursorLeft (bool mark, bool wrap)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_cursorLeft (rawObject, mark, wrap);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_cursorRight (IntPtr raw, bool mark, bool wrap);
		protected void CursorRight (bool mark, bool wrap)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_cursorRight (rawObject, mark, wrap);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_cursorUp (IntPtr raw, bool mark);
		protected void CursorUp (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_cursorUp (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_cursorDown (IntPtr raw, bool mark);
		protected void CursorDown (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_cursorDown (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_backspace (IntPtr raw);
		protected void Backspace ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_backspace (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_home (IntPtr raw, bool mark);
		protected void Home (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_home (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QMultiLineEdit_end (IntPtr raw, bool mark);
		protected void End (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QMultiLineEdit_end (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QMultiLineEdit_getMarkedRegion (IntPtr raw, int[] line1, int[] col1, int[] line2, int[] col2);
		protected bool GetMarkedRegion (int[] line1, int[] col1, int[] line2, int[] col2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMultiLineEdit_getMarkedRegion (rawObject, line1, col1, line2, col2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QMultiLineEdit_lineLength (IntPtr raw, int row);
		protected int LineLength (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QMultiLineEdit_lineLength (rawObject, row);
		}

		public void InsertLine (string s)
		{
			InsertLine(s, (int) -1);
		}

		public void InsertAt (string s, int line, int col)
		{
			InsertAt(s, line, col, false);
		}

		public void SetCursorPosition (int line, int col)
		{
			SetCursorPosition(line, col, false);
		}

		protected void PageUp ()
		{
			PageUp(false);
		}

		protected void PageDown ()
		{
			PageDown(false);
		}

		protected void CursorLeft ()
		{
			CursorLeft(false);
		}

		protected void CursorLeft (bool mark)
		{
			CursorLeft(mark, true);
		}

		protected void CursorRight ()
		{
			CursorRight(false);
		}

		protected void CursorRight (bool mark)
		{
			CursorRight(mark, true);
		}

		protected void CursorUp ()
		{
			CursorUp(false);
		}

		protected void CursorDown ()
		{
			CursorDown(false);
		}

		protected void Home ()
		{
			Home(false);
		}

		protected void End ()
		{
			End(false);
		}

		// Begin interface methods.

	}
}