// QNPInstance.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QNPInstance : QObject, IDisposable {

		public enum Reason {
			ReasonDone = 0,
			ReasonBreak = 1,
			ReasonError = 2,
			ReasonUnknown = -1
		}

		public enum InstanceMode {
			Embed = 1,
			Full = 2,
			Background = 3
		}

		public enum StreamMode {
			Normal = 1,
			Seek = 2,
			AsFile = 3,
			AsFileOnly = 4
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QNPInstance ();
		protected QNPInstance () : this (QNull.Instance)
		{
			rawObject = qt_new_QNPInstance ();
			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QNPInstance (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QNPInstance (QNull dummy) : base (QNull.Instance) {}

		~QNPInstance ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QNPInstance (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QNPInstance (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QNPInstance_argc (IntPtr raw);
		public int Argc ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNPInstance_argc (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QNPInstance_argn (IntPtr raw, int arg1);
		public string Argn (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNPInstance_argn (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QNPInstance_argv (IntPtr raw, int arg1);
		public string Argv (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNPInstance_argv (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QNPInstance_arg (IntPtr raw, string name);
		public string Arg (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNPInstance_arg (rawObject, name);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QNPInstance.InstanceMode qt_QNPInstance_mode (IntPtr raw);
		public QNPInstance.InstanceMode Mode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNPInstance_mode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QNPInstance_userAgent (IntPtr raw);
		public string UserAgent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNPInstance_userAgent (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QNPInstance_newWindow (IntPtr raw);
		public QNPWidget NewWindow ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QNPInstance_newWindow (rawObject), typeof (QNPWidget)) as QNPWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QNPInstance_widget (IntPtr raw);
		public QNPWidget Widget ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QNPInstance_widget (rawObject), typeof (QNPWidget)) as QNPWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QNPInstance_newStreamCreated (IntPtr raw, IntPtr arg1, QNPInstance.StreamMode smode);
		public bool NewStreamCreated (QNPStream arg1, QNPInstance.StreamMode smode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNPInstance_newStreamCreated (rawObject, arg1.RawObject, smode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QNPInstance_writeReady (IntPtr raw, IntPtr arg1);
		public int WriteReady (QNPStream arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNPInstance_writeReady (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QNPInstance_write (IntPtr raw, IntPtr arg1, int offset, int len, int[] buffer);
		public int Write (QNPStream arg1, int offset, int len, int[] buffer)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNPInstance_write (rawObject, arg1.RawObject, offset, len, buffer);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNPInstance_streamDestroyed (IntPtr raw, IntPtr arg1);
		public void StreamDestroyed (QNPStream arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNPInstance_streamDestroyed (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNPInstance_status (IntPtr raw, string msg);
		public void Status (string msg)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNPInstance_status (rawObject, msg);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNPInstance_getURLNotify (IntPtr raw, string url, string window, int[] data);
		public void GetURLNotify (string url, string window, int[] data)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNPInstance_getURLNotify (rawObject, url, window, data);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNPInstance_getURL (IntPtr raw, string url, string window);
		public void GetURL (string url, string window)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNPInstance_getURL (rawObject, url, window);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNPInstance_postURL (IntPtr raw, string url, string window, uint len, string buf, bool file);
		public void PostURL (string url, string window, uint len, string buf, bool file)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNPInstance_postURL (rawObject, url, window, len, buf, file);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QNPInstance_newStream (IntPtr raw, string mimetype, string window, bool as_file);
		public QNPStream NewStream (string mimetype, string window, bool as_file)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QNPInstance_newStream (rawObject, mimetype, window, as_file), typeof (QNPStream)) as QNPStream;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNPInstance_streamAsFile (IntPtr raw, IntPtr arg1, string fname);
		public void StreamAsFile (QNPStream arg1, string fname)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNPInstance_streamAsFile (rawObject, arg1.RawObject, fname);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QNPInstance_getJavaPeer (IntPtr raw);
		public int[] GetJavaPeer ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNPInstance_getJavaPeer (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNPInstance_notifyURL (IntPtr raw, string url, Reason r, int[] notifyData);
		public void NotifyURL (string url, Reason r, int[] notifyData)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNPInstance_notifyURL (rawObject, url, r, notifyData);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QNPInstance_printFullPage (IntPtr raw);
		public bool PrintFullPage ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNPInstance_printFullPage (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNPInstance_print (IntPtr raw, IntPtr arg1);
		public void Print (QPainter arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNPInstance_print (rawObject, arg1.RawObject);
		}

		public void GetURLNotify (string url)
		{
			GetURLNotify(url, "");
		}

		public void GetURLNotify (string url, string window)
		{
			GetURLNotify(url, window, new int[]{0});
		}

		public void GetURL (string url)
		{
			GetURL(url, "");
		}

		public QNPStream NewStream (string mimetype, string window)
		{
			return NewStream(mimetype, window, false);
		}

		// Begin interface methods.

	}
}