// QNetworkProtocol.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QNetworkProtocol : QObject, IDisposable {

		public enum State {
			StWaiting = 0,
			StInProgress = 1,
			StDone = 2,
			StFailed = 3,
			StStopped = 4
		}

		public enum Operation {
			OpListChildren = 1,
			OpMkDir = 2,
			OpMkdir = OpMkDir,
			OpRemove = 4,
			OpRename = 8,
			OpGet = 32,
			OpPut = 64
		}

		public enum ConnectionState {
			ConHostFound = 0,
			ConConnected = 1,
			ConClosed = 2
		}

		public enum Error {
			NoError = 0,
			ErrValid = 1,
			ErrUnknownProtocol = 2,
			ErrUnsupported = 3,
			ErrParse = 4,
			ErrLoginIncorrect = 5,
			ErrHostNotFound = 6,
			ErrListChildren = 7,
			ErrListChlidren = ErrListChildren,
			ErrMkDir = 8,
			ErrMkdir = ErrMkDir,
			ErrRemove = 9,
			ErrRename = 10,
			ErrGet = 11,
			ErrPut = 12,
			ErrFileNotExisting = 13,
			ErrPermissionDenied = 14
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QNetworkProtocol ();
		public QNetworkProtocol () : this (QNull.Instance)
		{
			rawObject = qt_new_QNetworkProtocol ();
			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QNetworkProtocol (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QNetworkProtocol (QNull dummy) : base (QNull.Instance) {}

		~QNetworkProtocol ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QNetworkProtocol (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QNetworkProtocol (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_setUrl (IntPtr raw, IntPtr u);
		public void SetUrl (QUrlOperator u)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_setUrl (rawObject, u.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_setAutoDelete (IntPtr raw, bool b, int i);
		public void SetAutoDelete (bool b, int i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_setAutoDelete (rawObject, b, i);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QNetworkProtocol_autoDelete (IntPtr raw);
		public bool AutoDelete ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNetworkProtocol_autoDelete (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QNetworkProtocol_supportedOperations (IntPtr raw);
		public int SupportedOperations ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNetworkProtocol_supportedOperations (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_addOperation (IntPtr raw, IntPtr op);
		public void AddOperation (QNetworkOperation op)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_addOperation (rawObject, op.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QNetworkProtocol_url (IntPtr raw);
		public QUrlOperator Url ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QNetworkProtocol_url (rawObject), typeof (QUrlOperator)) as QUrlOperator;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QNetworkProtocol_operationInProgress (IntPtr raw);
		public QNetworkOperation OperationInProgress ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QNetworkProtocol_operationInProgress (rawObject), typeof (QNetworkOperation)) as QNetworkOperation;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_clearOperationQueue (IntPtr raw);
		public void ClearOperationQueue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_clearOperationQueue (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_stop (IntPtr raw);
		public void Stop ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_stop (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_registerNetworkProtocol (IntPtr protocol, IntPtr protocolFactory);
		public static void RegisterNetworkProtocol (string protocol, QNetworkProtocolFactoryBase protocolFactory)
		{
			qt_QNetworkProtocol_registerNetworkProtocol (new QString (protocol).RawObject, protocolFactory.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QNetworkProtocol_getNetworkProtocol (IntPtr protocol);
		public static QNetworkProtocol GetNetworkProtocol (string protocol)
		{
			return LookupObject (qt_QNetworkProtocol_getNetworkProtocol (new QString (protocol).RawObject), typeof (QNetworkProtocol)) as QNetworkProtocol;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QNetworkProtocol_hasOnlyLocalFileSystem ();
		public static bool HasOnlyLocalFileSystem ()
		{
			return qt_QNetworkProtocol_hasOnlyLocalFileSystem ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_processOperation (IntPtr raw, IntPtr op);
		protected void ProcessOperation (QNetworkOperation op)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_processOperation (rawObject, op.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_operationListChildren (IntPtr raw, IntPtr op);
		protected void OperationListChildren (QNetworkOperation op)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_operationListChildren (rawObject, op.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_operationMkDir (IntPtr raw, IntPtr op);
		protected void OperationMkDir (QNetworkOperation op)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_operationMkDir (rawObject, op.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_operationRemove (IntPtr raw, IntPtr op);
		protected void OperationRemove (QNetworkOperation op)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_operationRemove (rawObject, op.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_operationRename (IntPtr raw, IntPtr op);
		protected void OperationRename (QNetworkOperation op)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_operationRename (rawObject, op.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_operationGet (IntPtr raw, IntPtr op);
		protected void OperationGet (QNetworkOperation op)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_operationGet (rawObject, op.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_operationPut (IntPtr raw, IntPtr op);
		protected void OperationPut (QNetworkOperation op)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_operationPut (rawObject, op.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QNetworkProtocol_operationPutChunk (IntPtr raw, IntPtr op);
		protected void OperationPutChunk (QNetworkOperation op)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QNetworkProtocol_operationPutChunk (rawObject, op.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QNetworkProtocol_checkConnection (IntPtr raw, IntPtr op);
		protected bool CheckConnection (QNetworkOperation op)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QNetworkProtocol_checkConnection (rawObject, op.RawObject);
		}

		public void SetAutoDelete (bool b)
		{
			SetAutoDelete(b, (int) 10000);
		}

		// Begin interface methods.

	}
}