// QPaintDevice.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QPaintDevice : QtSupport, IDisposable {

		public enum PDevCmd {
			PdcNOP = 0,
			PdcDrawPoint = 1,
			PdcDrawFirst = PdcDrawPoint,
			PdcMoveTo = 2,
			PdcLineTo = 3,
			PdcDrawLine = 4,
			PdcDrawRect = 5,
			PdcDrawRoundRect = 6,
			PdcDrawEllipse = 7,
			PdcDrawArc = 8,
			PdcDrawPie = 9,
			PdcDrawChord = 10,
			PdcDrawLineSegments = 11,
			PdcDrawPolyline = 12,
			PdcDrawPolygon = 13,
			PdcDrawCubicBezier = 14,
			PdcDrawText = 15,
			PdcDrawTextFormatted = 16,
			PdcDrawPixmap = 17,
			PdcDrawImage = 18,
			PdcDrawText2 = 19,
			PdcDrawText2Formatted = 20,
			PdcDrawLast = PdcDrawText2Formatted,
			PdcBegin = 30,
			PdcEnd = 31,
			PdcSave = 32,
			PdcRestore = 33,
			PdcSetdev = 34,
			PdcSetBkColor = 40,
			PdcSetBkMode = 41,
			PdcSetROP = 42,
			PdcSetBrushOrigin = 43,
			PdcSetFont = 45,
			PdcSetPen = 46,
			PdcSetBrush = 47,
			PdcSetTabStops = 48,
			PdcSetTabArray = 49,
			PdcSetUnit = 50,
			PdcSetVXform = 51,
			PdcSetWindow = 52,
			PdcSetViewport = 53,
			PdcSetWXform = 54,
			PdcSetWMatrix = 55,
			PdcSaveWMatrix = 56,
			PdcRestoreWMatrix = 57,
			PdcSetClip = 60,
			PdcSetClipRegion = 61,
			PdcReservedStart = 0,
			PdcReservedStop = 199
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPaintDevice (uint devflags);
		protected QPaintDevice (uint devflags) : this (QNull.Instance)
		{
			rawObject = qt_new_QPaintDevice (devflags);
			RegisterObject (this);
		}

		internal QPaintDevice () : this (QNull.Instance) {}

		public QPaintDevice (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QPaintDevice (QNull dummy) : base (QNull.Instance) {}

		~QPaintDevice ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QPaintDevice (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QPaintDevice (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_devType (IntPtr raw);
		public int DevType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_devType (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_isExtDev (IntPtr raw);
		public bool IsExtDev ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_isExtDev (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_paintingActive (IntPtr raw);
		public bool PaintingActive ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_paintingActive (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_setResolution (IntPtr raw, int arg1);
		public void SetResolution (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPaintDevice_setResolution (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_resolution (IntPtr raw);
		public int Resolution ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_resolution (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QPaintDevice_handle (IntPtr raw);
		public uint Handle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_handle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11RenderHandle (IntPtr raw);
		public IntPtr X11RenderHandle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11RenderHandle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11Display (IntPtr raw);
		public IntPtr X11Display ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Display (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11Screen (IntPtr raw);
		public int X11Screen ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Screen (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11Depth (IntPtr raw);
		public int X11Depth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Depth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11Cells (IntPtr raw);
		public int X11Cells ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Cells (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11Colormap (IntPtr raw);
		public IntPtr X11Colormap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Colormap (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_x11DefaultColormap (IntPtr raw);
		public bool X11DefaultColormap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11DefaultColormap (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QPaintDevice_x11Visual (IntPtr raw);
		public int[] X11Visual ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Visual (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_x11DefaultVisual (IntPtr raw);
		public bool X11DefaultVisual ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11DefaultVisual (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QPaintDevice_scanLine (IntPtr raw, int arg1);
		public string ScanLine (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_scanLine (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_bytesPerLine (IntPtr raw);
		public int BytesPerLine ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_bytesPerLine (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_graphicsContext (IntPtr raw, bool clip_children);
		public IntPtr GraphicsContext (bool clip_children)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_graphicsContext (rawObject, clip_children);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11AppDisplay ();
		public static IntPtr X11AppDisplay ()
		{
			return qt_QPaintDevice_x11AppDisplay ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppScreen ();
		public static int X11AppScreen ()
		{
			return qt_QPaintDevice_x11AppScreen ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppDepth ();
		public static int X11AppDepth ()
		{
			return qt_QPaintDevice_x11AppDepth ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppCells ();
		public static int X11AppCells ()
		{
			return qt_QPaintDevice_x11AppCells ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppDpiX ();
		public static int X11AppDpiX ()
		{
			return qt_QPaintDevice_x11AppDpiX ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppDpiY ();
		public static int X11AppDpiY ()
		{
			return qt_QPaintDevice_x11AppDpiY ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11AppColormap ();
		public static IntPtr X11AppColormap ()
		{
			return qt_QPaintDevice_x11AppColormap ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_x11AppDefaultColormap ();
		public static bool X11AppDefaultColormap ()
		{
			return qt_QPaintDevice_x11AppDefaultColormap ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QPaintDevice_x11AppVisual ();
		public static int[] X11AppVisual ()
		{
			return qt_QPaintDevice_x11AppVisual ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_x11AppDefaultVisual ();
		public static bool X11AppDefaultVisual ()
		{
			return qt_QPaintDevice_x11AppDefaultVisual ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_x11SetAppDpiX (int arg1);
		public static void X11SetAppDpiX (int arg1)
		{
			qt_QPaintDevice_x11SetAppDpiX (arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_x11SetAppDpiY (int arg1);
		public static void X11SetAppDpiY (int arg1)
		{
			qt_QPaintDevice_x11SetAppDpiY (arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_qwsDisplay ();
		public static IntPtr QwsDisplay ()
		{
			return qt_QPaintDevice_qwsDisplay ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_copyX11Data (IntPtr raw, IntPtr arg1);
		protected void CopyX11Data (IQPaintDevice arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPaintDevice_copyX11Data (rawObject, arg1.QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_cloneX11Data (IntPtr raw, IntPtr arg1);
		protected void CloneX11Data (IQPaintDevice arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPaintDevice_cloneX11Data (rawObject, arg1.QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_setX11Data (IntPtr raw, IntPtr arg1);
		protected void SetX11Data (QPaintDeviceX11Data arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPaintDevice_setX11Data (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_getX11Data (IntPtr raw, bool def);
		protected QPaintDeviceX11Data GetX11Data (bool def)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPaintDevice_getX11Data (rawObject, def), typeof (QPaintDeviceX11Data)) as QPaintDeviceX11Data;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_cmd (IntPtr raw, int arg1, IntPtr arg2, IntPtr arg3);
		protected bool Cmd (int arg1, QPainter arg2, QPDevCmdParam arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_cmd (rawObject, arg1, arg2.RawObject, arg3.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_metric (IntPtr raw, int arg1);
		protected int Metric (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_metric (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_fontMet (IntPtr raw, IntPtr arg1, int arg2, string arg3, int arg4);
		protected int FontMet (QFont arg1, int arg2, string arg3, int arg4)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_fontMet (rawObject, arg1.RawObject, arg2, arg3, arg4);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_fontInf (IntPtr raw, IntPtr arg1, int arg2);
		protected int FontInf (QFont arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_fontInf (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_macCGContext (IntPtr raw, bool clipped);
		protected IntPtr MacCGContext (bool clipped)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_macCGContext (rawObject, clipped);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_bitBlt (IntPtr dst, int dx, int dy, IntPtr src, int sx, int sy, int sw, int sh, Qt.RasterOp rop, bool ignoreMask);
		public static void BitBlt (IQPaintDevice dst, int dx, int dy, IQPaintDevice src, int sx, int sy, int sw, int sh, Qt.RasterOp rop, bool ignoreMask)
		{
			qt_QPaintDevice_bitBlt (dst.QPaintDevice (), dx, dy, src.QPaintDevice (), sx, sy, sw, sh, rop, ignoreMask);
		}

		public IntPtr GraphicsContext ()
		{
			return GraphicsContext(true);
		}

		protected QPaintDeviceX11Data GetX11Data ()
		{
			return GetX11Data(false);
		}

		protected int FontMet (QFont arg1, int arg2)
		{
			return FontMet(arg1, arg2, "");
		}

		protected int FontMet (QFont arg1, int arg2, string arg3)
		{
			return FontMet(arg1, arg2, arg3, (int) 0);
		}

		protected IntPtr MacCGContext ()
		{
			return MacCGContext(true);
		}
	}
}