// QPainter.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QPainter : QtSupport, IDisposable {

		public enum CoordinateMode {
			CoordDevice = 0,
			CoordPainter = 1
		}

		public enum TextDirection {
			Auto = 0,
			RTL = 1,
			LTR = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPainter ();
		public QPainter () : this (QNull.Instance)
		{
			rawObject = qt_new_QPainter ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPainter1 (IntPtr arg1, bool unclipped);
		public QPainter (IQPaintDevice arg1, bool unclipped) : this (QNull.Instance)
		{
			rawObject = qt_new_QPainter1 (arg1.QPaintDevice (), unclipped);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPainter2 (IntPtr arg1, IntPtr arg2, bool unclipped);
		public QPainter (IQPaintDevice arg1, QWidget arg2, bool unclipped) : this (QNull.Instance)
		{
			rawObject = qt_new_QPainter2 (arg1.QPaintDevice (), arg2.RawObject, unclipped);
			RegisterObject (this);
		}

		public QPainter (IQPaintDevice arg1) : this (arg1, false) {}

		public QPainter (IQPaintDevice arg1, QWidget arg2) : this (arg1, arg2, false) {}

		public QPainter (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QPainter (QNull dummy) : base (QNull.Instance) {}

		~QPainter ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QPainter (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QPainter (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPainter_begin (IntPtr raw, IntPtr arg1, bool unclipped);
		public bool Begin (IQPaintDevice arg1, bool unclipped)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_begin (rawObject, arg1.QPaintDevice (), unclipped);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPainter_begin1 (IntPtr raw, IntPtr arg1, IntPtr arg2, bool unclipped);
		public bool Begin (IQPaintDevice arg1, QWidget arg2, bool unclipped)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_begin1 (rawObject, arg1.QPaintDevice (), arg2.RawObject, unclipped);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPainter_end (IntPtr raw);
		public bool End ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_end (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IQPaintDevice qt_QPainter_device (IntPtr raw);
		public IQPaintDevice Device ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_device (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_internalGfx (IntPtr raw);
		public IntPtr InternalGfx ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_internalGfx (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPainter_isActive (IntPtr raw);
		public bool IsActive ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_isActive (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_flush (IntPtr raw, IntPtr region, QPainter.CoordinateMode cm);
		public void Flush (QRegion region, QPainter.CoordinateMode cm)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_flush (rawObject, region.RawObject, cm);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_flush1 (IntPtr raw);
		public void Flush ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_flush1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_save (IntPtr raw);
		public void Save ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_save (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_restore (IntPtr raw);
		public void Restore ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_restore (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_fontMetrics (IntPtr raw);
		public QFontMetrics FontMetrics ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_fontMetrics (rawObject), typeof (QFontMetrics)) as QFontMetrics;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_fontInfo (IntPtr raw);
		public QFontInfo FontInfo ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_fontInfo (rawObject), typeof (QFontInfo)) as QFontInfo;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_font (IntPtr raw);
		public QFont Font ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_font (rawObject), typeof (QFont)) as QFont;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setFont (IntPtr raw, IntPtr arg1);
		public void SetFont (QFont arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setFont (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_pen (IntPtr raw);
		public QPen Pen ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_pen (rawObject), typeof (QPen)) as QPen;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setPen (IntPtr raw, IntPtr arg1);
		public void SetPen (QPen arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setPen (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setPen1 (IntPtr raw, Qt.PenStyle arg1);
		public void SetPen (Qt.PenStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setPen1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setPen2 (IntPtr raw, IntPtr arg1);
		public void SetPen (QColor arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setPen2 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_brush (IntPtr raw);
		public QBrush Brush ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_brush (rawObject), typeof (QBrush)) as QBrush;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setBrush (IntPtr raw, IntPtr arg1);
		public void SetBrush (QBrush arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setBrush (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setBrush1 (IntPtr raw, Qt.BrushStyle arg1);
		public void SetBrush (Qt.BrushStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setBrush1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setBrush2 (IntPtr raw, IntPtr arg1);
		public void SetBrush (QColor arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setBrush2 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_pos (IntPtr raw);
		public QPoint Pos ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_pos (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_backgroundColor (IntPtr raw);
		public QColor BackgroundColor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_backgroundColor (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setBackgroundColor (IntPtr raw, IntPtr arg1);
		public void SetBackgroundColor (QColor arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setBackgroundColor (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.BGMode qt_QPainter_backgroundMode (IntPtr raw);
		public Qt.BGMode BackgroundMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_backgroundMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setBackgroundMode (IntPtr raw, Qt.BGMode arg1);
		public void SetBackgroundMode (Qt.BGMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setBackgroundMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.RasterOp qt_QPainter_rasterOp (IntPtr raw);
		public Qt.RasterOp RasterOp ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_rasterOp (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setRasterOp (IntPtr raw, Qt.RasterOp arg1);
		public void SetRasterOp (Qt.RasterOp arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setRasterOp (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_brushOrigin (IntPtr raw);
		public QPoint BrushOrigin ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_brushOrigin (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setBrushOrigin (IntPtr raw, int x, int y);
		public void SetBrushOrigin (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setBrushOrigin (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setBrushOrigin1 (IntPtr raw, IntPtr arg1);
		public void SetBrushOrigin (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setBrushOrigin1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPainter_hasViewXForm (IntPtr raw);
		public bool HasViewXForm ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_hasViewXForm (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPainter_hasWorldXForm (IntPtr raw);
		public bool HasWorldXForm ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_hasWorldXForm (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setViewXForm (IntPtr raw, bool arg1);
		public void SetViewXForm (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setViewXForm (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_window (IntPtr raw);
		public QRect Window ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_window (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setWindow (IntPtr raw, IntPtr arg1);
		public void SetWindow (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setWindow (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setWindow1 (IntPtr raw, int x, int y, int w, int h);
		public void SetWindow (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setWindow1 (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_viewport (IntPtr raw);
		public QRect Viewport ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_viewport (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setViewport (IntPtr raw, IntPtr arg1);
		public void SetViewport (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setViewport (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setViewport1 (IntPtr raw, int x, int y, int w, int h);
		public void SetViewport (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setViewport1 (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setWorldXForm (IntPtr raw, bool arg1);
		public void SetWorldXForm (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setWorldXForm (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_worldMatrix (IntPtr raw);
		public QWMatrix WorldMatrix ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_worldMatrix (rawObject), typeof (QWMatrix)) as QWMatrix;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setWorldMatrix (IntPtr raw, IntPtr arg1, bool combine);
		public void SetWorldMatrix (QWMatrix arg1, bool combine)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setWorldMatrix (rawObject, arg1.RawObject, combine);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_saveWorldMatrix (IntPtr raw);
		public void SaveWorldMatrix ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_saveWorldMatrix (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_restoreWorldMatrix (IntPtr raw);
		public void RestoreWorldMatrix ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_restoreWorldMatrix (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_scale (IntPtr raw, double sx, double sy);
		public void Scale (double sx, double sy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_scale (rawObject, sx, sy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_shear (IntPtr raw, double sh, double sv);
		public void Shear (double sh, double sv)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_shear (rawObject, sh, sv);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_rotate (IntPtr raw, double a);
		public void Rotate (double a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_rotate (rawObject, a);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_translate (IntPtr raw, double dx, double dy);
		public void Translate (double dx, double dy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_translate (rawObject, dx, dy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_resetXForm (IntPtr raw);
		public void ResetXForm ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_resetXForm (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QPainter_translationX (IntPtr raw);
		public double TranslationX ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_translationX (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QPainter_translationY (IntPtr raw);
		public double TranslationY ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_translationY (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_xForm (IntPtr raw, IntPtr arg1);
		public QPoint XForm (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_xForm (rawObject, arg1.RawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_xForm1 (IntPtr raw, IntPtr arg1);
		public QRect XForm (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_xForm1 (rawObject, arg1.RawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_xForm2 (IntPtr raw, IntPtr arg1);
		public QPointArray XForm (QPointArray arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_xForm2 (rawObject, arg1.RawObject), typeof (QPointArray)) as QPointArray;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_xForm3 (IntPtr raw, IntPtr arg1, int index, int npoints);
		public QPointArray XForm (QPointArray arg1, int index, int npoints)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_xForm3 (rawObject, arg1.RawObject, index, npoints), typeof (QPointArray)) as QPointArray;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_xFormDev (IntPtr raw, IntPtr arg1);
		public QPoint XFormDev (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_xFormDev (rawObject, arg1.RawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_xFormDev1 (IntPtr raw, IntPtr arg1);
		public QRect XFormDev (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_xFormDev1 (rawObject, arg1.RawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_xFormDev2 (IntPtr raw, IntPtr arg1);
		public QPointArray XFormDev (QPointArray arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_xFormDev2 (rawObject, arg1.RawObject), typeof (QPointArray)) as QPointArray;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_xFormDev3 (IntPtr raw, IntPtr arg1, int index, int npoints);
		public QPointArray XFormDev (QPointArray arg1, int index, int npoints)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_xFormDev3 (rawObject, arg1.RawObject, index, npoints), typeof (QPointArray)) as QPointArray;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setClipping (IntPtr raw, bool arg1);
		public void SetClipping (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setClipping (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPainter_hasClipping (IntPtr raw);
		public bool HasClipping ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_hasClipping (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_clipRegion (IntPtr raw, QPainter.CoordinateMode arg1);
		public QRegion ClipRegion (QPainter.CoordinateMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_clipRegion (rawObject, arg1), typeof (QRegion)) as QRegion;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setClipRect (IntPtr raw, IntPtr arg1, QPainter.CoordinateMode arg2);
		public void SetClipRect (QRect arg1, QPainter.CoordinateMode arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setClipRect (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setClipRect1 (IntPtr raw, int x, int y, int w, int h, QPainter.CoordinateMode arg1);
		public void SetClipRect (int x, int y, int w, int h, QPainter.CoordinateMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setClipRect1 (rawObject, x, y, w, h, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setClipRegion (IntPtr raw, IntPtr arg1, QPainter.CoordinateMode arg2);
		public void SetClipRegion (QRegion arg1, QPainter.CoordinateMode arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setClipRegion (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPoint (IntPtr raw, int x, int y);
		public void DrawPoint (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPoint (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPoint1 (IntPtr raw, IntPtr arg1);
		public void DrawPoint (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPoint1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPoints (IntPtr raw, IntPtr a, int index, int npoints);
		public void DrawPoints (QPointArray a, int index, int npoints)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPoints (rawObject, a.RawObject, index, npoints);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_moveTo (IntPtr raw, int x, int y);
		public void MoveTo (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_moveTo (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_moveTo1 (IntPtr raw, IntPtr arg1);
		public void MoveTo (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_moveTo1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_lineTo (IntPtr raw, int x, int y);
		public void LineTo (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_lineTo (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_lineTo1 (IntPtr raw, IntPtr arg1);
		public void LineTo (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_lineTo1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawLine (IntPtr raw, int x1, int y1, int x2, int y2);
		public void DrawLine (int x1, int y1, int x2, int y2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawLine (rawObject, x1, y1, x2, y2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawLine1 (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public void DrawLine (QPoint arg1, QPoint arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawLine1 (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawRect (IntPtr raw, int x, int y, int w, int h);
		public void DrawRect (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawRect (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawRect1 (IntPtr raw, IntPtr arg1);
		public void DrawRect (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawRect1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawWinFocusRect (IntPtr raw, int x, int y, int w, int h);
		public void DrawWinFocusRect (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawWinFocusRect (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawWinFocusRect1 (IntPtr raw, int x, int y, int w, int h, IntPtr bgColor);
		public void DrawWinFocusRect (int x, int y, int w, int h, QColor bgColor)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawWinFocusRect1 (rawObject, x, y, w, h, bgColor.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawWinFocusRect2 (IntPtr raw, IntPtr arg1);
		public void DrawWinFocusRect (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawWinFocusRect2 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawWinFocusRect3 (IntPtr raw, IntPtr arg1, IntPtr bgColor);
		public void DrawWinFocusRect (QRect arg1, QColor bgColor)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawWinFocusRect3 (rawObject, arg1.RawObject, bgColor.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawRoundRect (IntPtr raw, int x, int y, int w, int h, int arg1, int arg2);
		public void DrawRoundRect (int x, int y, int w, int h, int arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawRoundRect (rawObject, x, y, w, h, arg1, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawRoundRect1 (IntPtr raw, IntPtr arg1, int arg2, int arg3);
		public void DrawRoundRect (QRect arg1, int arg2, int arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawRoundRect1 (rawObject, arg1.RawObject, arg2, arg3);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawEllipse (IntPtr raw, int x, int y, int w, int h);
		public void DrawEllipse (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawEllipse (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawEllipse1 (IntPtr raw, IntPtr arg1);
		public void DrawEllipse (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawEllipse1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawArc (IntPtr raw, int x, int y, int w, int h, int a, int alen);
		public void DrawArc (int x, int y, int w, int h, int a, int alen)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawArc (rawObject, x, y, w, h, a, alen);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawArc1 (IntPtr raw, IntPtr arg1, int a, int alen);
		public void DrawArc (QRect arg1, int a, int alen)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawArc1 (rawObject, arg1.RawObject, a, alen);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPie (IntPtr raw, int x, int y, int w, int h, int a, int alen);
		public void DrawPie (int x, int y, int w, int h, int a, int alen)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPie (rawObject, x, y, w, h, a, alen);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPie1 (IntPtr raw, IntPtr arg1, int a, int alen);
		public void DrawPie (QRect arg1, int a, int alen)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPie1 (rawObject, arg1.RawObject, a, alen);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawChord (IntPtr raw, int x, int y, int w, int h, int a, int alen);
		public void DrawChord (int x, int y, int w, int h, int a, int alen)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawChord (rawObject, x, y, w, h, a, alen);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawChord1 (IntPtr raw, IntPtr arg1, int a, int alen);
		public void DrawChord (QRect arg1, int a, int alen)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawChord1 (rawObject, arg1.RawObject, a, alen);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawLineSegments (IntPtr raw, IntPtr arg1, int index, int nlines);
		public void DrawLineSegments (QPointArray arg1, int index, int nlines)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawLineSegments (rawObject, arg1.RawObject, index, nlines);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPolyline (IntPtr raw, IntPtr arg1, int index, int npoints);
		public void DrawPolyline (QPointArray arg1, int index, int npoints)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPolyline (rawObject, arg1.RawObject, index, npoints);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPolygon (IntPtr raw, IntPtr arg1, bool winding, int index, int npoints);
		public void DrawPolygon (QPointArray arg1, bool winding, int index, int npoints)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPolygon (rawObject, arg1.RawObject, winding, index, npoints);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawConvexPolygon (IntPtr raw, IntPtr arg1, int index, int npoints);
		public void DrawConvexPolygon (QPointArray arg1, int index, int npoints)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawConvexPolygon (rawObject, arg1.RawObject, index, npoints);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawCubicBezier (IntPtr raw, IntPtr arg1, int index);
		public void DrawCubicBezier (QPointArray arg1, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawCubicBezier (rawObject, arg1.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPixmap (IntPtr raw, int x, int y, IntPtr arg1, int sx, int sy, int sw, int sh);
		public void DrawPixmap (int x, int y, QPixmap arg1, int sx, int sy, int sw, int sh)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPixmap (rawObject, x, y, arg1.RawObject, sx, sy, sw, sh);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPixmap1 (IntPtr raw, IntPtr arg1, IntPtr arg2, IntPtr sr);
		public void DrawPixmap (QPoint arg1, QPixmap arg2, QRect sr)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPixmap1 (rawObject, arg1.RawObject, arg2.RawObject, sr.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPixmap2 (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public void DrawPixmap (QPoint arg1, QPixmap arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPixmap2 (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPixmap3 (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public void DrawPixmap (QRect arg1, QPixmap arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPixmap3 (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawImage (IntPtr raw, int x, int y, IntPtr arg1, int sx, int sy, int sw, int sh, int conversionFlags);
		public void DrawImage (int x, int y, QImage arg1, int sx, int sy, int sw, int sh, int conversionFlags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawImage (rawObject, x, y, arg1.RawObject, sx, sy, sw, sh, conversionFlags);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawImage1 (IntPtr raw, IntPtr arg1, IntPtr arg2, IntPtr sr, int conversionFlags);
		public void DrawImage (QPoint arg1, QImage arg2, QRect sr, int conversionFlags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawImage1 (rawObject, arg1.RawObject, arg2.RawObject, sr.RawObject, conversionFlags);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawImage2 (IntPtr raw, IntPtr arg1, IntPtr arg2, int conversion_flags);
		public void DrawImage (QPoint arg1, QImage arg2, int conversion_flags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawImage2 (rawObject, arg1.RawObject, arg2.RawObject, conversion_flags);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawImage3 (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public void DrawImage (QRect arg1, QImage arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawImage3 (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawTiledPixmap (IntPtr raw, int x, int y, int w, int h, IntPtr arg1, int sx, int sy);
		public void DrawTiledPixmap (int x, int y, int w, int h, QPixmap arg1, int sx, int sy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawTiledPixmap (rawObject, x, y, w, h, arg1.RawObject, sx, sy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawTiledPixmap1 (IntPtr raw, IntPtr arg1, IntPtr arg2, IntPtr arg3);
		public void DrawTiledPixmap (QRect arg1, QPixmap arg2, QPoint arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawTiledPixmap1 (rawObject, arg1.RawObject, arg2.RawObject, arg3.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawTiledPixmap2 (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public void DrawTiledPixmap (QRect arg1, QPixmap arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawTiledPixmap2 (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPicture (IntPtr raw, IntPtr arg1);
		public void DrawPicture (QPicture arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPicture (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPicture1 (IntPtr raw, int x, int y, IntPtr arg1);
		public void DrawPicture (int x, int y, QPicture arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPicture1 (rawObject, x, y, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawPicture2 (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public void DrawPicture (QPoint arg1, QPicture arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawPicture2 (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_fillRect (IntPtr raw, int x, int y, int w, int h, IntPtr arg1);
		public void FillRect (int x, int y, int w, int h, QBrush arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_fillRect (rawObject, x, y, w, h, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_fillRect1 (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public void FillRect (QRect arg1, QBrush arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_fillRect1 (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_eraseRect (IntPtr raw, int x, int y, int w, int h);
		public void EraseRect (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_eraseRect (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_eraseRect1 (IntPtr raw, IntPtr arg1);
		public void EraseRect (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_eraseRect1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawText (IntPtr raw, int x, int y, IntPtr arg1, int len, QPainter.TextDirection dir);
		public void DrawText (int x, int y, string arg1, int len, QPainter.TextDirection dir)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawText (rawObject, x, y, new QString (arg1).RawObject, len, dir);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawText1 (IntPtr raw, IntPtr arg1, IntPtr arg2, int len, QPainter.TextDirection dir);
		public void DrawText (QPoint arg1, string arg2, int len, QPainter.TextDirection dir)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawText1 (rawObject, arg1.RawObject, new QString (arg2).RawObject, len, dir);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawText2 (IntPtr raw, int x, int y, IntPtr arg1, int pos, int len, QPainter.TextDirection dir);
		public void DrawText (int x, int y, string arg1, int pos, int len, QPainter.TextDirection dir)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawText2 (rawObject, x, y, new QString (arg1).RawObject, pos, len, dir);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawText3 (IntPtr raw, IntPtr p, IntPtr arg1, int pos, int len, QPainter.TextDirection dir);
		public void DrawText (QPoint p, string arg1, int pos, int len, QPainter.TextDirection dir)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawText3 (rawObject, p.RawObject, new QString (arg1).RawObject, pos, len, dir);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawText4 (IntPtr raw, int x, int y, int w, int h, int flags, IntPtr arg1, int len, IntPtr br, IntPtr intern);
		public void DrawText (int x, int y, int w, int h, int flags, string arg1, int len, QRect br, IntPtr intern)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawText4 (rawObject, x, y, w, h, flags, new QString (arg1).RawObject, len, br.RawObject, intern);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_drawText5 (IntPtr raw, IntPtr arg1, int flags, IntPtr arg2, int len, IntPtr br, IntPtr intern);
		public void DrawText (QRect arg1, int flags, string arg2, int len, QRect br, IntPtr intern)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_drawText5 (rawObject, arg1.RawObject, flags, new QString (arg2).RawObject, len, br.RawObject, intern);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_boundingRect (IntPtr raw, int x, int y, int w, int h, int flags, IntPtr arg1, int len, IntPtr intern);
		public QRect BoundingRect (int x, int y, int w, int h, int flags, string arg1, int len, IntPtr intern)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_boundingRect (rawObject, x, y, w, h, flags, new QString (arg1).RawObject, len, intern), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPainter_boundingRect1 (IntPtr raw, IntPtr arg1, int flags, IntPtr arg2, int len, IntPtr intern);
		public QRect BoundingRect (QRect arg1, int flags, string arg2, int len, IntPtr intern)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPainter_boundingRect1 (rawObject, arg1.RawObject, flags, new QString (arg2).RawObject, len, intern), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPainter_tabStops (IntPtr raw);
		public int TabStops ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_tabStops (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setTabStops (IntPtr raw, int arg1);
		public void SetTabStops (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setTabStops (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QPainter_tabArray (IntPtr raw);
		public int[] TabArray ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_tabArray (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_setTabArray (IntPtr raw, int[] arg1);
		public void SetTabArray (int[] arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_setTabArray (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QPainter_handle (IntPtr raw);
		public uint Handle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPainter_handle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_redirect (IntPtr pdev, IntPtr replacement);
		public static void Redirect (IQPaintDevice pdev, IQPaintDevice replacement)
		{
			qt_QPainter_redirect (pdev.QPaintDevice (), replacement.QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_initialize ();
		public static void Initialize ()
		{
			qt_QPainter_initialize ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_cleanup ();
		public static void Cleanup ()
		{
			qt_QPainter_cleanup ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPainter_initPaintDevice (IntPtr raw, bool force);
		protected void InitPaintDevice (bool force)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPainter_initPaintDevice (rawObject, force);
		}

		public bool Begin (IQPaintDevice arg1)
		{
			return Begin(arg1, false);
		}

		public bool Begin (IQPaintDevice arg1, QWidget arg2)
		{
			return Begin(arg1, arg2, false);
		}

		public void Flush (QRegion region)
		{
			Flush(region, QPainter.CoordinateMode.CoordDevice);
		}

		public void SetWorldMatrix (QWMatrix arg1)
		{
			SetWorldMatrix(arg1, false);
		}

		public QRegion ClipRegion ()
		{
			return ClipRegion(QPainter.CoordinateMode.CoordDevice);
		}

		public void SetClipRect (QRect arg1)
		{
			SetClipRect(arg1, QPainter.CoordinateMode.CoordDevice);
		}

		public void SetClipRect (int x, int y, int w, int h)
		{
			SetClipRect(x, y, w, h, QPainter.CoordinateMode.CoordDevice);
		}

		public void SetClipRegion (QRegion arg1)
		{
			SetClipRegion(arg1, QPainter.CoordinateMode.CoordDevice);
		}

		public void DrawPoints (QPointArray a)
		{
			DrawPoints(a, (int) 0);
		}

		public void DrawPoints (QPointArray a, int index)
		{
			DrawPoints(a, index, (int) -1);
		}

		public void DrawRoundRect (int x, int y, int w, int h)
		{
			DrawRoundRect(x, y, w, h, (int) 25);
		}

		public void DrawRoundRect (int x, int y, int w, int h, int arg1)
		{
			DrawRoundRect(x, y, w, h, arg1, (int) 25);
		}

		public void DrawRoundRect (QRect arg1)
		{
			DrawRoundRect(arg1, (int) 25);
		}

		public void DrawRoundRect (QRect arg1, int arg2)
		{
			DrawRoundRect(arg1, arg2, (int) 25);
		}

		public void DrawLineSegments (QPointArray arg1)
		{
			DrawLineSegments(arg1, (int) 0);
		}

		public void DrawLineSegments (QPointArray arg1, int index)
		{
			DrawLineSegments(arg1, index, (int) -1);
		}

		public void DrawPolyline (QPointArray arg1)
		{
			DrawPolyline(arg1, (int) 0);
		}

		public void DrawPolyline (QPointArray arg1, int index)
		{
			DrawPolyline(arg1, index, (int) -1);
		}

		public void DrawPolygon (QPointArray arg1)
		{
			DrawPolygon(arg1, false);
		}

		public void DrawPolygon (QPointArray arg1, bool winding)
		{
			DrawPolygon(arg1, winding, (int) 0);
		}

		public void DrawPolygon (QPointArray arg1, bool winding, int index)
		{
			DrawPolygon(arg1, winding, index, (int) -1);
		}

		public void DrawConvexPolygon (QPointArray arg1)
		{
			DrawConvexPolygon(arg1, (int) 0);
		}

		public void DrawConvexPolygon (QPointArray arg1, int index)
		{
			DrawConvexPolygon(arg1, index, (int) -1);
		}

		public void DrawCubicBezier (QPointArray arg1)
		{
			DrawCubicBezier(arg1, (int) 0);
		}

		public void DrawPixmap (int x, int y, QPixmap arg1)
		{
			DrawPixmap(x, y, arg1, (int) 0);
		}

		public void DrawPixmap (int x, int y, QPixmap arg1, int sx)
		{
			DrawPixmap(x, y, arg1, sx, (int) 0);
		}

		public void DrawPixmap (int x, int y, QPixmap arg1, int sx, int sy)
		{
			DrawPixmap(x, y, arg1, sx, sy, (int) -1);
		}

		public void DrawPixmap (int x, int y, QPixmap arg1, int sx, int sy, int sw)
		{
			DrawPixmap(x, y, arg1, sx, sy, sw, (int) -1);
		}

		public void DrawImage (int x, int y, QImage arg1)
		{
			DrawImage(x, y, arg1, (int) 0);
		}

		public void DrawImage (int x, int y, QImage arg1, int sx)
		{
			DrawImage(x, y, arg1, sx, (int) 0);
		}

		public void DrawImage (int x, int y, QImage arg1, int sx, int sy)
		{
			DrawImage(x, y, arg1, sx, sy, (int) -1);
		}

		public void DrawImage (int x, int y, QImage arg1, int sx, int sy, int sw)
		{
			DrawImage(x, y, arg1, sx, sy, sw, (int) -1);
		}

		public void DrawImage (int x, int y, QImage arg1, int sx, int sy, int sw, int sh)
		{
			DrawImage(x, y, arg1, sx, sy, sw, sh, (int) 0);
		}

		public void DrawImage (QPoint arg1, QImage arg2, QRect sr)
		{
			DrawImage(arg1, arg2, sr, (int) 0);
		}

		public void DrawImage (QPoint arg1, QImage arg2)
		{
			DrawImage(arg1, arg2, (int) 0);
		}

		public void DrawTiledPixmap (int x, int y, int w, int h, QPixmap arg1)
		{
			DrawTiledPixmap(x, y, w, h, arg1, (int) 0);
		}

		public void DrawTiledPixmap (int x, int y, int w, int h, QPixmap arg1, int sx)
		{
			DrawTiledPixmap(x, y, w, h, arg1, sx, (int) 0);
		}

		public void DrawText (int x, int y, string arg1)
		{
			DrawText(x, y, arg1, (int) -1);
		}

		public void DrawText (int x, int y, string arg1, int len)
		{
			DrawText(x, y, arg1, len, QPainter.TextDirection.Auto);
		}

		public void DrawText (QPoint arg1, string arg2)
		{
			DrawText(arg1, arg2, (int) -1);
		}

		public void DrawText (QPoint arg1, string arg2, int len)
		{
			DrawText(arg1, arg2, len, QPainter.TextDirection.Auto);
		}

		public void DrawText (int x, int y, string arg1, int pos, int len)
		{
			DrawText(x, y, arg1, pos, len, QPainter.TextDirection.Auto);
		}

		public void DrawText (QPoint p, string arg1, int pos, int len)
		{
			DrawText(p, arg1, pos, len, QPainter.TextDirection.Auto);
		}

		public void DrawText (int x, int y, int w, int h, int flags, string arg1)
		{
			DrawText(x, y, w, h, flags, arg1, (int) -1);
		}

		public void DrawText (int x, int y, int w, int h, int flags, string arg1, int len)
		{
			DrawText(x, y, w, h, flags, arg1, len, new QRect ());
		}

		public void DrawText (int x, int y, int w, int h, int flags, string arg1, int len, QRect br)
		{
			DrawText(x, y, w, h, flags, arg1, len, br, (IntPtr) 0);
		}

		public void DrawText (QRect arg1, int flags, string arg2)
		{
			DrawText(arg1, flags, arg2, (int) -1);
		}

		public void DrawText (QRect arg1, int flags, string arg2, int len)
		{
			DrawText(arg1, flags, arg2, len, new QRect ());
		}

		public void DrawText (QRect arg1, int flags, string arg2, int len, QRect br)
		{
			DrawText(arg1, flags, arg2, len, br, (IntPtr) 0);
		}

		public QRect BoundingRect (int x, int y, int w, int h, int flags, string arg1)
		{
			return BoundingRect(x, y, w, h, flags, arg1, (int) -1);
		}

		public QRect BoundingRect (int x, int y, int w, int h, int flags, string arg1, int len)
		{
			return BoundingRect(x, y, w, h, flags, arg1, len, (IntPtr) 0);
		}

		public QRect BoundingRect (QRect arg1, int flags, string arg2)
		{
			return BoundingRect(arg1, flags, arg2, (int) -1);
		}

		public QRect BoundingRect (QRect arg1, int flags, string arg2, int len)
		{
			return BoundingRect(arg1, flags, arg2, len, (IntPtr) 0);
		}

		protected void InitPaintDevice ()
		{
			InitPaintDevice(false);
		}

		// Begin interface methods.

	}
}