// QPalette.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QPalette : QtSupport, IDisposable {

		public enum ColorGroup {
			Disabled = 0,
			Active = 1,
			Inactive = 2,
			NColorGroups = 3,
			Normal = Active
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPalette ();
		public QPalette () : this (QNull.Instance)
		{
			rawObject = qt_new_QPalette ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPalette1 (IntPtr button);
		public QPalette (QColor button) : this (QNull.Instance)
		{
			rawObject = qt_new_QPalette1 (button.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPalette2 (IntPtr button, IntPtr background);
		public QPalette (QColor button, QColor background) : this (QNull.Instance)
		{
			rawObject = qt_new_QPalette2 (button.RawObject, background.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPalette3 (IntPtr active, IntPtr disabled, IntPtr inactive);
		public QPalette (QColorGroup active, QColorGroup disabled, QColorGroup inactive) : this (QNull.Instance)
		{
			rawObject = qt_new_QPalette3 (active.RawObject, disabled.RawObject, inactive.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPalette4 (IntPtr arg1);
		public QPalette (QPalette arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QPalette4 (arg1.RawObject);
			RegisterObject (this);
		}

		public QPalette (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QPalette (QNull dummy) : base (QNull.Instance) {}

		~QPalette ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QPalette (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QPalette (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPalette_color (IntPtr raw, QPalette.ColorGroup arg1, QColorGroup.ColorRole arg2);
		public QColor Color (QPalette.ColorGroup arg1, QColorGroup.ColorRole arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPalette_color (rawObject, arg1, arg2), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPalette_brush (IntPtr raw, QPalette.ColorGroup arg1, QColorGroup.ColorRole arg2);
		public QBrush Brush (QPalette.ColorGroup arg1, QColorGroup.ColorRole arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPalette_brush (rawObject, arg1, arg2), typeof (QBrush)) as QBrush;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPalette_setColor (IntPtr raw, QPalette.ColorGroup arg1, QColorGroup.ColorRole arg2, IntPtr arg3);
		public void SetColor (QPalette.ColorGroup arg1, QColorGroup.ColorRole arg2, QColor arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPalette_setColor (rawObject, arg1, arg2, arg3.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPalette_setBrush (IntPtr raw, QPalette.ColorGroup arg1, QColorGroup.ColorRole arg2, IntPtr arg3);
		public void SetBrush (QPalette.ColorGroup arg1, QColorGroup.ColorRole arg2, QBrush arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPalette_setBrush (rawObject, arg1, arg2, arg3.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPalette_setColor1 (IntPtr raw, QColorGroup.ColorRole arg1, IntPtr arg2);
		public void SetColor (QColorGroup.ColorRole arg1, QColor arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPalette_setColor1 (rawObject, arg1, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPalette_setBrush1 (IntPtr raw, QColorGroup.ColorRole arg1, IntPtr arg2);
		public void SetBrush (QColorGroup.ColorRole arg1, QBrush arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPalette_setBrush1 (rawObject, arg1, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPalette_copy (IntPtr raw);
		public QPalette Copy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPalette_copy (rawObject), typeof (QPalette)) as QPalette;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPalette_active (IntPtr raw);
		public QColorGroup Active ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPalette_active (rawObject), typeof (QColorGroup)) as QColorGroup;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPalette_disabled (IntPtr raw);
		public QColorGroup Disabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPalette_disabled (rawObject), typeof (QColorGroup)) as QColorGroup;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPalette_inactive (IntPtr raw);
		public QColorGroup Inactive ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPalette_inactive (rawObject), typeof (QColorGroup)) as QColorGroup;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPalette_normal (IntPtr raw);
		public QColorGroup Normal ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPalette_normal (rawObject), typeof (QColorGroup)) as QColorGroup;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPalette_setActive (IntPtr raw, IntPtr arg1);
		public void SetActive (QColorGroup arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPalette_setActive (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPalette_setDisabled (IntPtr raw, IntPtr arg1);
		public void SetDisabled (QColorGroup arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPalette_setDisabled (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPalette_setInactive (IntPtr raw, IntPtr arg1);
		public void SetInactive (QColorGroup arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPalette_setInactive (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPalette_setNormal (IntPtr raw, IntPtr cg);
		public void SetNormal (QColorGroup cg)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPalette_setNormal (rawObject, cg.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPalette_isCopyOf (IntPtr raw, IntPtr arg1);
		public bool IsCopyOf (QPalette arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPalette_isCopyOf (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPalette_serialNumber (IntPtr raw);
		public int SerialNumber ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPalette_serialNumber (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QColorGroup.ColorRole qt_QPalette_foregroundRoleFromMode (Qt.BackgroundMode mode);
		public static QColorGroup.ColorRole ForegroundRoleFromMode (Qt.BackgroundMode mode)
		{
			return qt_QPalette_foregroundRoleFromMode (mode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QColorGroup.ColorRole qt_QPalette_backgroundRoleFromMode (Qt.BackgroundMode mode);
		public static QColorGroup.ColorRole BackgroundRoleFromMode (Qt.BackgroundMode mode)
		{
			return qt_QPalette_backgroundRoleFromMode (mode);
		}
	}
}