// QPixmap.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QPixmap : QtSupport, IQPaintDevice, IDisposable {

		public enum ColorMode {
			Auto = 0,
			Color = 1,
			Mono = 2
		}

		public enum Optimization {
			DefaultOptim = 0,
			NoOptim = 1,
			MemoryOptim = NoOptim,
			NormalOptim = 2,
			BestOptim = 3
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPixmap ();
		public QPixmap () : this (QNull.Instance)
		{
			rawObject = qt_new_QPixmap ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPixmap1 (IntPtr image);
		public QPixmap (QImage image) : this (QNull.Instance)
		{
			rawObject = qt_new_QPixmap1 (image.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPixmap2 (int w, int h, int depth, QPixmap.Optimization arg1);
		public QPixmap (int w, int h, int depth, QPixmap.Optimization arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QPixmap2 (w, h, depth, arg1);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPixmap3 (IntPtr arg1, int depth, QPixmap.Optimization arg2);
		public QPixmap (QSize arg1, int depth, QPixmap.Optimization arg2) : this (QNull.Instance)
		{
			rawObject = qt_new_QPixmap3 (arg1.RawObject, depth, arg2);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPixmap4 (IntPtr fileName, string format, ColorMode mode);
		public QPixmap (string fileName, string format, ColorMode mode) : this (QNull.Instance)
		{
			rawObject = qt_new_QPixmap4 (new QString (fileName).RawObject, format, mode);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPixmap5 (IntPtr fileName, string format, int conversion_flags);
		public QPixmap (string fileName, string format, int conversion_flags) : this (QNull.Instance)
		{
			rawObject = qt_new_QPixmap5 (new QString (fileName).RawObject, format, conversion_flags);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPixmap6 (string[] xpm);
		public QPixmap (string[] xpm) : this (QNull.Instance)
		{
			rawObject = qt_new_QPixmap6 (xpm);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPixmap7 (byte[] data);
		public QPixmap (byte[] data) : this (QNull.Instance)
		{
			rawObject = qt_new_QPixmap7 (data);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPixmap8 (IntPtr arg1);
		public QPixmap (QPixmap arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QPixmap8 (arg1.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPixmap9 (int w, int h, string data, bool isXbitmap);
		protected QPixmap (int w, int h, string data, bool isXbitmap) : this (QNull.Instance)
		{
			rawObject = qt_new_QPixmap9 (w, h, data, isXbitmap);
			RegisterObject (this);
		}

		public QPixmap (int w, int h) : this (w, h, (int) -1) {}

		public QPixmap (int w, int h, int depth) : this (w, h, depth, QPixmap.Optimization.DefaultOptim) {}

		public QPixmap (QSize arg1) : this (arg1, (int) -1) {}

		public QPixmap (QSize arg1, int depth) : this (arg1, depth, QPixmap.Optimization.DefaultOptim) {}

		public QPixmap (string fileName) : this (fileName, "") {}

		public QPixmap (string fileName, string format) : this (fileName, format, ColorMode.Auto) {}

		public QPixmap (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QPixmap (QNull dummy) : base (QNull.Instance) {}

		~QPixmap ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QPixmap (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QPixmap (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPixmap_isNull (IntPtr raw);
		public bool IsNull ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_isNull (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPixmap_width (IntPtr raw);
		public int Width ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_width (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPixmap_height (IntPtr raw);
		public int Height ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_height (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPixmap_size (IntPtr raw);
		public QSize Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPixmap_size (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPixmap_rect (IntPtr raw);
		public QRect Rect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPixmap_rect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPixmap_depth (IntPtr raw);
		public int Depth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_depth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPixmap_fill (IntPtr raw, IntPtr fillColor);
		public void Fill (QColor fillColor)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPixmap_fill (rawObject, fillColor.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPixmap_fill1 (IntPtr raw, IntPtr arg1, int xofs, int yofs);
		public void Fill (QWidget arg1, int xofs, int yofs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPixmap_fill1 (rawObject, arg1.RawObject, xofs, yofs);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPixmap_fill2 (IntPtr raw, IntPtr arg1, IntPtr ofs);
		public void Fill (QWidget arg1, QPoint ofs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPixmap_fill2 (rawObject, arg1.RawObject, ofs.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPixmap_resize (IntPtr raw, int width, int height);
		public void Resize (int width, int height)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPixmap_resize (rawObject, width, height);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPixmap_resize1 (IntPtr raw, IntPtr arg1);
		public void Resize (QSize arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPixmap_resize1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPixmap_mask (IntPtr raw);
		public QBitmap Mask ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPixmap_mask (rawObject), typeof (QBitmap)) as QBitmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPixmap_setMask (IntPtr raw, IntPtr arg1);
		public void SetMask (QBitmap arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPixmap_setMask (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPixmap_selfMask (IntPtr raw);
		public bool SelfMask ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_selfMask (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPixmap_createHeuristicMask (IntPtr raw, bool clipTight);
		public QBitmap CreateHeuristicMask (bool clipTight)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPixmap_createHeuristicMask (rawObject, clipTight), typeof (QBitmap)) as QBitmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPixmap_xForm (IntPtr raw, IntPtr arg1);
		public QPixmap XForm (QWMatrix arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPixmap_xForm (rawObject, arg1.RawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPixmap_convertToImage (IntPtr raw);
		public QImage ConvertToImage ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPixmap_convertToImage (rawObject), typeof (QImage)) as QImage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPixmap_convertFromImage (IntPtr raw, IntPtr arg1, ColorMode mode);
		public bool ConvertFromImage (QImage arg1, ColorMode mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_convertFromImage (rawObject, arg1.RawObject, mode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPixmap_convertFromImage1 (IntPtr raw, IntPtr arg1, int conversion_flags);
		public bool ConvertFromImage (QImage arg1, int conversion_flags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_convertFromImage1 (rawObject, arg1.RawObject, conversion_flags);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPixmap_load (IntPtr raw, IntPtr fileName, string format, ColorMode mode);
		public bool Load (string fileName, string format, ColorMode mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_load (rawObject, new QString (fileName).RawObject, format, mode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPixmap_load1 (IntPtr raw, IntPtr fileName, string format, int conversion_flags);
		public bool Load (string fileName, string format, int conversion_flags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_load1 (rawObject, new QString (fileName).RawObject, format, conversion_flags);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPixmap_loadFromData (IntPtr raw, string buf, uint len, string format, ColorMode mode);
		public bool LoadFromData (string buf, uint len, string format, ColorMode mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_loadFromData (rawObject, buf, len, format, mode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPixmap_loadFromData1 (IntPtr raw, string buf, uint len, string format, int conversion_flags);
		public bool LoadFromData (string buf, uint len, string format, int conversion_flags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_loadFromData1 (rawObject, buf, len, format, conversion_flags);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPixmap_loadFromData2 (IntPtr raw, byte[] data, string format, int conversion_flags);
		public bool LoadFromData (byte[] data, string format, int conversion_flags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_loadFromData2 (rawObject, data, format, conversion_flags);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPixmap_save (IntPtr raw, IntPtr fileName, string format, int quality);
		public bool Save (string fileName, string format, int quality)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_save (rawObject, new QString (fileName).RawObject, format, quality);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QPixmap_hbm (IntPtr raw);
		public uint Hbm ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_hbm (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPixmap_serialNumber (IntPtr raw);
		public int SerialNumber ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_serialNumber (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QPixmap.Optimization qt_QPixmap_optimization (IntPtr raw);
		public QPixmap.Optimization TheOptimization ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_optimization (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPixmap_setOptimization (IntPtr raw, QPixmap.Optimization arg1);
		public void SetOptimization (QPixmap.Optimization arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPixmap_setOptimization (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPixmap_detach (IntPtr raw);
		public void Detach ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPixmap_detach (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPixmap_isQBitmap (IntPtr raw);
		public bool IsQBitmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_isQBitmap (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPixmap_isMultiCellPixmap (IntPtr raw);
		public bool IsMultiCellPixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_isMultiCellPixmap (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QPixmap_multiCellHandle (IntPtr raw);
		public uint MultiCellHandle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_multiCellHandle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QPixmap_multiCellBitmap (IntPtr raw);
		public uint MultiCellBitmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_multiCellBitmap (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPixmap_multiCellOffset (IntPtr raw);
		public int MultiCellOffset ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_multiCellOffset (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPixmap_allocCell (IntPtr raw);
		public int AllocCell ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_allocCell (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPixmap_freeCell (IntPtr raw, bool arg1);
		public void FreeCell (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPixmap_freeCell (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPixmap_graphicsContext (IntPtr raw, bool clip_children);
		public IntPtr GraphicsContext (bool clip_children)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_graphicsContext (rawObject, clip_children);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QPixmap_scanLine (IntPtr raw, int arg1);
		public string ScanLine (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_scanLine (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPixmap_bytesPerLine (IntPtr raw);
		public int BytesPerLine ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_bytesPerLine (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPixmap_clut (IntPtr raw);
		public int Clut ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_clut (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPixmap_numCols (IntPtr raw);
		public int NumCols ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_numCols (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPixmap_x11SetScreen (IntPtr raw, int screen);
		public void X11SetScreen (int screen)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPixmap_x11SetScreen (rawObject, screen);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPixmap_defaultDepth ();
		public static int DefaultDepth ()
		{
			return qt_QPixmap_defaultDepth ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPixmap_grabWindow (uint arg1, int x, int y, int w, int h);
		public static QPixmap GrabWindow (uint arg1, int x, int y, int w, int h)
		{
			return LookupObject (qt_QPixmap_grabWindow (arg1, x, y, w, h), typeof (QPixmap)) as QPixmap;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPixmap_grabWidget (IntPtr widget, int x, int y, int w, int h);
		public static QPixmap GrabWidget (QWidget widget, int x, int y, int w, int h)
		{
			return LookupObject (qt_QPixmap_grabWidget (widget.RawObject, x, y, w, h), typeof (QPixmap)) as QPixmap;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPixmap_trueMatrix (IntPtr arg1, int w, int h);
		public static QWMatrix TrueMatrix (QWMatrix arg1, int w, int h)
		{
			return LookupObject (qt_QPixmap_trueMatrix (arg1.RawObject, w, h), typeof (QWMatrix)) as QWMatrix;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QPixmap_imageFormat (IntPtr fileName);
		public static string ImageFormat (string fileName)
		{
			return qt_QPixmap_imageFormat (new QString (fileName).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QPixmap.Optimization qt_QPixmap_defaultOptimization ();
		public static QPixmap.Optimization DefaultOptimization ()
		{
			return qt_QPixmap_defaultOptimization ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPixmap_setDefaultOptimization (QPixmap.Optimization arg1);
		public static void SetDefaultOptimization (QPixmap.Optimization arg1)
		{
			qt_QPixmap_setDefaultOptimization (arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPixmap_x11SetDefaultScreen (int screen);
		public static int X11SetDefaultScreen (int screen)
		{
			return qt_QPixmap_x11SetDefaultScreen (screen);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPixmap_metric (IntPtr raw, int arg1);
		protected int Metric (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_metric (rawObject, arg1);
		}

		public void Fill ()
		{
			Fill(new QColor ());
		}

		public QBitmap CreateHeuristicMask ()
		{
			return CreateHeuristicMask(true);
		}

		public bool ConvertFromImage (QImage arg1)
		{
			return ConvertFromImage(arg1, ColorMode.Auto);
		}

		public bool Load (string fileName)
		{
			return Load(fileName, "");
		}

		public bool Load (string fileName, string format)
		{
			return Load(fileName, format, ColorMode.Auto);
		}

		public bool LoadFromData (string buf, uint len)
		{
			return LoadFromData(buf, len, "");
		}

		public bool LoadFromData (string buf, uint len, string format)
		{
			return LoadFromData(buf, len, format, ColorMode.Auto);
		}

		public bool LoadFromData (byte[] data)
		{
			return LoadFromData(data, "");
		}

		public bool LoadFromData (byte[] data, string format)
		{
			return LoadFromData(data, format, (int) 0);
		}

		public bool Save (string fileName, string format)
		{
			return Save(fileName, format, (int) -1);
		}

		public void FreeCell ()
		{
			FreeCell(false);
		}

		public IntPtr GraphicsContext ()
		{
			return GraphicsContext(true);
		}

		public static QPixmap GrabWindow (uint arg1)
		{
			return GrabWindow(arg1, (int) 0);
		}

		public static QPixmap GrabWindow (uint arg1, int x)
		{
			return GrabWindow(arg1, x, (int) 0);
		}

		public static QPixmap GrabWindow (uint arg1, int x, int y)
		{
			return GrabWindow(arg1, x, y, (int) -1);
		}

		public static QPixmap GrabWindow (uint arg1, int x, int y, int w)
		{
			return GrabWindow(arg1, x, y, w, (int) -1);
		}

		public static QPixmap GrabWidget (QWidget widget)
		{
			return GrabWidget(widget, (int) 0);
		}

		public static QPixmap GrabWidget (QWidget widget, int x)
		{
			return GrabWidget(widget, x, (int) 0);
		}

		public static QPixmap GrabWidget (QWidget widget, int x, int y)
		{
			return GrabWidget(widget, x, y, (int) -1);
		}

		public static QPixmap GrabWidget (QWidget widget, int x, int y, int w)
		{
			return GrabWidget(widget, x, y, w, (int) -1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPixmap_QPaintDevice (IntPtr raw);
		public IntPtr QPaintDevice ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPixmap_QPaintDevice (rawObject);
		}

		// Begin interface methods.


		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_devType (IntPtr raw);
		public int DevType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_devType (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_isExtDev (IntPtr raw);
		public bool IsExtDev ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_isExtDev (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_paintingActive (IntPtr raw);
		public bool PaintingActive ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_paintingActive (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_setResolution (IntPtr raw, int arg1);
		public void SetResolution (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPaintDevice_setResolution (QPaintDevice (), arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_resolution (IntPtr raw);
		public int Resolution ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_resolution (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QPaintDevice_handle (IntPtr raw);
		public uint Handle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_handle (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11RenderHandle (IntPtr raw);
		public IntPtr X11RenderHandle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11RenderHandle (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11Display (IntPtr raw);
		public IntPtr X11Display ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Display (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11Screen (IntPtr raw);
		public int X11Screen ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Screen (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11Depth (IntPtr raw);
		public int X11Depth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Depth (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11Cells (IntPtr raw);
		public int X11Cells ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Cells (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11Colormap (IntPtr raw);
		public IntPtr X11Colormap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Colormap (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_x11DefaultColormap (IntPtr raw);
		public bool X11DefaultColormap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11DefaultColormap (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QPaintDevice_x11Visual (IntPtr raw);
		public int[] X11Visual ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Visual (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_x11DefaultVisual (IntPtr raw);
		public bool X11DefaultVisual ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11DefaultVisual (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11AppDisplay ();
		public static IntPtr X11AppDisplay ()
		{
			return qt_QPaintDevice_x11AppDisplay ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppScreen ();
		public static int X11AppScreen ()
		{
			return qt_QPaintDevice_x11AppScreen ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppDepth ();
		public static int X11AppDepth ()
		{
			return qt_QPaintDevice_x11AppDepth ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppCells ();
		public static int X11AppCells ()
		{
			return qt_QPaintDevice_x11AppCells ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppDpiX ();
		public static int X11AppDpiX ()
		{
			return qt_QPaintDevice_x11AppDpiX ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppDpiY ();
		public static int X11AppDpiY ()
		{
			return qt_QPaintDevice_x11AppDpiY ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11AppColormap ();
		public static IntPtr X11AppColormap ()
		{
			return qt_QPaintDevice_x11AppColormap ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_x11AppDefaultColormap ();
		public static bool X11AppDefaultColormap ()
		{
			return qt_QPaintDevice_x11AppDefaultColormap ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QPaintDevice_x11AppVisual ();
		public static int[] X11AppVisual ()
		{
			return qt_QPaintDevice_x11AppVisual ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_x11AppDefaultVisual ();
		public static bool X11AppDefaultVisual ()
		{
			return qt_QPaintDevice_x11AppDefaultVisual ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_x11SetAppDpiX (int arg1);
		public static void X11SetAppDpiX (int arg1)
		{
			qt_QPaintDevice_x11SetAppDpiX (arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_x11SetAppDpiY (int arg1);
		public static void X11SetAppDpiY (int arg1)
		{
			qt_QPaintDevice_x11SetAppDpiY (arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_qwsDisplay ();
		public static IntPtr QwsDisplay ()
		{
			return qt_QPaintDevice_qwsDisplay ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_copyX11Data (IntPtr raw, IntPtr arg1);
		protected void CopyX11Data (IQPaintDevice arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPaintDevice_copyX11Data (QPaintDevice (), arg1.QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_cloneX11Data (IntPtr raw, IntPtr arg1);
		protected void CloneX11Data (IQPaintDevice arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPaintDevice_cloneX11Data (QPaintDevice (), arg1.QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_setX11Data (IntPtr raw, IntPtr arg1);
		protected void SetX11Data (QPaintDeviceX11Data arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPaintDevice_setX11Data (QPaintDevice (), arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_getX11Data (IntPtr raw, bool def);
		protected QPaintDeviceX11Data GetX11Data (bool def)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPaintDevice_getX11Data (QPaintDevice (), def), typeof (QPaintDeviceX11Data)) as QPaintDeviceX11Data;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_cmd (IntPtr raw, int arg1, IntPtr arg2, IntPtr arg3);
		protected bool Cmd (int arg1, QPainter arg2, QPDevCmdParam arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_cmd (QPaintDevice (), arg1, arg2.RawObject, arg3.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_fontMet (IntPtr raw, IntPtr arg1, int arg2, string arg3, int arg4);
		protected int FontMet (QFont arg1, int arg2, string arg3, int arg4)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_fontMet (QPaintDevice (), arg1.RawObject, arg2, arg3, arg4);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_fontInf (IntPtr raw, IntPtr arg1, int arg2);
		protected int FontInf (QFont arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_fontInf (QPaintDevice (), arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_macCGContext (IntPtr raw, bool clipped);
		protected IntPtr MacCGContext (bool clipped)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_macCGContext (QPaintDevice (), clipped);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_bitBlt (IntPtr dst, int dx, int dy, IntPtr src, int sx, int sy, int sw, int sh, Qt.RasterOp rop, bool ignoreMask);
		public static void BitBlt (IQPaintDevice dst, int dx, int dy, IQPaintDevice src, int sx, int sy, int sw, int sh, Qt.RasterOp rop, bool ignoreMask)
		{
			qt_QPaintDevice_bitBlt (dst.QPaintDevice (), dx, dy, src.QPaintDevice (), sx, sy, sw, sh, rop, ignoreMask);
		}

		protected QPaintDeviceX11Data GetX11Data ()
		{
			return GetX11Data(false);
		}

		protected int FontMet (QFont arg1, int arg2)
		{
			return FontMet(arg1, arg2, "");
		}

		protected int FontMet (QFont arg1, int arg2, string arg3)
		{
			return FontMet(arg1, arg2, arg3, (int) 0);
		}

		protected IntPtr MacCGContext ()
		{
			return MacCGContext(true);
		}

		// Begin interface methods.

	}
}