// QPointArray.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QPointArray : QMemArray, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPointArray ();
		public QPointArray () : this (QNull.Instance)
		{
			rawObject = qt_new_QPointArray ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPointArray3 (IntPtr r, bool closed);
		public QPointArray (QRect r, bool closed) : this (QNull.Instance)
		{
			rawObject = qt_new_QPointArray3 (r.RawObject, closed);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPointArray4 (int nPoints, short points);
		public QPointArray (int nPoints, short points) : this (QNull.Instance)
		{
			rawObject = qt_new_QPointArray4 (nPoints, points);
			RegisterObject (this);
		}

		public QPointArray (QRect r) : this (r, false) {}

		public QPointArray (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QPointArray (QNull dummy) : base (QNull.Instance) {}

		~QPointArray ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QPointArray (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QPointArray (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPointArray_copy (IntPtr raw);
		public QPointArray Copy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPointArray_copy (rawObject), typeof (QPointArray)) as QPointArray;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPointArray_translate (IntPtr raw, int dx, int dy);
		public void Translate (int dx, int dy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPointArray_translate (rawObject, dx, dy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPointArray_boundingRect (IntPtr raw);
		public QRect BoundingRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPointArray_boundingRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPointArray_point (IntPtr raw, uint i, int[] x, int[] y);
		public void Point (uint i, int[] x, int[] y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPointArray_point (rawObject, i, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPointArray_point1 (IntPtr raw, uint i);
		public QPoint Point (uint i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPointArray_point1 (rawObject, i), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPointArray_setPoint (IntPtr raw, uint i, int x, int y);
		public void SetPoint (uint i, int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPointArray_setPoint (rawObject, i, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPointArray_setPoint1 (IntPtr raw, uint i, IntPtr p);
		public void SetPoint (uint i, QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPointArray_setPoint1 (rawObject, i, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPointArray_setPoints (IntPtr raw, int nPoints, short points);
		public bool SetPoints (int nPoints, short points)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPointArray_setPoints (rawObject, nPoints, points);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPointArray_putPoints (IntPtr raw, int index, int nPoints, short points);
		public bool PutPoints (int index, int nPoints, short points)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPointArray_putPoints (rawObject, index, nPoints, points);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPointArray_putPoints2 (IntPtr raw, int index, int nPoints, IntPtr from, int fromIndex);
		public bool PutPoints (int index, int nPoints, QPointArray from, int fromIndex)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPointArray_putPoints2 (rawObject, index, nPoints, from.RawObject, fromIndex);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPointArray_makeArc (IntPtr raw, int x, int y, int w, int h, int a1, int a2);
		public void MakeArc (int x, int y, int w, int h, int a1, int a2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPointArray_makeArc (rawObject, x, y, w, h, a1, a2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPointArray_makeEllipse (IntPtr raw, int x, int y, int w, int h);
		public void MakeEllipse (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPointArray_makeEllipse (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPointArray_makeArc1 (IntPtr raw, int x, int y, int w, int h, int a1, int a2, IntPtr arg1);
		public void MakeArc (int x, int y, int w, int h, int a1, int a2, QWMatrix arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPointArray_makeArc1 (rawObject, x, y, w, h, a1, a2, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPointArray_cubicBezier (IntPtr raw);
		public QPointArray CubicBezier ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPointArray_cubicBezier (rawObject), typeof (QPointArray)) as QPointArray;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QPointArray_shortPoints (IntPtr raw, int index, int nPoints);
		public int[] ShortPoints (int index, int nPoints)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPointArray_shortPoints (rawObject, index, nPoints);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPointArray_cleanBuffers ();
		public static void CleanBuffers ()
		{
			qt_QPointArray_cleanBuffers ();
		}

		public bool PutPoints (int index, int nPoints, QPointArray from)
		{
			return PutPoints(index, nPoints, from, (int) 0);
		}

		public int[] ShortPoints ()
		{
			return ShortPoints((int) 0);
		}

		public int[] ShortPoints (int index)
		{
			return ShortPoints(index, (int) -1);
		}

		// Begin interface methods.

	}
}