// QPolygonScanner.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QPolygonScanner : QtSupport, IDisposable {

		public enum Edge {
			Left = 1,
			Right = 2,
			Top = 4,
			Bottom = 8
		}

		internal QPolygonScanner () : this (QNull.Instance) {}

		public QPolygonScanner (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QPolygonScanner (QNull dummy) : base (QNull.Instance) {}

		~QPolygonScanner ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QPolygonScanner function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPolygonScanner_scan (IntPtr raw, IntPtr pa, bool winding, int index, int npoints);
		public void Scan (QPointArray pa, bool winding, int index, int npoints)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPolygonScanner_scan (rawObject, pa.RawObject, winding, index, npoints);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPolygonScanner_scan1 (IntPtr raw, IntPtr pa, bool winding, int index, int npoints, bool stitchable);
		public void Scan (QPointArray pa, bool winding, int index, int npoints, bool stitchable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPolygonScanner_scan1 (rawObject, pa.RawObject, winding, index, npoints, stitchable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPolygonScanner_scan2 (IntPtr raw, IntPtr pa, bool winding, int index, int npoints, QPolygonScanner.Edge edges);
		public void Scan (QPointArray pa, bool winding, int index, int npoints, QPolygonScanner.Edge edges)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPolygonScanner_scan2 (rawObject, pa.RawObject, winding, index, npoints, edges);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPolygonScanner_processSpans (IntPtr raw, int n, IntPtr point, int[] width);
		public void ProcessSpans (int n, QPoint point, int[] width)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPolygonScanner_processSpans (rawObject, n, point.RawObject, width);
		}

		public void Scan (QPointArray pa, bool winding)
		{
			Scan(pa, winding, (int) 0);
		}

		public void Scan (QPointArray pa, bool winding, int index)
		{
			Scan(pa, winding, index, (int) -1);
		}
	}
}