// QPrinter.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QPrinter : QPaintDevice, IDisposable {

		public enum PrinterMode {
			ScreenResolution = 0,
			PrinterResolution = 1,
			HighResolution = 2,
			Compatible = 3
		}

		public enum Orientation {
			Portrait = 0,
			Landscape = 1
		}

		public enum PageSize {
			A4 = 0,
			B5 = 1,
			Letter = 2,
			Legal = 3,
			Executive = 4,
			A0 = 5,
			A1 = 6,
			A2 = 7,
			A3 = 8,
			A5 = 9,
			A6 = 10,
			A7 = 11,
			A8 = 12,
			A9 = 13,
			B0 = 14,
			B1 = 15,
			B10 = 16,
			B2 = 17,
			B3 = 18,
			B4 = 19,
			B6 = 20,
			B7 = 21,
			B8 = 22,
			B9 = 23,
			C5E = 24,
			Comm10E = 25,
			DLE = 26,
			Folio = 27,
			Ledger = 28,
			Tabloid = 29,
			Custom = 30,
			NPageSize = Custom
		}

		public enum PageOrder {
			FirstPageFirst = 0,
			LastPageFirst = 1
		}

		public enum ColorMode {
			GrayScale = 0,
			Color = 1
		}

		public enum PaperSource {
			OnlyOne = 0,
			Lower = 1,
			Middle = 2,
			Manual = 3,
			Envelope = 4,
			EnvelopeManual = 5,
			Auto = 6,
			Tractor = 7,
			SmallFormat = 8,
			LargeFormat = 9,
			LargeCapacity = 10,
			Cassette = 11,
			FormSource = 12
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QPrinter (QPrinter.PrinterMode mode);
		public QPrinter (QPrinter.PrinterMode mode) : this (QNull.Instance)
		{
			rawObject = qt_new_QPrinter (mode);
			RegisterObject (this);
		}

		public QPrinter () : this (QPrinter.PrinterMode.ScreenResolution) {}

		public QPrinter (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QPrinter (QNull dummy) : base (QNull.Instance) {}

		~QPrinter ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QPrinter (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QPrinter (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPrinter_printerName (IntPtr raw);
		public string PrinterName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QPrinter_printerName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setPrinterName (IntPtr raw, IntPtr arg1);
		public void SetPrinterName (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setPrinterName (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPrinter_outputToFile (IntPtr raw);
		public bool OutputToFile ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_outputToFile (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setOutputToFile (IntPtr raw, bool arg1);
		public void SetOutputToFile (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setOutputToFile (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPrinter_outputFileName (IntPtr raw);
		public string OutputFileName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QPrinter_outputFileName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setOutputFileName (IntPtr raw, IntPtr arg1);
		public void SetOutputFileName (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setOutputFileName (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPrinter_printProgram (IntPtr raw);
		public string PrintProgram ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QPrinter_printProgram (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setPrintProgram (IntPtr raw, IntPtr arg1);
		public void SetPrintProgram (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setPrintProgram (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPrinter_printerSelectionOption (IntPtr raw);
		public string PrinterSelectionOption ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QPrinter_printerSelectionOption (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setPrinterSelectionOption (IntPtr raw, IntPtr arg1);
		public void SetPrinterSelectionOption (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setPrinterSelectionOption (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPrinter_docName (IntPtr raw);
		public string DocName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QPrinter_docName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setDocName (IntPtr raw, IntPtr arg1);
		public void SetDocName (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setDocName (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPrinter_creator (IntPtr raw);
		public string Creator ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QPrinter_creator (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setCreator (IntPtr raw, IntPtr arg1);
		public void SetCreator (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setCreator (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Orientation qt_QPrinter_orientation (IntPtr raw);
		public Orientation TheOrientation ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_orientation (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setOrientation (IntPtr raw, Orientation arg1);
		public void SetOrientation (Orientation arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setOrientation (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QPrinter.PageSize qt_QPrinter_pageSize (IntPtr raw);
		public QPrinter.PageSize ThePageSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_pageSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setPageSize (IntPtr raw, QPrinter.PageSize arg1);
		public void SetPageSize (QPrinter.PageSize arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setPageSize (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern short qt_QPrinter_winPageSize (IntPtr raw);
		public short WinPageSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_winPageSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setPageOrder (IntPtr raw, QPrinter.PageOrder arg1);
		public void SetPageOrder (QPrinter.PageOrder arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setPageOrder (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QPrinter.PageOrder qt_QPrinter_pageOrder (IntPtr raw);
		public QPrinter.PageOrder ThePageOrder ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_pageOrder (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setResolution (IntPtr raw, int arg1);
		public void SetResolution (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setResolution (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPrinter_resolution (IntPtr raw);
		public int Resolution ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_resolution (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setColorMode (IntPtr raw, ColorMode arg1);
		public void SetColorMode (ColorMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setColorMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ColorMode qt_QPrinter_colorMode (IntPtr raw);
		public ColorMode TheColorMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_colorMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setFullPage (IntPtr raw, bool arg1);
		public void SetFullPage (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setFullPage (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPrinter_fullPage (IntPtr raw);
		public bool FullPage ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_fullPage (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPrinter_margins (IntPtr raw);
		public QSize Margins ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPrinter_margins (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPrinter_fromPage (IntPtr raw);
		public int FromPage ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_fromPage (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPrinter_toPage (IntPtr raw);
		public int ToPage ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_toPage (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setFromTo (IntPtr raw, int fromPage, int toPage);
		public void SetFromTo (int fromPage, int toPage)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setFromTo (rawObject, fromPage, toPage);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPrinter_minPage (IntPtr raw);
		public int MinPage ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_minPage (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPrinter_maxPage (IntPtr raw);
		public int MaxPage ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_maxPage (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setMinMax (IntPtr raw, int minPage, int maxPage);
		public void SetMinMax (int minPage, int maxPage)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setMinMax (rawObject, minPage, maxPage);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPrinter_numCopies (IntPtr raw);
		public int NumCopies ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_numCopies (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setNumCopies (IntPtr raw, int arg1);
		public void SetNumCopies (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setNumCopies (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPrinter_collateCopiesEnabled (IntPtr raw);
		public bool CollateCopiesEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_collateCopiesEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setCollateCopiesEnabled (IntPtr raw, bool arg1);
		public void SetCollateCopiesEnabled (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setCollateCopiesEnabled (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPrinter_collateCopies (IntPtr raw);
		public bool CollateCopies ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_collateCopies (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setCollateCopies (IntPtr raw, bool arg1);
		public void SetCollateCopies (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setCollateCopies (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPrinter_newPage (IntPtr raw);
		public bool NewPage ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_newPage (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPrinter_abort (IntPtr raw);
		public bool Abort ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_abort (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPrinter_aborted (IntPtr raw);
		public bool Aborted ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_aborted (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPrinter_setup (IntPtr raw, IntPtr parent);
		public bool Setup (QWidget parent)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_setup (rawObject, parent.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QPrinter.PaperSource qt_QPrinter_paperSource (IntPtr raw);
		public QPrinter.PaperSource ThePaperSource ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_paperSource (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setPaperSource (IntPtr raw, QPrinter.PaperSource arg1);
		public void SetPaperSource (QPrinter.PaperSource arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setPaperSource (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPrinter_cmd (IntPtr raw, int arg1, IntPtr arg2, IntPtr arg3);
		protected bool Cmd (int arg1, QPainter arg2, QPDevCmdParam arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_cmd (rawObject, arg1, arg2.RawObject, arg3.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPrinter_metric (IntPtr raw, int arg1);
		protected int Metric (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPrinter_metric (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setActive (IntPtr raw);
		protected void SetActive ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setActive (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPrinter_setIdle (IntPtr raw);
		protected void SetIdle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPrinter_setIdle (rawObject);
		}

		public bool Setup ()
		{
			return Setup(new QWidget ());
		}

		// Begin interface methods.

	}
}