// QProcess.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QProcess : QObject, IDisposable {

		public enum Communication {
			Stdin = 1,
			Stdout = 2,
			Stderr = 4,
			DupStderr = 8
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QProcess (IntPtr parent, string name);
		public QProcess (QObject parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QProcess (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QProcess1 (IntPtr arg0, IntPtr parent, string name);
		public QProcess (string arg0, QObject parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QProcess1 (new QString (arg0).RawObject, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QProcess2 (IntPtr args, IntPtr parent, string name);
		public QProcess (QStringList args, QObject parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QProcess2 (args.RawObject, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QProcess () : this (new QObject ()) {}

		public QProcess (QObject parent) : this (parent, "") {}

		public QProcess (string arg0) : this (arg0, new QObject ()) {}

		public QProcess (string arg0, QObject parent) : this (arg0, parent, "") {}

		public QProcess (QStringList args) : this (args, new QObject ()) {}

		public QProcess (QStringList args, QObject parent) : this (args, parent, "") {}

		public QProcess (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QProcess (QNull dummy) : base (QNull.Instance) {}

		~QProcess ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QProcess (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QProcess (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QProcess_arguments (IntPtr raw);
		public QStringList Arguments ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QProcess_arguments (rawObject), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_clearArguments (IntPtr raw);
		public void ClearArguments ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_clearArguments (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_setArguments (IntPtr raw, IntPtr args);
		public void SetArguments (QStringList args)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_setArguments (rawObject, args.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_addArgument (IntPtr raw, IntPtr arg);
		public void AddArgument (string arg)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_addArgument (rawObject, new QString (arg).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QProcess_workingDirectory (IntPtr raw);
		public QDir WorkingDirectory ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QProcess_workingDirectory (rawObject), typeof (QDir)) as QDir;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_setWorkingDirectory (IntPtr raw, IntPtr dir);
		public void SetWorkingDirectory (QDir dir)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_setWorkingDirectory (rawObject, dir.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_setCommunication (IntPtr raw, int c);
		public void SetCommunication (int c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_setCommunication (rawObject, c);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QProcess_communication (IntPtr raw);
		public int TheCommunication ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProcess_communication (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProcess_start (IntPtr raw, IntPtr env);
		public bool Start (QStringList env)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProcess_start (rawObject, env.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProcess_launch (IntPtr raw, IntPtr buf, IntPtr env);
		public bool Launch (string buf, QStringList env)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProcess_launch (rawObject, new QString (buf).RawObject, env.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProcess_launch1 (IntPtr raw, byte[] buf, IntPtr env);
		public bool Launch (byte[] buf, QStringList env)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProcess_launch1 (rawObject, buf, env.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProcess_isRunning (IntPtr raw);
		public bool IsRunning ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProcess_isRunning (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProcess_normalExit (IntPtr raw);
		public bool NormalExit ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProcess_normalExit (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QProcess_exitStatus (IntPtr raw);
		public int ExitStatus ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProcess_exitStatus (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern byte[] qt_QProcess_readStdout (IntPtr raw);
		public byte[] ReadStdout ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProcess_readStdout (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern byte[] qt_QProcess_readStderr (IntPtr raw);
		public byte[] ReadStderr ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProcess_readStderr (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProcess_canReadLineStdout (IntPtr raw);
		public bool CanReadLineStdout ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProcess_canReadLineStdout (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProcess_canReadLineStderr (IntPtr raw);
		public bool CanReadLineStderr ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProcess_canReadLineStderr (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QProcess_readLineStdout (IntPtr raw);
		public string ReadLineStdout ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QProcess_readLineStdout (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QProcess_readLineStderr (IntPtr raw);
		public string ReadLineStderr ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QProcess_readLineStderr (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QProcess_processIdentifier (IntPtr raw);
		public long ProcessIdentifier ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProcess_processIdentifier (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_flushStdin (IntPtr raw);
		public void FlushStdin ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_flushStdin (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_tryTerminate (IntPtr raw);
		public void TryTerminate ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_tryTerminate (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_kill (IntPtr raw);
		public void Kill ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_kill (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_writeToStdin (IntPtr raw, byte[] buf);
		public void WriteToStdin (byte[] buf)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_writeToStdin (rawObject, buf);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_writeToStdin1 (IntPtr raw, IntPtr buf);
		public void WriteToStdin (string buf)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_writeToStdin1 (rawObject, new QString (buf).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_closeStdin (IntPtr raw);
		public void CloseStdin ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_closeStdin (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_connectNotify (IntPtr raw, string signal);
		protected void ConnectNotify (string signal)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_connectNotify (rawObject, signal);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProcess_disconnectNotify (IntPtr raw, string signal);
		protected void DisconnectNotify (string signal)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProcess_disconnectNotify (rawObject, signal);
		}

		public bool Start ()
		{
			return Start(new QStringList ());
		}

		public bool Launch (string buf)
		{
			return Launch(buf, new QStringList ());
		}

		public bool Launch (byte[] buf)
		{
			return Launch(buf, new QStringList ());
		}

		// Begin interface methods.

	}
}