// QProgressBar.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QProgressBar : QFrame, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QProgressBar (IntPtr parent, string name, Qt.WidgetFlags f);
		public QProgressBar (QWidget parent, string name, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QProgressBar (parent != null ? parent.RawObject : IntPtr.Zero, name, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QProgressBar1 (int totalSteps, IntPtr parent, string name, Qt.WidgetFlags f);
		public QProgressBar (int totalSteps, QWidget parent, string name, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QProgressBar1 (totalSteps, parent != null ? parent.RawObject : IntPtr.Zero, name, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QProgressBar () : this (new QWidget ()) {}

		public QProgressBar (QWidget parent) : this (parent, "") {}

		public QProgressBar (QWidget parent, string name) : this (parent, name, Qt.WidgetFlags.WWinOwnDC) {}

		public QProgressBar (int totalSteps) : this (totalSteps, new QWidget ()) {}

		public QProgressBar (int totalSteps, QWidget parent) : this (totalSteps, parent, "") {}

		public QProgressBar (int totalSteps, QWidget parent, string name) : this (totalSteps, parent, name, Qt.WidgetFlags.WWinOwnDC) {}

		public QProgressBar (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QProgressBar (QNull dummy) : base (QNull.Instance) {}

		~QProgressBar ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QProgressBar function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QProgressBar_totalSteps (IntPtr raw);
		public int TotalSteps ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProgressBar_totalSteps (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QProgressBar_progress (IntPtr raw);
		public int Progress ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProgressBar_progress (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QProgressBar_progressString (IntPtr raw);
		public string ProgressString ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QProgressBar_progressString (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QProgressBar_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QProgressBar_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QProgressBar_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QProgressBar_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressBar_setCenterIndicator (IntPtr raw, bool on);
		public void SetCenterIndicator (bool on)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressBar_setCenterIndicator (rawObject, on);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProgressBar_centerIndicator (IntPtr raw);
		public bool CenterIndicator ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProgressBar_centerIndicator (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressBar_setIndicatorFollowsStyle (IntPtr raw, bool arg1);
		public void SetIndicatorFollowsStyle (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressBar_setIndicatorFollowsStyle (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProgressBar_indicatorFollowsStyle (IntPtr raw);
		public bool IndicatorFollowsStyle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProgressBar_indicatorFollowsStyle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProgressBar_percentageVisible (IntPtr raw);
		public bool PercentageVisible ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProgressBar_percentageVisible (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressBar_setPercentageVisible (IntPtr raw, bool arg1);
		public void SetPercentageVisible (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressBar_setPercentageVisible (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressBar_show (IntPtr raw);
		public void Show ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressBar_show (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressBar_reset (IntPtr raw);
		public void Reset ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressBar_reset (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressBar_setTotalSteps (IntPtr raw, int totalSteps);
		public void SetTotalSteps (int totalSteps)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressBar_setTotalSteps (rawObject, totalSteps);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressBar_setProgress (IntPtr raw, int progress);
		public void SetProgress (int progress)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressBar_setProgress (rawObject, progress);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressBar_drawContents (IntPtr raw, IntPtr arg1);
		protected void DrawContents (QPainter arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressBar_drawContents (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProgressBar_setIndicator (IntPtr raw, IntPtr progress_str, int progress, int totalSteps);
		protected bool SetIndicator (string progress_str, int progress, int totalSteps)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProgressBar_setIndicator (rawObject, new QString (progress_str).RawObject, progress, totalSteps);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressBar_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressBar_styleChange (rawObject, arg1.RawObject);
		}

		// Begin interface methods.

	}
}