// QProgressDialog.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QProgressDialog : QDialog, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QProgressDialog (IntPtr parent, string name, bool modal, Qt.WidgetFlags f);
		public QProgressDialog (QWidget parent, string name, bool modal, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QProgressDialog (parent != null ? parent.RawObject : IntPtr.Zero, name, modal, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QProgressDialog1 (IntPtr labelText, IntPtr cancelButtonText, int totalSteps, IntPtr parent, string name, bool modal, Qt.WidgetFlags f);
		public QProgressDialog (string labelText, string cancelButtonText, int totalSteps, QWidget parent, string name, bool modal, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QProgressDialog1 (new QString (labelText).RawObject, new QString (cancelButtonText).RawObject, totalSteps, parent != null ? parent.RawObject : IntPtr.Zero, name, modal, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QProgressDialog () : this (new QWidget ()) {}

		public QProgressDialog (QWidget parent) : this (parent, "") {}

		public QProgressDialog (QWidget parent, string name) : this (parent, name, false) {}

		public QProgressDialog (QWidget parent, string name, bool modal) : this (parent, name, modal, Qt.WidgetFlags.WWinOwnDC) {}

		public QProgressDialog (string labelText, string cancelButtonText, int totalSteps) : this (labelText, cancelButtonText, totalSteps, new QWidget ()) {}

		public QProgressDialog (string labelText, string cancelButtonText, int totalSteps, QWidget parent) : this (labelText, cancelButtonText, totalSteps, parent, "") {}

		public QProgressDialog (string labelText, string cancelButtonText, int totalSteps, QWidget parent, string name) : this (labelText, cancelButtonText, totalSteps, parent, name, false) {}

		public QProgressDialog (string labelText, string cancelButtonText, int totalSteps, QWidget parent, string name, bool modal) : this (labelText, cancelButtonText, totalSteps, parent, name, modal, Qt.WidgetFlags.WWinOwnDC) {}

		public QProgressDialog (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QProgressDialog (QNull dummy) : base (QNull.Instance) {}

		~QProgressDialog ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QProgressDialog (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QProgressDialog (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_setLabel (IntPtr raw, IntPtr arg1);
		public void SetLabel (QLabel arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_setLabel (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_setCancelButton (IntPtr raw, IntPtr arg1);
		public void SetCancelButton (QPushButton arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_setCancelButton (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_setBar (IntPtr raw, IntPtr arg1);
		public void SetBar (QProgressBar arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_setBar (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProgressDialog_wasCancelled (IntPtr raw);
		public bool WasCancelled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProgressDialog_wasCancelled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QProgressDialog_totalSteps (IntPtr raw);
		public int TotalSteps ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProgressDialog_totalSteps (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QProgressDialog_progress (IntPtr raw);
		public int Progress ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProgressDialog_progress (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QProgressDialog_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QProgressDialog_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QProgressDialog_labelText (IntPtr raw);
		public string LabelText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QProgressDialog_labelText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_setAutoReset (IntPtr raw, bool b);
		public void SetAutoReset (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_setAutoReset (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProgressDialog_autoReset (IntPtr raw);
		public bool AutoReset ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProgressDialog_autoReset (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_setAutoClose (IntPtr raw, bool b);
		public void SetAutoClose (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_setAutoClose (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QProgressDialog_autoClose (IntPtr raw);
		public bool AutoClose ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProgressDialog_autoClose (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QProgressDialog_minimumDuration (IntPtr raw);
		public int MinimumDuration ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QProgressDialog_minimumDuration (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_cancel (IntPtr raw);
		public void Cancel ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_cancel (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_reset (IntPtr raw);
		public void Reset ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_reset (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_setTotalSteps (IntPtr raw, int totalSteps);
		public void SetTotalSteps (int totalSteps)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_setTotalSteps (rawObject, totalSteps);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_setProgress (IntPtr raw, int progress);
		public void SetProgress (int progress)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_setProgress (rawObject, progress);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_setLabelText (IntPtr raw, IntPtr arg1);
		public void SetLabelText (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_setLabelText (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_setCancelButtonText (IntPtr raw, IntPtr arg1);
		public void SetCancelButtonText (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_setCancelButtonText (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_setMinimumDuration (IntPtr raw, int ms);
		public void SetMinimumDuration (int ms)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_setMinimumDuration (rawObject, ms);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QProgressDialog_forceShow (IntPtr raw);
		protected void ForceShow ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QProgressDialog_forceShow (rawObject);
		}

		// Begin interface methods.

	}
}