// QRect.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QRect : QtSupport, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRect ();
		public QRect () : this (QNull.Instance)
		{
			rawObject = qt_new_QRect ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRect1 (IntPtr topleft, IntPtr bottomright);
		public QRect (QPoint topleft, QPoint bottomright) : this (QNull.Instance)
		{
			rawObject = qt_new_QRect1 (topleft.RawObject, bottomright.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRect2 (IntPtr topleft, IntPtr size);
		public QRect (QPoint topleft, QSize size) : this (QNull.Instance)
		{
			rawObject = qt_new_QRect2 (topleft.RawObject, size.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRect3 (int left, int top, int width, int height);
		public QRect (int left, int top, int width, int height) : this (QNull.Instance)
		{
			rawObject = qt_new_QRect3 (left, top, width, height);
			RegisterObject (this);
		}

		public QRect (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QRect (QNull dummy) : base (QNull.Instance) {}

		~QRect ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QRect function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRect_isNull (IntPtr raw);
		public bool IsNull ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_isNull (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRect_isEmpty (IntPtr raw);
		public bool IsEmpty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_isEmpty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRect_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRect_normalize (IntPtr raw);
		public QRect Normalize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRect_normalize (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRect_left (IntPtr raw);
		public int Left ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_left (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRect_top (IntPtr raw);
		public int Top ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_top (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRect_right (IntPtr raw);
		public int Right ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_right (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRect_bottom (IntPtr raw);
		public int Bottom ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_bottom (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern short qt_QRect_rLeft (IntPtr raw);
		public short RLeft ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_rLeft (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern short qt_QRect_rTop (IntPtr raw);
		public short RTop ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_rTop (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern short qt_QRect_rRight (IntPtr raw);
		public short RRight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_rRight (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern short qt_QRect_rBottom (IntPtr raw);
		public short RBottom ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_rBottom (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRect_x (IntPtr raw);
		public int X ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_x (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRect_y (IntPtr raw);
		public int Y ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_y (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_setLeft (IntPtr raw, int pos);
		public void SetLeft (int pos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_setLeft (rawObject, pos);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_setTop (IntPtr raw, int pos);
		public void SetTop (int pos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_setTop (rawObject, pos);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_setRight (IntPtr raw, int pos);
		public void SetRight (int pos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_setRight (rawObject, pos);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_setBottom (IntPtr raw, int pos);
		public void SetBottom (int pos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_setBottom (rawObject, pos);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_setX (IntPtr raw, int x);
		public void SetX (int x)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_setX (rawObject, x);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_setY (IntPtr raw, int y);
		public void SetY (int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_setY (rawObject, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRect_topLeft (IntPtr raw);
		public QPoint TopLeft ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRect_topLeft (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRect_bottomRight (IntPtr raw);
		public QPoint BottomRight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRect_bottomRight (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRect_topRight (IntPtr raw);
		public QPoint TopRight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRect_topRight (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRect_bottomLeft (IntPtr raw);
		public QPoint BottomLeft ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRect_bottomLeft (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRect_center (IntPtr raw);
		public QPoint Center ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRect_center (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_rect (IntPtr raw, int[] x, int[] y, int[] w, int[] h);
		public void Rect (int[] x, int[] y, int[] w, int[] h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_rect (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_coords (IntPtr raw, int[] x1, int[] y1, int[] x2, int[] y2);
		public void Coords (int[] x1, int[] y1, int[] x2, int[] y2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_coords (rawObject, x1, y1, x2, y2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_moveTopLeft (IntPtr raw, IntPtr p);
		public void MoveTopLeft (QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_moveTopLeft (rawObject, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_moveBottomRight (IntPtr raw, IntPtr p);
		public void MoveBottomRight (QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_moveBottomRight (rawObject, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_moveTopRight (IntPtr raw, IntPtr p);
		public void MoveTopRight (QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_moveTopRight (rawObject, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_moveBottomLeft (IntPtr raw, IntPtr p);
		public void MoveBottomLeft (QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_moveBottomLeft (rawObject, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_moveCenter (IntPtr raw, IntPtr p);
		public void MoveCenter (QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_moveCenter (rawObject, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_moveBy (IntPtr raw, int dx, int dy);
		public void MoveBy (int dx, int dy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_moveBy (rawObject, dx, dy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_setRect (IntPtr raw, int x, int y, int w, int h);
		public void SetRect (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_setRect (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_setCoords (IntPtr raw, int x1, int y1, int x2, int y2);
		public void SetCoords (int x1, int y1, int x2, int y2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_setCoords (rawObject, x1, y1, x2, y2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_addCoords (IntPtr raw, int x1, int y1, int x2, int y2);
		public void AddCoords (int x1, int y1, int x2, int y2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_addCoords (rawObject, x1, y1, x2, y2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRect_size (IntPtr raw);
		public QSize Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRect_size (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRect_width (IntPtr raw);
		public int Width ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_width (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRect_height (IntPtr raw);
		public int Height ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_height (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_setWidth (IntPtr raw, int w);
		public void SetWidth (int w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_setWidth (rawObject, w);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_setHeight (IntPtr raw, int h);
		public void SetHeight (int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_setHeight (rawObject, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRect_setSize (IntPtr raw, IntPtr s);
		public void SetSize (QSize s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRect_setSize (rawObject, s.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRect_contains (IntPtr raw, IntPtr p, bool proper);
		public bool Contains (QPoint p, bool proper)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_contains (rawObject, p.RawObject, proper);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRect_contains1 (IntPtr raw, int x, int y, bool proper);
		public bool Contains (int x, int y, bool proper)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_contains1 (rawObject, x, y, proper);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRect_contains2 (IntPtr raw, IntPtr r, bool proper);
		public bool Contains (QRect r, bool proper)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_contains2 (rawObject, r.RawObject, proper);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRect_unite (IntPtr raw, IntPtr r);
		public QRect Unite (QRect r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRect_unite (rawObject, r.RawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRect_intersect (IntPtr raw, IntPtr r);
		public QRect Intersect (QRect r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRect_intersect (rawObject, r.RawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRect_intersects (IntPtr raw, IntPtr r);
		public bool Intersects (QRect r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRect_intersects (rawObject, r.RawObject);
		}

		public bool Contains (QPoint p)
		{
			return Contains(p, false);
		}

		public bool Contains (int x, int y)
		{
			return Contains(x, y, false);
		}

		public bool Contains (QRect r)
		{
			return Contains(r, false);
		}
	}
}