// QRegExp.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QRegExp : QtSupport, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRegExp ();
		public QRegExp () : this (QNull.Instance)
		{
			rawObject = qt_new_QRegExp ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRegExp1 (IntPtr pattern, bool caseSensitive, bool wildcard);
		public QRegExp (string pattern, bool caseSensitive, bool wildcard) : this (QNull.Instance)
		{
			rawObject = qt_new_QRegExp1 (new QString (pattern).RawObject, caseSensitive, wildcard);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRegExp2 (IntPtr rx);
		public QRegExp (QRegExp rx) : this (QNull.Instance)
		{
			rawObject = qt_new_QRegExp2 (rx.RawObject);
			RegisterObject (this);
		}

		public QRegExp (string pattern) : this (pattern, true) {}

		public QRegExp (string pattern, bool caseSensitive) : this (pattern, caseSensitive, false) {}

		public QRegExp (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QRegExp (QNull dummy) : base (QNull.Instance) {}

		~QRegExp ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QRegExp (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QRegExp (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRegExp_isEmpty (IntPtr raw);
		public bool IsEmpty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegExp_isEmpty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRegExp_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegExp_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRegExp_pattern (IntPtr raw);
		public string Pattern ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QRegExp_pattern (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRegExp_setPattern (IntPtr raw, IntPtr pattern);
		public void SetPattern (string pattern)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRegExp_setPattern (rawObject, new QString (pattern).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRegExp_caseSensitive (IntPtr raw);
		public bool CaseSensitive ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegExp_caseSensitive (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRegExp_setCaseSensitive (IntPtr raw, bool sensitive);
		public void SetCaseSensitive (bool sensitive)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRegExp_setCaseSensitive (rawObject, sensitive);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRegExp_wildcard (IntPtr raw);
		public bool Wildcard ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegExp_wildcard (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRegExp_setWildcard (IntPtr raw, bool wildcard);
		public void SetWildcard (bool wildcard)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRegExp_setWildcard (rawObject, wildcard);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRegExp_minimal (IntPtr raw);
		public bool Minimal ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegExp_minimal (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRegExp_setMinimal (IntPtr raw, bool minimal);
		public void SetMinimal (bool minimal)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRegExp_setMinimal (rawObject, minimal);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRegExp_exactMatch (IntPtr raw, IntPtr str);
		public bool ExactMatch (string str)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegExp_exactMatch (rawObject, new QString (str).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRegExp_match (IntPtr raw, IntPtr str, int index, int[] len, bool indexIsStart);
		public int Match (string str, int index, int[] len, bool indexIsStart)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegExp_match (rawObject, new QString (str).RawObject, index, len, indexIsStart);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRegExp_search (IntPtr raw, IntPtr str, int start);
		public int Search (string str, int start)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegExp_search (rawObject, new QString (str).RawObject, start);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRegExp_searchRev (IntPtr raw, IntPtr str, int start);
		public int SearchRev (string str, int start)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegExp_searchRev (rawObject, new QString (str).RawObject, start);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRegExp_matchedLength (IntPtr raw);
		public int MatchedLength ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegExp_matchedLength (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRegExp_capturedTexts (IntPtr raw);
		public QStringList CapturedTexts ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRegExp_capturedTexts (rawObject), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRegExp_cap (IntPtr raw, int nth);
		public string Cap (int nth)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QRegExp_cap (rawObject, nth));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRegExp_pos (IntPtr raw, int nth);
		public int Pos (int nth)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegExp_pos (rawObject, nth);
		}

		public int Match (string str)
		{
			return Match(str, (int) 0);
		}

		public int Match (string str, int index)
		{
			return Match(str, index, new int[]{0});
		}

		public int Match (string str, int index, int[] len)
		{
			return Match(str, index, len, true);
		}

		public int Search (string str)
		{
			return Search(str, (int) 0);
		}

		public int SearchRev (string str)
		{
			return SearchRev(str, (int) -1);
		}

		public string Cap ()
		{
			return Cap((int) 0);
		}

		public int Pos ()
		{
			return Pos((int) 0);
		}
	}
}