// QRegion.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QRegion : QtSupport, IDisposable {

		public enum RegionType {
			Rectangle = 0,
			Ellipse = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRegion ();
		public QRegion () : this (QNull.Instance)
		{
			rawObject = qt_new_QRegion ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRegion1 (int x, int y, int w, int h, QRegion.RegionType arg1);
		public QRegion (int x, int y, int w, int h, QRegion.RegionType arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QRegion1 (x, y, w, h, arg1);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRegion2 (IntPtr arg1, QRegion.RegionType arg2);
		public QRegion (QRect arg1, QRegion.RegionType arg2) : this (QNull.Instance)
		{
			rawObject = qt_new_QRegion2 (arg1.RawObject, arg2);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRegion3 (IntPtr arg1, bool winding);
		public QRegion (QPointArray arg1, bool winding) : this (QNull.Instance)
		{
			rawObject = qt_new_QRegion3 (arg1.RawObject, winding);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRegion4 (IntPtr arg1);
		public QRegion (QRegion arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QRegion4 (arg1.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QRegion5 (IntPtr arg1);
		public QRegion (QBitmap arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QRegion5 (arg1.RawObject);
			RegisterObject (this);
		}

		public QRegion (int x, int y, int w, int h) : this (x, y, w, h, QRegion.RegionType.Rectangle) {}

		public QRegion (QRect arg1) : this (arg1, QRegion.RegionType.Rectangle) {}

		public QRegion (QPointArray arg1) : this (arg1, false) {}

		public QRegion (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QRegion (QNull dummy) : base (QNull.Instance) {}

		~QRegion ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QRegion (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QRegion (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRegion_isNull (IntPtr raw);
		public bool IsNull ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegion_isNull (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRegion_isEmpty (IntPtr raw);
		public bool IsEmpty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegion_isEmpty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRegion_contains (IntPtr raw, IntPtr p);
		public bool Contains (QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegion_contains (rawObject, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QRegion_contains1 (IntPtr raw, IntPtr r);
		public bool Contains (QRect r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegion_contains1 (rawObject, r.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRegion_translate (IntPtr raw, int dx, int dy);
		public void Translate (int dx, int dy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRegion_translate (rawObject, dx, dy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRegion_unite (IntPtr raw, IntPtr arg1);
		public QRegion Unite (QRegion arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRegion_unite (rawObject, arg1.RawObject), typeof (QRegion)) as QRegion;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRegion_intersect (IntPtr raw, IntPtr arg1);
		public QRegion Intersect (QRegion arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRegion_intersect (rawObject, arg1.RawObject), typeof (QRegion)) as QRegion;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRegion_subtract (IntPtr raw, IntPtr arg1);
		public QRegion Subtract (QRegion arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRegion_subtract (rawObject, arg1.RawObject), typeof (QRegion)) as QRegion;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRegion_eor (IntPtr raw, IntPtr arg1);
		public QRegion Eor (QRegion arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRegion_eor (rawObject, arg1.RawObject), typeof (QRegion)) as QRegion;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRegion_boundingRect (IntPtr raw);
		public QRect BoundingRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QRegion_boundingRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRegion_setRects (IntPtr raw, IntPtr arg1, int arg2);
		public void SetRects (QRect arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRegion_setRects (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QRegion_handle (IntPtr raw, bool require_rgn);
		public IntPtr Handle (bool require_rgn)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRegion_handle (rawObject, require_rgn);
		}

		public IntPtr Handle ()
		{
			return Handle(false);
		}
	}
}