// QScrollBar.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QScrollBar : QWidget, IQRangeControl, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QScrollBar (IntPtr parent, string name);
		public QScrollBar (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QScrollBar (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QScrollBar1 (Orientation arg1, IntPtr parent, string name);
		public QScrollBar (Orientation arg1, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QScrollBar1 (arg1, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QScrollBar2 (int minValue, int maxValue, int LineStep, int PageStep, int value, Orientation arg1, IntPtr parent, string name);
		public QScrollBar (int minValue, int maxValue, int LineStep, int PageStep, int value, Orientation arg1, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QScrollBar2 (minValue, maxValue, LineStep, PageStep, value, arg1, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QScrollBar (QWidget parent) : this (parent, "") {}

		public QScrollBar (Orientation arg1, QWidget parent) : this (arg1, parent, "") {}

		public QScrollBar (int minValue, int maxValue, int LineStep, int PageStep, int value, Orientation arg1, QWidget parent) : this (minValue, maxValue, LineStep, PageStep, value, arg1, parent, "") {}

		internal QScrollBar () : this (QNull.Instance) {}

		public QScrollBar (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QScrollBar (QNull dummy) : base (QNull.Instance) {}

		~QScrollBar ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QScrollBar function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollBar_setOrientation (IntPtr raw, Orientation arg1);
		public void SetOrientation (Orientation arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollBar_setOrientation (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Orientation qt_QScrollBar_orientation (IntPtr raw);
		public Orientation Orientation ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollBar_orientation (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollBar_setTracking (IntPtr raw, bool enable);
		public void SetTracking (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollBar_setTracking (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QScrollBar_tracking (IntPtr raw);
		public bool Tracking ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollBar_tracking (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QScrollBar_draggingSlider (IntPtr raw);
		public bool DraggingSlider ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollBar_draggingSlider (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollBar_setPalette (IntPtr raw, IntPtr arg1);
		public void SetPalette (QPalette arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollBar_setPalette (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollBar_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QScrollBar_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollBar_minValue (IntPtr raw);
		public int MinValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollBar_minValue (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollBar_maxValue (IntPtr raw);
		public int MaxValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollBar_maxValue (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollBar_setMinValue (IntPtr raw, int arg1);
		public void SetMinValue (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollBar_setMinValue (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollBar_setMaxValue (IntPtr raw, int arg1);
		public void SetMaxValue (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollBar_setMaxValue (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollBar_lineStep (IntPtr raw);
		public int LineStep ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollBar_lineStep (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollBar_pageStep (IntPtr raw);
		public int PageStep ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollBar_pageStep (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollBar_setLineStep (IntPtr raw, int arg1);
		public void SetLineStep (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollBar_setLineStep (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollBar_setPageStep (IntPtr raw, int arg1);
		public void SetPageStep (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollBar_setPageStep (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollBar_value (IntPtr raw);
		public int Value ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollBar_value (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollBar_sliderStart (IntPtr raw);
		public int SliderStart ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollBar_sliderStart (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollBar_sliderRect (IntPtr raw);
		public QRect SliderRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QScrollBar_sliderRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollBar_setValue (IntPtr raw, int arg1);
		public void SetValue (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollBar_setValue (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollBar_valueChange (IntPtr raw);
		protected void ValueChange ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollBar_valueChange (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollBar_stepChange (IntPtr raw);
		protected void StepChange ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollBar_stepChange (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollBar_rangeChange (IntPtr raw);
		protected void RangeChange ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollBar_rangeChange (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollBar_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollBar_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollBar_QRangeControl (IntPtr raw);
		public IntPtr QRangeControl ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollBar_QRangeControl (rawObject);
		}

		// Begin interface methods.


		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRangeControl_setRange (IntPtr raw, int minValue, int maxValue);
		public void SetRange (int minValue, int maxValue)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRangeControl_setRange (QRangeControl (), minValue, maxValue);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRangeControl_setSteps (IntPtr raw, int line, int page);
		public void SetSteps (int line, int page)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRangeControl_setSteps (QRangeControl (), line, page);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRangeControl_bound (IntPtr raw, int arg1);
		public int Bound (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRangeControl_bound (QRangeControl (), arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRangeControl_positionFromValue (IntPtr raw, int val, int space);
		protected int PositionFromValue (int val, int space)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRangeControl_positionFromValue (QRangeControl (), val, space);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRangeControl_valueFromPosition (IntPtr raw, int pos, int space);
		protected int ValueFromPosition (int pos, int space)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRangeControl_valueFromPosition (QRangeControl (), pos, space);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRangeControl_directSetValue (IntPtr raw, int val);
		protected void DirectSetValue (int val)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRangeControl_directSetValue (QRangeControl (), val);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRangeControl_prevValue (IntPtr raw);
		protected int PrevValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRangeControl_prevValue (QRangeControl ());
		}

		// Begin interface methods.

	}
}