// QScrollView.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QScrollView : QFrame, IDisposable {

		public enum ResizePolicy {
			Default = 0,
			Manual = 1,
			AutoOne = 2,
			AutoOneFit = 3
		}

		public enum ScrollBarMode {
			Auto = 0,
			AlwaysOff = 1,
			AlwaysOn = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QScrollView (IntPtr parent, string name, Qt.WidgetFlags f);
		public QScrollView (QWidget parent, string name, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QScrollView (parent != null ? parent.RawObject : IntPtr.Zero, name, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QScrollView () : this (new QWidget ()) {}

		public QScrollView (QWidget parent) : this (parent, "") {}

		public QScrollView (QWidget parent, string name) : this (parent, name, Qt.WidgetFlags.WWinOwnDC) {}

		public QScrollView (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QScrollView (QNull dummy) : base (QNull.Instance) {}

		~QScrollView ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QScrollView (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QScrollView (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_setResizePolicy (IntPtr raw, QScrollView.ResizePolicy arg1);
		public void SetResizePolicy (QScrollView.ResizePolicy arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_setResizePolicy (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QScrollView.ResizePolicy qt_QScrollView_resizePolicy (IntPtr raw);
		public QScrollView.ResizePolicy TheResizePolicy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_resizePolicy (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_styleChange (IntPtr raw, IntPtr arg1);
		public void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_removeChild (IntPtr raw, IntPtr child);
		public void RemoveChild (QWidget child)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_removeChild (rawObject, child.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_addChild (IntPtr raw, IntPtr child, int x, int y);
		public void AddChild (QWidget child, int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_addChild (rawObject, child.RawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_moveChild (IntPtr raw, IntPtr child, int x, int y);
		public void MoveChild (QWidget child, int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_moveChild (rawObject, child.RawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollView_childX (IntPtr raw, IntPtr child);
		public int ChildX (QWidget child)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_childX (rawObject, child.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollView_childY (IntPtr raw, IntPtr child);
		public int ChildY (QWidget child)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_childY (rawObject, child.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QScrollView_childIsVisible (IntPtr raw, IntPtr child);
		public bool ChildIsVisible (QWidget child)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_childIsVisible (rawObject, child.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_showChild (IntPtr raw, IntPtr child, bool yes);
		public void ShowChild (QWidget child, bool yes)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_showChild (rawObject, child.RawObject, yes);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QScrollView.ScrollBarMode qt_QScrollView_vScrollBarMode (IntPtr raw);
		public QScrollView.ScrollBarMode VScrollBarMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_vScrollBarMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_setVScrollBarMode (IntPtr raw, QScrollView.ScrollBarMode arg1);
		public void SetVScrollBarMode (QScrollView.ScrollBarMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_setVScrollBarMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QScrollView.ScrollBarMode qt_QScrollView_hScrollBarMode (IntPtr raw);
		public QScrollView.ScrollBarMode HScrollBarMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_hScrollBarMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_setHScrollBarMode (IntPtr raw, QScrollView.ScrollBarMode arg1);
		public void SetHScrollBarMode (QScrollView.ScrollBarMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_setHScrollBarMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollView_cornerWidget (IntPtr raw);
		public QWidget CornerWidget ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QScrollView_cornerWidget (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_setCornerWidget (IntPtr raw, IntPtr arg1);
		public void SetCornerWidget (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_setCornerWidget (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollView_horizontalScrollBar (IntPtr raw);
		public QScrollBar HorizontalScrollBar ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QScrollView_horizontalScrollBar (rawObject), typeof (QScrollBar)) as QScrollBar;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollView_verticalScrollBar (IntPtr raw);
		public QScrollBar VerticalScrollBar ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QScrollView_verticalScrollBar (rawObject), typeof (QScrollBar)) as QScrollBar;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollView_viewport (IntPtr raw);
		public QWidget Viewport ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QScrollView_viewport (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollView_clipper (IntPtr raw);
		public QWidget Clipper ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QScrollView_clipper (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollView_visibleWidth (IntPtr raw);
		public int VisibleWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_visibleWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollView_visibleHeight (IntPtr raw);
		public int VisibleHeight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_visibleHeight (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollView_contentsWidth (IntPtr raw);
		public int ContentsWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_contentsWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollView_contentsHeight (IntPtr raw);
		public int ContentsHeight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_contentsHeight (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollView_contentsX (IntPtr raw);
		public int ContentsX ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_contentsX (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollView_contentsY (IntPtr raw);
		public int ContentsY ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_contentsY (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_resize (IntPtr raw, int w, int h);
		public void Resize (int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_resize (rawObject, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_resize1 (IntPtr raw, IntPtr arg1);
		public void Resize (QSize arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_resize1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_show (IntPtr raw);
		public void Show ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_show (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_updateContents (IntPtr raw, int x, int y, int w, int h);
		public void UpdateContents (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_updateContents (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_updateContents1 (IntPtr raw, IntPtr r);
		public void UpdateContents (QRect r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_updateContents1 (rawObject, r.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_updateContents2 (IntPtr raw);
		public void UpdateContents ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_updateContents2 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_repaintContents (IntPtr raw, int x, int y, int w, int h, bool erase);
		public void RepaintContents (int x, int y, int w, int h, bool erase)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_repaintContents (rawObject, x, y, w, h, erase);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_repaintContents1 (IntPtr raw, IntPtr r, bool erase);
		public void RepaintContents (QRect r, bool erase)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_repaintContents1 (rawObject, r.RawObject, erase);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_repaintContents2 (IntPtr raw, bool erase);
		public void RepaintContents (bool erase)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_repaintContents2 (rawObject, erase);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_contentsToViewport (IntPtr raw, int x, int y, int vx, int vy);
		public void ContentsToViewport (int x, int y, int vx, int vy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_contentsToViewport (rawObject, x, y, vx, vy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_viewportToContents (IntPtr raw, int vx, int vy, int x, int y);
		public void ViewportToContents (int vx, int vy, int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_viewportToContents (rawObject, vx, vy, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollView_contentsToViewport1 (IntPtr raw, IntPtr arg1);
		public QPoint ContentsToViewport (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QScrollView_contentsToViewport1 (rawObject, arg1.RawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollView_viewportToContents1 (IntPtr raw, IntPtr arg1);
		public QPoint ViewportToContents (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QScrollView_viewportToContents1 (rawObject, arg1.RawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_enableClipper (IntPtr raw, bool y);
		public void EnableClipper (bool y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_enableClipper (rawObject, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_setStaticBackground (IntPtr raw, bool y);
		public void SetStaticBackground (bool y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_setStaticBackground (rawObject, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QScrollView_hasStaticBackground (IntPtr raw);
		public bool HasStaticBackground ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_hasStaticBackground (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollView_viewportSize (IntPtr raw, int arg1, int arg2);
		public QSize ViewportSize (int arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QScrollView_viewportSize (rawObject, arg1, arg2), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollView_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QScrollView_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QScrollView_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QScrollView_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_removeChild1 (IntPtr raw, IntPtr child);
		public void RemoveChild (QObject child)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_removeChild1 (rawObject, child.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_setDragAutoScroll (IntPtr raw, bool b);
		public void SetDragAutoScroll (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_setDragAutoScroll (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QScrollView_dragAutoScroll (IntPtr raw);
		public bool DragAutoScroll ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_dragAutoScroll (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_resizeContents (IntPtr raw, int w, int h);
		public void ResizeContents (int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_resizeContents (rawObject, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_scrollBy (IntPtr raw, int dx, int dy);
		public void ScrollBy (int dx, int dy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_scrollBy (rawObject, dx, dy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_setContentsPos (IntPtr raw, int x, int y);
		public void SetContentsPos (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_setContentsPos (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_ensureVisible (IntPtr raw, int x, int y);
		public void EnsureVisible (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_ensureVisible (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_ensureVisible1 (IntPtr raw, int x, int y, int xmargin, int ymargin);
		public void EnsureVisible (int x, int y, int xmargin, int ymargin)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_ensureVisible1 (rawObject, x, y, xmargin, ymargin);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_center (IntPtr raw, int x, int y);
		public void Center (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_center (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_center1 (IntPtr raw, int x, int y, float xmargin, float ymargin);
		public void Center (int x, int y, float xmargin, float ymargin)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_center1 (rawObject, x, y, xmargin, ymargin);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_updateScrollBars (IntPtr raw);
		public void UpdateScrollBars ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_updateScrollBars (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_setEnabled (IntPtr raw, bool enable);
		public void SetEnabled (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_setEnabled (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_drawContents (IntPtr raw, IntPtr arg1, int cx, int cy, int cw, int ch);
		protected void DrawContents (QPainter arg1, int cx, int cy, int cw, int ch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_drawContents (rawObject, arg1.RawObject, cx, cy, cw, ch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_drawContentsOffset (IntPtr raw, IntPtr arg1, int ox, int oy, int cx, int cy, int cw, int ch);
		protected void DrawContentsOffset (QPainter arg1, int ox, int oy, int cx, int cy, int cw, int ch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_drawContentsOffset (rawObject, arg1.RawObject, ox, oy, cx, cy, cw, ch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_frameChanged (IntPtr raw);
		protected void FrameChanged ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_frameChanged (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_setMargins (IntPtr raw, int left, int top, int right, int bottom);
		protected void SetMargins (int left, int top, int right, int bottom)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_setMargins (rawObject, left, top, right, bottom);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollView_leftMargin (IntPtr raw);
		protected int LeftMargin ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_leftMargin (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollView_topMargin (IntPtr raw);
		protected int TopMargin ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_topMargin (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollView_rightMargin (IntPtr raw);
		protected int RightMargin ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_rightMargin (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QScrollView_bottomMargin (IntPtr raw);
		protected int BottomMargin ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_bottomMargin (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QScrollView_focusNextPrevChild (IntPtr raw, bool next);
		protected bool FocusNextPrevChild (bool next)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_focusNextPrevChild (rawObject, next);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_setHBarGeometry (IntPtr raw, IntPtr hbar, int x, int y, int w, int h);
		protected void SetHBarGeometry (QScrollBar hbar, int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_setHBarGeometry (rawObject, hbar.RawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QScrollView_setVBarGeometry (IntPtr raw, IntPtr vbar, int x, int y, int w, int h);
		protected void SetVBarGeometry (QScrollBar vbar, int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QScrollView_setVBarGeometry (rawObject, vbar.RawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QScrollView_eventFilter (IntPtr raw, IntPtr arg1, IntPtr e);
		protected bool EventFilter (QObject arg1, QEvent e)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QScrollView_eventFilter (rawObject, arg1.RawObject, e.RawObject);
		}

		public void AddChild (QWidget child)
		{
			AddChild(child, (int) 0);
		}

		public void AddChild (QWidget child, int x)
		{
			AddChild(child, x, (int) 0);
		}

		public void ShowChild (QWidget child)
		{
			ShowChild(child, true);
		}

		public void RepaintContents (int x, int y, int w, int h)
		{
			RepaintContents(x, y, w, h, true);
		}

		public void RepaintContents (QRect r)
		{
			RepaintContents(r, true);
		}

		public void RepaintContents ()
		{
			RepaintContents(true);
		}

		// Begin interface methods.

	}
}