// QSessionManager.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSessionManager : QObject, IDisposable {

		public enum RestartHint {
			RestartIfRunning = 0,
			RestartAnyway = 1,
			RestartImmediately = 2,
			RestartNever = 3
		}

		internal QSessionManager () : this (QNull.Instance) {}

		public QSessionManager (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSessionManager (QNull dummy) : base (QNull.Instance) {}

		~QSessionManager ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QSessionManager function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSessionManager_sessionId (IntPtr raw);
		public string SessionId ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSessionManager_sessionId (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QSessionManager_handle (IntPtr raw);
		public int[] Handle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSessionManager_handle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSessionManager_allowsInteraction (IntPtr raw);
		public bool AllowsInteraction ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSessionManager_allowsInteraction (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSessionManager_allowsErrorInteraction (IntPtr raw);
		public bool AllowsErrorInteraction ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSessionManager_allowsErrorInteraction (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSessionManager_release (IntPtr raw);
		public void Release ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSessionManager_release (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSessionManager_cancel (IntPtr raw);
		public void Cancel ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSessionManager_cancel (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSessionManager_setRestartHint (IntPtr raw, QSessionManager.RestartHint arg1);
		public void SetRestartHint (QSessionManager.RestartHint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSessionManager_setRestartHint (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSessionManager.RestartHint qt_QSessionManager_restartHint (IntPtr raw);
		public QSessionManager.RestartHint TheRestartHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSessionManager_restartHint (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSessionManager_setRestartCommand (IntPtr raw, IntPtr arg1);
		public void SetRestartCommand (QStringList arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSessionManager_setRestartCommand (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSessionManager_restartCommand (IntPtr raw);
		public QStringList RestartCommand ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSessionManager_restartCommand (rawObject), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSessionManager_setDiscardCommand (IntPtr raw, IntPtr arg1);
		public void SetDiscardCommand (QStringList arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSessionManager_setDiscardCommand (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSessionManager_discardCommand (IntPtr raw);
		public QStringList DiscardCommand ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSessionManager_discardCommand (rawObject), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSessionManager_setManagerProperty (IntPtr raw, IntPtr name, IntPtr value);
		public void SetManagerProperty (string name, string value)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSessionManager_setManagerProperty (rawObject, new QString (name).RawObject, new QString (value).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSessionManager_setManagerProperty1 (IntPtr raw, IntPtr name, IntPtr value);
		public void SetManagerProperty (string name, QStringList value)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSessionManager_setManagerProperty1 (rawObject, new QString (name).RawObject, value.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSessionManager_isPhase2 (IntPtr raw);
		public bool IsPhase2 ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSessionManager_isPhase2 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSessionManager_requestPhase2 (IntPtr raw);
		public void RequestPhase2 ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSessionManager_requestPhase2 (rawObject);
		}

		// Begin interface methods.

	}
}