// QSizePolicy.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSizePolicy : QtSupport, IDisposable {

		public enum SizeType {
			Fixed = 0,
			Minimum = 1,
			Ignored = 2,
			MinimumExpanding = 3,
			Maximum = 4,
			Preferred = 5,
			Expanding = 7
		}

		public enum ExpandData {
			NoDirection = 0,
			Horizontally = 1,
			Vertically = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSizePolicy ();
		public QSizePolicy () : this (QNull.Instance)
		{
			rawObject = qt_new_QSizePolicy ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSizePolicy1 (QSizePolicy.SizeType hor, QSizePolicy.SizeType ver, bool hfw);
		public QSizePolicy (QSizePolicy.SizeType hor, QSizePolicy.SizeType ver, bool hfw) : this (QNull.Instance)
		{
			rawObject = qt_new_QSizePolicy1 (hor, ver, hfw);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSizePolicy2 (QSizePolicy.SizeType hor, QSizePolicy.SizeType ver, byte horStretch, byte verStretch, bool hfw);
		public QSizePolicy (QSizePolicy.SizeType hor, QSizePolicy.SizeType ver, byte horStretch, byte verStretch, bool hfw) : this (QNull.Instance)
		{
			rawObject = qt_new_QSizePolicy2 (hor, ver, horStretch, verStretch, hfw);
			RegisterObject (this);
		}

		public QSizePolicy (QSizePolicy.SizeType hor, QSizePolicy.SizeType ver) : this (hor, ver, false) {}

		public QSizePolicy (QSizePolicy.SizeType hor, QSizePolicy.SizeType ver, byte horStretch, byte verStretch) : this (hor, ver, horStretch, verStretch, false) {}

		public QSizePolicy (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSizePolicy (QNull dummy) : base (QNull.Instance) {}

		~QSizePolicy ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QSizePolicy function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSizePolicy.SizeType qt_QSizePolicy_horData (IntPtr raw);
		public QSizePolicy.SizeType HorData ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSizePolicy_horData (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSizePolicy.SizeType qt_QSizePolicy_verData (IntPtr raw);
		public QSizePolicy.SizeType VerData ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSizePolicy_verData (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSizePolicy_mayShrinkHorizontally (IntPtr raw);
		public bool MayShrinkHorizontally ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSizePolicy_mayShrinkHorizontally (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSizePolicy_mayShrinkVertically (IntPtr raw);
		public bool MayShrinkVertically ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSizePolicy_mayShrinkVertically (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSizePolicy_mayGrowHorizontally (IntPtr raw);
		public bool MayGrowHorizontally ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSizePolicy_mayGrowHorizontally (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSizePolicy_mayGrowVertically (IntPtr raw);
		public bool MayGrowVertically ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSizePolicy_mayGrowVertically (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSizePolicy.ExpandData qt_QSizePolicy_expanding (IntPtr raw);
		public QSizePolicy.ExpandData Expanding ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSizePolicy_expanding (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSizePolicy_setHorData (IntPtr raw, QSizePolicy.SizeType d);
		public void SetHorData (QSizePolicy.SizeType d)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSizePolicy_setHorData (rawObject, d);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSizePolicy_setVerData (IntPtr raw, QSizePolicy.SizeType d);
		public void SetVerData (QSizePolicy.SizeType d)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSizePolicy_setVerData (rawObject, d);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSizePolicy_setHeightForWidth (IntPtr raw, bool b);
		public void SetHeightForWidth (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSizePolicy_setHeightForWidth (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSizePolicy_hasHeightForWidth (IntPtr raw);
		public bool HasHeightForWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSizePolicy_hasHeightForWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QSizePolicy_horStretch (IntPtr raw);
		public uint HorStretch ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSizePolicy_horStretch (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QSizePolicy_verStretch (IntPtr raw);
		public uint VerStretch ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSizePolicy_verStretch (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSizePolicy_setHorStretch (IntPtr raw, byte sf);
		public void SetHorStretch (byte sf)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSizePolicy_setHorStretch (rawObject, sf);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSizePolicy_setVerStretch (IntPtr raw, byte sf);
		public void SetVerStretch (byte sf)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSizePolicy_setVerStretch (rawObject, sf);
		}
	}
}