// QSlider.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSlider : QWidget, IQRangeControl, IDisposable {

		public enum TickSetting {
			NoMarks = 0,
			Above = 1,
			Left = Above,
			Below = 2,
			Right = Below,
			Both = 3
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSlider (IntPtr parent, string name);
		public QSlider (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QSlider (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSlider1 (Orientation arg1, IntPtr parent, string name);
		public QSlider (Orientation arg1, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QSlider1 (arg1, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSlider2 (int minValue, int maxValue, int pageStep, int value, Orientation arg1, IntPtr parent, string name);
		public QSlider (int minValue, int maxValue, int pageStep, int value, Orientation arg1, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QSlider2 (minValue, maxValue, pageStep, value, arg1, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QSlider (QWidget parent) : this (parent, "") {}

		public QSlider (Orientation arg1, QWidget parent) : this (arg1, parent, "") {}

		public QSlider (int minValue, int maxValue, int pageStep, int value, Orientation arg1, QWidget parent) : this (minValue, maxValue, pageStep, value, arg1, parent, "") {}

		internal QSlider () : this (QNull.Instance) {}

		public QSlider (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSlider (QNull dummy) : base (QNull.Instance) {}

		~QSlider ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QSlider function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_setOrientation (IntPtr raw, Orientation arg1);
		public void SetOrientation (Orientation arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_setOrientation (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Orientation qt_QSlider_orientation (IntPtr raw);
		public Orientation Orientation ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSlider_orientation (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_setTracking (IntPtr raw, bool enable);
		public void SetTracking (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_setTracking (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSlider_tracking (IntPtr raw);
		public bool Tracking ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSlider_tracking (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_setPalette (IntPtr raw, IntPtr arg1);
		public void SetPalette (QPalette arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_setPalette (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSlider_sliderStart (IntPtr raw);
		public int SliderStart ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSlider_sliderStart (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSlider_sliderRect (IntPtr raw);
		public QRect SliderRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSlider_sliderRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSlider_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSlider_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSlider_sizePolicy (IntPtr raw);
		public QSizePolicy SizePolicy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSlider_sizePolicy (rawObject), typeof (QSizePolicy)) as QSizePolicy;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSlider_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSlider_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_setTickmarks (IntPtr raw, QSlider.TickSetting arg1);
		public void SetTickmarks (QSlider.TickSetting arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_setTickmarks (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSlider.TickSetting qt_QSlider_tickmarks (IntPtr raw);
		public QSlider.TickSetting Tickmarks ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSlider_tickmarks (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_setTickInterval (IntPtr raw, int arg1);
		public void SetTickInterval (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_setTickInterval (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSlider_tickInterval (IntPtr raw);
		public int TickInterval ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSlider_tickInterval (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSlider_minValue (IntPtr raw);
		public int MinValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSlider_minValue (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSlider_maxValue (IntPtr raw);
		public int MaxValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSlider_maxValue (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_setMinValue (IntPtr raw, int arg1);
		public void SetMinValue (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_setMinValue (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_setMaxValue (IntPtr raw, int arg1);
		public void SetMaxValue (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_setMaxValue (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSlider_lineStep (IntPtr raw);
		public int LineStep ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSlider_lineStep (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSlider_pageStep (IntPtr raw);
		public int PageStep ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSlider_pageStep (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_setLineStep (IntPtr raw, int arg1);
		public void SetLineStep (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_setLineStep (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_setPageStep (IntPtr raw, int arg1);
		public void SetPageStep (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_setPageStep (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSlider_value (IntPtr raw);
		public int Value ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSlider_value (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_setValue (IntPtr raw, int arg1);
		public void SetValue (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_setValue (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_addStep (IntPtr raw);
		public void AddStep ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_addStep (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_subtractStep (IntPtr raw);
		public void SubtractStep ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_subtractStep (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_valueChange (IntPtr raw);
		protected void ValueChange ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_valueChange (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSlider_rangeChange (IntPtr raw);
		protected void RangeChange ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSlider_rangeChange (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSlider_QRangeControl (IntPtr raw);
		public IntPtr QRangeControl ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSlider_QRangeControl (rawObject);
		}

		// Begin interface methods.


		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRangeControl_setRange (IntPtr raw, int minValue, int maxValue);
		public void SetRange (int minValue, int maxValue)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRangeControl_setRange (QRangeControl (), minValue, maxValue);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRangeControl_setSteps (IntPtr raw, int line, int page);
		public void SetSteps (int line, int page)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRangeControl_setSteps (QRangeControl (), line, page);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRangeControl_bound (IntPtr raw, int arg1);
		public int Bound (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRangeControl_bound (QRangeControl (), arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRangeControl_positionFromValue (IntPtr raw, int val, int space);
		protected int PositionFromValue (int val, int space)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRangeControl_positionFromValue (QRangeControl (), val, space);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRangeControl_valueFromPosition (IntPtr raw, int pos, int space);
		protected int ValueFromPosition (int pos, int space)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRangeControl_valueFromPosition (QRangeControl (), pos, space);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRangeControl_directSetValue (IntPtr raw, int val);
		protected void DirectSetValue (int val)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRangeControl_directSetValue (QRangeControl (), val);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRangeControl_prevValue (IntPtr raw);
		protected int PrevValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRangeControl_prevValue (QRangeControl ());
		}

		// Begin interface methods.

	}
}