// QSocket.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSocket : QObject, IQIODevice, IDisposable {

		public enum Error {
			ErrConnectionRefused = 0,
			ErrHostNotFound = 1,
			ErrSocketRead = 2
		}

		public enum State {
			Idle = 0,
			HostLookup = 1,
			Connecting = 2,
			Connected = 3,
			Closing = 4,
			Connection = Connected
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSocket (IntPtr parent, string name);
		public QSocket (QObject parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QSocket (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QSocket () : this (new QObject ()) {}

		public QSocket (QObject parent) : this (parent, "") {}

		public QSocket (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSocket (QNull dummy) : base (QNull.Instance) {}

		~QSocket ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QSocket (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QSocket (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern State qt_QSocket_state (IntPtr raw);
		public State TheState ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_state (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocket_socket (IntPtr raw);
		public int Socket ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_socket (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocket_setSocket (IntPtr raw, int arg1);
		public void SetSocket (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocket_setSocket (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSocket_socketDevice (IntPtr raw);
		public QSocketDevice SocketDevice ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSocket_socketDevice (rawObject), typeof (QSocketDevice)) as QSocketDevice;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocket_setSocketDevice (IntPtr raw, IntPtr arg1);
		public void SetSocketDevice (QSocketDevice arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocket_setSocketDevice (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocket_connectToHost (IntPtr raw, IntPtr host, ushort port);
		public void ConnectToHost (string host, ushort port)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocket_connectToHost (rawObject, new QString (host).RawObject, port);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSocket_peerName (IntPtr raw);
		public string PeerName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSocket_peerName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocket_open (IntPtr raw, int mode);
		public bool Open (int mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_open (rawObject, mode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocket_close (IntPtr raw);
		public void Close ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocket_close (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocket_flush (IntPtr raw);
		public void Flush ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocket_flush (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocket_size (IntPtr raw);
		public int Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_size (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocket_at (IntPtr raw);
		public int At ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_at (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocket_at1 (IntPtr raw, int arg1);
		public bool At (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_at1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocket_atEnd (IntPtr raw);
		public bool AtEnd ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_atEnd (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QSocket_bytesAvailable (IntPtr raw);
		public long BytesAvailable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_bytesAvailable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QSocket_waitForMore (IntPtr raw, int msecs);
		public long WaitForMore (int msecs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_waitForMore (rawObject, msecs);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QSocket_bytesToWrite (IntPtr raw);
		public long BytesToWrite ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_bytesToWrite (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QSocket_readBlock (IntPtr raw, string data, long maxlen);
		public long ReadBlock (string data, long maxlen)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_readBlock (rawObject, data, maxlen);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QSocket_writeBlock (IntPtr raw, string data, long len);
		public long WriteBlock (string data, long len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_writeBlock (rawObject, data, len);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QSocket_readLine (IntPtr raw, string data, long maxlen);
		public long ReadLine (string data, long maxlen)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_readLine (rawObject, data, maxlen);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocket_getch (IntPtr raw);
		public int Getch ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_getch (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocket_putch (IntPtr raw, int arg1);
		public int Putch (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_putch (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocket_ungetch (IntPtr raw, int arg1);
		public int Ungetch (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_ungetch (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocket_canReadLine (IntPtr raw);
		public bool CanReadLine ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_canReadLine (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSocket_readLine1 (IntPtr raw);
		public string ReadLine ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSocket_readLine1 (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ushort qt_QSocket_port (IntPtr raw);
		public ushort Port ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_port (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ushort qt_QSocket_peerPort (IntPtr raw);
		public ushort PeerPort ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_peerPort (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSocket_address (IntPtr raw);
		public QHostAddress Address ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSocket_address (rawObject), typeof (QHostAddress)) as QHostAddress;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSocket_peerAddress (IntPtr raw);
		public QHostAddress PeerAddress ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSocket_peerAddress (rawObject), typeof (QHostAddress)) as QHostAddress;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocket_sn_read (IntPtr raw, bool force);
		protected void Sn_read (bool force)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocket_sn_read (rawObject, force);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocket_sn_write (IntPtr raw);
		protected void Sn_write ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocket_sn_write (rawObject);
		}

		protected void Sn_read ()
		{
			Sn_read(false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSocket_QIODevice (IntPtr raw);
		public IntPtr QIODevice ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocket_QIODevice (rawObject);
		}

		// Begin interface methods.


		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QIODevice_flags (IntPtr raw);
		public int Flags ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_flags (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QIODevice_mode (IntPtr raw);
		public int Mode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_mode (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isDirectAccess (IntPtr raw);
		public bool IsDirectAccess ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isDirectAccess (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isSequentialAccess (IntPtr raw);
		public bool IsSequentialAccess ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isSequentialAccess (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isCombinedAccess (IntPtr raw);
		public bool IsCombinedAccess ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isCombinedAccess (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isBuffered (IntPtr raw);
		public bool IsBuffered ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isBuffered (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isRaw (IntPtr raw);
		public bool IsRaw ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isRaw (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isSynchronous (IntPtr raw);
		public bool IsSynchronous ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isSynchronous (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isAsynchronous (IntPtr raw);
		public bool IsAsynchronous ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isAsynchronous (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isTranslated (IntPtr raw);
		public bool IsTranslated ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isTranslated (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isReadable (IntPtr raw);
		public bool IsReadable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isReadable (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isWritable (IntPtr raw);
		public bool IsWritable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isWritable (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isReadWrite (IntPtr raw);
		public bool IsReadWrite ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isReadWrite (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isInactive (IntPtr raw);
		public bool IsInactive ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isInactive (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_isOpen (IntPtr raw);
		public bool IsOpen ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_isOpen (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QIODevice_status (IntPtr raw);
		public int Status ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_status (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QIODevice_resetStatus (IntPtr raw);
		public void ResetStatus ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QIODevice_resetStatus (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QIODevice_reset (IntPtr raw);
		public bool Reset ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_reset (QIODevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QIODevice_writeBlock1 (IntPtr raw, byte[] data);
		public long WriteBlock (byte[] data)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_writeBlock1 (QIODevice (), data);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern byte[] qt_QIODevice_readAll (IntPtr raw);
		public byte[] ReadAll ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QIODevice_readAll (QIODevice ());
		}

		// Begin interface methods.

	}
}