// QSocketDevice.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSocketDevice : QIODevice, IDisposable {

		public enum Type {
			Stream = 0,
			Datagram = 1
		}

		public enum Error {
			NoError = 0,
			AlreadyBound = 1,
			Inaccessible = 2,
			NoResources = 3,
			Bug = 4,
			Impossible = 5,
			NoFiles = 6,
			ConnectionRefused = 7,
			NetworkFailure = 8,
			UnknownError = 9
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSocketDevice (Type type);
		public QSocketDevice (Type type) : this (QNull.Instance)
		{
			rawObject = qt_new_QSocketDevice (type);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSocketDevice1 (int socket, Type type);
		public QSocketDevice (int socket, Type type) : this (QNull.Instance)
		{
			rawObject = qt_new_QSocketDevice1 (socket, type);
			RegisterObject (this);
		}

		public QSocketDevice () : this (Type.Stream) {}

		public QSocketDevice (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSocketDevice (QNull dummy) : base (QNull.Instance) {}

		~QSocketDevice ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QSocketDevice (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QSocketDevice (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocketDevice_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Type qt_QSocketDevice_type (IntPtr raw);
		public Type TheType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_type (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocketDevice_socket (IntPtr raw);
		public int Socket ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_socket (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocketDevice_setSocket (IntPtr raw, int socket, Type type);
		public void SetSocket (int socket, Type type)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocketDevice_setSocket (rawObject, socket, type);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocketDevice_open (IntPtr raw, int mode);
		public bool Open (int mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_open (rawObject, mode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocketDevice_close (IntPtr raw);
		public void Close ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocketDevice_close (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocketDevice_flush (IntPtr raw);
		public void Flush ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocketDevice_flush (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocketDevice_size (IntPtr raw);
		public int Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_size (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocketDevice_at (IntPtr raw);
		public int At ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_at (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocketDevice_at1 (IntPtr raw, int arg1);
		public bool At (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_at1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocketDevice_atEnd (IntPtr raw);
		public bool AtEnd ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_atEnd (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocketDevice_blocking (IntPtr raw);
		public bool Blocking ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_blocking (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocketDevice_setBlocking (IntPtr raw, bool arg1);
		public void SetBlocking (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocketDevice_setBlocking (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocketDevice_addressReusable (IntPtr raw);
		public bool AddressReusable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_addressReusable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocketDevice_setAddressReusable (IntPtr raw, bool arg1);
		public void SetAddressReusable (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocketDevice_setAddressReusable (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocketDevice_receiveBufferSize (IntPtr raw);
		public int ReceiveBufferSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_receiveBufferSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocketDevice_setReceiveBufferSize (IntPtr raw, uint arg1);
		public void SetReceiveBufferSize (uint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocketDevice_setReceiveBufferSize (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocketDevice_sendBufferSize (IntPtr raw);
		public int SendBufferSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_sendBufferSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocketDevice_setSendBufferSize (IntPtr raw, uint arg1);
		public void SetSendBufferSize (uint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocketDevice_setSendBufferSize (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocketDevice_connect (IntPtr raw, IntPtr arg1, ushort arg2);
		public bool Connect (QHostAddress arg1, ushort arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_connect (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocketDevice_bind (IntPtr raw, IntPtr arg1, ushort arg2);
		public bool Bind (QHostAddress arg1, ushort arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_bind (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocketDevice_listen (IntPtr raw, int backlog);
		public bool Listen (int backlog)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_listen (rawObject, backlog);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocketDevice_accept (IntPtr raw);
		public int Accept ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_accept (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QSocketDevice_bytesAvailable (IntPtr raw);
		public long BytesAvailable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_bytesAvailable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QSocketDevice_waitForMore (IntPtr raw, int msecs, bool timeout);
		public long WaitForMore (int msecs, bool timeout)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_waitForMore (rawObject, msecs, timeout);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QSocketDevice_readBlock (IntPtr raw, string data, long maxlen);
		public long ReadBlock (string data, long maxlen)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_readBlock (rawObject, data, maxlen);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QSocketDevice_writeBlock (IntPtr raw, string data, long len);
		public long WriteBlock (string data, long len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_writeBlock (rawObject, data, len);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern long qt_QSocketDevice_writeBlock1 (IntPtr raw, string data, long len, IntPtr host, ushort port);
		public long WriteBlock (string data, long len, QHostAddress host, ushort port)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_writeBlock1 (rawObject, data, len, host.RawObject, port);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocketDevice_getch (IntPtr raw);
		public int Getch ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_getch (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocketDevice_putch (IntPtr raw, int arg1);
		public int Putch (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_putch (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocketDevice_ungetch (IntPtr raw, int arg1);
		public int Ungetch (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_ungetch (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ushort qt_QSocketDevice_port (IntPtr raw);
		public ushort Port ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_port (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ushort qt_QSocketDevice_peerPort (IntPtr raw);
		public ushort PeerPort ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_peerPort (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSocketDevice_address (IntPtr raw);
		public QHostAddress Address ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSocketDevice_address (rawObject), typeof (QHostAddress)) as QHostAddress;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSocketDevice_peerAddress (IntPtr raw);
		public QHostAddress PeerAddress ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSocketDevice_peerAddress (rawObject), typeof (QHostAddress)) as QHostAddress;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Error qt_QSocketDevice_error (IntPtr raw);
		public Error TheError ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketDevice_error (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocketDevice_setError (IntPtr raw, Error err);
		protected void SetError (Error err)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocketDevice_setError (rawObject, err);
		}

		public long WaitForMore (int msecs)
		{
			return WaitForMore(msecs, false);
		}

		// Begin interface methods.

	}
}