// QSocketNotifier.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSocketNotifier : QObject, IDisposable {

		public enum Type {
			Read = 0,
			Write = 1,
			Exception = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSocketNotifier (int socket, Type arg1, IntPtr parent, string name);
		public QSocketNotifier (int socket, Type arg1, QObject parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QSocketNotifier (socket, arg1, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QSocketNotifier (int socket, Type arg1) : this (socket, arg1, new QObject ()) {}

		public QSocketNotifier (int socket, Type arg1, QObject parent) : this (socket, arg1, parent, "") {}

		internal QSocketNotifier () : this (QNull.Instance) {}

		public QSocketNotifier (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSocketNotifier (QNull dummy) : base (QNull.Instance) {}

		~QSocketNotifier ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QSocketNotifier (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QSocketNotifier (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSocketNotifier_socket (IntPtr raw);
		public int Socket ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketNotifier_socket (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Type qt_QSocketNotifier_type (IntPtr raw);
		public Type TheType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketNotifier_type (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocketNotifier_isEnabled (IntPtr raw);
		public bool IsEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketNotifier_isEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSocketNotifier_setEnabled (IntPtr raw, bool arg1);
		public void SetEnabled (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSocketNotifier_setEnabled (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSocketNotifier_event (IntPtr raw, IntPtr arg1);
		protected bool Q_event (QEvent arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSocketNotifier_event (rawObject, arg1.RawObject);
		}

		// Begin interface methods.

	}
}