// QSpacerItem.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSpacerItem : QLayoutItem, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSpacerItem (int w, int h, QSizePolicy.SizeType hData, QSizePolicy.SizeType vData);
		public QSpacerItem (int w, int h, QSizePolicy.SizeType hData, QSizePolicy.SizeType vData) : this (QNull.Instance)
		{
			rawObject = qt_new_QSpacerItem (w, h, hData, vData);
			RegisterObject (this);
		}

		public QSpacerItem (int w, int h) : this (w, h, QSizePolicy.SizeType.Minimum) {}

		public QSpacerItem (int w, int h, QSizePolicy.SizeType hData) : this (w, h, hData, QSizePolicy.SizeType.Minimum) {}

		internal QSpacerItem () : this (QNull.Instance) {}

		public QSpacerItem (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSpacerItem (QNull dummy) : base (QNull.Instance) {}

		~QSpacerItem ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QSpacerItem function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpacerItem_changeSize (IntPtr raw, int w, int h, QSizePolicy.SizeType hData, QSizePolicy.SizeType vData);
		public void ChangeSize (int w, int h, QSizePolicy.SizeType hData, QSizePolicy.SizeType vData)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpacerItem_changeSize (rawObject, w, h, hData, vData);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpacerItem_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpacerItem_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpacerItem_minimumSize (IntPtr raw);
		public QSize MinimumSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpacerItem_minimumSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpacerItem_maximumSize (IntPtr raw);
		public QSize MaximumSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpacerItem_maximumSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSizePolicy.ExpandData qt_QSpacerItem_expanding (IntPtr raw);
		public QSizePolicy.ExpandData Expanding ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpacerItem_expanding (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSpacerItem_isEmpty (IntPtr raw);
		public bool IsEmpty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpacerItem_isEmpty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpacerItem_setGeometry (IntPtr raw, IntPtr arg1);
		public void SetGeometry (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpacerItem_setGeometry (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpacerItem_geometry (IntPtr raw);
		public QRect Geometry ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpacerItem_geometry (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpacerItem_spacerItem (IntPtr raw);
		public QSpacerItem SpacerItem ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpacerItem_spacerItem (rawObject), typeof (QSpacerItem)) as QSpacerItem;
		}

		public void ChangeSize (int w, int h)
		{
			ChangeSize(w, h, QSizePolicy.SizeType.Minimum);
		}

		public void ChangeSize (int w, int h, QSizePolicy.SizeType hData)
		{
			ChangeSize(w, h, hData, QSizePolicy.SizeType.Minimum);
		}

		// Begin interface methods.

	}
}