// QSpinBox.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSpinBox : QWidget, IQRangeControl, IDisposable {

		public enum ButtonSymbols {
			UpDownArrows = 0,
			PlusMinus = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSpinBox (IntPtr parent, string name);
		public QSpinBox (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QSpinBox (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSpinBox1 (int minValue, int maxValue, int step, IntPtr parent, string name);
		public QSpinBox (int minValue, int maxValue, int step, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QSpinBox1 (minValue, maxValue, step, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QSpinBox () : this (new QWidget ()) {}

		public QSpinBox (QWidget parent) : this (parent, "") {}

		public QSpinBox (int minValue, int maxValue) : this (minValue, maxValue, (int) 1) {}

		public QSpinBox (int minValue, int maxValue, int step) : this (minValue, maxValue, step, new QWidget ()) {}

		public QSpinBox (int minValue, int maxValue, int step, QWidget parent) : this (minValue, maxValue, step, parent, "") {}

		public QSpinBox (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSpinBox (QNull dummy) : base (QNull.Instance) {}

		~QSpinBox ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QSpinBox (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QSpinBox (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_text (IntPtr raw);
		public string Text ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSpinBox_text (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_prefix (IntPtr raw);
		public string Prefix ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSpinBox_prefix (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_suffix (IntPtr raw);
		public string Suffix ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSpinBox_suffix (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_cleanText (IntPtr raw);
		public string CleanText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSpinBox_cleanText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_setSpecialValueText (IntPtr raw, IntPtr text);
		public void SetSpecialValueText (string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_setSpecialValueText (rawObject, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_specialValueText (IntPtr raw);
		public string SpecialValueText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSpinBox_specialValueText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_setWrapping (IntPtr raw, bool on);
		public void SetWrapping (bool on)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_setWrapping (rawObject, on);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSpinBox_wrapping (IntPtr raw);
		public bool Wrapping ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpinBox_wrapping (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_setButtonSymbols (IntPtr raw, ButtonSymbols arg1);
		public void SetButtonSymbols (ButtonSymbols arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_setButtonSymbols (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ButtonSymbols qt_QSpinBox_buttonSymbols (IntPtr raw);
		public ButtonSymbols TheButtonSymbols ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpinBox_buttonSymbols (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_setValidator (IntPtr raw, IntPtr v);
		public void SetValidator (QValidator v)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_setValidator (rawObject, v.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_validator (IntPtr raw);
		public QValidator Validator ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpinBox_validator (rawObject), typeof (QValidator)) as QValidator;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpinBox_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpinBox_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSpinBox_minValue (IntPtr raw);
		public int MinValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpinBox_minValue (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSpinBox_maxValue (IntPtr raw);
		public int MaxValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpinBox_maxValue (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_setMinValue (IntPtr raw, int arg1);
		public void SetMinValue (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_setMinValue (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_setMaxValue (IntPtr raw, int arg1);
		public void SetMaxValue (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_setMaxValue (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSpinBox_lineStep (IntPtr raw);
		public int LineStep ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpinBox_lineStep (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_setLineStep (IntPtr raw, int arg1);
		public void SetLineStep (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_setLineStep (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSpinBox_value (IntPtr raw);
		public int Value ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpinBox_value (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_upRect (IntPtr raw);
		public QRect UpRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpinBox_upRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_downRect (IntPtr raw);
		public QRect DownRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpinBox_downRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_setValue (IntPtr raw, int value);
		public void SetValue (int value)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_setValue (rawObject, value);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_setPrefix (IntPtr raw, IntPtr text);
		public void SetPrefix (string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_setPrefix (rawObject, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_setSuffix (IntPtr raw, IntPtr text);
		public void SetSuffix (string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_setSuffix (rawObject, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_stepUp (IntPtr raw);
		public void StepUp ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_stepUp (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_stepDown (IntPtr raw);
		public void StepDown ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_stepDown (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_setEnabled (IntPtr raw, bool enabled);
		public void SetEnabled (bool enabled)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_setEnabled (rawObject, enabled);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_selectAll (IntPtr raw);
		public void SelectAll ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_selectAll (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_mapValueToText (IntPtr raw, int value);
		protected string MapValueToText (int value)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSpinBox_mapValueToText (rawObject, value));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSpinBox_mapTextToValue (IntPtr raw, bool ok);
		protected int MapTextToValue (bool ok)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpinBox_mapTextToValue (rawObject, ok);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_currentValueText (IntPtr raw);
		protected string CurrentValueText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSpinBox_currentValueText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_updateDisplay (IntPtr raw);
		protected void UpdateDisplay ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_updateDisplay (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_interpretText (IntPtr raw);
		protected void InterpretText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_interpretText (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_editor (IntPtr raw);
		protected QLineEdit Editor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpinBox_editor (rawObject), typeof (QLineEdit)) as QLineEdit;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_valueChange (IntPtr raw);
		protected void ValueChange ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_valueChange (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_rangeChange (IntPtr raw);
		protected void RangeChange ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_rangeChange (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSpinBox_eventFilter (IntPtr raw, IntPtr obj, IntPtr ev);
		protected bool EventFilter (QObject obj, QEvent ev)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpinBox_eventFilter (rawObject, obj.RawObject, ev.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinBox_textChanged (IntPtr raw);
		protected void TextChanged ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinBox_textChanged (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinBox_QRangeControl (IntPtr raw);
		public IntPtr QRangeControl ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpinBox_QRangeControl (rawObject);
		}

		// Begin interface methods.


		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRangeControl_setRange (IntPtr raw, int minValue, int maxValue);
		public void SetRange (int minValue, int maxValue)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRangeControl_setRange (QRangeControl (), minValue, maxValue);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRangeControl_setSteps (IntPtr raw, int line, int page);
		public void SetSteps (int line, int page)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRangeControl_setSteps (QRangeControl (), line, page);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRangeControl_bound (IntPtr raw, int arg1);
		public int Bound (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRangeControl_bound (QRangeControl (), arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRangeControl_positionFromValue (IntPtr raw, int val, int space);
		protected int PositionFromValue (int val, int space)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRangeControl_positionFromValue (QRangeControl (), val, space);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRangeControl_valueFromPosition (IntPtr raw, int pos, int space);
		protected int ValueFromPosition (int pos, int space)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRangeControl_valueFromPosition (QRangeControl (), pos, space);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QRangeControl_directSetValue (IntPtr raw, int val);
		protected void DirectSetValue (int val)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QRangeControl_directSetValue (QRangeControl (), val);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QRangeControl_prevValue (IntPtr raw);
		protected int PrevValue ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QRangeControl_prevValue (QRangeControl ());
		}

		// Begin interface methods.

	}
}