// QSpinWidget.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSpinWidget : QWidget, IDisposable {

		public enum ButtonSymbols {
			UpDownArrows = 0,
			PlusMinus = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSpinWidget (IntPtr parent, string name);
		public QSpinWidget (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QSpinWidget (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QSpinWidget () : this (new QWidget ()) {}

		public QSpinWidget (QWidget parent) : this (parent, "") {}

		public QSpinWidget (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSpinWidget (QNull dummy) : base (QNull.Instance) {}

		~QSpinWidget ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QSpinWidget (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QSpinWidget (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinWidget_setEditWidget (IntPtr raw, IntPtr widget);
		public void SetEditWidget (QWidget widget)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinWidget_setEditWidget (rawObject, widget.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinWidget_editWidget (IntPtr raw);
		public QWidget EditWidget ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpinWidget_editWidget (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinWidget_upRect (IntPtr raw);
		public QRect UpRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpinWidget_upRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSpinWidget_downRect (IntPtr raw);
		public QRect DownRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSpinWidget_downRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinWidget_setUpEnabled (IntPtr raw, bool on);
		public void SetUpEnabled (bool on)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinWidget_setUpEnabled (rawObject, on);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinWidget_setDownEnabled (IntPtr raw, bool on);
		public void SetDownEnabled (bool on)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinWidget_setDownEnabled (rawObject, on);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSpinWidget_isUpEnabled (IntPtr raw);
		public bool IsUpEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpinWidget_isUpEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSpinWidget_isDownEnabled (IntPtr raw);
		public bool IsDownEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpinWidget_isDownEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinWidget_setButtonSymbols (IntPtr raw, ButtonSymbols bs);
		public void SetButtonSymbols (ButtonSymbols bs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinWidget_setButtonSymbols (rawObject, bs);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern ButtonSymbols qt_QSpinWidget_buttonSymbols (IntPtr raw);
		public ButtonSymbols TheButtonSymbols ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSpinWidget_buttonSymbols (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinWidget_arrange (IntPtr raw);
		public void Arrange ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinWidget_arrange (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinWidget_stepUp (IntPtr raw);
		public void StepUp ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinWidget_stepUp (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinWidget_stepDown (IntPtr raw);
		public void StepDown ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinWidget_stepDown (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinWidget_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinWidget_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSpinWidget_enableChanged (IntPtr raw, bool old);
		protected void EnableChanged (bool old)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSpinWidget_enableChanged (rawObject, old);
		}

		// Begin interface methods.

	}
}