// QSplitter.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSplitter : QFrame, IDisposable {

		public enum ResizeMode {
			Stretch = 0,
			KeepSize = 1,
			FollowSizeHint = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSplitter (IntPtr parent, string name);
		public QSplitter (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QSplitter (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSplitter1 (Orientation arg1, IntPtr parent, string name);
		public QSplitter (Orientation arg1, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QSplitter1 (arg1, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QSplitter () : this (new QWidget ()) {}

		public QSplitter (QWidget parent) : this (parent, "") {}

		public QSplitter (Orientation arg1) : this (arg1, new QWidget ()) {}

		public QSplitter (Orientation arg1, QWidget parent) : this (arg1, parent, "") {}

		public QSplitter (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSplitter (QNull dummy) : base (QNull.Instance) {}

		~QSplitter ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QSplitter (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QSplitter (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSplitter_setOrientation (IntPtr raw, Orientation arg1);
		public void SetOrientation (Orientation arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSplitter_setOrientation (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Orientation qt_QSplitter_orientation (IntPtr raw);
		public Orientation Orientation ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSplitter_orientation (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSplitter_setResizeMode (IntPtr raw, IntPtr w, ResizeMode arg1);
		public void SetResizeMode (QWidget w, ResizeMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSplitter_setResizeMode (rawObject, w.RawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSplitter_setOpaqueResize (IntPtr raw, bool arg1);
		public void SetOpaqueResize (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSplitter_setOpaqueResize (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSplitter_opaqueResize (IntPtr raw);
		public bool OpaqueResize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSplitter_opaqueResize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSplitter_moveToFirst (IntPtr raw, IntPtr arg1);
		public void MoveToFirst (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSplitter_moveToFirst (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSplitter_moveToLast (IntPtr raw, IntPtr arg1);
		public void MoveToLast (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSplitter_moveToLast (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSplitter_refresh (IntPtr raw);
		public void Refresh ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSplitter_refresh (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSplitter_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSplitter_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSplitter_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSplitter_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSplitter_event (IntPtr raw, IntPtr arg1);
		protected bool Q_event (QEvent arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSplitter_event (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSplitter_idAfter (IntPtr raw, IntPtr arg1);
		protected int IdAfter (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSplitter_idAfter (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSplitter_moveSplitter (IntPtr raw, short pos, int identifier);
		protected void MoveSplitter (short pos, int identifier)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSplitter_moveSplitter (rawObject, pos, identifier);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSplitter_drawSplitter (IntPtr raw, IntPtr arg1, short x, short y, short w, short h);
		protected void DrawSplitter (QPainter arg1, short x, short y, short w, short h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSplitter_drawSplitter (rawObject, arg1.RawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSplitter_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSplitter_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSplitter_adjustPos (IntPtr raw, int arg1, int arg2);
		protected int AdjustPos (int arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSplitter_adjustPos (rawObject, arg1, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSplitter_setRubberband (IntPtr raw, int arg1);
		protected void SetRubberband (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSplitter_setRubberband (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSplitter_getRange (IntPtr raw, int identifier, int[] arg1, int[] arg2);
		protected void GetRange (int identifier, int[] arg1, int[] arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSplitter_getRange (rawObject, identifier, arg1, arg2);
		}

		public void SetOpaqueResize ()
		{
			SetOpaqueResize(true);
		}

		// Begin interface methods.

	}
}