// QSqlDatabase.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSqlDatabase : QObject, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSqlDatabase (IntPtr type, IntPtr name, IntPtr parent, string objname);
		protected QSqlDatabase (string type, string name, QObject parent, string objname) : this (QNull.Instance)
		{
			rawObject = qt_new_QSqlDatabase (new QString (type).RawObject, new QString (name).RawObject, parent != null ? parent.RawObject : IntPtr.Zero, objname);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		protected QSqlDatabase (string type, string name) : this (type, name, new QObject ()) {}

		protected QSqlDatabase (string type, string name, QObject parent) : this (type, name, parent, "") {}

		internal QSqlDatabase () : this (QNull.Instance) {}

		public QSqlDatabase (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSqlDatabase (QNull dummy) : base (QNull.Instance) {}

		~QSqlDatabase ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QSqlDatabase (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QSqlDatabase (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDatabase_open (IntPtr raw);
		public bool Open ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDatabase_open (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDatabase_open1 (IntPtr raw, IntPtr user, IntPtr password);
		public bool Open (string user, string password)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDatabase_open1 (rawObject, new QString (user).RawObject, new QString (password).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlDatabase_close (IntPtr raw);
		public void Close ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlDatabase_close (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDatabase_isOpen (IntPtr raw);
		public bool IsOpen ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDatabase_isOpen (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDatabase_isOpenError (IntPtr raw);
		public bool IsOpenError ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDatabase_isOpenError (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_tables (IntPtr raw);
		public QStringList Tables ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDatabase_tables (rawObject), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_primaryIndex (IntPtr raw, IntPtr tablename);
		public QSqlIndex PrimaryIndex (string tablename)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDatabase_primaryIndex (rawObject, new QString (tablename).RawObject), typeof (QSqlIndex)) as QSqlIndex;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_record (IntPtr raw, IntPtr tablename);
		public QSqlRecord Record (string tablename)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDatabase_record (rawObject, new QString (tablename).RawObject), typeof (QSqlRecord)) as QSqlRecord;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_record1 (IntPtr raw, IntPtr query);
		public QSqlRecord Record (QSqlQuery query)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDatabase_record1 (rawObject, query.RawObject), typeof (QSqlRecord)) as QSqlRecord;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_recordInfo (IntPtr raw, IntPtr tablename);
		public IntPtr RecordInfo (string tablename)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDatabase_recordInfo (rawObject, new QString (tablename).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_recordInfo1 (IntPtr raw, IntPtr query);
		public IntPtr RecordInfo (QSqlQuery query)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDatabase_recordInfo1 (rawObject, query.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_exec (IntPtr raw, IntPtr query);
		public QSqlQuery Exec (string query)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDatabase_exec (rawObject, new QString (query).RawObject), typeof (QSqlQuery)) as QSqlQuery;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_lastError (IntPtr raw);
		public QSqlError LastError ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDatabase_lastError (rawObject), typeof (QSqlError)) as QSqlError;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDatabase_transaction (IntPtr raw);
		public bool Transaction ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDatabase_transaction (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDatabase_commit (IntPtr raw);
		public bool Commit ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDatabase_commit (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDatabase_rollback (IntPtr raw);
		public bool Rollback ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDatabase_rollback (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlDatabase_setDatabaseName (IntPtr raw, IntPtr name);
		public void SetDatabaseName (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlDatabase_setDatabaseName (rawObject, new QString (name).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlDatabase_setUserName (IntPtr raw, IntPtr name);
		public void SetUserName (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlDatabase_setUserName (rawObject, new QString (name).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlDatabase_setPassword (IntPtr raw, IntPtr password);
		public void SetPassword (string password)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlDatabase_setPassword (rawObject, new QString (password).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlDatabase_setHostName (IntPtr raw, IntPtr host);
		public void SetHostName (string host)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlDatabase_setHostName (rawObject, new QString (host).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlDatabase_setPort (IntPtr raw, int p);
		public void SetPort (int p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlDatabase_setPort (rawObject, p);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_databaseName (IntPtr raw);
		public string DatabaseName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSqlDatabase_databaseName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_userName (IntPtr raw);
		public string UserName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSqlDatabase_userName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_password (IntPtr raw);
		public string Password ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSqlDatabase_password (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_hostName (IntPtr raw);
		public string HostName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSqlDatabase_hostName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_driverName (IntPtr raw);
		public string DriverName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSqlDatabase_driverName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSqlDatabase_port (IntPtr raw);
		public int Port ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDatabase_port (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_driver (IntPtr raw);
		public QSqlDriver Driver ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDatabase_driver (rawObject), typeof (QSqlDriver)) as QSqlDriver;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_addDatabase (IntPtr type, IntPtr connectionName);
		public static QSqlDatabase AddDatabase (string type, string connectionName)
		{
			return LookupObject (qt_QSqlDatabase_addDatabase (new QString (type).RawObject, new QString (connectionName).RawObject), typeof (QSqlDatabase)) as QSqlDatabase;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_database (IntPtr connectionName, bool open);
		public static QSqlDatabase Database (string connectionName, bool open)
		{
			return LookupObject (qt_QSqlDatabase_database (new QString (connectionName).RawObject, open), typeof (QSqlDatabase)) as QSqlDatabase;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlDatabase_removeDatabase (IntPtr connectionName);
		public static void RemoveDatabase (string connectionName)
		{
			qt_QSqlDatabase_removeDatabase (new QString (connectionName).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDatabase_contains (IntPtr connectionName);
		public static bool Contains (string connectionName)
		{
			return qt_QSqlDatabase_contains (new QString (connectionName).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDatabase_drivers ();
		public static QStringList Drivers ()
		{
			return LookupObject (qt_QSqlDatabase_drivers (), typeof (QStringList)) as QStringList;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlDatabase_registerSqlDriver (IntPtr name, IntPtr dcb);
		public static void RegisterSqlDriver (string name, QSqlDriverCreatorBase dcb)
		{
			qt_QSqlDatabase_registerSqlDriver (new QString (name).RawObject, dcb.RawObject);
		}

		public QSqlQuery Exec ()
		{
			return Exec((string) "");
		}

		public static QSqlDatabase AddDatabase (string type)
		{
			return AddDatabase(type, (string) "defaultConnection");
		}

		public static QSqlDatabase Database ()
		{
			return Database((string) "defaultConnection");
		}

		public static QSqlDatabase Database (string connectionName)
		{
			return Database(connectionName, true);
		}

		public static bool Contains ()
		{
			return Contains((string) "defaultConnection");
		}

		// Begin interface methods.

	}
}