// QSqlDriver.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSqlDriver : QObject, IDisposable {

		public enum DriverFeature {
			Transactions = 0,
			QuerySize = 1,
			BLOB = 2
		}

		internal QSqlDriver () : this (QNull.Instance) {}

		public QSqlDriver (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSqlDriver (QNull dummy) : base (QNull.Instance) {}

		~QSqlDriver ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QSqlDriver (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QSqlDriver (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDriver_isOpen (IntPtr raw);
		public bool IsOpen ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDriver_isOpen (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDriver_isOpenError (IntPtr raw);
		public bool IsOpenError ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDriver_isOpenError (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDriver_beginTransaction (IntPtr raw);
		public bool BeginTransaction ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDriver_beginTransaction (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDriver_commitTransaction (IntPtr raw);
		public bool CommitTransaction ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDriver_commitTransaction (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDriver_rollbackTransaction (IntPtr raw);
		public bool RollbackTransaction ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDriver_rollbackTransaction (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDriver_tables (IntPtr raw, IntPtr user);
		public QStringList Tables (string user)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDriver_tables (rawObject, new QString (user).RawObject), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDriver_primaryIndex (IntPtr raw, IntPtr tableName);
		public QSqlIndex PrimaryIndex (string tableName)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDriver_primaryIndex (rawObject, new QString (tableName).RawObject), typeof (QSqlIndex)) as QSqlIndex;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDriver_record (IntPtr raw, IntPtr tableName);
		public QSqlRecord Record (string tableName)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDriver_record (rawObject, new QString (tableName).RawObject), typeof (QSqlRecord)) as QSqlRecord;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDriver_record1 (IntPtr raw, IntPtr query);
		public QSqlRecord Record (QSqlQuery query)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDriver_record1 (rawObject, query.RawObject), typeof (QSqlRecord)) as QSqlRecord;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDriver_recordInfo (IntPtr raw, IntPtr tablename);
		public IntPtr RecordInfo (string tablename)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDriver_recordInfo (rawObject, new QString (tablename).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDriver_recordInfo1 (IntPtr raw, IntPtr query);
		public IntPtr RecordInfo (QSqlQuery query)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDriver_recordInfo1 (rawObject, query.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDriver_nullText (IntPtr raw);
		public string NullText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSqlDriver_nullText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDriver_formatValue (IntPtr raw, IntPtr field, bool trimStrings);
		public string FormatValue (QSqlField field, bool trimStrings)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSqlDriver_formatValue (rawObject, field.RawObject, trimStrings));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDriver_lastError (IntPtr raw);
		public QSqlError LastError ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDriver_lastError (rawObject), typeof (QSqlError)) as QSqlError;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDriver_hasFeature (IntPtr raw, QSqlDriver.DriverFeature f);
		public bool HasFeature (QSqlDriver.DriverFeature f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDriver_hasFeature (rawObject, f);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlDriver_open (IntPtr raw, IntPtr db, IntPtr user, IntPtr password, IntPtr host, int port);
		public bool Open (string db, string user, string password, string host, int port)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlDriver_open (rawObject, new QString (db).RawObject, new QString (user).RawObject, new QString (password).RawObject, new QString (host).RawObject, port);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlDriver_close (IntPtr raw);
		public void Close ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlDriver_close (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlDriver_createQuery (IntPtr raw);
		public QSqlQuery CreateQuery ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlDriver_createQuery (rawObject), typeof (QSqlQuery)) as QSqlQuery;
		}

		public string FormatValue (QSqlField field)
		{
			return FormatValue(field, false);
		}

		public bool Open (string db)
		{
			return Open(db, (string) "");
		}

		public bool Open (string db, string user)
		{
			return Open(db, user, (string) "");
		}

		public bool Open (string db, string user, string password)
		{
			return Open(db, user, password, (string) "");
		}

		public bool Open (string db, string user, string password, string host)
		{
			return Open(db, user, password, host, (int) -1);
		}

		// Begin interface methods.

	}
}