// QSqlError.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSqlError : QtSupport, IDisposable {

		public enum Type {
			None = 0,
			Connection = 1,
			Statement = 2,
			Transaction = 3,
			Unknown = 4
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSqlError (IntPtr driverText, IntPtr databaseText, int type, int number);
		public QSqlError (string driverText, string databaseText, int type, int number) : this (QNull.Instance)
		{
			rawObject = qt_new_QSqlError (new QString (driverText).RawObject, new QString (databaseText).RawObject, type, number);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSqlError1 (IntPtr other);
		public QSqlError (QSqlError other) : this (QNull.Instance)
		{
			rawObject = qt_new_QSqlError1 (other.RawObject);
			RegisterObject (this);
		}

		public QSqlError () : this ((string) "") {}

		public QSqlError (string driverText) : this (driverText, (string) "") {}

		public QSqlError (string driverText, string databaseText) : this (driverText, databaseText, (int) Type.None) {}

		public QSqlError (string driverText, string databaseText, int type) : this (driverText, databaseText, type, (int) -1) {}

		public QSqlError (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSqlError (QNull dummy) : base (QNull.Instance) {}

		~QSqlError ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QSqlError (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QSqlError (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlError_driverText (IntPtr raw);
		public string DriverText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSqlError_driverText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlError_setDriverText (IntPtr raw, IntPtr driverText);
		public void SetDriverText (string driverText)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlError_setDriverText (rawObject, new QString (driverText).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlError_databaseText (IntPtr raw);
		public string DatabaseText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSqlError_databaseText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlError_setDatabaseText (IntPtr raw, IntPtr databaseText);
		public void SetDatabaseText (string databaseText)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlError_setDatabaseText (rawObject, new QString (databaseText).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSqlError_type (IntPtr raw);
		public int TheType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlError_type (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlError_setType (IntPtr raw, int type);
		public void SetType (int type)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlError_setType (rawObject, type);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSqlError_number (IntPtr raw);
		public int Number ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlError_number (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlError_setNumber (IntPtr raw, int number);
		public void SetNumber (int number)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlError_setNumber (rawObject, number);
		}
	}
}