// QSqlIndex.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSqlIndex : QSqlRecord, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSqlIndex (IntPtr cursorName, IntPtr name);
		public QSqlIndex (string cursorName, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QSqlIndex (new QString (cursorName).RawObject, new QString (name).RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSqlIndex1 (IntPtr other);
		public QSqlIndex (QSqlIndex other) : this (QNull.Instance)
		{
			rawObject = qt_new_QSqlIndex1 (other.RawObject);
			RegisterObject (this);
		}

		public QSqlIndex () : this ((string) "") {}

		public QSqlIndex (string cursorName) : this (cursorName, (string) "") {}

		public QSqlIndex (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSqlIndex (QNull dummy) : base (QNull.Instance) {}

		~QSqlIndex ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QSqlIndex (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QSqlIndex (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlIndex_setCursorName (IntPtr raw, IntPtr cursorName);
		public void SetCursorName (string cursorName)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlIndex_setCursorName (rawObject, new QString (cursorName).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlIndex_cursorName (IntPtr raw);
		public string CursorName ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSqlIndex_cursorName (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlIndex_setName (IntPtr raw, IntPtr name);
		public void SetName (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlIndex_setName (rawObject, new QString (name).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlIndex_name (IntPtr raw);
		public string Name ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSqlIndex_name (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlIndex_append (IntPtr raw, IntPtr field);
		public void Append (QSqlField field)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlIndex_append (rawObject, field.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlIndex_append1 (IntPtr raw, IntPtr field, bool desc);
		public void Append (QSqlField field, bool desc)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlIndex_append1 (rawObject, field.RawObject, desc);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlIndex_isDescending (IntPtr raw, int i);
		public bool IsDescending (int i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlIndex_isDescending (rawObject, i);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlIndex_setDescending (IntPtr raw, int i, bool desc);
		public void SetDescending (int i, bool desc)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlIndex_setDescending (rawObject, i, desc);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlIndex_toStringList (IntPtr raw, IntPtr prefix, bool verbose);
		public QStringList ToStringList (string prefix, bool verbose)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlIndex_toStringList (rawObject, new QString (prefix).RawObject, verbose), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlIndex_fromStringList (IntPtr l, IntPtr cursor);
		public static QSqlIndex FromStringList (QStringList l, QSqlCursor cursor)
		{
			return LookupObject (qt_QSqlIndex_fromStringList (l.RawObject, cursor.RawObject), typeof (QSqlIndex)) as QSqlIndex;

		}

		public QStringList ToStringList ()
		{
			return ToStringList((string) "");
		}

		public QStringList ToStringList (string prefix)
		{
			return ToStringList(prefix, true);
		}

		// Begin interface methods.

	}
}