// QSqlQuery.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QSqlQuery : QtSupport, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSqlQuery (IntPtr r);
		public QSqlQuery (QSqlResult r) : this (QNull.Instance)
		{
			rawObject = qt_new_QSqlQuery (r.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSqlQuery1 (IntPtr query, IntPtr db);
		public QSqlQuery (string query, QSqlDatabase db) : this (QNull.Instance)
		{
			rawObject = qt_new_QSqlQuery1 (new QString (query).RawObject, db.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QSqlQuery2 (IntPtr other);
		public QSqlQuery (QSqlQuery other) : this (QNull.Instance)
		{
			rawObject = qt_new_QSqlQuery2 (other.RawObject);
			RegisterObject (this);
		}

		public QSqlQuery () : this ((string) "") {}

		public QSqlQuery (string query) : this (query, new QSqlDatabase ()) {}

		public QSqlQuery (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QSqlQuery (QNull dummy) : base (QNull.Instance) {}

		~QSqlQuery ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QSqlQuery (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QSqlQuery (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlQuery_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlQuery_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlQuery_isActive (IntPtr raw);
		public bool IsActive ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlQuery_isActive (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlQuery_isNull (IntPtr raw, int field);
		public bool IsNull (int field)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlQuery_isNull (rawObject, field);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSqlQuery_at (IntPtr raw);
		public int At ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlQuery_at (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlQuery_lastQuery (IntPtr raw);
		public string LastQuery ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QSqlQuery_lastQuery (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSqlQuery_numRowsAffected (IntPtr raw);
		public int NumRowsAffected ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlQuery_numRowsAffected (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlQuery_lastError (IntPtr raw);
		public QSqlError LastError ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlQuery_lastError (rawObject), typeof (QSqlError)) as QSqlError;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlQuery_isSelect (IntPtr raw);
		public bool IsSelect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlQuery_isSelect (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QSqlQuery_size (IntPtr raw);
		public int Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlQuery_size (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlQuery_driver (IntPtr raw);
		public QSqlDriver Driver ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlQuery_driver (rawObject), typeof (QSqlDriver)) as QSqlDriver;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QSqlQuery_result (IntPtr raw);
		public QSqlResult Result ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QSqlQuery_result (rawObject), typeof (QSqlResult)) as QSqlResult;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlQuery_seek (IntPtr raw, int i, bool relative);
		public bool Seek (int i, bool relative)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlQuery_seek (rawObject, i, relative);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlQuery_next (IntPtr raw);
		public bool Next ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlQuery_next (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlQuery_prev (IntPtr raw);
		public bool Prev ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlQuery_prev (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlQuery_first (IntPtr raw);
		public bool First ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlQuery_first (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QSqlQuery_last (IntPtr raw);
		public bool Last ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QSqlQuery_last (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QSqlQuery_beforeSeek (IntPtr raw);
		protected void BeforeSeek ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QSqlQuery_beforeSeek (rawObject);
		}

		public bool Seek (int i)
		{
			return Seek(i, false);
		}
	}
}