// QStringList.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QStringList : QValueList, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QStringList ();
		public QStringList () : this (QNull.Instance)
		{
			rawObject = qt_new_QStringList ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QStringList3 (IntPtr i);
		public QStringList (string i) : this (QNull.Instance)
		{
			rawObject = qt_new_QStringList3 (new QString (i).RawObject);
			RegisterObject (this);
		}

		public QStringList (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QStringList (QNull dummy) : base (QNull.Instance) {}

		~QStringList ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QStringList function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStringList_sort (IntPtr raw);
		public void Sort ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStringList_sort (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStringList_join (IntPtr raw, IntPtr sep);
		public string Join (string sep)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QStringList_join (rawObject, new QString (sep).RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStringList_grep (IntPtr raw, IntPtr str, bool cs);
		public QStringList Grep (string str, bool cs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QStringList_grep (rawObject, new QString (str).RawObject, cs), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStringList_grep1 (IntPtr raw, IntPtr expr);
		public QStringList Grep (QRegExp expr)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QStringList_grep1 (rawObject, expr.RawObject), typeof (QStringList)) as QStringList;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStringList_fromStrList (IntPtr arg1);
		public static QStringList FromStrList (QStrList arg1)
		{
			return LookupObject (qt_QStringList_fromStrList (arg1.RawObject), typeof (QStringList)) as QStringList;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStringList_split (IntPtr sep, IntPtr str, bool allowEmptyEntries);
		public static QStringList Split (string sep, string str, bool allowEmptyEntries)
		{
			return LookupObject (qt_QStringList_split (new QString (sep).RawObject, new QString (str).RawObject, allowEmptyEntries), typeof (QStringList)) as QStringList;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStringList_split1 (IntPtr sep, IntPtr str, bool allowEmptyEntries);
		public static QStringList Split (QChar sep, string str, bool allowEmptyEntries)
		{
			return LookupObject (qt_QStringList_split1 (sep.RawObject, new QString (str).RawObject, allowEmptyEntries), typeof (QStringList)) as QStringList;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStringList_split2 (IntPtr sep, IntPtr str, bool allowEmptyEntries);
		public static QStringList Split (QRegExp sep, string str, bool allowEmptyEntries)
		{
			return LookupObject (qt_QStringList_split2 (sep.RawObject, new QString (str).RawObject, allowEmptyEntries), typeof (QStringList)) as QStringList;

		}

		public QStringList Grep (string str)
		{
			return Grep(str, true);
		}

		public static QStringList Split (string sep, string str)
		{
			return Split(sep, str, false);
		}

		public static QStringList Split (QChar sep, string str)
		{
			return Split(sep, str, false);
		}

		public static QStringList Split (QRegExp sep, string str)
		{
			return Split(sep, str, false);
		}

		// Begin interface methods.

	}
}