// QStyleSheet.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QStyleSheet : QObject, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QStyleSheet (IntPtr parent, string name);
		public QStyleSheet (QObject parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QStyleSheet (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QStyleSheet () : this (new QObject ()) {}

		public QStyleSheet (QObject parent) : this (parent, "") {}

		public QStyleSheet (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QStyleSheet (QNull dummy) : base (QNull.Instance) {}

		~QStyleSheet ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QStyleSheet (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QStyleSheet (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStyleSheet_item (IntPtr raw, IntPtr name);
		public QStyleSheetItem Item (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QStyleSheet_item (rawObject, new QString (name).RawObject), typeof (QStyleSheetItem)) as QStyleSheetItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheet_insert (IntPtr raw, IntPtr item);
		public void Insert (QStyleSheetItem item)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheet_insert (rawObject, item.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheet_scaleFont (IntPtr raw, IntPtr font, int logicalSize);
		public void ScaleFont (QFont font, int logicalSize)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheet_scaleFont (rawObject, font.RawObject, logicalSize);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheet_error (IntPtr raw, IntPtr arg1);
		public void Error (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheet_error (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStyleSheet_defaultSheet ();
		public static QStyleSheet DefaultSheet ()
		{
			return LookupObject (qt_QStyleSheet_defaultSheet (), typeof (QStyleSheet)) as QStyleSheet;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheet_setDefaultSheet (IntPtr arg1);
		public static void SetDefaultSheet (QStyleSheet arg1)
		{
			qt_QStyleSheet_setDefaultSheet (arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStyleSheet_escape (IntPtr arg1);
		public static string Escape (string arg1)
		{
			QString qstr = new QString (qt_QStyleSheet_escape (new QString (arg1).RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStyleSheet_convertFromPlainText (IntPtr arg1, QStyleSheetItem.WhiteSpaceMode mode);
		public static string ConvertFromPlainText (string arg1, QStyleSheetItem.WhiteSpaceMode mode)
		{
			QString qstr = new QString (qt_QStyleSheet_convertFromPlainText (new QString (arg1).RawObject, mode));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QStyleSheet_mightBeRichText (IntPtr arg1);
		public static bool MightBeRichText (string arg1)
		{
			return qt_QStyleSheet_mightBeRichText (new QString (arg1).RawObject);
		}

		public static string ConvertFromPlainText (string arg1)
		{
			return ConvertFromPlainText(arg1, QStyleSheetItem.WhiteSpaceMode.WhiteSpacePre);
		}

		// Begin interface methods.

	}
}