// QStyleSheetItem.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QStyleSheetItem : QtSupport, IDisposable {

		public enum AdditionalStyleValues {
			Undefined = -1
		}

		public enum DisplayMode {
			DisplayBlock = 0,
			DisplayInline = 1,
			DisplayListItem = 2,
			DisplayNone = 3
		}

		public enum VerticalAlignment {
			VAlignBaseline = 0,
			VAlignSub = 1,
			VAlignSuper = 2
		}

		public enum WhiteSpaceMode {
			WhiteSpaceNormal = 0,
			WhiteSpacePre = 1,
			WhiteSpaceNoWrap = 2
		}

		public enum Margin {
			MarginLeft = 0,
			MarginRight = 1,
			MarginTop = 2,
			MarginBottom = 3,
			MarginFirstLine = 4,
			MarginAll = 5,
			MarginVertical = 6,
			MarginHorizontal = 7
		}

		public enum ListStyle {
			ListDisc = 0,
			ListCircle = 1,
			ListSquare = 2,
			ListDecimal = 3,
			ListLowerAlpha = 4,
			ListUpperAlpha = 5
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QStyleSheetItem (IntPtr parent, IntPtr name);
		public QStyleSheetItem (QStyleSheet parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QStyleSheetItem (parent.RawObject, new QString (name).RawObject);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QStyleSheetItem1 (IntPtr arg1);
		public QStyleSheetItem (QStyleSheetItem arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QStyleSheetItem1 (arg1.RawObject);
			RegisterObject (this);
		}

		internal QStyleSheetItem () : this (QNull.Instance) {}

		public QStyleSheetItem (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QStyleSheetItem (QNull dummy) : base (QNull.Instance) {}

		~QStyleSheetItem ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QStyleSheetItem (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QStyleSheetItem (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStyleSheetItem_name (IntPtr raw);
		public string Name ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QStyleSheetItem_name (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStyleSheetItem_styleSheet (IntPtr raw);
		public QStyleSheet StyleSheet ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QStyleSheetItem_styleSheet (rawObject), typeof (QStyleSheet)) as QStyleSheet;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QStyleSheetItem.DisplayMode qt_QStyleSheetItem_displayMode (IntPtr raw);
		public QStyleSheetItem.DisplayMode TheDisplayMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_displayMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setDisplayMode (IntPtr raw, QStyleSheetItem.DisplayMode m);
		public void SetDisplayMode (QStyleSheetItem.DisplayMode m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setDisplayMode (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QStyleSheetItem_alignment (IntPtr raw);
		public int Alignment ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_alignment (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setAlignment (IntPtr raw, int f);
		public void SetAlignment (int f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setAlignment (rawObject, f);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern VerticalAlignment qt_QStyleSheetItem_verticalAlignment (IntPtr raw);
		public VerticalAlignment TheVerticalAlignment ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_verticalAlignment (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setVerticalAlignment (IntPtr raw, VerticalAlignment valign);
		public void SetVerticalAlignment (VerticalAlignment valign)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setVerticalAlignment (rawObject, valign);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QStyleSheetItem_fontWeight (IntPtr raw);
		public int FontWeight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_fontWeight (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setFontWeight (IntPtr raw, int w);
		public void SetFontWeight (int w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setFontWeight (rawObject, w);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QStyleSheetItem_logicalFontSize (IntPtr raw);
		public int LogicalFontSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_logicalFontSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setLogicalFontSize (IntPtr raw, int s);
		public void SetLogicalFontSize (int s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setLogicalFontSize (rawObject, s);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QStyleSheetItem_logicalFontSizeStep (IntPtr raw);
		public int LogicalFontSizeStep ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_logicalFontSizeStep (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setLogicalFontSizeStep (IntPtr raw, int s);
		public void SetLogicalFontSizeStep (int s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setLogicalFontSizeStep (rawObject, s);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QStyleSheetItem_fontSize (IntPtr raw);
		public int FontSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_fontSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setFontSize (IntPtr raw, int s);
		public void SetFontSize (int s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setFontSize (rawObject, s);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStyleSheetItem_fontFamily (IntPtr raw);
		public string FontFamily ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QStyleSheetItem_fontFamily (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setFontFamily (IntPtr raw, IntPtr arg1);
		public void SetFontFamily (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setFontFamily (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QStyleSheetItem_numberOfColumns (IntPtr raw);
		public int NumberOfColumns ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_numberOfColumns (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setNumberOfColumns (IntPtr raw, int ncols);
		public void SetNumberOfColumns (int ncols)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setNumberOfColumns (rawObject, ncols);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStyleSheetItem_color (IntPtr raw);
		public QColor Color ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QStyleSheetItem_color (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setColor (IntPtr raw, IntPtr arg1);
		public void SetColor (QColor arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setColor (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QStyleSheetItem_fontItalic (IntPtr raw);
		public bool FontItalic ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_fontItalic (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setFontItalic (IntPtr raw, bool arg1);
		public void SetFontItalic (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setFontItalic (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QStyleSheetItem_definesFontItalic (IntPtr raw);
		public bool DefinesFontItalic ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_definesFontItalic (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QStyleSheetItem_fontUnderline (IntPtr raw);
		public bool FontUnderline ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_fontUnderline (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setFontUnderline (IntPtr raw, bool arg1);
		public void SetFontUnderline (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setFontUnderline (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QStyleSheetItem_definesFontUnderline (IntPtr raw);
		public bool DefinesFontUnderline ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_definesFontUnderline (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QStyleSheetItem_isAnchor (IntPtr raw);
		public bool IsAnchor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_isAnchor (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setAnchor (IntPtr raw, bool anc);
		public void SetAnchor (bool anc)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setAnchor (rawObject, anc);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QStyleSheetItem.WhiteSpaceMode qt_QStyleSheetItem_whiteSpaceMode (IntPtr raw);
		public QStyleSheetItem.WhiteSpaceMode TheWhiteSpaceMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_whiteSpaceMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setWhiteSpaceMode (IntPtr raw, QStyleSheetItem.WhiteSpaceMode m);
		public void SetWhiteSpaceMode (QStyleSheetItem.WhiteSpaceMode m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setWhiteSpaceMode (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QStyleSheetItem_margin (IntPtr raw, QStyleSheetItem.Margin m);
		public int TheMargin (QStyleSheetItem.Margin m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_margin (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setMargin (IntPtr raw, QStyleSheetItem.Margin arg1, int arg2);
		public void SetMargin (QStyleSheetItem.Margin arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setMargin (rawObject, arg1, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QStyleSheetItem.ListStyle qt_QStyleSheetItem_listStyle (IntPtr raw);
		public QStyleSheetItem.ListStyle TheListStyle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_listStyle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setListStyle (IntPtr raw, QStyleSheetItem.ListStyle arg1);
		public void SetListStyle (QStyleSheetItem.ListStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setListStyle (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QStyleSheetItem_contexts (IntPtr raw);
		public string Contexts ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QStyleSheetItem_contexts (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setContexts (IntPtr raw, IntPtr arg1);
		public void SetContexts (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setContexts (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QStyleSheetItem_allowedInContext (IntPtr raw, IntPtr arg1);
		public bool AllowedInContext (QStyleSheetItem arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_allowedInContext (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QStyleSheetItem_selfNesting (IntPtr raw);
		public bool SelfNesting ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_selfNesting (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setSelfNesting (IntPtr raw, bool arg1);
		public void SetSelfNesting (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setSelfNesting (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QStyleSheetItem_setLineSpacing (IntPtr raw, int ls);
		public void SetLineSpacing (int ls)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QStyleSheetItem_setLineSpacing (rawObject, ls);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QStyleSheetItem_lineSpacing (IntPtr raw);
		public int LineSpacing ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QStyleSheetItem_lineSpacing (rawObject);
		}

		// Begin interface methods.

	}
}