// QTabBar.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QTabBar : QWidget, IDisposable {

		public enum Shape {
			RoundedAbove = 0,
			RoundedBelow = 1,
			TriangularAbove = 2,
			TriangularBelow = 3
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTabBar (IntPtr parent, string name);
		public QTabBar (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QTabBar (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QTabBar () : this (new QWidget ()) {}

		public QTabBar (QWidget parent) : this (parent, "") {}

		public QTabBar (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QTabBar (QNull dummy) : base (QNull.Instance) {}

		~QTabBar ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QTabBar (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QTabBar (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Shape qt_QTabBar_shape (IntPtr raw);
		public Shape TheShape ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabBar_shape (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_setShape (IntPtr raw, Shape arg1);
		public void SetShape (Shape arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_setShape (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_show (IntPtr raw);
		public void Show ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_show (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTabBar_addTab (IntPtr raw, IntPtr arg1);
		public int AddTab (QTab arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabBar_addTab (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTabBar_insertTab (IntPtr raw, IntPtr arg1, int index);
		public int InsertTab (QTab arg1, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabBar_insertTab (rawObject, arg1.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_removeTab (IntPtr raw, IntPtr arg1);
		public void RemoveTab (QTab arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_removeTab (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_setTabEnabled (IntPtr raw, int arg1, bool arg2);
		public void SetTabEnabled (int arg1, bool arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_setTabEnabled (rawObject, arg1, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTabBar_isTabEnabled (IntPtr raw, int arg1);
		public bool IsTabEnabled (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabBar_isTabEnabled (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTabBar_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTabBar_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTabBar_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTabBar_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTabBar_currentTab (IntPtr raw);
		public int CurrentTab ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabBar_currentTab (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTabBar_keyboardFocusTab (IntPtr raw);
		public int KeyboardFocusTab ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabBar_keyboardFocusTab (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTabBar_tab (IntPtr raw, int arg1);
		public QTab Tab (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTabBar_tab (rawObject, arg1), typeof (QTab)) as QTab;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTabBar_tabAt (IntPtr raw, int arg1);
		public QTab TabAt (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTabBar_tabAt (rawObject, arg1), typeof (QTab)) as QTab;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTabBar_indexOf (IntPtr raw, int arg1);
		public int IndexOf (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabBar_indexOf (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTabBar_count (IntPtr raw);
		public int Count ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabBar_count (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_layoutTabs (IntPtr raw);
		public void LayoutTabs ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_layoutTabs (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTabBar_selectTab (IntPtr raw, IntPtr p);
		public QTab SelectTab (QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTabBar_selectTab (rawObject, p.RawObject), typeof (QTab)) as QTab;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_removeToolTip (IntPtr raw, int index);
		public void RemoveToolTip (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_removeToolTip (rawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_setToolTip (IntPtr raw, int index, IntPtr tip);
		public void SetToolTip (int index, string tip)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_setToolTip (rawObject, index, new QString (tip).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTabBar_toolTip (IntPtr raw, int index);
		public string ToolTip (int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTabBar_toolTip (rawObject, index));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_setCurrentTab (IntPtr raw, int arg1);
		public void SetCurrentTab (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_setCurrentTab (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_setCurrentTab1 (IntPtr raw, IntPtr arg1);
		public void SetCurrentTab (QTab arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_setCurrentTab1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_paint (IntPtr raw, IntPtr arg1, IntPtr arg2, bool arg3);
		protected void Paint (QPainter arg1, QTab arg2, bool arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_paint (rawObject, arg1.RawObject, arg2.RawObject, arg3);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_paintLabel (IntPtr raw, IntPtr arg1, IntPtr arg2, IntPtr arg3, bool arg4);
		protected void PaintLabel (QPainter arg1, QRect arg2, QTab arg3, bool arg4)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_paintLabel (rawObject, arg1.RawObject, arg2.RawObject, arg3.RawObject, arg4);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabBar_fontChange (IntPtr raw, IntPtr arg1);
		protected void FontChange (QFont arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabBar_fontChange (rawObject, arg1.RawObject);
		}

		public int InsertTab (QTab arg1)
		{
			return InsertTab(arg1, (int) -1);
		}

		// Begin interface methods.

	}
}