// QTabDialog.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QTabDialog : QDialog, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTabDialog (IntPtr parent, string name, bool modal, Qt.WidgetFlags f);
		public QTabDialog (QWidget parent, string name, bool modal, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QTabDialog (parent != null ? parent.RawObject : IntPtr.Zero, name, modal, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QTabDialog () : this (new QWidget ()) {}

		public QTabDialog (QWidget parent) : this (parent, "") {}

		public QTabDialog (QWidget parent, string name) : this (parent, name, false) {}

		public QTabDialog (QWidget parent, string name, bool modal) : this (parent, name, modal, Qt.WidgetFlags.WWinOwnDC) {}

		public QTabDialog (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QTabDialog (QNull dummy) : base (QNull.Instance) {}

		~QTabDialog ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QTabDialog (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QTabDialog (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_show (IntPtr raw);
		public void Show ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_show (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setFont (IntPtr raw, IntPtr font);
		public void SetFont (QFont font)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setFont (rawObject, font.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_addTab (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public void AddTab (QWidget arg1, string arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_addTab (rawObject, arg1.RawObject, new QString (arg2).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_addTab1 (IntPtr raw, IntPtr child, IntPtr iconset, IntPtr label);
		public void AddTab (QWidget child, QIconSet iconset, string label)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_addTab1 (rawObject, child.RawObject, iconset.RawObject, new QString (label).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_addTab2 (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public void AddTab (QWidget arg1, QTab arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_addTab2 (rawObject, arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_insertTab (IntPtr raw, IntPtr arg1, IntPtr arg2, int index);
		public void InsertTab (QWidget arg1, string arg2, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_insertTab (rawObject, arg1.RawObject, new QString (arg2).RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_insertTab1 (IntPtr raw, IntPtr child, IntPtr iconset, IntPtr label, int index);
		public void InsertTab (QWidget child, QIconSet iconset, string label, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_insertTab1 (rawObject, child.RawObject, iconset.RawObject, new QString (label).RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_insertTab2 (IntPtr raw, IntPtr arg1, IntPtr arg2, int index);
		public void InsertTab (QWidget arg1, QTab arg2, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_insertTab2 (rawObject, arg1.RawObject, arg2.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_changeTab (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public void ChangeTab (QWidget arg1, string arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_changeTab (rawObject, arg1.RawObject, new QString (arg2).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_changeTab1 (IntPtr raw, IntPtr child, IntPtr iconset, IntPtr label);
		public void ChangeTab (QWidget child, QIconSet iconset, string label)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_changeTab1 (rawObject, child.RawObject, iconset.RawObject, new QString (label).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTabDialog_isTabEnabled (IntPtr raw, IntPtr arg1);
		public bool IsTabEnabled (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabDialog_isTabEnabled (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setTabEnabled (IntPtr raw, IntPtr arg1, bool arg2);
		public void SetTabEnabled (QWidget arg1, bool arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setTabEnabled (rawObject, arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTabDialog_isTabEnabled1 (IntPtr raw, string arg1);
		public bool IsTabEnabled (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabDialog_isTabEnabled1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setTabEnabled1 (IntPtr raw, string arg1, bool arg2);
		public void SetTabEnabled (string arg1, bool arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setTabEnabled1 (rawObject, arg1, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_showPage (IntPtr raw, IntPtr arg1);
		public void ShowPage (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_showPage (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_removePage (IntPtr raw, IntPtr arg1);
		public void RemovePage (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_removePage (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTabDialog_tabLabel (IntPtr raw, IntPtr arg1);
		public string TabLabel (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTabDialog_tabLabel (rawObject, arg1.RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTabDialog_currentPage (IntPtr raw);
		public QWidget CurrentPage ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTabDialog_currentPage (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setDefaultButton (IntPtr raw, IntPtr text);
		public void SetDefaultButton (string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setDefaultButton (rawObject, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setDefaultButton1 (IntPtr raw);
		public void SetDefaultButton ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setDefaultButton1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTabDialog_hasDefaultButton (IntPtr raw);
		public bool HasDefaultButton ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabDialog_hasDefaultButton (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setHelpButton (IntPtr raw, IntPtr text);
		public void SetHelpButton (string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setHelpButton (rawObject, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setHelpButton1 (IntPtr raw);
		public void SetHelpButton ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setHelpButton1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTabDialog_hasHelpButton (IntPtr raw);
		public bool HasHelpButton ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabDialog_hasHelpButton (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setCancelButton (IntPtr raw, IntPtr text);
		public void SetCancelButton (string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setCancelButton (rawObject, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setCancelButton1 (IntPtr raw);
		public void SetCancelButton ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setCancelButton1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTabDialog_hasCancelButton (IntPtr raw);
		public bool HasCancelButton ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabDialog_hasCancelButton (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setApplyButton (IntPtr raw, IntPtr text);
		public void SetApplyButton (string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setApplyButton (rawObject, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setApplyButton1 (IntPtr raw);
		public void SetApplyButton ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setApplyButton1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTabDialog_hasApplyButton (IntPtr raw);
		public bool HasApplyButton ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabDialog_hasApplyButton (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setOKButton (IntPtr raw, IntPtr text);
		public void SetOKButton (string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setOKButton (rawObject, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setOkButton (IntPtr raw, IntPtr text);
		public void SetOkButton (string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setOkButton (rawObject, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setOkButton1 (IntPtr raw);
		public void SetOkButton ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setOkButton1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTabDialog_hasOkButton (IntPtr raw);
		public bool HasOkButton ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabDialog_hasOkButton (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabDialog_setTabBar (IntPtr raw, IntPtr arg1);
		protected void SetTabBar (QTabBar arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabDialog_setTabBar (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTabDialog_tabBar (IntPtr raw);
		protected QTabBar TabBar ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTabDialog_tabBar (rawObject), typeof (QTabBar)) as QTabBar;
		}

		public void InsertTab (QWidget arg1, string arg2)
		{
			InsertTab(arg1, arg2, (int) -1);
		}

		public void InsertTab (QWidget child, QIconSet iconset, string label)
		{
			InsertTab(child, iconset, label, (int) -1);
		}

		public void InsertTab (QWidget arg1, QTab arg2)
		{
			InsertTab(arg1, arg2, (int) -1);
		}

		public void SetOKButton ()
		{
			SetOKButton((string) "");
		}

		// Begin interface methods.

	}
}