// QTabWidget.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QTabWidget : QWidget, IDisposable {

		public enum TabPosition {
			Top = 0,
			Bottom = 1
		}

		public enum TabShape {
			Rounded = 0,
			Triangular = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTabWidget (IntPtr parent, string name);
		public QTabWidget (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QTabWidget (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QTabWidget (QWidget parent) : this (parent, "") {}

		internal QTabWidget () : this (QNull.Instance) {}

		public QTabWidget (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QTabWidget (QNull dummy) : base (QNull.Instance) {}

		~QTabWidget ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QTabWidget function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabWidget_insertTab (IntPtr raw, IntPtr child, IntPtr label, int index);
		public void InsertTab (QWidget child, string label, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabWidget_insertTab (rawObject, child.RawObject, new QString (label).RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabWidget_insertTab1 (IntPtr raw, IntPtr child, IntPtr iconset, IntPtr label, int index);
		public void InsertTab (QWidget child, QIconSet iconset, string label, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabWidget_insertTab1 (rawObject, child.RawObject, iconset.RawObject, new QString (label).RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabWidget_insertTab2 (IntPtr raw, IntPtr child, IntPtr tab, int index);
		public void InsertTab (QWidget child, QTab tab, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabWidget_insertTab2 (rawObject, child.RawObject, tab.RawObject, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabWidget_setCurrentPage (IntPtr raw, int arg1);
		public void SetCurrentPage (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabWidget_setCurrentPage (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabWidget_showPage (IntPtr raw, IntPtr arg1);
		public void ShowPage (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabWidget_showPage (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabWidget_removePage (IntPtr raw, IntPtr arg1);
		public void RemovePage (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabWidget_removePage (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabWidget_setTabBar (IntPtr raw, IntPtr arg1);
		protected void SetTabBar (QTabBar arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabWidget_setTabBar (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTabWidget_tabBar (IntPtr raw);
		protected QTabBar TabBar ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTabWidget_tabBar (rawObject), typeof (QTabBar)) as QTabBar;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabWidget_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabWidget_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTabWidget_updateMask (IntPtr raw);
		protected void UpdateMask ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTabWidget_updateMask (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTabWidget_eventFilter (IntPtr raw, IntPtr arg1, IntPtr arg2);
		protected bool EventFilter (QObject arg1, QEvent arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTabWidget_eventFilter (rawObject, arg1.RawObject, arg2.RawObject);
		}

		public void InsertTab (QWidget child, string label)
		{
			InsertTab(child, label, (int) -1);
		}

		public void InsertTab (QWidget child, QIconSet iconset, string label)
		{
			InsertTab(child, iconset, label, (int) -1);
		}

		public void InsertTab (QWidget child, QTab tab)
		{
			InsertTab(child, tab, (int) -1);
		}

		// Begin interface methods.

	}
}