// QTable.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QTable : QScrollView, IDisposable {

		public enum SelectionMode {
			Single = 0,
			Multi = 1,
			SingleRow = 2,
			MultiRow = 3,
			NoSelection = 4
		}

		public enum FocusStyle {
			FollowStyle = 0,
			SpreadSheet = 1
		}

		protected enum EditMode {
			NotEditing = 0,
			Editing = 1,
			Replacing = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTable (IntPtr parent, string name);
		public QTable (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QTable (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTable1 (int numRows, int numCols, IntPtr parent, string name);
		public QTable (int numRows, int numCols, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QTable1 (numRows, numCols, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QTable () : this (new QWidget ()) {}

		public QTable (QWidget parent) : this (parent, "") {}

		public QTable (int numRows, int numCols) : this (numRows, numCols, new QWidget ()) {}

		public QTable (int numRows, int numCols, QWidget parent) : this (numRows, numCols, parent, "") {}

		public QTable (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QTable (QNull dummy) : base (QNull.Instance) {}

		~QTable ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QTable (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QTable (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_horizontalHeader (IntPtr raw);
		public QHeader HorizontalHeader ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTable_horizontalHeader (rawObject), typeof (QHeader)) as QHeader;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_verticalHeader (IntPtr raw);
		public QHeader VerticalHeader ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTable_verticalHeader (rawObject), typeof (QHeader)) as QHeader;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setSelectionMode (IntPtr raw, SelectionMode mode);
		public void SetSelectionMode (SelectionMode mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setSelectionMode (rawObject, mode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern SelectionMode qt_QTable_selectionMode (IntPtr raw);
		public SelectionMode TheSelectionMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_selectionMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setItem (IntPtr raw, int row, int col, IntPtr item);
		public void SetItem (int row, int col, QTableItem item)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setItem (rawObject, row, col, item.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setText (IntPtr raw, int row, int col, IntPtr text);
		public void SetText (int row, int col, string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setText (rawObject, row, col, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setPixmap (IntPtr raw, int row, int col, IntPtr pix);
		public void SetPixmap (int row, int col, QPixmap pix)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setPixmap (rawObject, row, col, pix.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_item (IntPtr raw, int row, int col);
		public QTableItem Item (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTable_item (rawObject, row, col), typeof (QTableItem)) as QTableItem;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_text (IntPtr raw, int row, int col);
		public string Text (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTable_text (rawObject, row, col));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_pixmap (IntPtr raw, int row, int col);
		public QPixmap Pixmap (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTable_pixmap (rawObject, row, col), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_clearCell (IntPtr raw, int row, int col);
		public void ClearCell (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_clearCell (rawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_cellGeometry (IntPtr raw, int row, int col);
		public QRect CellGeometry (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTable_cellGeometry (rawObject, row, col), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_columnWidth (IntPtr raw, int col);
		public int ColumnWidth (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_columnWidth (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_rowHeight (IntPtr raw, int row);
		public int RowHeight (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_rowHeight (rawObject, row);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_columnPos (IntPtr raw, int col);
		public int ColumnPos (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_columnPos (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_rowPos (IntPtr raw, int row);
		public int RowPos (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_rowPos (rawObject, row);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_columnAt (IntPtr raw, int x);
		public int ColumnAt (int x)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_columnAt (rawObject, x);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_rowAt (IntPtr raw, int y);
		public int RowAt (int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_rowAt (rawObject, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_numRows (IntPtr raw);
		public int NumRows ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_numRows (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_numCols (IntPtr raw);
		public int NumCols ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_numCols (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_updateCell (IntPtr raw, int row, int col);
		public void UpdateCell (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_updateCell (rawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_eventFilter (IntPtr raw, IntPtr o, IntPtr arg1);
		public bool EventFilter (QObject o, QEvent arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_eventFilter (rawObject, o.RawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_currentRow (IntPtr raw);
		public int CurrentRow ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_currentRow (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_currentColumn (IntPtr raw);
		public int CurrentColumn ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_currentColumn (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_ensureCellVisible (IntPtr raw, int row, int col);
		public void EnsureCellVisible (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_ensureCellVisible (rawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_isSelected (IntPtr raw, int row, int col);
		public bool IsSelected (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_isSelected (rawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_isRowSelected (IntPtr raw, int row, bool full);
		public bool IsRowSelected (int row, bool full)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_isRowSelected (rawObject, row, full);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_isColumnSelected (IntPtr raw, int col, bool full);
		public bool IsColumnSelected (int col, bool full)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_isColumnSelected (rawObject, col, full);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_numSelections (IntPtr raw);
		public int NumSelections ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_numSelections (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_selection (IntPtr raw, int num);
		public QTableSelection Selection (int num)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTable_selection (rawObject, num), typeof (QTableSelection)) as QTableSelection;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_addSelection (IntPtr raw, IntPtr s);
		public int AddSelection (QTableSelection s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_addSelection (rawObject, s.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_removeSelection (IntPtr raw, IntPtr s);
		public void RemoveSelection (QTableSelection s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_removeSelection (rawObject, s.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_removeSelection1 (IntPtr raw, int num);
		public void RemoveSelection (int num)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_removeSelection1 (rawObject, num);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_currentSelection (IntPtr raw);
		public int CurrentSelection ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_currentSelection (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_showGrid (IntPtr raw);
		public bool ShowGrid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_showGrid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_columnMovingEnabled (IntPtr raw);
		public bool ColumnMovingEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_columnMovingEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_rowMovingEnabled (IntPtr raw);
		public bool RowMovingEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_rowMovingEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_sortColumn (IntPtr raw, int col, bool ascending, bool wholeRows);
		public void SortColumn (int col, bool ascending, bool wholeRows)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_sortColumn (rawObject, col, ascending, wholeRows);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_sorting (IntPtr raw);
		public bool Sorting ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_sorting (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_takeItem (IntPtr raw, IntPtr i);
		public void TakeItem (QTableItem i)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_takeItem (rawObject, i.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setCellWidget (IntPtr raw, int row, int col, IntPtr e);
		public void SetCellWidget (int row, int col, QWidget e)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setCellWidget (rawObject, row, col, e.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_cellWidget (IntPtr raw, int row, int col);
		public QWidget CellWidget (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTable_cellWidget (rawObject, row, col), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_clearCellWidget (IntPtr raw, int row, int col);
		public void ClearCellWidget (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_clearCellWidget (rawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_cellRect (IntPtr raw, int row, int col);
		public QRect CellRect (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTable_cellRect (rawObject, row, col), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_paintCell (IntPtr raw, IntPtr p, int row, int col, IntPtr cr, bool selected);
		public void PaintCell (QPainter p, int row, int col, QRect cr, bool selected)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_paintCell (rawObject, p.RawObject, row, col, cr.RawObject, selected);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_paintCell1 (IntPtr raw, IntPtr p, int row, int col, IntPtr cr, bool selected, IntPtr cg);
		public void PaintCell (QPainter p, int row, int col, QRect cr, bool selected, QColorGroup cg)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_paintCell1 (rawObject, p.RawObject, row, col, cr.RawObject, selected, cg.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_paintFocus (IntPtr raw, IntPtr p, IntPtr r);
		public void PaintFocus (QPainter p, QRect r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_paintFocus (rawObject, p.RawObject, r.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTable_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_isReadOnly (IntPtr raw);
		public bool IsReadOnly ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_isReadOnly (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_isRowReadOnly (IntPtr raw, int row);
		public bool IsRowReadOnly (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_isRowReadOnly (rawObject, row);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_isColumnReadOnly (IntPtr raw, int col);
		public bool IsColumnReadOnly (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_isColumnReadOnly (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setEnabled (IntPtr raw, bool b);
		public void SetEnabled (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setEnabled (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_repaintSelections (IntPtr raw);
		public void RepaintSelections ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_repaintSelections (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setFocusStyle (IntPtr raw, QTable.FocusStyle fs);
		public void SetFocusStyle (QTable.FocusStyle fs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setFocusStyle (rawObject, fs);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QTable.FocusStyle qt_QTable_focusStyle (IntPtr raw);
		public QTable.FocusStyle TheFocusStyle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_focusStyle (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setNumRows (IntPtr raw, int r);
		public void SetNumRows (int r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setNumRows (rawObject, r);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setNumCols (IntPtr raw, int r);
		public void SetNumCols (int r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setNumCols (rawObject, r);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setShowGrid (IntPtr raw, bool b);
		public void SetShowGrid (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setShowGrid (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_hideRow (IntPtr raw, int row);
		public void HideRow (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_hideRow (rawObject, row);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_hideColumn (IntPtr raw, int col);
		public void HideColumn (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_hideColumn (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_showRow (IntPtr raw, int row);
		public void ShowRow (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_showRow (rawObject, row);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_showColumn (IntPtr raw, int col);
		public void ShowColumn (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_showColumn (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setColumnWidth (IntPtr raw, int col, int w);
		public void SetColumnWidth (int col, int w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setColumnWidth (rawObject, col, w);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setRowHeight (IntPtr raw, int row, int h);
		public void SetRowHeight (int row, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setRowHeight (rawObject, row, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_adjustColumn (IntPtr raw, int col);
		public void AdjustColumn (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_adjustColumn (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_adjustRow (IntPtr raw, int row);
		public void AdjustRow (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_adjustRow (rawObject, row);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setColumnStretchable (IntPtr raw, int col, bool stretch);
		public void SetColumnStretchable (int col, bool stretch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setColumnStretchable (rawObject, col, stretch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setRowStretchable (IntPtr raw, int row, bool stretch);
		public void SetRowStretchable (int row, bool stretch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setRowStretchable (rawObject, row, stretch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_isColumnStretchable (IntPtr raw, int col);
		public bool IsColumnStretchable (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_isColumnStretchable (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_isRowStretchable (IntPtr raw, int row);
		public bool IsRowStretchable (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_isRowStretchable (rawObject, row);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setSorting (IntPtr raw, bool b);
		public void SetSorting (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setSorting (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_swapRows (IntPtr raw, int row1, int row2, bool swapHeader);
		public void SwapRows (int row1, int row2, bool swapHeader)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_swapRows (rawObject, row1, row2, swapHeader);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_swapColumns (IntPtr raw, int col1, int col2, bool swapHeader);
		public void SwapColumns (int col1, int col2, bool swapHeader)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_swapColumns (rawObject, col1, col2, swapHeader);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_swapCells (IntPtr raw, int row1, int col1, int row2, int col2);
		public void SwapCells (int row1, int col1, int row2, int col2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_swapCells (rawObject, row1, col1, row2, col2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setLeftMargin (IntPtr raw, int m);
		public void SetLeftMargin (int m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setLeftMargin (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setTopMargin (IntPtr raw, int m);
		public void SetTopMargin (int m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setTopMargin (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setCurrentCell (IntPtr raw, int row, int col);
		public void SetCurrentCell (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setCurrentCell (rawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_clearSelection (IntPtr raw, bool repaint);
		public void ClearSelection (bool repaint)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_clearSelection (rawObject, repaint);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setColumnMovingEnabled (IntPtr raw, bool b);
		public void SetColumnMovingEnabled (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setColumnMovingEnabled (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setRowMovingEnabled (IntPtr raw, bool b);
		public void SetRowMovingEnabled (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setRowMovingEnabled (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setReadOnly (IntPtr raw, bool b);
		public void SetReadOnly (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setReadOnly (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setRowReadOnly (IntPtr raw, int row, bool ro);
		public void SetRowReadOnly (int row, bool ro)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setRowReadOnly (rawObject, row, ro);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setColumnReadOnly (IntPtr raw, int col, bool ro);
		public void SetColumnReadOnly (int col, bool ro)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setColumnReadOnly (rawObject, col, ro);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setDragEnabled (IntPtr raw, bool b);
		public void SetDragEnabled (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setDragEnabled (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_dragEnabled (IntPtr raw);
		public bool DragEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_dragEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_insertRows (IntPtr raw, int row, int count);
		public void InsertRows (int row, int count)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_insertRows (rawObject, row, count);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_insertColumns (IntPtr raw, int col, int count);
		public void InsertColumns (int col, int count)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_insertColumns (rawObject, col, count);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_removeRow (IntPtr raw, int row);
		public void RemoveRow (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_removeRow (rawObject, row);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_removeColumn (IntPtr raw, int col);
		public void RemoveColumn (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_removeColumn (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_editCell (IntPtr raw, int row, int col, bool replace);
		public void EditCell (int row, int col, bool replace)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_editCell (rawObject, row, col, replace);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_drawContents (IntPtr raw, IntPtr p, int cx, int cy, int cw, int ch);
		protected void DrawContents (QPainter p, int cx, int cy, int cw, int ch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_drawContents (rawObject, p.RawObject, cx, cy, cw, ch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setEditMode (IntPtr raw, QTable.EditMode mode, int row, int col);
		protected void SetEditMode (QTable.EditMode mode, int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setEditMode (rawObject, mode, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_dragObject (IntPtr raw);
		protected QDragObject DragObject ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTable_dragObject (rawObject), typeof (QDragObject)) as QDragObject;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_startDrag (IntPtr raw);
		protected void StartDrag ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_startDrag (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_paintEmptyArea (IntPtr raw, IntPtr p, int cx, int cy, int cw, int ch);
		protected void PaintEmptyArea (QPainter p, int cx, int cy, int cw, int ch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_paintEmptyArea (rawObject, p.RawObject, cx, cy, cw, ch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_activateNextCell (IntPtr raw);
		protected void ActivateNextCell ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_activateNextCell (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_createEditor (IntPtr raw, int row, int col, bool initFromCell);
		protected QWidget CreateEditor (int row, int col, bool initFromCell)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTable_createEditor (rawObject, row, col, initFromCell), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_setCellContentFromEditor (IntPtr raw, int row, int col);
		protected void SetCellContentFromEditor (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_setCellContentFromEditor (rawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTable_beginEdit (IntPtr raw, int row, int col, bool replace);
		protected QWidget BeginEdit (int row, int col, bool replace)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTable_beginEdit (rawObject, row, col, replace), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_endEdit (IntPtr raw, int row, int col, bool accept, bool replace);
		protected void EndEdit (int row, int col, bool accept, bool replace)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_endEdit (rawObject, row, col, accept, replace);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_resizeData (IntPtr raw, int len);
		protected void ResizeData (int len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_resizeData (rawObject, len);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_insertWidget (IntPtr raw, int row, int col, IntPtr w);
		protected void InsertWidget (int row, int col, QWidget w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_insertWidget (rawObject, row, col, w.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_indexOf (IntPtr raw, int row, int col);
		protected int IndexOf (int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_indexOf (rawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_windowActivationChange (IntPtr raw, bool arg1);
		protected void WindowActivationChange (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_windowActivationChange (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTable_isEditing (IntPtr raw);
		protected bool IsEditing ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_isEditing (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QTable.EditMode qt_QTable_editMode (IntPtr raw);
		protected QTable.EditMode TheEditMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_editMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_currEditRow (IntPtr raw);
		protected int CurrEditRow ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_currEditRow (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTable_currEditCol (IntPtr raw);
		protected int CurrEditCol ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTable_currEditCol (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_columnWidthChanged (IntPtr raw, int col);
		protected void ColumnWidthChanged (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_columnWidthChanged (rawObject, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_rowHeightChanged (IntPtr raw, int row);
		protected void RowHeightChanged (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_rowHeightChanged (rawObject, row);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_columnIndexChanged (IntPtr raw, int section, int fromIndex, int toIndex);
		protected void ColumnIndexChanged (int section, int fromIndex, int toIndex)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_columnIndexChanged (rawObject, section, fromIndex, toIndex);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_rowIndexChanged (IntPtr raw, int section, int fromIndex, int toIndex);
		protected void RowIndexChanged (int section, int fromIndex, int toIndex)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_rowIndexChanged (rawObject, section, fromIndex, toIndex);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTable_columnClicked (IntPtr raw, int col);
		protected void ColumnClicked (int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTable_columnClicked (rawObject, col);
		}

		public bool IsRowSelected (int row)
		{
			return IsRowSelected(row, false);
		}

		public bool IsColumnSelected (int col)
		{
			return IsColumnSelected(col, false);
		}

		public void SortColumn (int col)
		{
			SortColumn(col, true);
		}

		public void SortColumn (int col, bool ascending)
		{
			SortColumn(col, ascending, false);
		}

		public void SwapRows (int row1, int row2)
		{
			SwapRows(row1, row2, false);
		}

		public void SwapColumns (int col1, int col2)
		{
			SwapColumns(col1, col2, false);
		}

		public void ClearSelection ()
		{
			ClearSelection(true);
		}

		public void InsertRows (int row)
		{
			InsertRows(row, (int) 1);
		}

		public void InsertColumns (int col)
		{
			InsertColumns(col, (int) 1);
		}

		public void EditCell (int row, int col)
		{
			EditCell(row, col, false);
		}

		// Begin interface methods.

	}
}