// QTableItem.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QTableItem : QtSupport, IDisposable {

		public enum EditType {
			Never = 0,
			OnTyping = 1,
			WhenCurrent = 2,
			Always = 3
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTableItem (IntPtr table, QTableItem.EditType et, IntPtr text);
		public QTableItem (QTable table, QTableItem.EditType et, string text) : this (QNull.Instance)
		{
			rawObject = qt_new_QTableItem (table.RawObject, et, new QString (text).RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTableItem1 (IntPtr table, QTableItem.EditType et, IntPtr text, IntPtr p);
		public QTableItem (QTable table, QTableItem.EditType et, string text, QPixmap p) : this (QNull.Instance)
		{
			rawObject = qt_new_QTableItem1 (table.RawObject, et, new QString (text).RawObject, p.RawObject);
			RegisterObject (this);
		}

		internal QTableItem () : this (QNull.Instance) {}

		public QTableItem (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QTableItem (QNull dummy) : base (QNull.Instance) {}

		~QTableItem ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QTableItem (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QTableItem (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTableItem_pixmap (IntPtr raw);
		public QPixmap Pixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTableItem_pixmap (rawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTableItem_text (IntPtr raw);
		public string Text ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTableItem_text (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTableItem_setPixmap (IntPtr raw, IntPtr p);
		public void SetPixmap (QPixmap p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTableItem_setPixmap (rawObject, p.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTableItem_setText (IntPtr raw, IntPtr t);
		public void SetText (string t)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTableItem_setText (rawObject, new QString (t).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTableItem_table (IntPtr raw);
		public QTable Table ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTableItem_table (rawObject), typeof (QTable)) as QTable;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTableItem_alignment (IntPtr raw);
		public int Alignment ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTableItem_alignment (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTableItem_setWordWrap (IntPtr raw, bool b);
		public void SetWordWrap (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTableItem_setWordWrap (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTableItem_wordWrap (IntPtr raw);
		public bool WordWrap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTableItem_wordWrap (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QTableItem.EditType qt_QTableItem_editType (IntPtr raw);
		public QTableItem.EditType TheEditType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTableItem_editType (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTableItem_createEditor (IntPtr raw);
		public QWidget CreateEditor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTableItem_createEditor (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTableItem_setContentFromEditor (IntPtr raw, IntPtr w);
		public void SetContentFromEditor (QWidget w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTableItem_setContentFromEditor (rawObject, w.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTableItem_setReplaceable (IntPtr raw, bool arg1);
		public void SetReplaceable (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTableItem_setReplaceable (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTableItem_isReplaceable (IntPtr raw);
		public bool IsReplaceable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTableItem_isReplaceable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTableItem_key (IntPtr raw);
		public string Key ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTableItem_key (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTableItem_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTableItem_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTableItem_setSpan (IntPtr raw, int rs, int cs);
		public void SetSpan (int rs, int cs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTableItem_setSpan (rawObject, rs, cs);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTableItem_rowSpan (IntPtr raw);
		public int RowSpan ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTableItem_rowSpan (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTableItem_colSpan (IntPtr raw);
		public int ColSpan ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTableItem_colSpan (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTableItem_setRow (IntPtr raw, int r);
		public void SetRow (int r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTableItem_setRow (rawObject, r);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTableItem_setCol (IntPtr raw, int c);
		public void SetCol (int c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTableItem_setCol (rawObject, c);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTableItem_row (IntPtr raw);
		public int Row ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTableItem_row (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTableItem_col (IntPtr raw);
		public int Col ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTableItem_col (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTableItem_paint (IntPtr raw, IntPtr p, IntPtr cg, IntPtr cr, bool selected);
		public void Paint (QPainter p, QColorGroup cg, QRect cr, bool selected)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTableItem_paint (rawObject, p.RawObject, cg.RawObject, cr.RawObject, selected);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTableItem_updateEditor (IntPtr raw, int oldRow, int oldCol);
		public void UpdateEditor (int oldRow, int oldCol)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTableItem_updateEditor (rawObject, oldRow, oldCol);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTableItem_setEnabled (IntPtr raw, bool b);
		public void SetEnabled (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTableItem_setEnabled (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTableItem_isEnabled (IntPtr raw);
		public bool IsEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTableItem_isEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTableItem_rtti (IntPtr raw);
		public int Rtti ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTableItem_rtti (rawObject);
		}

		// Begin interface methods.

	}
}