// QTextEdit.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QTextEdit : QScrollView, IDisposable {

		public enum WordWrap {
			NoWrap = 0,
			WidgetWidth = 1,
			FixedPixelWidth = 2,
			FixedColumnWidth = 3
		}

		public enum WrapPolicy {
			AtWordBoundary = 0,
			Anywhere = 1,
			AtWhiteSpace = AtWordBoundary
		}

		public enum KeyboardAction {
			ActionBackspace = 0,
			ActionDelete = 1,
			ActionReturn = 2,
			ActionKill = 3
		}

		public enum CursorAction {
			MoveBackward = 0,
			MoveForward = 1,
			MoveWordBackward = 2,
			MoveWordForward = 3,
			MoveUp = 4,
			MoveDown = 5,
			MoveLineStart = 6,
			MoveLineEnd = 7,
			MoveHome = 8,
			MoveEnd = 9,
			MovePgUp = 10,
			MovePgDown = 11
		}

		public enum VerticalAlignment {
			AlignNormal = 0,
			AlignSuperScript = 1,
			AlignSubScript = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTextEdit (IntPtr text, IntPtr context, IntPtr parent, string name);
		public QTextEdit (string text, string context, QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QTextEdit (new QString (text).RawObject, new QString (context).RawObject, parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTextEdit1 (IntPtr parent, string name);
		public QTextEdit (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QTextEdit1 (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QTextEdit (string text) : this (text, (string) "") {}

		public QTextEdit (string text, string context) : this (text, context, new QWidget ()) {}

		public QTextEdit (string text, string context, QWidget parent) : this (text, context, parent, "") {}

		public QTextEdit () : this (new QWidget ()) {}

		public QTextEdit (QWidget parent) : this (parent, "") {}

		public QTextEdit (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QTextEdit (QNull dummy) : base (QNull.Instance) {}

		~QTextEdit ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QTextEdit (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QTextEdit (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setPalette (IntPtr raw, IntPtr arg1);
		public void SetPalette (QPalette arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setPalette (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_text (IntPtr raw);
		public string Text ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTextEdit_text (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_text1 (IntPtr raw, int para);
		public string Text (int para)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTextEdit_text1 (rawObject, para));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.TextFormat qt_QTextEdit_textFormat (IntPtr raw);
		public Qt.TextFormat TextFormat ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_textFormat (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_context (IntPtr raw);
		public string Context ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTextEdit_context (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_documentTitle (IntPtr raw);
		public string DocumentTitle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTextEdit_documentTitle (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_getSelection (IntPtr raw, int[] paraFrom, int[] indexFrom, int[] paraTo, int[] indexTo, int selNum);
		public void GetSelection (int[] paraFrom, int[] indexFrom, int[] paraTo, int[] indexTo, int selNum)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_getSelection (rawObject, paraFrom, indexFrom, paraTo, indexTo, selNum);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_find (IntPtr raw, IntPtr expr, bool cs, bool wo, bool forward, int[] para, int[] index);
		public bool Find (string expr, bool cs, bool wo, bool forward, int[] para, int[] index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_find (rawObject, new QString (expr).RawObject, cs, wo, forward, para, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_paragraphs (IntPtr raw);
		public int Paragraphs ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_paragraphs (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_lines (IntPtr raw);
		public int Lines ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_lines (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_linesOfParagraph (IntPtr raw, int para);
		public int LinesOfParagraph (int para)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_linesOfParagraph (rawObject, para);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_lineOfChar (IntPtr raw, int para, int chr);
		public int LineOfChar (int para, int chr)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_lineOfChar (rawObject, para, chr);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_length (IntPtr raw);
		public int Length ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_length (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_paragraphRect (IntPtr raw, int para);
		public QRect ParagraphRect (int para)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextEdit_paragraphRect (rawObject, para), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_paragraphAt (IntPtr raw, IntPtr pos);
		public int ParagraphAt (QPoint pos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_paragraphAt (rawObject, pos.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_charAt (IntPtr raw, IntPtr pos, int[] para);
		public int CharAt (QPoint pos, int[] para)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_charAt (rawObject, pos.RawObject, para);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_paragraphLength (IntPtr raw, int para);
		public int ParagraphLength (int para)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_paragraphLength (rawObject, para);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_styleSheet (IntPtr raw);
		public QStyleSheet StyleSheet ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextEdit_styleSheet (rawObject), typeof (QStyleSheet)) as QStyleSheet;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_mimeSourceFactory (IntPtr raw);
		public QMimeSourceFactory MimeSourceFactory ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextEdit_mimeSourceFactory (rawObject), typeof (QMimeSourceFactory)) as QMimeSourceFactory;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_paper (IntPtr raw);
		public QBrush Paper ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextEdit_paper (rawObject), typeof (QBrush)) as QBrush;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_linkUnderline (IntPtr raw);
		public bool LinkUnderline ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_linkUnderline (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_heightForWidth (IntPtr raw, int w);
		public int HeightForWidth (int w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_heightForWidth (rawObject, w);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_hasSelectedText (IntPtr raw);
		public bool HasSelectedText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_hasSelectedText (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_selectedText (IntPtr raw);
		public string SelectedText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTextEdit_selectedText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_isUndoAvailable (IntPtr raw);
		public bool IsUndoAvailable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_isUndoAvailable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_isRedoAvailable (IntPtr raw);
		public bool IsRedoAvailable ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_isRedoAvailable (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern WordWrap qt_QTextEdit_wordWrap (IntPtr raw);
		public WordWrap TheWordWrap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_wordWrap (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_wrapColumnOrWidth (IntPtr raw);
		public int WrapColumnOrWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_wrapColumnOrWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern WrapPolicy qt_QTextEdit_wrapPolicy (IntPtr raw);
		public WrapPolicy TheWrapPolicy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_wrapPolicy (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_tabStopWidth (IntPtr raw);
		public int TabStopWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_tabStopWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_anchorAt (IntPtr raw, IntPtr pos);
		public string AnchorAt (QPoint pos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTextEdit_anchorAt (rawObject, pos.RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextEdit_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_isReadOnly (IntPtr raw);
		public bool IsReadOnly ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_isReadOnly (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_getCursorPosition (IntPtr raw, int[] parag, int[] index);
		public void GetCursorPosition (int[] parag, int[] index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_getCursorPosition (rawObject, parag, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_isModified (IntPtr raw);
		public bool IsModified ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_isModified (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_italic (IntPtr raw);
		public bool Italic ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_italic (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_bold (IntPtr raw);
		public bool Bold ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_bold (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_underline (IntPtr raw);
		public bool Underline ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_underline (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_family (IntPtr raw);
		public string Family ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTextEdit_family (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_pointSize (IntPtr raw);
		public int PointSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_pointSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_color (IntPtr raw);
		public QColor Color ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextEdit_color (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_font (IntPtr raw);
		public QFont Font ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextEdit_font (rawObject), typeof (QFont)) as QFont;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_alignment (IntPtr raw);
		public int Alignment ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_alignment (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextEdit_undoDepth (IntPtr raw);
		public int UndoDepth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_undoDepth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_getFormat (IntPtr raw, int para, int index, IntPtr font, IntPtr color, VerticalAlignment verticalAlignment);
		public bool GetFormat (int para, int index, QFont font, QColor color, VerticalAlignment verticalAlignment)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_getFormat (rawObject, para, index, font.RawObject, color.RawObject, verticalAlignment);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_getParagraphFormat (IntPtr raw, int para, IntPtr font, IntPtr color, VerticalAlignment verticalAlignment, int[] alignment, QStyleSheetItem.DisplayMode displayMode, QStyleSheetItem.ListStyle listStyle, int[] listDepth);
		public bool GetParagraphFormat (int para, QFont font, QColor color, VerticalAlignment verticalAlignment, int[] alignment, QStyleSheetItem.DisplayMode displayMode, QStyleSheetItem.ListStyle listStyle, int[] listDepth)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_getParagraphFormat (rawObject, para, font.RawObject, color.RawObject, verticalAlignment, alignment, displayMode, listStyle, listDepth);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_isOverwriteMode (IntPtr raw);
		public bool IsOverwriteMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_isOverwriteMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_paragraphBackgroundColor (IntPtr raw, int para);
		public QColor ParagraphBackgroundColor (int para)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextEdit_paragraphBackgroundColor (rawObject, para), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_isUndoRedoEnabled (IntPtr raw);
		public bool IsUndoRedoEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_isUndoRedoEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_eventFilter (IntPtr raw, IntPtr o, IntPtr e);
		public bool EventFilter (QObject o, QEvent e)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_eventFilter (rawObject, o.RawObject, e.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setEnabled (IntPtr raw, bool arg1);
		public void SetEnabled (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setEnabled (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setMimeSourceFactory (IntPtr raw, IntPtr factory);
		public void SetMimeSourceFactory (QMimeSourceFactory factory)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setMimeSourceFactory (rawObject, factory.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setStyleSheet (IntPtr raw, IntPtr styleSheet);
		public void SetStyleSheet (QStyleSheet styleSheet)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setStyleSheet (rawObject, styleSheet.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_scrollToAnchor (IntPtr raw, IntPtr name);
		public void ScrollToAnchor (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_scrollToAnchor (rawObject, new QString (name).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setPaper (IntPtr raw, IntPtr pap);
		public void SetPaper (QBrush pap)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setPaper (rawObject, pap.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setLinkUnderline (IntPtr raw, bool arg1);
		public void SetLinkUnderline (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setLinkUnderline (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setWordWrap (IntPtr raw, WordWrap mode);
		public void SetWordWrap (WordWrap mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setWordWrap (rawObject, mode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setWrapColumnOrWidth (IntPtr raw, int arg1);
		public void SetWrapColumnOrWidth (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setWrapColumnOrWidth (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setWrapPolicy (IntPtr raw, WrapPolicy policy);
		public void SetWrapPolicy (WrapPolicy policy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setWrapPolicy (rawObject, policy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_copy (IntPtr raw);
		public void Copy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_copy (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_append (IntPtr raw, IntPtr text);
		public void Append (string text)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_append (rawObject, new QString (text).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setText (IntPtr raw, IntPtr txt);
		public void SetText (string txt)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setText (rawObject, new QString (txt).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setText1 (IntPtr raw, IntPtr txt, IntPtr context);
		public void SetText (string txt, string context)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setText1 (rawObject, new QString (txt).RawObject, new QString (context).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setTextFormat (IntPtr raw, Qt.TextFormat f);
		public void SetTextFormat (Qt.TextFormat f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setTextFormat (rawObject, f);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_selectAll (IntPtr raw, bool select);
		public void SelectAll (bool select)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_selectAll (rawObject, select);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setTabStopWidth (IntPtr raw, int ts);
		public void SetTabStopWidth (int ts)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setTabStopWidth (rawObject, ts);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_zoomIn (IntPtr raw, int range);
		public void ZoomIn (int range)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_zoomIn (rawObject, range);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_zoomIn1 (IntPtr raw);
		public void ZoomIn ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_zoomIn1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_zoomOut (IntPtr raw, int range);
		public void ZoomOut (int range)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_zoomOut (rawObject, range);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_zoomOut1 (IntPtr raw);
		public void ZoomOut ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_zoomOut1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_zoomTo (IntPtr raw, int size);
		public void ZoomTo (int size)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_zoomTo (rawObject, size);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_sync (IntPtr raw);
		public void Sync ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_sync (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setReadOnly (IntPtr raw, bool b);
		public void SetReadOnly (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setReadOnly (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_undo (IntPtr raw);
		public void Undo ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_undo (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_redo (IntPtr raw);
		public void Redo ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_redo (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_cut (IntPtr raw);
		public void Cut ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_cut (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_paste (IntPtr raw);
		public void Paste ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_paste (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_pasteSubType (IntPtr raw, IntPtr subtype);
		public void PasteSubType (QCString subtype)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_pasteSubType (rawObject, subtype.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_del (IntPtr raw);
		public void Del ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_del (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_indent (IntPtr raw);
		public void Indent ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_indent (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setItalic (IntPtr raw, bool b);
		public void SetItalic (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setItalic (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setBold (IntPtr raw, bool b);
		public void SetBold (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setBold (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setUnderline (IntPtr raw, bool b);
		public void SetUnderline (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setUnderline (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setFamily (IntPtr raw, IntPtr f);
		public void SetFamily (string f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setFamily (rawObject, new QString (f).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setPointSize (IntPtr raw, int s);
		public void SetPointSize (int s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setPointSize (rawObject, s);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setColor (IntPtr raw, IntPtr c);
		public void SetColor (QColor c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setColor (rawObject, c.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setFont (IntPtr raw, IntPtr f);
		public void SetFont (QFont f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setFont (rawObject, f.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setVerticalAlignment (IntPtr raw, VerticalAlignment a);
		public void SetVerticalAlignment (VerticalAlignment a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setVerticalAlignment (rawObject, a);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setAlignment (IntPtr raw, int a);
		public void SetAlignment (int a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setAlignment (rawObject, a);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setParagType (IntPtr raw, QStyleSheetItem.DisplayMode dm, QStyleSheetItem.ListStyle listStyle);
		public void SetParagType (QStyleSheetItem.DisplayMode dm, QStyleSheetItem.ListStyle listStyle)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setParagType (rawObject, dm, listStyle);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setCursorPosition (IntPtr raw, int parag, int index);
		public void SetCursorPosition (int parag, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setCursorPosition (rawObject, parag, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setSelection (IntPtr raw, int parag_from, int index_from, int parag_to, int index_to, int selNum);
		public void SetSelection (int parag_from, int index_from, int parag_to, int index_to, int selNum)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setSelection (rawObject, parag_from, index_from, parag_to, index_to, selNum);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setSelectionAttributes (IntPtr raw, int selNum, IntPtr back, bool invertText);
		public void SetSelectionAttributes (int selNum, QColor back, bool invertText)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setSelectionAttributes (rawObject, selNum, back.RawObject, invertText);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setModified (IntPtr raw, bool m);
		public void SetModified (bool m)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setModified (rawObject, m);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_resetFormat (IntPtr raw);
		public void ResetFormat ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_resetFormat (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setUndoDepth (IntPtr raw, int d);
		public void SetUndoDepth (int d)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setUndoDepth (rawObject, d);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setFormat (IntPtr raw, IntPtr f, int flags);
		public void SetFormat (IntPtr f, int flags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setFormat (rawObject, f, flags);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_ensureCursorVisible (IntPtr raw);
		public void EnsureCursorVisible ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_ensureCursorVisible (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_placeCursor (IntPtr raw, IntPtr pos, IntPtr c);
		public void PlaceCursor (QPoint pos, IntPtr c)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_placeCursor (rawObject, pos.RawObject, c);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_moveCursor (IntPtr raw, QTextEdit.CursorAction action, bool select);
		public void MoveCursor (QTextEdit.CursorAction action, bool select)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_moveCursor (rawObject, action, select);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_doKeyboardAction (IntPtr raw, QTextEdit.KeyboardAction action);
		public void DoKeyboardAction (QTextEdit.KeyboardAction action)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_doKeyboardAction (rawObject, action);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_removeSelectedText (IntPtr raw, int selNum);
		public void RemoveSelectedText (int selNum)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_removeSelectedText (rawObject, selNum);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_removeSelection (IntPtr raw, int selNum);
		public void RemoveSelection (int selNum)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_removeSelection (rawObject, selNum);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setCurrentFont (IntPtr raw, IntPtr f);
		public void SetCurrentFont (QFont f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setCurrentFont (rawObject, f.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setOverwriteMode (IntPtr raw, bool b);
		public void SetOverwriteMode (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setOverwriteMode (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_scrollToBottom (IntPtr raw);
		public void ScrollToBottom ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_scrollToBottom (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_insert (IntPtr raw, IntPtr text, bool indent, bool checkNewLine, bool removeSelected);
		public void Insert (string text, bool indent, bool checkNewLine, bool removeSelected)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_insert (rawObject, new QString (text).RawObject, indent, checkNewLine, removeSelected);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_insertAt (IntPtr raw, IntPtr text, int para, int index);
		public void InsertAt (string text, int para, int index)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_insertAt (rawObject, new QString (text).RawObject, para, index);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_removeParagraph (IntPtr raw, int para);
		public void RemoveParagraph (int para)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_removeParagraph (rawObject, para);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_insertParagraph (IntPtr raw, IntPtr text, int para);
		public void InsertParagraph (string text, int para)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_insertParagraph (rawObject, new QString (text).RawObject, para);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setParagraphBackgroundColor (IntPtr raw, int para, IntPtr bg);
		public void SetParagraphBackgroundColor (int para, QColor bg)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setParagraphBackgroundColor (rawObject, para, bg.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_clearParagraphBackground (IntPtr raw, int para);
		public void ClearParagraphBackground (int para)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_clearParagraphBackground (rawObject, para);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setUndoRedoEnabled (IntPtr raw, bool b);
		public void SetUndoRedoEnabled (bool b)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setUndoRedoEnabled (rawObject, b);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_repaintChanged (IntPtr raw);
		protected void RepaintChanged ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_repaintChanged (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_updateStyles (IntPtr raw);
		protected void UpdateStyles ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_updateStyles (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_drawContents (IntPtr raw, IntPtr p, int cx, int cy, int cw, int ch);
		protected void DrawContents (QPainter p, int cx, int cy, int cw, int ch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_drawContents (rawObject, p.RawObject, cx, cy, cw, ch);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_event (IntPtr raw, IntPtr e);
		protected bool Q_event (QEvent e)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_event (rawObject, e.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextEdit_focusNextPrevChild (IntPtr raw, bool next);
		protected bool FocusNextPrevChild (bool next)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_focusNextPrevChild (rawObject, next);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_document (IntPtr raw);
		protected IntPtr Document ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_document (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_textCursor (IntPtr raw);
		protected IntPtr TextCursor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextEdit_textCursor (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_setDocument (IntPtr raw, IntPtr doc);
		protected void SetDocument (IntPtr doc)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_setDocument (rawObject, doc);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_createPopupMenu (IntPtr raw, IntPtr pos);
		protected QPopupMenu CreatePopupMenu (QPoint pos)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextEdit_createPopupMenu (rawObject, pos.RawObject), typeof (QPopupMenu)) as QPopupMenu;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextEdit_createPopupMenu1 (IntPtr raw);
		protected QPopupMenu CreatePopupMenu ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextEdit_createPopupMenu1 (rawObject), typeof (QPopupMenu)) as QPopupMenu;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_drawCursor (IntPtr raw, bool visible);
		protected void DrawCursor (bool visible)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_drawCursor (rawObject, visible);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_windowActivationChange (IntPtr raw, bool arg1);
		protected void WindowActivationChange (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_windowActivationChange (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextEdit_doChangeInterval (IntPtr raw);
		protected void DoChangeInterval ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextEdit_doChangeInterval (rawObject);
		}

		public void GetSelection (int[] paraFrom, int[] indexFrom, int[] paraTo, int[] indexTo)
		{
			GetSelection(paraFrom, indexFrom, paraTo, indexTo, (int) 0);
		}

		public bool Find (string expr, bool cs, bool wo)
		{
			return Find(expr, cs, wo, true);
		}

		public bool Find (string expr, bool cs, bool wo, bool forward)
		{
			return Find(expr, cs, wo, forward, new int[]{0});
		}

		public bool Find (string expr, bool cs, bool wo, bool forward, int[] para)
		{
			return Find(expr, cs, wo, forward, para, new int[]{0});
		}

		public void SelectAll ()
		{
			SelectAll(true);
		}

		public void SetSelection (int parag_from, int index_from, int parag_to, int index_to)
		{
			SetSelection(parag_from, index_from, parag_to, index_to, (int) 0);
		}

		public void PlaceCursor (QPoint pos)
		{
			PlaceCursor(pos, (IntPtr) 0);
		}

		public void RemoveSelectedText ()
		{
			RemoveSelectedText((int) 0);
		}

		public void RemoveSelection ()
		{
			RemoveSelection((int) 0);
		}

		public void Insert (string text)
		{
			Insert(text, false);
		}

		public void Insert (string text, bool indent)
		{
			Insert(text, indent, true);
		}

		public void Insert (string text, bool indent, bool checkNewLine)
		{
			Insert(text, indent, checkNewLine, true);
		}

		// Begin interface methods.

	}
}