// QTextStream.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QTextStream : QtSupport, IDisposable {

		public enum Encoding {
			Locale = 0,
			Latin1 = 1,
			Unicode = 2,
			UnicodeNetworkOrder = 3,
			UnicodeReverse = 4,
			RawUnicode = 5,
			UnicodeUTF8 = 6
		}

		public enum blank {
			skipws = 1,
			left = 2,
			right = 4,
			res_internal = 8,
			bin = 16,
			oct = 32,
			dec = 64,
			hex = 128,
			showbase = 256,
			showpoint = 512,
			uppercase = 1024,
			showpos = 2048,
			scientific = 4096,
			res_fixed = 8192
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTextStream ();
		public QTextStream () : this (QNull.Instance)
		{
			rawObject = qt_new_QTextStream ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTextStream1 (IntPtr arg1);
		public QTextStream (QIODevice arg1) : this (QNull.Instance)
		{
			rawObject = qt_new_QTextStream1 (arg1.RawObject);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTextStream2 (IntPtr arg1, int mode);
		public QTextStream (string arg1, int mode) : this (QNull.Instance)
		{
			rawObject = qt_new_QTextStream2 (new QString (arg1).RawObject, mode);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTextStream4 (byte[] arg1, int mode);
		public QTextStream (byte[] arg1, int mode) : this (QNull.Instance)
		{
			rawObject = qt_new_QTextStream4 (arg1, mode);
			RegisterObject (this);
		}

		public QTextStream (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QTextStream (QNull dummy) : base (QNull.Instance) {}

		~QTextStream ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QTextStream (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QTextStream (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextStream_setEncoding (IntPtr raw, Encoding arg1);
		public void SetEncoding (Encoding arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextStream_setEncoding (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextStream_setCodec (IntPtr raw, IntPtr arg1);
		public void SetCodec (QTextCodec arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextStream_setCodec (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextStream_device (IntPtr raw);
		public QIODevice Device ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextStream_device (rawObject), typeof (QIODevice)) as QIODevice;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextStream_setDevice (IntPtr raw, IntPtr arg1);
		public void SetDevice (QIODevice arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextStream_setDevice (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextStream_unsetDevice (IntPtr raw);
		public void UnsetDevice ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextStream_unsetDevice (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextStream_atEnd (IntPtr raw);
		public bool AtEnd ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_atEnd (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTextStream_eof (IntPtr raw);
		public bool Eof ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_eof (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextStream_readRawBytes (IntPtr raw, string arg1, uint len);
		public QTextStream ReadRawBytes (string arg1, uint len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextStream_readRawBytes (rawObject, arg1, len), typeof (QTextStream)) as QTextStream;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextStream_writeRawBytes (IntPtr raw, string arg1, uint len);
		public QTextStream WriteRawBytes (string arg1, uint len)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTextStream_writeRawBytes (rawObject, arg1, len), typeof (QTextStream)) as QTextStream;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextStream_readLine (IntPtr raw);
		public string ReadLine ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTextStream_readLine (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTextStream_read (IntPtr raw);
		public string Read ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTextStream_read (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextStream_skipWhiteSpace (IntPtr raw);
		public void SkipWhiteSpace ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextStream_skipWhiteSpace (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextStream_flags (IntPtr raw);
		public int Flags ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_flags (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextStream_flags1 (IntPtr raw, int f);
		public int Flags (int f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_flags1 (rawObject, f);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextStream_setf (IntPtr raw, int bits);
		public int Setf (int bits)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_setf (rawObject, bits);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextStream_setf1 (IntPtr raw, int bits, int mask);
		public int Setf (int bits, int mask)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_setf1 (rawObject, bits, mask);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextStream_unsetf (IntPtr raw, int bits);
		public int Unsetf (int bits)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_unsetf (rawObject, bits);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTextStream_reset (IntPtr raw);
		public void Reset ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTextStream_reset (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextStream_width (IntPtr raw);
		public int Width ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_width (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextStream_width1 (IntPtr raw, int arg1);
		public int Width (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_width1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextStream_fill (IntPtr raw);
		public int Fill ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_fill (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextStream_fill1 (IntPtr raw, int arg1);
		public int Fill (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_fill1 (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextStream_precision (IntPtr raw);
		public int Precision ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_precision (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTextStream_precision1 (IntPtr raw, int arg1);
		public int Precision (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTextStream_precision1 (rawObject, arg1);
		}
	}
}