// QThread.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QThread : QtSupport, IDisposable {

		internal QThread () : this (QNull.Instance) {}

		public QThread (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QThread (QNull dummy) : base (QNull.Instance) {}

		~QThread ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QThread (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QThread (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QThread_wait (IntPtr raw, ulong time);
		public bool Wait (ulong time)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QThread_wait (rawObject, time);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QThread_start (IntPtr raw);
		public void Start ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QThread_start (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QThread_finished (IntPtr raw);
		public bool Finished ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QThread_finished (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QThread_running (IntPtr raw);
		public bool Running ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QThread_running (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QThread_currentThread ();
		public static IntPtr CurrentThread ()
		{
			return qt_QThread_currentThread ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QThread_initialize ();
		public static void Initialize ()
		{
			qt_QThread_initialize ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QThread_cleanup ();
		public static void Cleanup ()
		{
			qt_QThread_cleanup ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QThread_exit ();
		public static void Exit ()
		{
			qt_QThread_exit ();
		}

		public bool Wait ()
		{
			return Wait((ulong) UInt64.MaxValue);
		}

		// Begin interface methods.

	}
}