// QTime.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QTime : QtSupport, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTime ();
		public QTime () : this (QNull.Instance)
		{
			rawObject = qt_new_QTime ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTime1 (int h, int m, int s, int ms);
		public QTime (int h, int m, int s, int ms) : this (QNull.Instance)
		{
			rawObject = qt_new_QTime1 (h, m, s, ms);
			RegisterObject (this);
		}

		public QTime (int h, int m) : this (h, m, (int) 0) {}

		public QTime (int h, int m, int s) : this (h, m, s, (int) 0) {}

		public QTime (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QTime (QNull dummy) : base (QNull.Instance) {}

		~QTime ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QTime function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTime_isNull (IntPtr raw);
		public bool IsNull ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTime_isNull (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTime_isValid (IntPtr raw);
		public bool IsValid ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTime_isValid (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTime_hour (IntPtr raw);
		public int Hour ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTime_hour (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTime_minute (IntPtr raw);
		public int Minute ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTime_minute (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTime_second (IntPtr raw);
		public int Second ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTime_second (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTime_msec (IntPtr raw);
		public int Msec ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTime_msec (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTime_toString (IntPtr raw, Qt.DateFormat f);
		public string ToString (Qt.DateFormat f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTime_toString (rawObject, f));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTime_toString1 (IntPtr raw, IntPtr format);
		public string ToString (string format)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTime_toString1 (rawObject, new QString (format).RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTime_setHMS (IntPtr raw, int h, int m, int s, int ms);
		public bool SetHMS (int h, int m, int s, int ms)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTime_setHMS (rawObject, h, m, s, ms);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTime_addSecs (IntPtr raw, int secs);
		public QTime AddSecs (int secs)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTime_addSecs (rawObject, secs), typeof (QTime)) as QTime;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTime_secsTo (IntPtr raw, IntPtr arg1);
		public int SecsTo (QTime arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTime_secsTo (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTime_addMSecs (IntPtr raw, int ms);
		public QTime AddMSecs (int ms)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTime_addMSecs (rawObject, ms), typeof (QTime)) as QTime;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTime_msecsTo (IntPtr raw, IntPtr arg1);
		public int MsecsTo (QTime arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTime_msecsTo (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTime_start (IntPtr raw);
		public void Start ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTime_start (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTime_restart (IntPtr raw);
		public int Restart ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTime_restart (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QTime_elapsed (IntPtr raw);
		public int Elapsed ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTime_elapsed (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTime_currentTime ();
		public static QTime CurrentTime ()
		{
			return LookupObject (qt_QTime_currentTime (), typeof (QTime)) as QTime;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTime_fromString (IntPtr s, Qt.DateFormat f);
		public static QTime FromString (string s, Qt.DateFormat f)
		{
			return LookupObject (qt_QTime_fromString (new QString (s).RawObject, f), typeof (QTime)) as QTime;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTime_isValid1 (int h, int m, int s, int ms);
		public static bool IsValid (int h, int m, int s, int ms)
		{
			return qt_QTime_isValid1 (h, m, s, ms);
		}

		public string ToString ()
		{
			return ToString(Qt.DateFormat.TextDate);
		}

		public bool SetHMS (int h, int m, int s)
		{
			return SetHMS(h, m, s, (int) 0);
		}

		public static QTime FromString (string s)
		{
			return FromString(s, Qt.DateFormat.TextDate);
		}

		public static bool IsValid (int h, int m, int s)
		{
			return IsValid(h, m, s, (int) 0);
		}
	}
}