// QToolTip.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QToolTip : QtSupport, IDisposable {

		internal QToolTip () : this (QNull.Instance) {}

		public QToolTip (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QToolTip (QNull dummy) : base (QNull.Instance) {}

		~QToolTip ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QToolTip function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QToolTip_parentWidget (IntPtr raw);
		public QWidget ParentWidget ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QToolTip_parentWidget (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QToolTip_group (IntPtr raw);
		public QToolTipGroup Group ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QToolTip_group (rawObject), typeof (QToolTipGroup)) as QToolTipGroup;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QToolTip_add (IntPtr arg1, IntPtr arg2);
		public static void Add (QWidget arg1, string arg2)
		{
			qt_QToolTip_add (arg1.RawObject, new QString (arg2).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QToolTip_add1 (IntPtr arg1, IntPtr arg2, IntPtr arg3, IntPtr arg4);
		public static void Add (QWidget arg1, string arg2, QToolTipGroup arg3, string arg4)
		{
			qt_QToolTip_add1 (arg1.RawObject, new QString (arg2).RawObject, arg3.RawObject, new QString (arg4).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QToolTip_remove (IntPtr arg1);
		public static void Remove (QWidget arg1)
		{
			qt_QToolTip_remove (arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QToolTip_add2 (IntPtr arg1, IntPtr arg2, IntPtr arg3);
		public static void Add (QWidget arg1, QRect arg2, string arg3)
		{
			qt_QToolTip_add2 (arg1.RawObject, arg2.RawObject, new QString (arg3).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QToolTip_add3 (IntPtr arg1, IntPtr arg2, IntPtr arg3, IntPtr arg4, IntPtr arg5);
		public static void Add (QWidget arg1, QRect arg2, string arg3, QToolTipGroup arg4, string arg5)
		{
			qt_QToolTip_add3 (arg1.RawObject, arg2.RawObject, new QString (arg3).RawObject, arg4.RawObject, new QString (arg5).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QToolTip_remove1 (IntPtr arg1, IntPtr arg2);
		public static void Remove (QWidget arg1, QRect arg2)
		{
			qt_QToolTip_remove1 (arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QToolTip_textFor (IntPtr arg1, IntPtr pos);
		public static string TextFor (QWidget arg1, QPoint pos)
		{
			QString qstr = new QString (qt_QToolTip_textFor (arg1.RawObject, pos.RawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QToolTip_hide ();
		public static void Hide ()
		{
			qt_QToolTip_hide ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QToolTip_font ();
		public static QFont Font ()
		{
			return LookupObject (qt_QToolTip_font (), typeof (QFont)) as QFont;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QToolTip_setFont (IntPtr arg1);
		public static void SetFont (QFont arg1)
		{
			qt_QToolTip_setFont (arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QToolTip_palette ();
		public static QPalette Palette ()
		{
			return LookupObject (qt_QToolTip_palette (), typeof (QPalette)) as QPalette;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QToolTip_setPalette (IntPtr arg1);
		public static void SetPalette (QPalette arg1)
		{
			qt_QToolTip_setPalette (arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QToolTip_setEnabled (bool enable);
		public static void SetEnabled (bool enable)
		{
			qt_QToolTip_setEnabled (enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QToolTip_enabled ();
		public static bool Enabled ()
		{
			return qt_QToolTip_enabled ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QToolTip_setGloballyEnabled (bool arg1);
		public static void SetGloballyEnabled (bool arg1)
		{
			qt_QToolTip_setGloballyEnabled (arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QToolTip_isGloballyEnabled ();
		public static bool IsGloballyEnabled ()
		{
			return qt_QToolTip_isGloballyEnabled ();
		}

		public static string TextFor (QWidget arg1)
		{
			return TextFor(arg1, new QPoint ());
		}

		// Begin interface methods.

	}
}