// QTranslator.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QTranslator : QObject, IDisposable {

		public enum SaveMode {
			Everything = 0,
			Stripped = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QTranslator (IntPtr parent, string name);
		public QTranslator (QObject parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QTranslator (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QTranslator (QObject parent) : this (parent, "") {}

		internal QTranslator () : this (QNull.Instance) {}

		public QTranslator (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QTranslator (QNull dummy) : base (QNull.Instance) {}

		~QTranslator ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QTranslator (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QTranslator (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTranslator_find (IntPtr raw, string context, string sourceText, string comment);
		public string Find (string context, string sourceText, string comment)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QTranslator_find (rawObject, context, sourceText, comment));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QTranslator_findMessage (IntPtr raw, string arg1, string arg2, string arg3);
		public QTranslatorMessage FindMessage (string arg1, string arg2, string arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QTranslator_findMessage (rawObject, arg1, arg2, arg3), typeof (QTranslatorMessage)) as QTranslatorMessage;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTranslator_load (IntPtr raw, IntPtr filename, IntPtr directory, IntPtr search_delimiters, IntPtr suffix);
		public bool Load (string filename, string directory, string search_delimiters, string suffix)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTranslator_load (rawObject, new QString (filename).RawObject, new QString (directory).RawObject, new QString (search_delimiters).RawObject, new QString (suffix).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTranslator_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTranslator_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTranslator_save (IntPtr raw, IntPtr filename, QTranslator.SaveMode mode);
		public bool Save (string filename, QTranslator.SaveMode mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTranslator_save (rawObject, new QString (filename).RawObject, mode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTranslator_insert (IntPtr raw, IntPtr arg1);
		public void Insert (QTranslatorMessage arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTranslator_insert (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTranslator_insert1 (IntPtr raw, string context, string sourceText, IntPtr translation);
		public void Insert (string context, string sourceText, string translation)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTranslator_insert1 (rawObject, context, sourceText, new QString (translation).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTranslator_remove (IntPtr raw, IntPtr arg1);
		public void Remove (QTranslatorMessage arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTranslator_remove (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTranslator_remove1 (IntPtr raw, string context, string sourceText);
		public void Remove (string context, string sourceText)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTranslator_remove1 (rawObject, context, sourceText);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QTranslator_contains (IntPtr raw, string arg1, string arg2, string comment);
		public bool Contains (string arg1, string arg2, string comment)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QTranslator_contains (rawObject, arg1, arg2, comment);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTranslator_squeeze (IntPtr raw, QTranslator.SaveMode arg1);
		public void Squeeze (QTranslator.SaveMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTranslator_squeeze (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QTranslator_unsqueeze (IntPtr raw);
		public void Unsqueeze ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QTranslator_unsqueeze (rawObject);
		}

		public string Find (string context, string sourceText)
		{
			return Find(context, sourceText, "");
		}

		public bool Load (string filename)
		{
			return Load(filename, (string) "");
		}

		public bool Load (string filename, string directory)
		{
			return Load(filename, directory, (string) "");
		}

		public bool Load (string filename, string directory, string search_delimiters)
		{
			return Load(filename, directory, search_delimiters, (string) "");
		}

		public bool Save (string filename)
		{
			return Save(filename, QTranslator.SaveMode.Everything);
		}

		public bool Contains (string arg1, string arg2)
		{
			return Contains(arg1, arg2, "");
		}

		public void Squeeze ()
		{
			Squeeze(QTranslator.SaveMode.Everything);
		}

		// Begin interface methods.

	}
}