// QWMatrix.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QWMatrix : QtSupport, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QWMatrix ();
		public QWMatrix () : this (QNull.Instance)
		{
			rawObject = qt_new_QWMatrix ();
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QWMatrix1 (double m11, double m12, double m21, double m22, double dx, double dy);
		public QWMatrix (double m11, double m12, double m21, double m22, double dx, double dy) : this (QNull.Instance)
		{
			rawObject = qt_new_QWMatrix1 (m11, m12, m21, m22, dx, dy);
			RegisterObject (this);
		}

		public QWMatrix (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QWMatrix (QNull dummy) : base (QNull.Instance) {}

		~QWMatrix ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QWMatrix function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWMatrix_setMatrix (IntPtr raw, double m11, double m12, double m21, double m22, double dx, double dy);
		public void SetMatrix (double m11, double m12, double m21, double m22, double dx, double dy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWMatrix_setMatrix (rawObject, m11, m12, m21, m22, dx, dy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QWMatrix_m11 (IntPtr raw);
		public double M11 ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWMatrix_m11 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QWMatrix_m12 (IntPtr raw);
		public double M12 ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWMatrix_m12 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QWMatrix_m21 (IntPtr raw);
		public double M21 ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWMatrix_m21 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QWMatrix_m22 (IntPtr raw);
		public double M22 ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWMatrix_m22 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QWMatrix_dx (IntPtr raw);
		public double Dx ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWMatrix_dx (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern double qt_QWMatrix_dy (IntPtr raw);
		public double Dy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWMatrix_dy (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWMatrix_map (IntPtr raw, int x, int y, int[] tx, int[] ty);
		public void Map (int x, int y, int[] tx, int[] ty)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWMatrix_map (rawObject, x, y, tx, ty);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWMatrix_map1 (IntPtr raw, double x, double y, double[] tx, double[] ty);
		public void Map (double x, double y, double[] tx, double[] ty)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWMatrix_map1 (rawObject, x, y, tx, ty);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWMatrix_mapRect (IntPtr raw, IntPtr arg1);
		public QRect MapRect (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWMatrix_mapRect (rawObject, arg1.RawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWMatrix_map2 (IntPtr raw, IntPtr p);
		public QPoint Map (QPoint p)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWMatrix_map2 (rawObject, p.RawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWMatrix_map3 (IntPtr raw, IntPtr r);
		public QRect Map (QRect r)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWMatrix_map3 (rawObject, r.RawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWMatrix_map4 (IntPtr raw, IntPtr a);
		public QPointArray Map (QPointArray a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWMatrix_map4 (rawObject, a.RawObject), typeof (QPointArray)) as QPointArray;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWMatrix_reset (IntPtr raw);
		public void Reset ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWMatrix_reset (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWMatrix_isIdentity (IntPtr raw);
		public bool IsIdentity ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWMatrix_isIdentity (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWMatrix_translate (IntPtr raw, double dx, double dy);
		public QWMatrix Translate (double dx, double dy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWMatrix_translate (rawObject, dx, dy), typeof (QWMatrix)) as QWMatrix;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWMatrix_scale (IntPtr raw, double sx, double sy);
		public QWMatrix Scale (double sx, double sy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWMatrix_scale (rawObject, sx, sy), typeof (QWMatrix)) as QWMatrix;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWMatrix_shear (IntPtr raw, double sh, double sv);
		public QWMatrix Shear (double sh, double sv)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWMatrix_shear (rawObject, sh, sv), typeof (QWMatrix)) as QWMatrix;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWMatrix_rotate (IntPtr raw, double a);
		public QWMatrix Rotate (double a)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWMatrix_rotate (rawObject, a), typeof (QWMatrix)) as QWMatrix;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWMatrix_isInvertible (IntPtr raw);
		public bool IsInvertible ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWMatrix_isInvertible (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWMatrix_invert (IntPtr raw, bool arg1);
		public QWMatrix Invert (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWMatrix_invert (rawObject, arg1), typeof (QWMatrix)) as QWMatrix;
		}

		public QWMatrix Invert ()
		{
			return Invert(false);
		}
	}
}