// QWheelEvent.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QWheelEvent : QEvent, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QWheelEvent (IntPtr pos, int delta, int state, Qt.Orientation orient);
		public QWheelEvent (QPoint pos, int delta, int state, Qt.Orientation orient) : this (QNull.Instance)
		{
			rawObject = qt_new_QWheelEvent (pos.RawObject, delta, state, orient);
			RegisterObject (this);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QWheelEvent1 (IntPtr pos, IntPtr globalPos, int delta, int state, Qt.Orientation orient);
		public QWheelEvent (QPoint pos, QPoint globalPos, int delta, int state, Qt.Orientation orient) : this (QNull.Instance)
		{
			rawObject = qt_new_QWheelEvent1 (pos.RawObject, globalPos.RawObject, delta, state, orient);
			RegisterObject (this);
		}

		public QWheelEvent (QPoint pos, int delta, int state) : this (pos, delta, state, Qt.Orientation.Horizontal) {}

		public QWheelEvent (QPoint pos, QPoint globalPos, int delta, int state) : this (pos, globalPos, delta, state, Qt.Orientation.Horizontal) {}

		internal QWheelEvent () : this (QNull.Instance) {}

		public QWheelEvent (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QWheelEvent (QNull dummy) : base (QNull.Instance) {}

		~QWheelEvent ()
		{
			Dispose (false);
		}
		internal override void Delete ()
		{
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWheelEvent_delta (IntPtr raw);
		public int Delta ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWheelEvent_delta (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWheelEvent_pos (IntPtr raw);
		public QPoint Pos ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWheelEvent_pos (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWheelEvent_globalPos (IntPtr raw);
		public QPoint GlobalPos ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWheelEvent_globalPos (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWheelEvent_x (IntPtr raw);
		public int X ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWheelEvent_x (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWheelEvent_y (IntPtr raw);
		public int Y ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWheelEvent_y (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWheelEvent_globalX (IntPtr raw);
		public int GlobalX ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWheelEvent_globalX (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWheelEvent_globalY (IntPtr raw);
		public int GlobalY ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWheelEvent_globalY (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.ButtonState qt_QWheelEvent_state (IntPtr raw);
		public Qt.ButtonState State ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWheelEvent_state (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.Orientation qt_QWheelEvent_orientation (IntPtr raw);
		public Qt.Orientation Orientation ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWheelEvent_orientation (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWheelEvent_isAccepted (IntPtr raw);
		public bool IsAccepted ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWheelEvent_isAccepted (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWheelEvent_accept (IntPtr raw);
		public void Accept ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWheelEvent_accept (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWheelEvent_ignore (IntPtr raw);
		public void Ignore ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWheelEvent_ignore (rawObject);
		}

		// Begin interface methods.

	}
}