// QWidget.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QWidget : QObject, IQPaintDevice, IDisposable {

		public enum FocusPolicy {
			NoFocus = 0,
			TabFocus = 1,
			ClickFocus = 2,
			StrongFocus = 3,
			WheelFocus = 7
		}

		public enum BackgroundOrigin {
			WidgetOrigin = 0,
			ParentOrigin = 1,
			WindowOrigin = 2
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QWidget (IntPtr parent, string name, Qt.WidgetFlags f);
		public QWidget (QWidget parent, string name, Qt.WidgetFlags f) : this (QNull.Instance)
		{
			rawObject = qt_new_QWidget (parent != null ? parent.RawObject : IntPtr.Zero, name, f);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QWidget (QWidget parent) : this (parent, "") {}

		public QWidget (QWidget parent, string name) : this (parent, name, Qt.WidgetFlags.WWinOwnDC) {}

		internal QWidget () : this (QNull.Instance) {}

		public QWidget (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QWidget (QNull dummy) : base (QNull.Instance) {}

		~QWidget ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QWidget (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QWidget (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QWidget_winId (IntPtr raw);
		public uint WinId ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_winId (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setName (IntPtr raw, string name);
		public void SetName (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setName (rawObject, name);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_style (IntPtr raw);
		public QStyle Style ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_style (rawObject), typeof (QStyle)) as QStyle;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setStyle (IntPtr raw, IntPtr arg1);
		public void SetStyle (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setStyle (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_setStyle1 (IntPtr raw, IntPtr arg1);
		public QStyle SetStyle (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_setStyle1 (rawObject, new QString (arg1).RawObject), typeof (QStyle)) as QStyle;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isTopLevel (IntPtr raw);
		public bool IsTopLevel ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isTopLevel (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isDialog (IntPtr raw);
		public bool IsDialog ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isDialog (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isPopup (IntPtr raw);
		public bool IsPopup ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isPopup (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isDesktop (IntPtr raw);
		public bool IsDesktop ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isDesktop (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isModal (IntPtr raw);
		public bool IsModal ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isModal (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isEnabled (IntPtr raw);
		public bool IsEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isEnabledTo (IntPtr raw, IntPtr arg1);
		public bool IsEnabledTo (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isEnabledTo (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isEnabledToTLW (IntPtr raw);
		public bool IsEnabledToTLW ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isEnabledToTLW (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_frameGeometry (IntPtr raw);
		public QRect FrameGeometry ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_frameGeometry (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_geometry (IntPtr raw);
		public QRect Geometry ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_geometry (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWidget_x (IntPtr raw);
		public int X ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_x (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWidget_y (IntPtr raw);
		public int Y ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_y (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_pos (IntPtr raw);
		public QPoint Pos ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_pos (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_frameSize (IntPtr raw);
		public QSize FrameSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_frameSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_size (IntPtr raw);
		public QSize Size ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_size (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWidget_width (IntPtr raw);
		public int Width ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_width (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWidget_height (IntPtr raw);
		public int Height ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_height (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_rect (IntPtr raw);
		public QRect Rect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_rect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_childrenRect (IntPtr raw);
		public QRect ChildrenRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_childrenRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_childrenRegion (IntPtr raw);
		public QRegion ChildrenRegion ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_childrenRegion (rawObject), typeof (QRegion)) as QRegion;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_minimumSize (IntPtr raw);
		public QSize MinimumSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_minimumSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_maximumSize (IntPtr raw);
		public QSize MaximumSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_maximumSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWidget_minimumWidth (IntPtr raw);
		public int MinimumWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_minimumWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWidget_minimumHeight (IntPtr raw);
		public int MinimumHeight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_minimumHeight (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWidget_maximumWidth (IntPtr raw);
		public int MaximumWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_maximumWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWidget_maximumHeight (IntPtr raw);
		public int MaximumHeight ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_maximumHeight (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setMinimumSize (IntPtr raw, IntPtr arg1);
		public void SetMinimumSize (QSize arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setMinimumSize (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setMinimumSize1 (IntPtr raw, int minw, int minh);
		public void SetMinimumSize (int minw, int minh)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setMinimumSize1 (rawObject, minw, minh);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setMaximumSize (IntPtr raw, IntPtr arg1);
		public void SetMaximumSize (QSize arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setMaximumSize (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setMaximumSize1 (IntPtr raw, int maxw, int maxh);
		public void SetMaximumSize (int maxw, int maxh)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setMaximumSize1 (rawObject, maxw, maxh);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setMinimumWidth (IntPtr raw, int minw);
		public void SetMinimumWidth (int minw)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setMinimumWidth (rawObject, minw);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setMinimumHeight (IntPtr raw, int minh);
		public void SetMinimumHeight (int minh)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setMinimumHeight (rawObject, minh);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setMaximumWidth (IntPtr raw, int maxw);
		public void SetMaximumWidth (int maxw)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setMaximumWidth (rawObject, maxw);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setMaximumHeight (IntPtr raw, int maxh);
		public void SetMaximumHeight (int maxh)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setMaximumHeight (rawObject, maxh);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_sizeIncrement (IntPtr raw);
		public QSize SizeIncrement ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_sizeIncrement (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setSizeIncrement (IntPtr raw, IntPtr arg1);
		public void SetSizeIncrement (QSize arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setSizeIncrement (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setSizeIncrement1 (IntPtr raw, int w, int h);
		public void SetSizeIncrement (int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setSizeIncrement1 (rawObject, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_baseSize (IntPtr raw);
		public QSize BaseSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_baseSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setBaseSize (IntPtr raw, IntPtr arg1);
		public void SetBaseSize (QSize arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setBaseSize (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setBaseSize1 (IntPtr raw, int basew, int baseh);
		public void SetBaseSize (int basew, int baseh)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setBaseSize1 (rawObject, basew, baseh);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setFixedSize (IntPtr raw, IntPtr arg1);
		public void SetFixedSize (QSize arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setFixedSize (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setFixedSize1 (IntPtr raw, int w, int h);
		public void SetFixedSize (int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setFixedSize1 (rawObject, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setFixedWidth (IntPtr raw, int w);
		public void SetFixedWidth (int w)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setFixedWidth (rawObject, w);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setFixedHeight (IntPtr raw, int h);
		public void SetFixedHeight (int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setFixedHeight (rawObject, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_mapToGlobal (IntPtr raw, IntPtr arg1);
		public QPoint MapToGlobal (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_mapToGlobal (rawObject, arg1.RawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_mapFromGlobal (IntPtr raw, IntPtr arg1);
		public QPoint MapFromGlobal (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_mapFromGlobal (rawObject, arg1.RawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_mapToParent (IntPtr raw, IntPtr arg1);
		public QPoint MapToParent (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_mapToParent (rawObject, arg1.RawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_mapFromParent (IntPtr raw, IntPtr arg1);
		public QPoint MapFromParent (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_mapFromParent (rawObject, arg1.RawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_mapTo (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public QPoint MapTo (QWidget arg1, QPoint arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_mapTo (rawObject, arg1.RawObject, arg2.RawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_mapFrom (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public QPoint MapFrom (QWidget arg1, QPoint arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_mapFrom (rawObject, arg1.RawObject, arg2.RawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_topLevelWidget (IntPtr raw);
		public QWidget TopLevelWidget ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_topLevelWidget (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.BackgroundMode qt_QWidget_backgroundMode (IntPtr raw);
		public Qt.BackgroundMode BackgroundMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_backgroundMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setBackgroundMode (IntPtr raw, Qt.BackgroundMode arg1);
		public void SetBackgroundMode (Qt.BackgroundMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setBackgroundMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setBackgroundMode1 (IntPtr raw, Qt.BackgroundMode arg1, Qt.BackgroundMode arg2);
		public void SetBackgroundMode (Qt.BackgroundMode arg1, Qt.BackgroundMode arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setBackgroundMode1 (rawObject, arg1, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_foregroundColor (IntPtr raw);
		public QColor ForegroundColor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_foregroundColor (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_eraseColor (IntPtr raw);
		public QColor EraseColor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_eraseColor (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setEraseColor (IntPtr raw, IntPtr arg1);
		public void SetEraseColor (QColor arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setEraseColor (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_erasePixmap (IntPtr raw);
		public QPixmap ErasePixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_erasePixmap (rawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setErasePixmap (IntPtr raw, IntPtr arg1);
		public void SetErasePixmap (QPixmap arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setErasePixmap (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_colorGroup (IntPtr raw);
		public QColorGroup ColorGroup ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_colorGroup (rawObject), typeof (QColorGroup)) as QColorGroup;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_palette (IntPtr raw);
		public QPalette Palette ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_palette (rawObject), typeof (QPalette)) as QPalette;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_ownPalette (IntPtr raw);
		public bool OwnPalette ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_ownPalette (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setPalette (IntPtr raw, IntPtr arg1);
		public void SetPalette (QPalette arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setPalette (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_unsetPalette (IntPtr raw);
		public void UnsetPalette ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_unsetPalette (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_paletteForegroundColor (IntPtr raw);
		public QColor PaletteForegroundColor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_paletteForegroundColor (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setPaletteForegroundColor (IntPtr raw, IntPtr arg1);
		public void SetPaletteForegroundColor (QColor arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setPaletteForegroundColor (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_paletteBackgroundColor (IntPtr raw);
		public QColor PaletteBackgroundColor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_paletteBackgroundColor (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setPaletteBackgroundColor (IntPtr raw, IntPtr arg1);
		public void SetPaletteBackgroundColor (QColor arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setPaletteBackgroundColor (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_paletteBackgroundPixmap (IntPtr raw);
		public QPixmap PaletteBackgroundPixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_paletteBackgroundPixmap (rawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setPaletteBackgroundPixmap (IntPtr raw, IntPtr arg1);
		public void SetPaletteBackgroundPixmap (QPixmap arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setPaletteBackgroundPixmap (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_backgroundBrush (IntPtr raw);
		public QBrush BackgroundBrush ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_backgroundBrush (rawObject), typeof (QBrush)) as QBrush;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_font (IntPtr raw);
		public QFont Font ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_font (rawObject), typeof (QFont)) as QFont;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_ownFont (IntPtr raw);
		public bool OwnFont ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_ownFont (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setFont (IntPtr raw, IntPtr arg1);
		public void SetFont (QFont arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setFont (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_unsetFont (IntPtr raw);
		public void UnsetFont ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_unsetFont (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_fontMetrics (IntPtr raw);
		public QFontMetrics FontMetrics ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_fontMetrics (rawObject), typeof (QFontMetrics)) as QFontMetrics;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_fontInfo (IntPtr raw);
		public QFontInfo FontInfo ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_fontInfo (rawObject), typeof (QFontInfo)) as QFontInfo;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_cursor (IntPtr raw);
		public QCursor Cursor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_cursor (rawObject), typeof (QCursor)) as QCursor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_ownCursor (IntPtr raw);
		public bool OwnCursor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_ownCursor (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setCursor (IntPtr raw, IntPtr arg1);
		public void SetCursor (QCursor arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setCursor (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_unsetCursor (IntPtr raw);
		public void UnsetCursor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_unsetCursor (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_caption (IntPtr raw);
		public string Caption ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QWidget_caption (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_icon (IntPtr raw);
		public QPixmap Icon ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_icon (rawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_iconText (IntPtr raw);
		public string IconText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QWidget_iconText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_hasMouseTracking (IntPtr raw);
		public bool HasMouseTracking ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_hasMouseTracking (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_hasMouse (IntPtr raw);
		public bool HasMouse ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_hasMouse (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setMask (IntPtr raw, IntPtr arg1);
		public void SetMask (QBitmap arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setMask (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setMask1 (IntPtr raw, IntPtr arg1);
		public void SetMask (QRegion arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setMask1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_clearMask (IntPtr raw);
		public void ClearMask ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_clearMask (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_backgroundColor (IntPtr raw);
		public QColor BackgroundColor ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_backgroundColor (rawObject), typeof (QColor)) as QColor;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setBackgroundColor (IntPtr raw, IntPtr arg1);
		public void SetBackgroundColor (QColor arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setBackgroundColor (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_backgroundPixmap (IntPtr raw);
		public QPixmap BackgroundPixmap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_backgroundPixmap (rawObject), typeof (QPixmap)) as QPixmap;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setBackgroundPixmap (IntPtr raw, IntPtr arg1);
		public void SetBackgroundPixmap (QPixmap arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setBackgroundPixmap (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isActiveWindow (IntPtr raw);
		public bool IsActiveWindow ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isActiveWindow (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setActiveWindow (IntPtr raw);
		public void SetActiveWindow ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setActiveWindow (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isFocusEnabled (IntPtr raw);
		public bool IsFocusEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isFocusEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QWidget.FocusPolicy qt_QWidget_focusPolicy (IntPtr raw);
		public QWidget.FocusPolicy TheFocusPolicy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_focusPolicy (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setFocusPolicy (IntPtr raw, QWidget.FocusPolicy arg1);
		public void SetFocusPolicy (QWidget.FocusPolicy arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setFocusPolicy (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_hasFocus (IntPtr raw);
		public bool HasFocus ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_hasFocus (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setFocusProxy (IntPtr raw, IntPtr arg1);
		public void SetFocusProxy (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setFocusProxy (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_focusProxy (IntPtr raw);
		public QWidget FocusProxy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_focusProxy (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_grabMouse (IntPtr raw);
		public void GrabMouse ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_grabMouse (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_grabMouse1 (IntPtr raw, IntPtr arg1);
		public void GrabMouse (QCursor arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_grabMouse1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_releaseMouse (IntPtr raw);
		public void ReleaseMouse ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_releaseMouse (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_grabKeyboard (IntPtr raw);
		public void GrabKeyboard ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_grabKeyboard (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_releaseKeyboard (IntPtr raw);
		public void ReleaseKeyboard ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_releaseKeyboard (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isUpdatesEnabled (IntPtr raw);
		public bool IsUpdatesEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isUpdatesEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_repaintUnclipped (IntPtr raw, IntPtr arg1, bool erase);
		public void RepaintUnclipped (QRegion arg1, bool erase)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_repaintUnclipped (rawObject, arg1.RawObject, erase);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_close (IntPtr raw, bool alsoDelete);
		public bool Close (bool alsoDelete)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_close (rawObject, alsoDelete);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isVisible (IntPtr raw);
		public bool IsVisible ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isVisible (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isVisibleTo (IntPtr raw, IntPtr arg1);
		public bool IsVisibleTo (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isVisibleTo (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isVisibleToTLW (IntPtr raw);
		public bool IsVisibleToTLW ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isVisibleToTLW (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_visibleRect (IntPtr raw);
		public QRect VisibleRect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_visibleRect (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isHidden (IntPtr raw);
		public bool IsHidden ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isHidden (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isMinimized (IntPtr raw);
		public bool IsMinimized ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isMinimized (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isMaximized (IntPtr raw);
		public bool IsMaximized ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isMaximized (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_sizePolicy (IntPtr raw);
		public QSizePolicy SizePolicy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_sizePolicy (rawObject), typeof (QSizePolicy)) as QSizePolicy;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setSizePolicy (IntPtr raw, IntPtr arg1);
		public void SetSizePolicy (QSizePolicy arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setSizePolicy (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWidget_heightForWidth (IntPtr raw, int arg1);
		public int HeightForWidth (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_heightForWidth (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_adjustSize (IntPtr raw);
		public void AdjustSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_adjustSize (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_layout (IntPtr raw);
		public QLayout Layout ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_layout (rawObject), typeof (QLayout)) as QLayout;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_updateGeometry (IntPtr raw);
		public void UpdateGeometry ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_updateGeometry (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_reparent (IntPtr raw, IntPtr parent, Qt.WidgetFlags arg1, IntPtr arg2, bool showIt);
		public void Reparent (QWidget parent, Qt.WidgetFlags arg1, QPoint arg2, bool showIt)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_reparent (rawObject, parent.RawObject, arg1, arg2.RawObject, showIt);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_reparent1 (IntPtr raw, IntPtr parent, IntPtr arg1, bool showIt);
		public void Reparent (QWidget parent, QPoint arg1, bool showIt)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_reparent1 (rawObject, parent.RawObject, arg1.RawObject, showIt);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_recreate (IntPtr raw, IntPtr parent, Qt.WidgetFlags f, IntPtr p, bool showIt);
		public void Recreate (QWidget parent, Qt.WidgetFlags f, QPoint p, bool showIt)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_recreate (rawObject, parent.RawObject, f, p.RawObject, showIt);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_erase (IntPtr raw);
		public void Erase ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_erase (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_erase1 (IntPtr raw, int x, int y, int w, int h);
		public void Erase (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_erase1 (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_erase2 (IntPtr raw, IntPtr arg1);
		public void Erase (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_erase2 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_erase3 (IntPtr raw, IntPtr arg1);
		public void Erase (QRegion arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_erase3 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_scroll (IntPtr raw, int dx, int dy);
		public void Scroll (int dx, int dy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_scroll (rawObject, dx, dy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_scroll1 (IntPtr raw, int dx, int dy, IntPtr arg1);
		public void Scroll (int dx, int dy, QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_scroll1 (rawObject, dx, dy, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_drawText (IntPtr raw, int x, int y, IntPtr arg1);
		public void DrawText (int x, int y, string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_drawText (rawObject, x, y, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_drawText1 (IntPtr raw, IntPtr arg1, IntPtr arg2);
		public void DrawText (QPoint arg1, string arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_drawText1 (rawObject, arg1.RawObject, new QString (arg2).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_focusWidget (IntPtr raw);
		public QWidget FocusWidget ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_focusWidget (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_microFocusHint (IntPtr raw);
		public QRect MicroFocusHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_microFocusHint (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_acceptDrops (IntPtr raw);
		public bool AcceptDrops ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_acceptDrops (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setAcceptDrops (IntPtr raw, bool on);
		public void SetAcceptDrops (bool on)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setAcceptDrops (rawObject, on);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setAutoMask (IntPtr raw, bool arg1);
		public void SetAutoMask (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setAutoMask (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_autoMask (IntPtr raw);
		public bool AutoMask ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_autoMask (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setBackgroundOrigin (IntPtr raw, QWidget.BackgroundOrigin arg1);
		public void SetBackgroundOrigin (QWidget.BackgroundOrigin arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setBackgroundOrigin (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QWidget.BackgroundOrigin qt_QWidget_backgroundOrigin (IntPtr raw);
		public QWidget.BackgroundOrigin TheBackgroundOrigin ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_backgroundOrigin (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_customWhatsThis (IntPtr raw);
		public bool CustomWhatsThis ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_customWhatsThis (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_parentWidget (IntPtr raw, bool sameWindow);
		public QWidget ParentWidget (bool sameWindow)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_parentWidget (rawObject, sameWindow), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.WidgetState qt_QWidget_testWState (IntPtr raw, Qt.WidgetState s);
		public Qt.WidgetState TestWState (Qt.WidgetState s)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_testWState (rawObject, s);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.WidgetFlags qt_QWidget_testWFlags (IntPtr raw, Qt.WidgetFlags f);
		public Qt.WidgetFlags TestWFlags (Qt.WidgetFlags f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_testWFlags (rawObject, f);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_childAt (IntPtr raw, int x, int y, bool includeThis);
		public QWidget ChildAt (int x, int y, bool includeThis)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_childAt (rawObject, x, y, includeThis), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_childAt1 (IntPtr raw, IntPtr arg1, bool includeThis);
		public QWidget ChildAt (QPoint arg1, bool includeThis)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_childAt1 (rawObject, arg1.RawObject, includeThis), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_graphicsContext (IntPtr raw, bool clip_children);
		public IntPtr GraphicsContext (bool clip_children)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_graphicsContext (rawObject, clip_children);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_clippedRegion (IntPtr raw, bool do_children);
		public QRegion ClippedRegion (bool do_children)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_clippedRegion (rawObject, do_children), typeof (QRegion)) as QRegion;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QWidget_clippedSerial (IntPtr raw, bool do_children);
		public uint ClippedSerial (bool do_children)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_clippedSerial (rawObject, do_children);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_macCGContext (IntPtr raw, bool clipped);
		public IntPtr MacCGContext (bool clipped)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_macCGContext (rawObject, clipped);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setPalette1 (IntPtr raw, IntPtr p, bool arg1);
		public void SetPalette (QPalette p, bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setPalette1 (rawObject, p.RawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setFont1 (IntPtr raw, IntPtr f, bool arg1);
		public void SetFont (QFont f, bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setFont1 (rawObject, f.RawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setEnabled (IntPtr raw, bool arg1);
		public void SetEnabled (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setEnabled (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setDisabled (IntPtr raw, bool arg1);
		public void SetDisabled (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setDisabled (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setCaption (IntPtr raw, IntPtr arg1);
		public void SetCaption (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setCaption (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setIcon (IntPtr raw, IntPtr arg1);
		public void SetIcon (QPixmap arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setIcon (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setIconText (IntPtr raw, IntPtr arg1);
		public void SetIconText (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setIconText (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setMouseTracking (IntPtr raw, bool enable);
		public void SetMouseTracking (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setMouseTracking (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setFocus (IntPtr raw);
		public void SetFocus ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setFocus (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_clearFocus (IntPtr raw);
		public void ClearFocus ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_clearFocus (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setUpdatesEnabled (IntPtr raw, bool enable);
		public void SetUpdatesEnabled (bool enable)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setUpdatesEnabled (rawObject, enable);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_update (IntPtr raw);
		public void Update ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_update (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_update1 (IntPtr raw, int x, int y, int w, int h);
		public void Update (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_update1 (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_update2 (IntPtr raw, IntPtr arg1);
		public void Update (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_update2 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_repaint (IntPtr raw);
		public void Repaint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_repaint (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_repaint1 (IntPtr raw, bool erase);
		public void Repaint (bool erase)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_repaint1 (rawObject, erase);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_repaint2 (IntPtr raw, int x, int y, int w, int h, bool erase);
		public void Repaint (int x, int y, int w, int h, bool erase)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_repaint2 (rawObject, x, y, w, h, erase);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_repaint3 (IntPtr raw, IntPtr arg1, bool erase);
		public void Repaint (QRect arg1, bool erase)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_repaint3 (rawObject, arg1.RawObject, erase);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_repaint4 (IntPtr raw, IntPtr arg1, bool erase);
		public void Repaint (QRegion arg1, bool erase)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_repaint4 (rawObject, arg1.RawObject, erase);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_show (IntPtr raw);
		public void Show ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_show (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_hide (IntPtr raw);
		public void Hide ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_hide (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_iconify (IntPtr raw);
		public void Iconify ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_iconify (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_showMinimized (IntPtr raw);
		public void ShowMinimized ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_showMinimized (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_showMaximized (IntPtr raw);
		public void ShowMaximized ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_showMaximized (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_showFullScreen (IntPtr raw);
		public void ShowFullScreen ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_showFullScreen (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_showNormal (IntPtr raw);
		public void ShowNormal ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_showNormal (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_polish (IntPtr raw);
		public void Polish ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_polish (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_constPolish (IntPtr raw);
		public void ConstPolish ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_constPolish (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_close1 (IntPtr raw);
		public bool Close ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_close1 (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_raise (IntPtr raw);
		public void Raise ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_raise (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_lower (IntPtr raw);
		public void Lower ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_lower (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_stackUnder (IntPtr raw, IntPtr arg1);
		public void StackUnder (QWidget arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_stackUnder (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_move (IntPtr raw, int x, int y);
		public void Move (int x, int y)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_move (rawObject, x, y);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_move1 (IntPtr raw, IntPtr arg1);
		public void Move (QPoint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_move1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_resize (IntPtr raw, int w, int h);
		public void Resize (int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_resize (rawObject, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_resize1 (IntPtr raw, IntPtr arg1);
		public void Resize (QSize arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_resize1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setGeometry (IntPtr raw, int x, int y, int w, int h);
		public void SetGeometry (int x, int y, int w, int h)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setGeometry (rawObject, x, y, w, h);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setGeometry1 (IntPtr raw, IntPtr arg1);
		public void SetGeometry (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setGeometry1 (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setTabOrder (IntPtr arg1, IntPtr arg2);
		public static void SetTabOrder (QWidget arg1, QWidget arg2)
		{
			qt_QWidget_setTabOrder (arg1.RawObject, arg2.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_mouseGrabber ();
		public static QWidget MouseGrabber ()
		{
			return LookupObject (qt_QWidget_mouseGrabber (), typeof (QWidget)) as QWidget;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_keyboardGrabber ();
		public static QWidget KeyboardGrabber ()
		{
			return LookupObject (qt_QWidget_keyboardGrabber (), typeof (QWidget)) as QWidget;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_find (uint arg1);
		public static QWidget Find (uint arg1)
		{
			return LookupObject (qt_QWidget_find (arg1), typeof (QWidget)) as QWidget;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_wmapper ();
		public static IntPtr Wmapper ()
		{
			return qt_QWidget_wmapper ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_event (IntPtr raw, IntPtr arg1);
		protected bool Q_event (QEvent arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_event (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern string qt_QWidget_scanLine (IntPtr raw, int arg1);
		protected string ScanLine (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_scanLine (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWidget_bytesPerLine (IntPtr raw);
		protected int BytesPerLine ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_bytesPerLine (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_updateMask (IntPtr raw);
		protected void UpdateMask ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_updateMask (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_styleChange (IntPtr raw, IntPtr arg1);
		protected void StyleChange (QStyle arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_styleChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_enabledChange (IntPtr raw, bool oldEnabled);
		protected void EnabledChange (bool oldEnabled)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_enabledChange (rawObject, oldEnabled);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_paletteChange (IntPtr raw, IntPtr arg1);
		protected void PaletteChange (QPalette arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_paletteChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_fontChange (IntPtr raw, IntPtr arg1);
		protected void FontChange (QFont arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_fontChange (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_windowActivationChange (IntPtr raw, bool oldActive);
		protected void WindowActivationChange (bool oldActive)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_windowActivationChange (rawObject, oldActive);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWidget_metric (IntPtr raw, int arg1);
		protected int Metric (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_metric (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_resetInputContext (IntPtr raw);
		protected void ResetInputContext ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_resetInputContext (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_create (IntPtr raw, uint arg1, bool initializeWindow, bool destroyOldWindow);
		protected void Create (uint arg1, bool initializeWindow, bool destroyOldWindow)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_create (rawObject, arg1, initializeWindow, destroyOldWindow);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_destroy (IntPtr raw, bool destroyWindow, bool destroySubWindows);
		protected void Destroy (bool destroyWindow, bool destroySubWindows)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_destroy (rawObject, destroyWindow, destroySubWindows);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QWidget_getWState (IntPtr raw);
		protected uint GetWState ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_getWState (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setWState (IntPtr raw, uint arg1);
		protected void SetWState (uint arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setWState (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_clearWState (IntPtr raw, uint n);
		protected void ClearWState (uint n)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_clearWState (rawObject, n);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern Qt.WidgetFlags qt_QWidget_getWFlags (IntPtr raw);
		protected Qt.WidgetFlags GetWFlags ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_getWFlags (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setWFlags (IntPtr raw, Qt.WidgetFlags arg1);
		protected void SetWFlags (Qt.WidgetFlags arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setWFlags (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_clearWFlags (IntPtr raw, Qt.WidgetFlags n);
		protected void ClearWFlags (Qt.WidgetFlags n)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_clearWFlags (rawObject, n);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_focusNextPrevChild (IntPtr raw, bool next);
		protected bool FocusNextPrevChild (bool next)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_focusNextPrevChild (rawObject, next);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_extraData (IntPtr raw);
		protected QWExtra ExtraData ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_extraData (rawObject), typeof (QWExtra)) as QWExtra;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_topData (IntPtr raw);
		protected QTLWExtra TopData ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_topData (rawObject), typeof (QTLWExtra)) as QTLWExtra;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_focusData (IntPtr raw);
		protected QFocusData FocusData ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidget_focusData (rawObject), typeof (QFocusData)) as QFocusData;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setKeyCompression (IntPtr raw, bool arg1);
		protected void SetKeyCompression (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setKeyCompression (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_setMicroFocusHint (IntPtr raw, int x, int y, int w, int h, bool text, IntPtr f);
		protected void SetMicroFocusHint (int x, int y, int w, int h, bool text, QFont f)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_setMicroFocusHint (rawObject, x, y, w, h, text, f.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidget_dirtyClippedRegion (IntPtr raw, bool arg1);
		protected void DirtyClippedRegion (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidget_dirtyClippedRegion (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidget_isClippedRegionDirty (IntPtr raw);
		protected bool IsClippedRegionDirty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_isClippedRegionDirty (rawObject);
		}

		public void RepaintUnclipped (QRegion arg1)
		{
			RepaintUnclipped(arg1, true);
		}

		public void Reparent (QWidget parent, Qt.WidgetFlags arg1, QPoint arg2)
		{
			Reparent(parent, arg1, arg2, false);
		}

		public void Reparent (QWidget parent, QPoint arg1)
		{
			Reparent(parent, arg1, false);
		}

		public void Recreate (QWidget parent, Qt.WidgetFlags f, QPoint p)
		{
			Recreate(parent, f, p, false);
		}

		public QWidget ParentWidget ()
		{
			return ParentWidget(false);
		}

		public QWidget ChildAt (int x, int y)
		{
			return ChildAt(x, y, false);
		}

		public QWidget ChildAt (QPoint arg1)
		{
			return ChildAt(arg1, false);
		}

		public IntPtr GraphicsContext ()
		{
			return GraphicsContext(true);
		}

		public QRegion ClippedRegion ()
		{
			return ClippedRegion(true);
		}

		public uint ClippedSerial ()
		{
			return ClippedSerial(true);
		}

		public IntPtr MacCGContext ()
		{
			return MacCGContext(true);
		}

		public void Repaint (int x, int y, int w, int h)
		{
			Repaint(x, y, w, h, true);
		}

		public void Repaint (QRect arg1)
		{
			Repaint(arg1, true);
		}

		public void Repaint (QRegion arg1)
		{
			Repaint(arg1, true);
		}

		protected void Create ()
		{
			Create((uint) 0);
		}

		protected void Create (uint arg1)
		{
			Create(arg1, true);
		}

		protected void Create (uint arg1, bool initializeWindow)
		{
			Create(arg1, initializeWindow, true);
		}

		protected void Destroy ()
		{
			Destroy(true);
		}

		protected void Destroy (bool destroyWindow)
		{
			Destroy(destroyWindow, true);
		}

		protected void SetMicroFocusHint (int x, int y, int w, int h)
		{
			SetMicroFocusHint(x, y, w, h, true);
		}

		protected void SetMicroFocusHint (int x, int y, int w, int h, bool text)
		{
			SetMicroFocusHint(x, y, w, h, text, new QFont ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidget_QPaintDevice (IntPtr raw);
		public IntPtr QPaintDevice ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidget_QPaintDevice (rawObject);
		}

		// Begin interface methods.


		// Begin interface methods.


		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_devType (IntPtr raw);
		public int DevType ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_devType (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_isExtDev (IntPtr raw);
		public bool IsExtDev ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_isExtDev (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_paintingActive (IntPtr raw);
		public bool PaintingActive ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_paintingActive (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_setResolution (IntPtr raw, int arg1);
		public void SetResolution (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPaintDevice_setResolution (QPaintDevice (), arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_resolution (IntPtr raw);
		public int Resolution ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_resolution (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern uint qt_QPaintDevice_handle (IntPtr raw);
		public uint Handle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_handle (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11RenderHandle (IntPtr raw);
		public IntPtr X11RenderHandle ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11RenderHandle (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11Display (IntPtr raw);
		public IntPtr X11Display ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Display (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11Screen (IntPtr raw);
		public int X11Screen ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Screen (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11Depth (IntPtr raw);
		public int X11Depth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Depth (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11Cells (IntPtr raw);
		public int X11Cells ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Cells (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11Colormap (IntPtr raw);
		public IntPtr X11Colormap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Colormap (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_x11DefaultColormap (IntPtr raw);
		public bool X11DefaultColormap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11DefaultColormap (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QPaintDevice_x11Visual (IntPtr raw);
		public int[] X11Visual ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11Visual (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_x11DefaultVisual (IntPtr raw);
		public bool X11DefaultVisual ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_x11DefaultVisual (QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11AppDisplay ();
		public static IntPtr X11AppDisplay ()
		{
			return qt_QPaintDevice_x11AppDisplay ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppScreen ();
		public static int X11AppScreen ()
		{
			return qt_QPaintDevice_x11AppScreen ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppDepth ();
		public static int X11AppDepth ()
		{
			return qt_QPaintDevice_x11AppDepth ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppCells ();
		public static int X11AppCells ()
		{
			return qt_QPaintDevice_x11AppCells ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppDpiX ();
		public static int X11AppDpiX ()
		{
			return qt_QPaintDevice_x11AppDpiX ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_x11AppDpiY ();
		public static int X11AppDpiY ()
		{
			return qt_QPaintDevice_x11AppDpiY ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_x11AppColormap ();
		public static IntPtr X11AppColormap ()
		{
			return qt_QPaintDevice_x11AppColormap ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_x11AppDefaultColormap ();
		public static bool X11AppDefaultColormap ()
		{
			return qt_QPaintDevice_x11AppDefaultColormap ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QPaintDevice_x11AppVisual ();
		public static int[] X11AppVisual ()
		{
			return qt_QPaintDevice_x11AppVisual ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_x11AppDefaultVisual ();
		public static bool X11AppDefaultVisual ()
		{
			return qt_QPaintDevice_x11AppDefaultVisual ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_x11SetAppDpiX (int arg1);
		public static void X11SetAppDpiX (int arg1)
		{
			qt_QPaintDevice_x11SetAppDpiX (arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_x11SetAppDpiY (int arg1);
		public static void X11SetAppDpiY (int arg1)
		{
			qt_QPaintDevice_x11SetAppDpiY (arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_qwsDisplay ();
		public static IntPtr QwsDisplay ()
		{
			return qt_QPaintDevice_qwsDisplay ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_copyX11Data (IntPtr raw, IntPtr arg1);
		protected void CopyX11Data (IQPaintDevice arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPaintDevice_copyX11Data (QPaintDevice (), arg1.QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_cloneX11Data (IntPtr raw, IntPtr arg1);
		protected void CloneX11Data (IQPaintDevice arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPaintDevice_cloneX11Data (QPaintDevice (), arg1.QPaintDevice ());
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_setX11Data (IntPtr raw, IntPtr arg1);
		protected void SetX11Data (QPaintDeviceX11Data arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QPaintDevice_setX11Data (QPaintDevice (), arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QPaintDevice_getX11Data (IntPtr raw, bool def);
		protected QPaintDeviceX11Data GetX11Data (bool def)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QPaintDevice_getX11Data (QPaintDevice (), def), typeof (QPaintDeviceX11Data)) as QPaintDeviceX11Data;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QPaintDevice_cmd (IntPtr raw, int arg1, IntPtr arg2, IntPtr arg3);
		protected bool Cmd (int arg1, QPainter arg2, QPDevCmdParam arg3)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_cmd (QPaintDevice (), arg1, arg2.RawObject, arg3.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_fontMet (IntPtr raw, IntPtr arg1, int arg2, string arg3, int arg4);
		protected int FontMet (QFont arg1, int arg2, string arg3, int arg4)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_fontMet (QPaintDevice (), arg1.RawObject, arg2, arg3, arg4);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QPaintDevice_fontInf (IntPtr raw, IntPtr arg1, int arg2);
		protected int FontInf (QFont arg1, int arg2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QPaintDevice_fontInf (QPaintDevice (), arg1.RawObject, arg2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QPaintDevice_bitBlt (IntPtr dst, int dx, int dy, IntPtr src, int sx, int sy, int sw, int sh, Qt.RasterOp rop, bool ignoreMask);
		public static void BitBlt (IQPaintDevice dst, int dx, int dy, IQPaintDevice src, int sx, int sy, int sw, int sh, Qt.RasterOp rop, bool ignoreMask)
		{
			qt_QPaintDevice_bitBlt (dst.QPaintDevice (), dx, dy, src.QPaintDevice (), sx, sy, sw, sh, rop, ignoreMask);
		}

		protected QPaintDeviceX11Data GetX11Data ()
		{
			return GetX11Data(false);
		}

		protected int FontMet (QFont arg1, int arg2)
		{
			return FontMet(arg1, arg2, "");
		}

		protected int FontMet (QFont arg1, int arg2, string arg3)
		{
			return FontMet(arg1, arg2, arg3, (int) 0);
		}
	}
}