// QWidgetFactory.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QWidgetFactory : QtSupport, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QWidgetFactory ();
		public QWidgetFactory () : this (QNull.Instance)
		{
			rawObject = qt_new_QWidgetFactory ();
			RegisterObject (this);
		}

		public QWidgetFactory (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QWidgetFactory (QNull dummy) : base (QNull.Instance) {}

		~QWidgetFactory ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QWidgetFactory (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QWidgetFactory (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidgetFactory_createWidget (IntPtr raw, IntPtr className, IntPtr parent, string name);
		public QWidget CreateWidget (string className, QWidget parent, string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidgetFactory_createWidget (rawObject, new QString (className).RawObject, parent.RawObject, name), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidgetFactory_create (string uiFile, IntPtr connector, IntPtr parent, string name);
		public static QWidget Create (string uiFile, QObject connector, QWidget parent, string name)
		{
			return LookupObject (qt_QWidgetFactory_create (uiFile, connector.RawObject, parent.RawObject, name), typeof (QWidget)) as QWidget;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidgetFactory_create1 (IntPtr dev, IntPtr connector, IntPtr parent, string name);
		public static QWidget Create (QIODevice dev, QObject connector, QWidget parent, string name)
		{
			return LookupObject (qt_QWidgetFactory_create1 (dev.RawObject, connector.RawObject, parent.RawObject, name), typeof (QWidget)) as QWidget;

		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidgetFactory_addWidgetFactory (IntPtr factory);
		public static void AddWidgetFactory (QWidgetFactory factory)
		{
			qt_QWidgetFactory_addWidgetFactory (factory.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidgetFactory_loadImages (IntPtr dir);
		public static void LoadImages (string dir)
		{
			qt_QWidgetFactory_loadImages (new QString (dir).RawObject);
		}

		public static QWidget Create (string uiFile)
		{
			return Create(uiFile, new QObject ());
		}

		public static QWidget Create (string uiFile, QObject connector)
		{
			return Create(uiFile, connector, new QWidget ());
		}

		public static QWidget Create (string uiFile, QObject connector, QWidget parent)
		{
			return Create(uiFile, connector, parent, "");
		}

		public static QWidget Create (QIODevice dev)
		{
			return Create(dev, new QObject ());
		}

		public static QWidget Create (QIODevice dev, QObject connector)
		{
			return Create(dev, connector, new QWidget ());
		}

		public static QWidget Create (QIODevice dev, QObject connector, QWidget parent)
		{
			return Create(dev, connector, parent, "");
		}
	}
}