// QWidgetItem.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QWidgetItem : QLayoutItem, IDisposable {

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QWidgetItem (IntPtr w);
		public QWidgetItem (QWidget w) : this (QNull.Instance)
		{
			rawObject = qt_new_QWidgetItem (w.RawObject);
			RegisterObject (this);
		}

		internal QWidgetItem () : this (QNull.Instance) {}

		public QWidgetItem (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QWidgetItem (QNull dummy) : base (QNull.Instance) {}

		~QWidgetItem ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QWidgetItem function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidgetItem_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidgetItem_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidgetItem_minimumSize (IntPtr raw);
		public QSize MinimumSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidgetItem_minimumSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidgetItem_maximumSize (IntPtr raw);
		public QSize MaximumSize ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidgetItem_maximumSize (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern QSizePolicy.ExpandData qt_QWidgetItem_expanding (IntPtr raw);
		public QSizePolicy.ExpandData Expanding ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidgetItem_expanding (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidgetItem_isEmpty (IntPtr raw);
		public bool IsEmpty ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidgetItem_isEmpty (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QWidgetItem_setGeometry (IntPtr raw, IntPtr arg1);
		public void SetGeometry (QRect arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QWidgetItem_setGeometry (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidgetItem_geometry (IntPtr raw);
		public QRect Geometry ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidgetItem_geometry (rawObject), typeof (QRect)) as QRect;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidgetItem_widget (IntPtr raw);
		public QWidget Widget ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidgetItem_widget (rawObject), typeof (QWidget)) as QWidget;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QWidgetItem_hasHeightForWidth (IntPtr raw);
		public bool HasHeightForWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidgetItem_hasHeightForWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QWidgetItem_heightForWidth (IntPtr raw, int arg1);
		public int HeightForWidth (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QWidgetItem_heightForWidth (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QWidgetItem_widgetSizeHint (IntPtr raw);
		public QSize WidgetSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QWidgetItem_widgetSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		// Begin interface methods.

	}
}