// QXmlContentHandler.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QXmlContentHandler : QtSupport, IDisposable {

		internal QXmlContentHandler () : this (QNull.Instance) {}

		public QXmlContentHandler (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QXmlContentHandler (QNull dummy) : base (QNull.Instance) {}

		~QXmlContentHandler ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QXmlContentHandler function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QXmlContentHandler_setDocumentLocator (IntPtr raw, IntPtr locator);
		public void SetDocumentLocator (QXmlLocator locator)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QXmlContentHandler_setDocumentLocator (rawObject, locator.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlContentHandler_startDocument (IntPtr raw);
		public bool StartDocument ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlContentHandler_startDocument (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlContentHandler_endDocument (IntPtr raw);
		public bool EndDocument ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlContentHandler_endDocument (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlContentHandler_startPrefixMapping (IntPtr raw, IntPtr prefix, IntPtr uri);
		public bool StartPrefixMapping (string prefix, string uri)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlContentHandler_startPrefixMapping (rawObject, new QString (prefix).RawObject, new QString (uri).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlContentHandler_endPrefixMapping (IntPtr raw, IntPtr prefix);
		public bool EndPrefixMapping (string prefix)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlContentHandler_endPrefixMapping (rawObject, new QString (prefix).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlContentHandler_startElement (IntPtr raw, IntPtr namespaceURI, IntPtr localName, IntPtr qName, IntPtr atts);
		public bool StartElement (string namespaceURI, string localName, string qName, QXmlAttributes atts)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlContentHandler_startElement (rawObject, new QString (namespaceURI).RawObject, new QString (localName).RawObject, new QString (qName).RawObject, atts.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlContentHandler_endElement (IntPtr raw, IntPtr namespaceURI, IntPtr localName, IntPtr qName);
		public bool EndElement (string namespaceURI, string localName, string qName)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlContentHandler_endElement (rawObject, new QString (namespaceURI).RawObject, new QString (localName).RawObject, new QString (qName).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlContentHandler_characters (IntPtr raw, IntPtr ch);
		public bool Characters (string ch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlContentHandler_characters (rawObject, new QString (ch).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlContentHandler_ignorableWhitespace (IntPtr raw, IntPtr ch);
		public bool IgnorableWhitespace (string ch)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlContentHandler_ignorableWhitespace (rawObject, new QString (ch).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlContentHandler_processingInstruction (IntPtr raw, IntPtr target, IntPtr data);
		public bool ProcessingInstruction (string target, string data)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlContentHandler_processingInstruction (rawObject, new QString (target).RawObject, new QString (data).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlContentHandler_skippedEntity (IntPtr raw, IntPtr name);
		public bool SkippedEntity (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlContentHandler_skippedEntity (rawObject, new QString (name).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QXmlContentHandler_errorString (IntPtr raw);
		public string ErrorString ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QXmlContentHandler_errorString (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}
	}
}