// QXmlReader.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QXmlReader : QtSupport, IDisposable {

		internal QXmlReader () : this (QNull.Instance) {}

		public QXmlReader (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QXmlReader (QNull dummy) : base (QNull.Instance) {}

		~QXmlReader ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QXmlReader function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlReader_feature (IntPtr raw, IntPtr name, bool ok);
		public bool Feature (string name, bool ok)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlReader_feature (rawObject, new QString (name).RawObject, ok);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QXmlReader_setFeature (IntPtr raw, IntPtr name, bool value);
		public void SetFeature (string name, bool value)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QXmlReader_setFeature (rawObject, new QString (name).RawObject, value);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlReader_hasFeature (IntPtr raw, IntPtr name);
		public bool HasFeature (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlReader_hasFeature (rawObject, new QString (name).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int[] qt_QXmlReader_property (IntPtr raw, IntPtr name, bool ok);
		public int[] Property (string name, bool ok)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlReader_property (rawObject, new QString (name).RawObject, ok);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QXmlReader_setProperty (IntPtr raw, IntPtr name, int[] value);
		public void SetProperty (string name, int[] value)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QXmlReader_setProperty (rawObject, new QString (name).RawObject, value);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlReader_hasProperty (IntPtr raw, IntPtr name);
		public bool HasProperty (string name)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlReader_hasProperty (rawObject, new QString (name).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QXmlReader_setEntityResolver (IntPtr raw, IntPtr handler);
		public void SetEntityResolver (QXmlEntityResolver handler)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QXmlReader_setEntityResolver (rawObject, handler.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QXmlReader_entityResolver (IntPtr raw);
		public QXmlEntityResolver EntityResolver ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QXmlReader_entityResolver (rawObject), typeof (QXmlEntityResolver)) as QXmlEntityResolver;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QXmlReader_setDTDHandler (IntPtr raw, IntPtr handler);
		public void SetDTDHandler (QXmlDTDHandler handler)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QXmlReader_setDTDHandler (rawObject, handler.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QXmlReader_DTDHandler (IntPtr raw);
		public QXmlDTDHandler DTDHandler ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QXmlReader_DTDHandler (rawObject), typeof (QXmlDTDHandler)) as QXmlDTDHandler;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QXmlReader_setContentHandler (IntPtr raw, IntPtr handler);
		public void SetContentHandler (QXmlContentHandler handler)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QXmlReader_setContentHandler (rawObject, handler.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QXmlReader_contentHandler (IntPtr raw);
		public QXmlContentHandler ContentHandler ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QXmlReader_contentHandler (rawObject), typeof (QXmlContentHandler)) as QXmlContentHandler;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QXmlReader_setErrorHandler (IntPtr raw, IntPtr handler);
		public void SetErrorHandler (QXmlErrorHandler handler)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QXmlReader_setErrorHandler (rawObject, handler.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QXmlReader_errorHandler (IntPtr raw);
		public QXmlErrorHandler ErrorHandler ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QXmlReader_errorHandler (rawObject), typeof (QXmlErrorHandler)) as QXmlErrorHandler;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QXmlReader_setLexicalHandler (IntPtr raw, IntPtr handler);
		public void SetLexicalHandler (QXmlLexicalHandler handler)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QXmlReader_setLexicalHandler (rawObject, handler.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QXmlReader_lexicalHandler (IntPtr raw);
		public QXmlLexicalHandler LexicalHandler ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QXmlReader_lexicalHandler (rawObject), typeof (QXmlLexicalHandler)) as QXmlLexicalHandler;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QXmlReader_setDeclHandler (IntPtr raw, IntPtr handler);
		public void SetDeclHandler (QXmlDeclHandler handler)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QXmlReader_setDeclHandler (rawObject, handler.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QXmlReader_declHandler (IntPtr raw);
		public QXmlDeclHandler DeclHandler ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QXmlReader_declHandler (rawObject), typeof (QXmlDeclHandler)) as QXmlDeclHandler;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QXmlReader_parse (IntPtr raw, IntPtr input);
		public bool Parse (QXmlInputSource input)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QXmlReader_parse (rawObject, input.RawObject);
		}

		public bool Feature (string name)
		{
			return Feature(name, false);
		}

		public int[] Property (string name)
		{
			return Property(name, false);
		}
	}
}