// Qt.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class Qt : QtSupport, IDisposable {

		public enum ButtonState {
			NoButton = 0,
			LeftButton = 1,
			RightButton = 2,
			MidButton = 4,
			MouseButtonMask = 255,
			ShiftButton = 256,
			ControlButton = 512,
			AltButton = 1024,
			MetaButton = 2048,
			KeyButtonMask = 4095,
			Keypad = 16384
		}

		public enum Orientation {
			Horizontal = 0,
			Vertical = 1
		}

		public enum AlignmentFlags {
			AlignAuto = 0,
			AlignLeft = 1,
			AlignRight = 2,
			AlignHCenter = 4,
			AlignJustify = 8,
			AlignHorizontal_Mask = AlignLeft|AlignRight|AlignHCenter|AlignJustify,
			AlignTop = 16,
			AlignBottom = 32,
			AlignVCenter = 64,
			AlignVertical_Mask = AlignTop|AlignBottom|AlignVCenter,
			AlignCenter = AlignVCenter|AlignHCenter
		}

		public enum TextFlags {
			SingleLine = 128,
			DontClip = 256,
			ExpandTabs = 512,
			ShowPrefix = 1024,
			WordBreak = 2048,
			BreakAnywhere = 4096,
			DontPrint = 8192,
			NoAccel = 16384
		}

		public enum WidgetState {
			WState_Created = 1,
			WState_Disabled = 2,
			WState_Visible = 4,
			WState_ForceHide = 8,
			WState_OwnCursor = 16,
			WState_MouseTracking = 32,
			WState_CompressKeys = 64,
			WState_BlockUpdates = 128,
			WState_InPaintEvent = 256,
			WState_Reparented = 512,
			WState_ConfigPending = 1024,
			WState_Resized = 2048,
			WState_AutoMask = 4096,
			WState_Polished = 8192,
			WState_DND = 16384,
			WState_Reserved0 = 32768,
			WState_Reserved1 = 65536,
			WState_Reserved2 = 131072,
			WState_Reserved3 = 262144,
			WState_Maximized = 524288,
			WState_Minimized = 1048576,
			WState_ForceDisabled = 2097152,
			WState_Exposed = 4194304,
			WState_HasMouse = 8388608
		}

		public enum WidgetFlags {
			WWinOwnDC = 0,
			WType_TopLevel = 1,
			WType_Dialog = 2,
			WType_Popup = 4,
			WType_Desktop = 8,
			WType_Mask = 15,
			WStyle_Customize = 16,
			WStyle_NormalBorder = 32,
			WStyle_DialogBorder = 64,
			WStyle_NoBorder = 8192,
			WStyle_Title = 128,
			WStyle_SysMenu = 256,
			WStyle_Minimize = 512,
			WStyle_Maximize = 1024,
			WStyle_MinMax = WStyle_Minimize|WStyle_Maximize,
			WStyle_Tool = 2048,
			WStyle_StaysOnTop = 4096,
			WStyle_ContextHelp = 16384,
			WStyle_Reserved = 32768,
			WStyle_Mask = 65520,
			WDestructiveClose = 65536,
			WPaintDesktop = 131072,
			WPaintUnclipped = 262144,
			WPaintClever = 524288,
			WResizeNoErase = 1048576,
			WMouseNoMask = 2097152,
			WStaticContents = 4194304,
			WRepaintNoErase = 8388608,
			WX11BypassWM = 16777216,
			WGroupLeader = 33554432,
			WShowModal = 67108864,
			WNoMousePropagation = 134217728,
			WSubWindow = 268435456,
			WNorthWestGravity = WStaticContents,
			WType_Modal = WType_Dialog|WShowModal,
			WStyle_Dialog = WType_Dialog,
			WStyle_NoBorderEx = WStyle_NoBorder
		}

		public enum ImageConversionFlags {
			ColorMode_Mask = 3,
			AutoColor = 0,
			ColorOnly = 3,
			MonoOnly = 2,
			AlphaDither_Mask = 12,
			ThresholdAlphaDither = 0,
			OrderedAlphaDither = 4,
			DiffuseAlphaDither = 8,
			NoAlpha = 12,
			Dither_Mask = 48,
			DiffuseDither = 0,
			OrderedDither = 16,
			ThresholdDither = 32,
			DitherMode_Mask = 192,
			AutoDither = 0,
			PreferDither = 64,
			AvoidDither = 128
		}

		public enum BGMode {
			TransparentMode = 0,
			OpaqueMode = 1
		}

		public enum PaintUnit {
			PixelUnit = 0,
			LoMetricUnit = 1,
			HiMetricUnit = 2,
			LoEnglishUnit = 3,
			HiEnglishUnit = 4,
			TwipsUnit = 5
		}

		public enum GUIStyle {
			WindowsStyle = 1,
			MotifStyle = 4
		}

		public enum GUIStyle {
			MacStyle = 0,
			WindowsStyle = 1,
			Win3Style = 2,
			PMStyle = 3,
			MotifStyle = 4
		}

		public enum Modifier {
			SHIFT = 2097152,
			CTRL = 4194304,
			ALT = 8388608,
			MODIFIER_MASK = 14680064,
			UNICODE_ACCEL = 268435456,
			ASCII_ACCEL = UNICODE_ACCEL
		}

		public enum Key {
			Key_Escape = 4096,
			Key_Tab = 4097,
			Key_Backtab = 4098,
			Key_BackTab = Key_Backtab,
			Key_Backspace = 4099,
			Key_BackSpace = Key_Backspace,
			Key_Return = 4100,
			Key_Enter = 4101,
			Key_Insert = 4102,
			Key_Delete = 4103,
			Key_Pause = 4104,
			Key_Print = 4105,
			Key_SysReq = 4106,
			Key_Home = 4112,
			Key_End = 4113,
			Key_Left = 4114,
			Key_Up = 4115,
			Key_Right = 4116,
			Key_Down = 4117,
			Key_Prior = 4118,
			Key_PageUp = Key_Prior,
			Key_Next = 4119,
			Key_PageDown = Key_Next,
			Key_Shift = 4128,
			Key_Control = 4129,
			Key_Meta = 4130,
			Key_Alt = 4131,
			Key_CapsLock = 4132,
			Key_NumLock = 4133,
			Key_ScrollLock = 4134,
			Key_F1 = 4144,
			Key_F2 = 4145,
			Key_F3 = 4146,
			Key_F4 = 4147,
			Key_F5 = 4148,
			Key_F6 = 4149,
			Key_F7 = 4150,
			Key_F8 = 4151,
			Key_F9 = 4152,
			Key_F10 = 4153,
			Key_F11 = 4154,
			Key_F12 = 4155,
			Key_F13 = 4156,
			Key_F14 = 4157,
			Key_F15 = 4158,
			Key_F16 = 4159,
			Key_F17 = 4160,
			Key_F18 = 4161,
			Key_F19 = 4162,
			Key_F20 = 4163,
			Key_F21 = 4164,
			Key_F22 = 4165,
			Key_F23 = 4166,
			Key_F24 = 4167,
			Key_F25 = 4168,
			Key_F26 = 4169,
			Key_F27 = 4170,
			Key_F28 = 4171,
			Key_F29 = 4172,
			Key_F30 = 4173,
			Key_F31 = 4174,
			Key_F32 = 4175,
			Key_F33 = 4176,
			Key_F34 = 4177,
			Key_F35 = 4178,
			Key_Super_L = 4179,
			Key_Super_R = 4180,
			Key_Menu = 4181,
			Key_Hyper_L = 4182,
			Key_Hyper_R = 4183,
			Key_Help = 4184,
			Key_Direction_L = 4185,
			Key_Direction_R = 4192,
			Key_Space = 32,
			Key_Any = Key_Space,
			Key_Exclam = 33,
			Key_QuoteDbl = 34,
			Key_NumberSign = 35,
			Key_Dollar = 36,
			Key_Percent = 37,
			Key_Ampersand = 38,
			Key_Apostrophe = 39,
			Key_ParenLeft = 40,
			Key_ParenRight = 41,
			Key_Asterisk = 42,
			Key_Plus = 43,
			Key_Comma = 44,
			Key_Minus = 45,
			Key_Period = 46,
			Key_Slash = 47,
			Key_0 = 48,
			Key_1 = 49,
			Key_2 = 50,
			Key_3 = 51,
			Key_4 = 52,
			Key_5 = 53,
			Key_6 = 54,
			Key_7 = 55,
			Key_8 = 56,
			Key_9 = 57,
			Key_Colon = 58,
			Key_Semicolon = 59,
			Key_Less = 60,
			Key_Equal = 61,
			Key_Greater = 62,
			Key_Question = 63,
			Key_At = 64,
			Key_A = 65,
			Key_B = 66,
			Key_C = 67,
			Key_D = 68,
			Key_E = 69,
			Key_F = 70,
			Key_G = 71,
			Key_H = 72,
			Key_I = 73,
			Key_J = 74,
			Key_K = 75,
			Key_L = 76,
			Key_M = 77,
			Key_N = 78,
			Key_O = 79,
			Key_P = 80,
			Key_Q = 81,
			Key_R = 82,
			Key_S = 83,
			Key_T = 84,
			Key_U = 85,
			Key_V = 86,
			Key_W = 87,
			Key_X = 88,
			Key_Y = 89,
			Key_Z = 90,
			Key_BracketLeft = 91,
			Key_Backslash = 92,
			Key_BracketRight = 93,
			Key_AsciiCircum = 94,
			Key_Underscore = 95,
			Key_QuoteLeft = 96,
			Key_BraceLeft = 123,
			Key_Bar = 124,
			Key_BraceRight = 125,
			Key_AsciiTilde = 126,
			Key_nobreakspace = 160,
			Key_exclamdown = 161,
			Key_cent = 162,
			Key_sterling = 163,
			Key_currency = 164,
			Key_yen = 165,
			Key_brokenbar = 166,
			Key_section = 167,
			Key_diaeresis = 168,
			Key_copyright = 169,
			Key_ordfeminine = 170,
			Key_guillemotleft = 171,
			Key_notsign = 172,
			Key_hyphen = 173,
			Key_registered = 174,
			Key_macron = 175,
			Key_degree = 176,
			Key_plusminus = 177,
			Key_twosuperior = 178,
			Key_threesuperior = 179,
			Key_acute = 180,
			Key_mu = 181,
			Key_paragraph = 182,
			Key_periodcentered = 183,
			Key_cedilla = 184,
			Key_onesuperior = 185,
			Key_masculine = 186,
			Key_guillemotright = 187,
			Key_onequarter = 188,
			Key_onehalf = 189,
			Key_threequarters = 190,
			Key_questiondown = 191,
			Key_Agrave = 192,
			Key_Aacute = 193,
			Key_Acircumflex = 194,
			Key_Atilde = 195,
			Key_Adiaeresis = 196,
			Key_Aring = 197,
			Key_AE = 198,
			Key_Ccedilla = 199,
			Key_Egrave = 200,
			Key_Eacute = 201,
			Key_Ecircumflex = 202,
			Key_Ediaeresis = 203,
			Key_Igrave = 204,
			Key_Iacute = 205,
			Key_Icircumflex = 206,
			Key_Idiaeresis = 207,
			Key_ETH = 208,
			Key_Ntilde = 209,
			Key_Ograve = 210,
			Key_Oacute = 211,
			Key_Ocircumflex = 212,
			Key_Otilde = 213,
			Key_Odiaeresis = 214,
			Key_multiply = 215,
			Key_Ooblique = 216,
			Key_Ugrave = 217,
			Key_Uacute = 218,
			Key_Ucircumflex = 219,
			Key_Udiaeresis = 220,
			Key_Yacute = 221,
			Key_THORN = 222,
			Key_ssharp = 223,
			Key_agrave = 224,
			Key_aacute = 225,
			Key_acircumflex = 226,
			Key_atilde = 227,
			Key_adiaeresis = 228,
			Key_aring = 229,
			Key_ae = 230,
			Key_ccedilla = 231,
			Key_egrave = 232,
			Key_eacute = 233,
			Key_ecircumflex = 234,
			Key_ediaeresis = 235,
			Key_igrave = 236,
			Key_iacute = 237,
			Key_icircumflex = 238,
			Key_idiaeresis = 239,
			Key_eth = 240,
			Key_ntilde = 241,
			Key_ograve = 242,
			Key_oacute = 243,
			Key_ocircumflex = 244,
			Key_otilde = 245,
			Key_odiaeresis = 246,
			Key_division = 247,
			Key_oslash = 248,
			Key_ugrave = 249,
			Key_uacute = 250,
			Key_ucircumflex = 251,
			Key_udiaeresis = 252,
			Key_yacute = 253,
			Key_thorn = 254,
			Key_ydiaeresis = 255,
			Key_unknown = 65535
		}

		public enum ArrowType {
			UpArrow = 0,
			DownArrow = 1,
			LeftArrow = 2,
			RightArrow = 3
		}

		public enum RasterOp {
			CopyROP = 0,
			OrROP = 1,
			XorROP = 2,
			NotAndROP = 3,
			EraseROP = NotAndROP,
			NotCopyROP = 4,
			NotOrROP = 5,
			NotXorROP = 6,
			AndROP = 7,
			NotEraseROP = AndROP,
			NotROP = 8,
			ClearROP = 9,
			SetROP = 10,
			NopROP = 11,
			AndNotROP = 12,
			OrNotROP = 13,
			NandROP = 14,
			NorROP = 15,
			LastROP = NorROP
		}

		public enum PenStyle {
			NoPen = 0,
			SolidLine = 1,
			DashLine = 2,
			DotLine = 3,
			DashDotLine = 4,
			DashDotDotLine = 5,
			MPenStyle = 15
		}

		public enum PenCapStyle {
			FlatCap = 0,
			SquareCap = 16,
			RoundCap = 32,
			MPenCapStyle = 48
		}

		public enum PenJoinStyle {
			MiterJoin = 0,
			BevelJoin = 64,
			RoundJoin = 128,
			MPenJoinStyle = 192
		}

		public enum BrushStyle {
			NoBrush = 0,
			SolidPattern = 1,
			Dense1Pattern = 2,
			Dense2Pattern = 3,
			Dense3Pattern = 4,
			Dense4Pattern = 5,
			Dense5Pattern = 6,
			Dense6Pattern = 7,
			Dense7Pattern = 8,
			HorPattern = 9,
			VerPattern = 10,
			CrossPattern = 11,
			BDiagPattern = 12,
			FDiagPattern = 13,
			DiagCrossPattern = 14,
			CustomPattern = 24
		}

		public enum WindowsVersion {
			WV_32s = 1,
			WV_95 = 2,
			WV_98 = 3,
			WV_Me = 4,
			WV_DOS_based = 15,
			WV_NT = 16,
			WV_2000 = 32,
			WV_XP = 48,
			WV_NT_based = 240
		}

		public enum UIEffect {
			UI_General = 0,
			UI_AnimateMenu = 1,
			UI_FadeMenu = 2,
			UI_AnimateCombo = 3,
			UI_AnimateTooltip = 4,
			UI_FadeTooltip = 5
		}

		public enum CursorShape {
			ArrowCursor = 0,
			UpArrowCursor = 1,
			CrossCursor = 2,
			WaitCursor = 3,
			IbeamCursor = 4,
			SizeVerCursor = 5,
			SizeHorCursor = 6,
			SizeBDiagCursor = 7,
			SizeFDiagCursor = 8,
			SizeAllCursor = 9,
			BlankCursor = 10,
			SplitVCursor = 11,
			SplitHCursor = 12,
			PointingHandCursor = 13,
			ForbiddenCursor = 14,
			WhatsThisCursor = 15,
			LastCursor = WhatsThisCursor,
			BitmapCursor = 24
		}

		public enum TextFormat {
			PlainText = 0,
			RichText = 1,
			AutoText = 2
		}

		public enum Dock {
			DockUnmanaged = 0,
			DockTornOff = 1,
			DockTop = 2,
			DockBottom = 3,
			DockRight = 4,
			DockLeft = 5,
			DockMinimized = 6,
			Unmanaged = DockUnmanaged,
			TornOff = DockTornOff,
			Top = DockTop,
			Bottom = DockBottom,
			Right = DockRight,
			Left = DockLeft,
			Minimized = DockMinimized
		}

		public enum DateFormat {
			TextDate = 0,
			ISODate = 1,
			LocalDate = 2
		}

		public enum BackgroundMode {
			FixedColor = 0,
			FixedPixmap = 1,
			NoBackground = 2,
			PaletteForeground = 3,
			PaletteButton = 4,
			PaletteLight = 5,
			PaletteMidlight = 6,
			PaletteDark = 7,
			PaletteMid = 8,
			PaletteText = 9,
			PaletteBrightText = 10,
			PaletteBase = 11,
			PaletteBackground = 12,
			PaletteShadow = 13,
			PaletteHighlight = 14,
			PaletteHighlightedText = 15,
			PaletteButtonText = 16,
			PaletteLink = 17,
			PaletteLinkVisited = 18,
			X11ParentRelative = 19
		}

		public enum StringComparisonMode {
			CaseSensitive = 1,
			BeginsWith = 2,
			EndsWith = 4,
			Contains = 8,
			ExactMatch = 16
		}

		internal Qt () : this (QNull.Instance) {}

		public Qt (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal Qt (QNull dummy) : base (QNull.Instance) {}

		~Qt ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_Qt function
			deleted = true;
		}
	}
}