// QtMultiLineEdit.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QtMultiLineEdit : QtTableView, IDisposable {

		public enum EchoMode {
			Normal = 0,
			NoEcho = 1,
			Password = 2
		}

		public enum WordWrap {
			NoWrap = 0,
			WidgetWidth = 1,
			FixedPixelWidth = 2,
			FixedColumnWidth = 3
		}

		public enum WrapPolicy {
			AtWhiteSpace = 0,
			Anywhere = 1
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_new_QtMultiLineEdit (IntPtr parent, string name);
		public QtMultiLineEdit (QWidget parent, string name) : this (QNull.Instance)
		{
			rawObject = qt_new_QtMultiLineEdit (parent != null ? parent.RawObject : IntPtr.Zero, name);

			if ((qparent = parent) != null)
				qparent.AddChild (this);

			RegisterObject (this);
			Connect (this, SIGNAL ("destroyed ()"), SLOT ("NativeDestroyed ()"));
		}

		public QtMultiLineEdit () : this (new QWidget ()) {}

		public QtMultiLineEdit (QWidget parent) : this (parent, "") {}

		public QtMultiLineEdit (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QtMultiLineEdit (QNull dummy) : base (QNull.Instance) {}

		~QtMultiLineEdit ()
		{
			Dispose (false);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_del_QtMultiLineEdit (IntPtr raw);
		internal override void Delete ()
		{
			if (deleted) return;

			qt_del_QtMultiLineEdit (rawObject);
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QtMultiLineEdit_textLine (IntPtr raw, int line);
		public string TextLine (int line)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QtMultiLineEdit_textLine (rawObject, line));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_numLines (IntPtr raw);
		public int NumLines ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_numLines (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QtMultiLineEdit_sizeHint (IntPtr raw);
		public QSize SizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QtMultiLineEdit_sizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QtMultiLineEdit_minimumSizeHint (IntPtr raw);
		public QSize MinimumSizeHint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QtMultiLineEdit_minimumSizeHint (rawObject), typeof (QSize)) as QSize;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QtMultiLineEdit_sizePolicy (IntPtr raw);
		public QSizePolicy SizePolicy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QtMultiLineEdit_sizePolicy (rawObject), typeof (QSizePolicy)) as QSizePolicy;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setFont (IntPtr raw, IntPtr font);
		public void SetFont (QFont font)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setFont (rawObject, font.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_insertLine (IntPtr raw, IntPtr s, int line);
		public void InsertLine (string s, int line)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_insertLine (rawObject, new QString (s).RawObject, line);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_insertAt (IntPtr raw, IntPtr s, int line, int col, bool mark);
		public void InsertAt (string s, int line, int col, bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_insertAt (rawObject, new QString (s).RawObject, line, col, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_removeLine (IntPtr raw, int line);
		public void RemoveLine (int line)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_removeLine (rawObject, line);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_cursorPosition (IntPtr raw, int[] line, int[] col);
		public void CursorPosition (int[] line, int[] col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_cursorPosition (rawObject, line, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setCursorPosition (IntPtr raw, int line, int col, bool mark);
		public void SetCursorPosition (int line, int col, bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setCursorPosition (rawObject, line, col, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_getCursorPosition (IntPtr raw, int[] line, int[] col);
		public void GetCursorPosition (int[] line, int[] col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_getCursorPosition (rawObject, line, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QtMultiLineEdit_atBeginning (IntPtr raw);
		public bool AtBeginning ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_atBeginning (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QtMultiLineEdit_atEnd (IntPtr raw);
		public bool AtEnd ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_atEnd (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setFixedVisibleLines (IntPtr raw, int lines);
		public void SetFixedVisibleLines (int lines)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setFixedVisibleLines (rawObject, lines);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_maxLineWidth (IntPtr raw);
		public int MaxLineWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_maxLineWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setAlignment (IntPtr raw, int flags);
		public void SetAlignment (int flags)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setAlignment (rawObject, flags);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_alignment (IntPtr raw);
		public int Alignment ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_alignment (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setValidator (IntPtr raw, IntPtr arg1);
		public void SetValidator (QValidator arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setValidator (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QtMultiLineEdit_validator (IntPtr raw);
		public QValidator Validator ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QtMultiLineEdit_validator (rawObject), typeof (QValidator)) as QValidator;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setEdited (IntPtr raw, bool arg1);
		public void SetEdited (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setEdited (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QtMultiLineEdit_edited (IntPtr raw);
		public bool Edited ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_edited (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_cursorWordForward (IntPtr raw, bool mark);
		public void CursorWordForward (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_cursorWordForward (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_cursorWordBackward (IntPtr raw, bool mark);
		public void CursorWordBackward (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_cursorWordBackward (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setEchoMode (IntPtr raw, EchoMode arg1);
		public void SetEchoMode (EchoMode arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setEchoMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern EchoMode qt_QtMultiLineEdit_echoMode (IntPtr raw);
		public EchoMode TheEchoMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_echoMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setMaxLength (IntPtr raw, int arg1);
		public void SetMaxLength (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setMaxLength (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_maxLength (IntPtr raw);
		public int MaxLength ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_maxLength (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setMaxLineLength (IntPtr raw, int arg1);
		public void SetMaxLineLength (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setMaxLineLength (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_maxLineLength (IntPtr raw);
		public int MaxLineLength ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_maxLineLength (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setMaxLines (IntPtr raw, int arg1);
		public void SetMaxLines (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setMaxLines (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_maxLines (IntPtr raw);
		public int MaxLines ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_maxLines (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setHMargin (IntPtr raw, int arg1);
		public void SetHMargin (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setHMargin (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_hMargin (IntPtr raw);
		public int HMargin ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_hMargin (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setSelection (IntPtr raw, int row_from, int col_from, int row_to, int col_t);
		public void SetSelection (int row_from, int col_from, int row_to, int col_t)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setSelection (rawObject, row_from, col_from, row_to, col_t);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setWordWrap (IntPtr raw, WordWrap mode);
		public void SetWordWrap (WordWrap mode)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setWordWrap (rawObject, mode);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern WordWrap qt_QtMultiLineEdit_wordWrap (IntPtr raw);
		public WordWrap TheWordWrap ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_wordWrap (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setWrapColumnOrWidth (IntPtr raw, int arg1);
		public void SetWrapColumnOrWidth (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setWrapColumnOrWidth (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_wrapColumnOrWidth (IntPtr raw);
		public int WrapColumnOrWidth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_wrapColumnOrWidth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setWrapPolicy (IntPtr raw, WrapPolicy policy);
		public void SetWrapPolicy (WrapPolicy policy)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setWrapPolicy (rawObject, policy);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern WrapPolicy qt_QtMultiLineEdit_wrapPolicy (IntPtr raw);
		public WrapPolicy TheWrapPolicy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_wrapPolicy (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QtMultiLineEdit_autoUpdate (IntPtr raw);
		public bool AutoUpdate ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_autoUpdate (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setAutoUpdate (IntPtr raw, bool arg1);
		public void SetAutoUpdate (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setAutoUpdate (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setUndoEnabled (IntPtr raw, bool arg1);
		public void SetUndoEnabled (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setUndoEnabled (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QtMultiLineEdit_isUndoEnabled (IntPtr raw);
		public bool IsUndoEnabled ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_isUndoEnabled (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setUndoDepth (IntPtr raw, int arg1);
		public void SetUndoDepth (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setUndoDepth (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_undoDepth (IntPtr raw);
		public int UndoDepth ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_undoDepth (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QtMultiLineEdit_isReadOnly (IntPtr raw);
		public bool IsReadOnly ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_isReadOnly (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QtMultiLineEdit_isOverwriteMode (IntPtr raw);
		public bool IsOverwriteMode ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_isOverwriteMode (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QtMultiLineEdit_text (IntPtr raw);
		public string Text ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QtMultiLineEdit_text (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_length (IntPtr raw);
		public int Length ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_length (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setText (IntPtr raw, IntPtr arg1);
		public void SetText (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setText (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setReadOnly (IntPtr raw, bool arg1);
		public void SetReadOnly (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setReadOnly (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setOverwriteMode (IntPtr raw, bool arg1);
		public void SetOverwriteMode (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_setOverwriteMode (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_clear (IntPtr raw);
		public void Clear ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_clear (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_append (IntPtr raw, IntPtr arg1);
		public void Append (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_append (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_deselect (IntPtr raw);
		public void Deselect ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_deselect (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_selectAll (IntPtr raw);
		public void SelectAll ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_selectAll (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_paste (IntPtr raw);
		public void Paste ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_paste (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_pasteSubType (IntPtr raw, IntPtr subtype);
		public void PasteSubType (QCString subtype)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_pasteSubType (rawObject, subtype.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_copyText (IntPtr raw);
		public void CopyText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_copyText (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_copy (IntPtr raw);
		public void Copy ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_copy (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_cut (IntPtr raw);
		public void Cut ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_cut (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_insert (IntPtr raw, IntPtr arg1);
		public void Insert (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_insert (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_undo (IntPtr raw);
		public void Undo ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_undo (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_redo (IntPtr raw);
		public void Redo ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_redo (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_setDefaultTabStop (int ex);
		public static void SetDefaultTabStop (int ex)
		{
			qt_QtMultiLineEdit_setDefaultTabStop (ex);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_defaultTabStop ();
		public static int DefaultTabStop ()
		{
			return qt_QtMultiLineEdit_defaultTabStop ();
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_paintCell (IntPtr raw, IntPtr arg1, int row, int col);
		protected void PaintCell (QPainter arg1, int row, int col)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_paintCell (rawObject, arg1.RawObject, row, col);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QtMultiLineEdit_event (IntPtr raw, IntPtr arg1);
		protected bool Q_event (QEvent arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_event (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QtMultiLineEdit_focusNextPrevChild (IntPtr raw, bool arg1);
		protected bool FocusNextPrevChild (bool arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_focusNextPrevChild (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QtMultiLineEdit_hasMarkedText (IntPtr raw);
		protected bool HasMarkedText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_hasMarkedText (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QtMultiLineEdit_markedText (IntPtr raw);
		protected string MarkedText ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QtMultiLineEdit_markedText (rawObject));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_textWidth (IntPtr raw, int arg1);
		protected int TextWidth (int arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_textWidth (rawObject, arg1);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_textWidth1 (IntPtr raw, IntPtr arg1);
		protected int TextWidth (string arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_textWidth1 (rawObject, new QString (arg1).RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QtMultiLineEdit_cursorPoint (IntPtr raw);
		protected QPoint CursorPoint ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return LookupObject (qt_QtMultiLineEdit_cursorPoint (rawObject), typeof (QPoint)) as QPoint;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_insert1 (IntPtr raw, IntPtr arg1, bool mark);
		protected void Insert (string arg1, bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_insert1 (rawObject, new QString (arg1).RawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_newLine (IntPtr raw);
		protected void NewLine ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_newLine (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_killLine (IntPtr raw);
		protected void KillLine ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_killLine (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_pageUp (IntPtr raw, bool mark);
		protected void PageUp (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_pageUp (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_pageDown (IntPtr raw, bool mark);
		protected void PageDown (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_pageDown (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_cursorLeft (IntPtr raw, bool mark, bool wrap);
		protected void CursorLeft (bool mark, bool wrap)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_cursorLeft (rawObject, mark, wrap);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_cursorRight (IntPtr raw, bool mark, bool wrap);
		protected void CursorRight (bool mark, bool wrap)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_cursorRight (rawObject, mark, wrap);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_cursorUp (IntPtr raw, bool mark);
		protected void CursorUp (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_cursorUp (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_cursorDown (IntPtr raw, bool mark);
		protected void CursorDown (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_cursorDown (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_backspace (IntPtr raw);
		protected void Backspace ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_backspace (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_del (IntPtr raw);
		protected void Del ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_del (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_home (IntPtr raw, bool mark);
		protected void Home (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_home (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_end (IntPtr raw, bool mark);
		protected void End (bool mark)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_end (rawObject, mark);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QtMultiLineEdit_getMarkedRegion (IntPtr raw, int[] line1, int[] col1, int[] line2, int[] col2);
		protected bool GetMarkedRegion (int[] line1, int[] col1, int[] line2, int[] col2)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_getMarkedRegion (rawObject, line1, col1, line2, col2);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern int qt_QtMultiLineEdit_lineLength (IntPtr raw, int row);
		protected int LineLength (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_lineLength (rawObject, row);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QtMultiLineEdit_getString (IntPtr raw, int row);
		protected string GetString (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QtMultiLineEdit_getString (rawObject, row));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern bool qt_QtMultiLineEdit_isEndOfParagraph (IntPtr raw, int row);
		protected bool IsEndOfParagraph (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			return qt_QtMultiLineEdit_isEndOfParagraph (rawObject, row);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern IntPtr qt_QtMultiLineEdit_stringShown (IntPtr raw, int row);
		protected string StringShown (int row)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			QString qstr = new QString (qt_QtMultiLineEdit_stringShown (rawObject, row));
			string str = qstr.Latin1 ();
			qstr.Dispose ();
			return str;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtMultiLineEdit_insertChar (IntPtr raw, IntPtr arg1);
		protected void InsertChar (QChar arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtMultiLineEdit_insertChar (rawObject, arg1.RawObject);
		}

		public void InsertLine (string s)
		{
			InsertLine(s, (int) -1);
		}

		public void InsertAt (string s, int line, int col)
		{
			InsertAt(s, line, col, false);
		}

		public void SetCursorPosition (int line, int col)
		{
			SetCursorPosition(line, col, false);
		}

		protected void PageUp ()
		{
			PageUp(false);
		}

		protected void PageDown ()
		{
			PageDown(false);
		}

		protected void CursorLeft ()
		{
			CursorLeft(false);
		}

		protected void CursorLeft (bool mark)
		{
			CursorLeft(mark, true);
		}

		protected void CursorRight ()
		{
			CursorRight(false);
		}

		protected void CursorRight (bool mark)
		{
			CursorRight(mark, true);
		}

		protected void CursorUp ()
		{
			CursorUp(false);
		}

		protected void CursorDown ()
		{
			CursorDown(false);
		}

		protected void Home ()
		{
			Home(false);
		}

		protected void End ()
		{
			End(false);
		}

		// Begin interface methods.

	}
}