// QtTableView.cs - A Qt to C# binding.
//
// Copyright (C) 2002  Adam Treat (manyoso@yahoo.com)
//
// This program is free software; you can redistribute it and/or
// modify it under the terms of the GNU General Public License
// as published by the Free Software Foundation; either version 2
// of the License, or (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
//
// Generated File.  Do Not Modify.

namespace Qt {

	using Qt;
	using System;
	using System.Runtime.InteropServices;

	public class QtTableView : QFrame, IDisposable {

		internal QtTableView () : this (QNull.Instance) {}

		public QtTableView (IntPtr ptr) : this (QNull.Instance)
		{
			rawObject = ptr;
			RegisterObject(this);
		}

		internal QtTableView (QNull dummy) : base (QNull.Instance) {}

		~QtTableView ()
		{
			Dispose (false);
		}

		internal override void Delete ()
		{
			if (deleted) return;

			// libqtc lacks a qt_del_QtTableView function
			deleted = true;
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtTableView_setBackgroundColor (IntPtr raw, IntPtr arg1);
		public void SetBackgroundColor (QColor arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtTableView_setBackgroundColor (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtTableView_setPalette (IntPtr raw, IntPtr arg1);
		public void SetPalette (QPalette arg1)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtTableView_setPalette (rawObject, arg1.RawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtTableView_show (IntPtr raw);
		public void Show ()
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtTableView_show (rawObject);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtTableView_repaint (IntPtr raw, bool erase);
		public void Repaint (bool erase)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtTableView_repaint (rawObject, erase);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtTableView_repaint1 (IntPtr raw, int x, int y, int w, int h, bool erase);
		public void Repaint (int x, int y, int w, int h, bool erase)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtTableView_repaint1 (rawObject, x, y, w, h, erase);
		}

		[DllImport("libqtc", CharSet=CharSet.Ansi)]
		private static extern void qt_QtTableView_repaint2 (IntPtr raw, IntPtr arg1, bool erase);
		public void Repaint (QRect arg1, bool erase)
		{
			if (disposed)
				throw new ObjectDisposedException (this+": Attempted use of disposed object");

			qt_QtTableView_repaint2 (rawObject, arg1.RawObject, erase);
		}

		public void Repaint ()
		{
			Repaint(true);
		}

		public void Repaint (int x, int y, int w, int h)
		{
			Repaint(x, y, w, h, true);
		}

		public void Repaint (QRect arg1)
		{
			Repaint(arg1, true);
		}

		// Begin interface methods.

	}
}